<?php
/**
 * $Id: config.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class ResControllerConfig extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save');
		JRequest::setVar( 'view', 'config');
	}

	function display()
	{
		JRequest::setVar( 'view', 'config');
		parent::display();
	}

	function apply()
	{
		$this->save();
	}

	function save()
	{
		global $mainframe;

		$task = JRequest::getCmd( 'task');

		foreach ($_POST['params'] as $var => $val) {
			if(is_array($val)) $_POST['params'][$var] = serialize($val);
		}

		$params = new JParameter( $_POST['params'], JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'params.xml');
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini',  $ini );

		$msg = JText::_('Successfully Saved Configuration');
		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_resource&controller=config', $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_resource', $msg );
				break;
		}
	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_resource';
		$mainframe->redirect( $link );
	}

	function set( $key, $value, $group = '_default' )
	{
		global $JS_params_obj;

		if( ! isset($JS_params_obj) ){
			JError::raiseWarning( 500, JText::_('Config controller is not initialised.') );
			return false;
		}

		$JS_params_obj->set( $key, $value, $group );

		$ini = $JS_params_obj->toString();

		JFile::write( JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini', $ini );

		return true;
	}

	function initialyze()
	{
		static $init = false;
		
		if($init)
			return;
		$uri = & JFactory::getURI();

		$ini = JFile::read( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'config.ini');
		
		$config_params = new JParameter($ini);//,  JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'xml'.DS.'params.xml');

		$GLOBALS[ 'JS_params_obj' ] = $config_params ;

		$params_array = $config_params->toArray();
		//print'<table>';
		foreach($params_array AS $key => $val){
			$name = strtoupper('res_'.$key);
			//print '<tr><td>'.strtoupper($name).'</td><td>'.$val.'</td></tr>';
			if(defined(strtoupper($name))){
				continue;
			}

			define(strtoupper($name), $val, true);
		}
		$init = true;
		//print'</table>';
	}
}
?>