<?php
/**
 * $Id: filters.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.controller');

/**
 * Weblinks Weblink Controller
 *
 * @package		Joomla
 * @subpackage	Weblinks
 * @since 1.5
 */
class ResControllerFilters extends JController
{
	function __construct($config = array())
	{
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'filters');
			
		parent::__construct($config);

		// Register Extra tasks
		$this->registerTask( 'apply',  'save');
	}

	function edit()
	{
		JRequest::setVar( 'view', 'filters');
		JRequest::setVar( 'layout', 'form');
		parent::display();
	}

	function add()
	{
		JRequest::setVar( 'view', 'filters');
		JRequest::setVar( 'layout', 'form');
		parent::display();
	}

	function save()
	{
		$post	= JRequest::get('post');

		$model = $this->getModel('filters');

		if ( $model->store( $post ) ) {
			$msg = JText::_('Filter Saved');
		} else {
			$msg = JText::_('Error Saving Filter');
			$msg .= $model->getError();
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();

		$link = 'index.php?option=com_resource&controller=filters';
		if( JRequest::getVar('task') == 'apply' ) $link = "index.php?option=com_resource&controller=filters&view=filters&task=edit&cid[]=".($post['id'] ? $post['id'] : $model->_id);

		$this->setRedirect($link, $msg);
	}
	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('filters');
		
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_resource&controller=filters');
	}
	function orderup()
	{
		$model = $this->getModel('filters');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_resource&controller=filters');
	}

	function orderdown()
	{
		$model = $this->getModel('filters');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_resource&controller=filters');
	}
}
?>