<?php
/**
 * $Id: subtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

jimport('joomla.client.helper');

class ResControllerSubtmpls extends ResController1 {

	function __construct()
	{
		parent::__construct();
	}
	function display( )
	{
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'subtmpls');

		parent::display();
	}

	function doInstall()
	{
		global $mainframe;
		
		JRequest::checkToken() or die( 'Invalid Token');

		$model	= &$this->getModel( 'subtmplsinstall');
		
		if ($model->install()) {
			$cache = &JFactory::getCache('mod_menu');
			$cache->clean();
				
			$mainframe->enqueueMessage(JText::_('Templates has been installed successfully.'));
		}
		
		$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab') );
		$this->display();
	}

	function doUninstall()
	{
		global $mainframe;
		JRequest::checkToken() or die( 'Invalid Token');

		$tmpls = JRequest::getVar('cid');

		foreach( $tmpls as $tmpl ) {
			$matches = Array();
			preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );
				
			if( $matches[1] == 'default' ){
				JError::raiseWarning( 500, JText::_('Default template you can copy only') );
				$this->display();
				return;
			}
		}

		$model = &$this->getModel( 'Subtmplsuninstall');

		$model->uninstall( $tmpls );

		$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab'), JText::_('Templates has been uninstalled successfully.' ) );

		$this->display();
	}

	function change_name()
	{
		$tmpls    = JRequest::getVar('cid');
		
		$matches = Array();
		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpls[0], $matches );

		if( $matches[1] == 'default' ){
			JError::raiseWarning( 403, JText::_('Default template you can copy only') );
		} else {

			$new_name = JRequest::getVar('tmpl_name');
			$xmlFile = new JSimpleXML();
			$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$matches[1].'.xml';
			if (!$xmlFile->loadFile($file))
			{
				JError::raiseError(500, JText::_('Cannot load file'). ': ', $file);
				$this->display();
				return;
			}
		
			if (!$new_name)
			{
				JError::raiseError(500, JText::_('New name not set'));
				$this->display();
				return;
			}
			$model = &$this->getModel( 'Subtmplscopyrename');
			if( $model->change_name( $file, $new_name ) ){
				$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab'), JText::_('Templates has been renamed successfully.' ) );
			}
		}
		
		
		$this->display();
	}
	
	function renameTmpl()
	{
		global $mainframe;
		JRequest::checkToken() or die( 'Invalid Token');

		$tmpls    = JRequest::getVar('cid');

		$matches = Array();
		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpls[0], $matches );

		if( $matches[1] == 'default' ){
			JError::raiseWarning( 500, JText::_('Default template you can copy only') );
		} else {

			$new_name = JRequest::getVar('tmplname');
				
			$model = &$this->getModel( 'Subtmplscopyrename');
			if( $model->rename( $tmpls[0], $new_name ) ){
				$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab'), JText::_('Templates has been renamed successfully.' ) );
			}
		}
		$this->display();
	}

	function copyTmpl()
	{
		global $mainframe;
		 
		JRequest::checkToken() or die( 'Invalid Token');

		$new_name = JRequest::getVar('tmplname');
		$tmpls    = JRequest::getVar('cid');

		$model = &$this->getModel( 'Subtmplscopyrename');

		if( $model->copy( $tmpls[0], $new_name ) ){
			$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab'), JText::_('Templates has been copied successfully.' ) );
		}

		$this->display();
	}

	function apply()
	{
		$this->save();
	}

	function cancel()
	{
		global $mainframe;
		$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab') );
	}

	function save()
	{
		global $mainframe;

		$task = JRequest::getCmd( 'task');

		foreach ($_POST['params'] as $var => $val) {
			if( is_array( $val ) ) $_POST['params'][$var] = serialize($val);
		}
		$type = JRequest::getVar('type');

		$name = JRequest::getVar('name');
		$layouts_path = subTemplate::getTmplPath( $type );

		$file_name = subTemplate::getTmplFile( $type, $name );

		$params = new JParameter( $_POST['params'], $file_name.'.xml');
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( $file_name.'.ini', $ini);

		$msg = JText::_('Successfully Saved Configuration');

		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&layout=form&cid[]=['.$name.'],['.$type.']&tab='.JRequest::getVar('tab'), $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_resource&controller=subtmpls&view=subtmpls&tab='.JRequest::getVar('tab'), $msg );
				break;
		}
	}
}
?>