<?php
/**
 * $Id: subtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

class subTemplate
{
	function getTmplTypes()
	{
		return array( 'itemlist', 'filters', 'comments', 'article', 'rating', 'articleform', 'category', 'user_menu');
	}

	function getTmplPath( $type )
	{

		switch( $type ){
			case 'user_menu':
			case 'itemlist':
			case 'filters':
			case 'category':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl';
				break;
					
			case 'rating':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'rating_tmpls';
				break;
					
			case 'comments':
			case 'article':
			case 'articleform':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'article'.DS.'tmpl';
				break;

		}
		return $tmpl_path;

	}

	function getTmplImgSrc( $type, $name )
	{
		$img_path = '';
		switch ( $type ) {
			case 'user_menu':
				$view = 'list';
				$name     = 'default_menu_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'itemlist':
				$view = 'list';
				$name     = 'default_subtmpl_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'category':
				$view = 'list';
				$name     = 'default_cindex_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'filters':
				$view = 'list';
				$name     = 'default_filters_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'comments':
				$view = 'article';
				$name     = 'default_comments_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'article':
				$view = 'article';
				$name     = 'default_article_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'articleform':
				$view = 'article';
				$name     = 'form_articleform_'.$name.'.png';
				$img_path = JURI::root().'components/com_resource/views/'.$view.'/tmpl/'.$name;
				break;
			case 'rating':
				$img_path = JURI::root().'components/com_resource/views/rating_tmpls/'.$name.'_img/';
				break;
		}

		return $img_path;
	}

	function getTmplFile( $type, $name )
	{
		$layouts_path = subTemplate::getTmplPath( $type );
		$result='';

		switch ( $type ) {
			case 'user_menu':
				$result = $layouts_path.DS.'default_menu_'.$name;
				break;
			case 'category':
				$result = $layouts_path.DS.'default_cindex_'.$name;
				break;
			case 'itemlist':
				$result = $layouts_path.DS.'default_subtmpl_'.$name;
				break;
			case 'filters':
				$result = $layouts_path.DS.'default_filters_'.$name;
				break;
			case 'comments':
				$result = $layouts_path.DS.'default_comments_'.$name;
				break;
			case 'article':
				$result = $layouts_path.DS.'default_article_'.$name;
				break;
			case 'articleform':
				$result = $layouts_path.DS.'form_articleform_'.$name;
				break;
			case 'rating':
				$result = $layouts_path.DS.'rating_'.$name;
				break;
		}

		return $result;
	}

	function getTmplMask( $type, $name = '.*' )
	{

		$result = Array();

		switch( $type ){
			case 'user_menu':
				$result['index_file'] = '^default_menu_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_menu_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_menu_'.$name;
				break;
			case 'itemlist':
				$result['index_file'] = '^default_subtmpl_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_subtmpl_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_subtmpl_'.$name;
				break;
			case 'category':
				$result['index_file'] = '^default_cindex_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_cindex_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_cindex_'.$name;
				break;
			case 'filters':
				$result['index_file'] = '^default_filters_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_filters_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_filters_'.$name;
				break;
			case 'comments':
				$result['index_file'] = '^default_comments_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_comments_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_comments_'.$name;
				break;
			case 'article':
				$result['index_file'] = '^default_article_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_article_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^default_article_'.$name;
				break;
			case 'articleform':
				$result['index_file'] = '^form_articleform_'.$name.'\.xml$';
				$result['ident']      = array( "/^(form_articleform_)/", "/(\..{2,3})$/" );
				$result['folder'] = '^form_articleform_'.$name;
				break;
			case 'rating':
				$result['index_file']      = '^rating_'.$name.'\.xml$';
				$result['folder'] = 		"^".$name."_img$";
				$result['ident']           = array( "/^(rating_)/", "/(\..{2,3})$/" );
				break;
		}


		return $result;
	}

	function getTmplFullMask( $type, $name = '.*' )
	{

		$result = Array();

		switch( $type ){
			case 'user_menu':
				$result['index_file'] = '^default_menu_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_menu_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_menu_'.$name;
				break;
			case 'itemlist':
				$result['index_file'] = '^default_subtmpl_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_subtmpl_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_subtmpl_'.$name;
				break;
			case 'category':
				$result['index_file'] = '^default_cindex_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_cindex_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_cindex_'.$name;
				break;
			case 'filters':
				$result['index_file'] = '^default_filters_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_filters_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_filters_'.$name;
				break;
			case 'comments':
				$result['index_file'] = '^default_comments_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_comments_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_comments_'.$name;
				break;
			case 'article':
				$result['index_file'] = '^default_article_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(default_article_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^default_article_'.$name;
				break;
			case 'articleform':
				$result['index_file'] = '^form_articleform_'.$name.'\..{2,3}$';
				$result['title']      = array( "/^(form_articleform_)/", "/(\..{2,3})$/" );
				$result['folder']	  = '^form_articleform_'.$name;
				break;
			case 'rating':
				$result['index_file']      = '^rating_'.$name.'\..{2,3}$';
				$result['folder'] = 		"^".$name."_img$";
				$result['title']           = array( "/^(rating_)/", "/(\..{2,3})$/" );
				break;
		}


		return $result;
	}

	/*
	 * Hack function to load needed rating templates.
	 * Wrote, cuz the original code uses $this pointer
	 * of a JView.
	 * This function can be called from within an arbitary
	 * class instance.
	 */
	function loadRatingTemplateMCR($tmpl_name, $current, $rating_ident, $prod_id, $callbackfunction, $rating_active)
	{
		// chop off "/administrator" from url, for proper rating image loading.
		$baseUrl = JURI::base();
		$url = explode('/', $baseUrl);
		// remove empty elements
		while (count($url) > 1 && strlen($url[count($url) - 1]) == 0)
		array_pop($url);

		if (count($url) > 1 && $url[count($url) - 1] == 'administrator'){
			array_pop($url);
			$baseUrl = implode('/', $url).'/';
		}

		// Now, we initialize the needed data.
		$this->img_path = $baseUrl.'components/com_resource/views/rating_tmpls/'.$tmpl_name.'_img/';
		$this->rating_ident = $rating_ident.md5($prod_id);
		$this->rating_active = $rating_active;
		$this->callbackfunction = $callbackfunction;
		$this->rating_current = $current;

		$this->prod_id = $prod_id;
		ob_start();
		include (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'rating_tmpls'.DS.'rating_'.$tmpl_name.'.php');
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}

}

?>