<?php
/**
 * $Id: category.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');
jimport('joomla.application.component.model');

class ResModelCategory extends JModel
{
	var $_id = null;
	var $_data = null;
	function __construct()
	{
		global $mainframe, $option;
		parent::__construct();
		
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int');

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit	= JRequest::getVar('edit',true);
		if($edit)
			$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getCategory()
	{
		// Load the weblink data
		if (!$this->_loadData())
		{
			$this->_initData();
		}

		return $this->_data;
	}
	/**
	function _getCategories($parent = 0, $level = 0)
	{
		global $mainframe, $option;
		$p = $mainframe->getUserStateFromRequest( $option.'category.filter_catid',	'filter_catid',	0,'int');
		
		$where		= $this->_Where($p);
		$orderby	= $this->_OrderBy();

		$query = "SELECT j.*, $level as level, g.name as groupname FROM "
              . "#__js_res_category as j LEFT JOIN "
              . "#__groups AS g ON g.id = j.access "
              //. "WHERE 1 AND j.parent =  $parent"
              . $where
              . $orderby
              ;
        //echo $query."<br><br><br>";
        
        $res = $this->_getList($query);
		if($res)
		{
			foreach ($res AS $r)
			{
				$out[] = $r;
				//if(!$p){
				//	$add = $this->_getCategories($r->id, $level + 1);
				//	if(is_array($add)) $out = array_merge($out, $add);
				//}
			}
		}
		else 
		{
			return false;
		}
		return  $out;
		
	}
	*/
	function _getCategoriesList($parent = 0, $level = 0, $hm = 1000)
	{
		static $cats = array();
		$key = "$parent-$level-$hm";
		
		if(array_key_exists($key, $cats)) return $cats[$key];
		
		//$db = & JFactory::getDBO();
		if($level >= $hm) return;
		$sql = "select id AS value, concat('".str_repeat('&nbsp;&nbsp;&nbsp;- ', $level)."',name) as text 
		FROM #__js_res_category WHERE parent = $parent ORDER BY ordering";
		$res = $this->_getList($sql);
		if($res)
		{
			foreach ($res AS $r)
			{
				$out[] = JHTML::_('select.option', $r->value, $r->text);
				//echo $r->parent;
				$add = $this->_getCategoriesList($r->value, $level + 1, $hm);
				if(is_array($add)) $out = array_merge($out, $add);
			}
		}
		else 
		{
			return false;
		}
		
		$cats[$key] = $out;
		return  $out;
		
	}
	function getUpId($filter_catid)
	{
		$sql = "SELECT parent FROM #__js_res_category WHERE id = ".$filter_catid;
		$this->_db->setQuery($sql);
		//echo $sql;
		$res = $this->_db->loadResult();
		if($res === false) return -1;
		return $res;
	}
	function getCategories()
	{
		global $mainframe, $option;
		
		$p = $mainframe->getUserStateFromRequest( $option.'category.filter_catid',	
		'filter_catid',	0,'int');
		
		if (empty($this->_data))
		{
			$query = $this->_Query($p);
			//echo $query;
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	function _Query($r){
		$where		= $this->_Where($r);
		$orderby	= $this->_OrderBy();

		$query = "SELECT j.*, g.name as groupname, count(c.id) as total "
			  . " FROM #__js_res_category as j "
              . " LEFT JOIN #__groups AS g ON g.id = j.access "
              . " LEFT JOIN #__js_res_category AS c ON c.parent = j.id "
              
              //. "WHERE 1 AND j.parent =  $parent"
              . $where
              . " GROUP BY j.id "
              . ($r ? $orderby : ' ORDER BY j.id ASC ')
              ;
        return $query;
	}
	function _OrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.category.filter_order',		'filter_order',		'j.ordering',	'var');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.category.filter_order_Dir',	'filter_order_Dir',	'ASC',		'word');
        
		$orderby = '';
		if($filter_order && $filter_order_Dir) $orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		else $orderby = ' ORDER BY j.ordering';
		
		return $orderby;
	}
	function _Where($parent = 0)
	{
		global $mainframe, $option;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'category.filter_state',		'filter_state',		'',				'word');
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'category.filter_catid',		'filter_catid',		0,				'int');
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'records.filter_type',		'filter_type',		0,				'int');
		
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string');
		$search				= JString::strtolower( $search );

		$where = array();

		if ($filter_catid > 0) {
			$where[] = 'j.parent = '.(int) $filter_catid;
		}
		else 
		{
			$where[] = 'j.parent =  '. $parent;
		}
		if ($search) {
			$w[] = 'LOWER(j.title) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w[] = 'LOWER(j.name) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w[] = 'LOWER(j.description) LIKE '.$this->_db->Quote('%'.$search.'%');
			$where[] = '( '.implode(' OR ', $w).' )';
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'j.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'j.published = 0';
			}
		}

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '');

		return $where;
	}
	
	function getTotal()
	{
		global $mainframe, $option;
		
		$p = $mainframe->getUserStateFromRequest( $option.'category.filter_catid',	'filter_catid',	0,'int');
		
		if (empty($this->_total))
		{
			$query = $this->_Query($p);
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	/**
	 * Tests if weblink is checked out
	 *
	 * @access	public
	 * @param	int	A user id
	 * @return	boolean	True if checked out
	 * @since	1.5
	 */
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	/**
	 * Method to checkin/unlock the weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function checkin()
	{
		if ($this->_id)
		{
			$record = & $this->getTable('record','Res');
			if(! $record->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	/**
	 * Method to checkout/lock the weblink
	 *
	 * @access	public
	 * @param	int	$uid	User ID of the user checking the article out
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$record = & $this->getTable('record','Res');
			if(!$record->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}

	function store($data)
	{
		$row =& $this->getTable('category','Res');

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		// Create the timestamp for the date
		$row->mtime = gmdate('Y-m-d H:i:s');

		// if new item, order last in appropriate group
		if (!$row->id) {
			//$where = 'catid = ' . (int) $row->catid ;
			$row->ordering = $row->getNextOrder("parent = ".$row->parent);
		}

		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError("Check:". $this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError("Store:".$this->_db->_sql);
			return false;
		}
		$this->id = $row->id;
		
		// Updates categories in record table
		
		$sql = "SELECT GROUP_CONCAT(CONVERT(catid, CHAR(8)) SEPARATOR ',') as catids,rc.record_id
				FROM #__js_res_record_category AS rc
				WHERE rc.record_id IN (SELECT rc2.record_id FROM #__js_res_record_category AS rc2 WHERE rc2.catid = {$this->id})
				GROUP BY rc.record_id";
		$this->_db->setQuery( $sql );
		$records = $this->_db->loadObjectList();
		
		foreach ($records AS $record)
		{
			
			$sql = "SELECT id, name FROM #__js_res_category WHERE id IN (".$record->catids.") ";
			$this->_db->setQuery( $sql );
			$record_categories = $this->_db->loadObjectList();
			$store_categories = array();
			foreach ($record_categories AS $category)
			{
				$store_categories[$category->id] = $category->name;
			}
			$store_categories = serialize($store_categories);
		
			$sql = "UPDATE #__js_res_record SET categories = '{$store_categories}' WHERE id = {$record->record_id}";
			$this->_db->setQuery($sql);
			$this->_db->query();
		}
		return true;
	}

	/**
	 * Method to remove a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function delete($cid = array())
	{
		$result = false;

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__js_res_record'
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	/**
	 * Method to (un)publish a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__js_res_record'
				. ' SET published = '.(int) $publish
				. ' WHERE id IN ( '.$cids.' )'
				. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	/**
	 * Method to move a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function move($direction)
	{
		$row =& $this->getTable('category','Res');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' parent = '.(int) $row->parent.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	/**
	 * Method to move a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function saveorder($cid = array(), $order)
	{
		
		$row =& $this->getTable('category', 'Res');
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->parent;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('parent = '.(int) $group);
		}

		return true;
	}

	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__js_res_category WHERE id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	/**
	 * Method to initialise the weblink data
	 *
	 * @access	private
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$user = & JFactory::getUser();
			$record = new stdClass();

			$record->id	= null;
		    $record->name	= '';
		    $record->description = '';
		    /** @var string */
		    //$record->level	= 0;
		    $record->ordering = 0;
		    $record->published = 0;
		    $record->trash = 0;
		    $record->icon	= '';
		    $record->ctime	= null;
		    $record->mtime	= null;
		    $record->parent	= 0;
		    $record->itemid				= '';
		    $record->access	= '';
		    $record->checked_out = null;
		    $record->checked_out_time = null;
		    $record->clicks = 0;
		    $record->image	= '';
		    $record->image_position	= '';
		    $record->title	= '';
		    $record->params	= '';
		    $record->meta_key	= '';
		    $record->meta_descr	= '';
    		$record->section_id	= '';
    		$record->alias	= '';
			$this->_data				= $record;
			return (boolean) $this->_data;
		}
		return true;
	}
}
?>
