<?php
/**
 * $Id: comments.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport('joomla.application.component.model');

class ResModelComments extends JModel
{
	var $_item       = null;
	var $_data       = null;
	var $_total      = null;
	var $_pagination = null;


	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		$limit      = $mainframe->getUserStateFromRequest( 'global.list.limit',   'limit',      $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0,                                'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit',      $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData()
	{
		if (empty($this->_data)) {

			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function getItem()
	{
		if (empty($this->_item)) {

			$id = JRequest::getInt('id');

			$query = ' SELECT a.* FROM #__js_res_comments AS a WHERE a.id = '.$id;
			$this->_db->setQuery($query);
			$this->_item = $this->_db->loadObject();
		}

		return $this->_item;
	}

	function getTotal()
	{

		if (empty($this->_total)) {

			$query = $this->_buildTotalQuery();
			$this->_db->setQuery( $query );
			$this->_db->query();
			$this->_total = $this->_db->loadResult();
		}

		return $this->_total;
	}

	function getPagination()
	{

		if (empty($this->_pagination)) {
			jimport( 'joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	function _buildTotalQuery()
	{

		global $mainframe, $option;
		$where    = $this->_buildContentWhere();
//		$orderby  = $this->_buildContentOrderBy();

		$search        = $mainframe->getUserStateFromRequest( $option.'comments.search',        'search',        '', 'string');
		$search        = JString::strtolower( $search );


		$query = "    SELECT count( DISTINCT a.id)"
		. "\n      FROM #__js_res_comments        AS a "
		. "\n LEFT JOIN #__js_res_record          AS r  ON r.id = a.record_id "
		. "\n LEFT JOIN #__js_res_record_category AS c  ON c.record_id = r.id "
		. "\n LEFT JOIN #__js_res_types           AS t  ON t.id = r.type_id "
		. "\n LEFT JOIN #__users                  AS u  ON u.id = a.user_id ";
		if(substr($search, 0 , 8) == 'country:')
		{
			$query .= "\n LEFT JOIN #__js_ip_2_country AS i ON i.ip_from <= inet_aton(a.ip) AND i.ip_to >= inet_aton(a.ip)";
		}

		$query .= $where;// . "\n  GROUP BY a.id ";

		return $query;
	}

	function _buildQuery()
	{

		global $mainframe, $option;
		$where    = $this->_buildContentWhere();
		$orderby  = $this->_buildContentOrderBy();

		$search        = $mainframe->getUserStateFromRequest( $option.'comments.search',        'search',        '', 'string');
		$search        = JString::strtolower( $search );


		$query = "    SELECT a.*, r.title AS record, t.name AS type, u.username, u.id AS userid, u.email AS useremail"
		. "\n      FROM #__js_res_comments        AS a "
		. "\n LEFT JOIN #__js_res_record          AS r  ON r.id = a.record_id ";
		
		if($mainframe->getUserStateFromRequest( $option.'comments.filter_catid',  'filter_catid',  0,  'int'))
			$query .= "\n LEFT JOIN #__js_res_record_category AS c  ON c.record_id = r.id ";
			
		$query .= "\n LEFT JOIN #__js_res_types           AS t  ON t.id = r.type_id "
		. "\n LEFT JOIN #__users                  AS u  ON u.id = a.user_id ";
		if(substr($search, 0 , 8) == 'country:')
		{
			$query .= "\n LEFT JOIN #__js_ip_2_country AS i ON i.ip_from <= inet_aton(a.ip) AND i.ip_to >= inet_aton(a.ip)";
		}

		$query .= $where . "\n  GROUP BY a.id "	. $orderby;

		return $query;
	}

	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest( $option.'comments.filter_order',     'filter_order',     'a.ctime',  'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'comments.filter_order_Dir', 'filter_order_Dir', 'DESC',         'word');

		if ($filter_order == 'a.ctime'){
			$orderby   = ' ORDER BY a.ctime '.$filter_order_Dir;
		} else {
			$orderby   = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.ctime ';
		}

		return $orderby;
	}

	function _buildContentWhere()
	{
		global $mainframe, $option;
		$db =& JFactory::getDBO();

		$filter_catid  = $mainframe->getUserStateFromRequest( $option.'comments.filter_catid',  'filter_catid',  0,  'int');
		$filter_typeid = $mainframe->getUserStateFromRequest( $option.'comments.filter_typeid', 'filter_typeid', 0,  'int');
		$search        = $mainframe->getUserStateFromRequest( $option.'comments.search',        'search',        '', 'string');
		$search        = JString::strtolower( $search );

		$where = array();

		if ( $filter_catid ) {
			$where[] = 'c.catid = '.(int) $filter_catid;
		}

		if ( $filter_typeid ) {
			$where[] = 't.id = '.(int) $filter_typeid;
		}

		if ( $search ) {
			if(substr($search, 0 , 8) == 'country:')
			{
				$code = strtoupper(substr($search, 8 , 11));
				$where[] = "i.code = '{$code}' ";
			}
			else
			{
				$w[] = "a.subject  LIKE '%".$search."%'";
				$w[] = "a.comment  LIKE '%".$search."%'";
				$w[] = "r.title    LIKE '%".$search."%'";
				$w[] = "u.username LIKE '%".$search."%'";
				$w[] = "a.ip LIKE '%".$search."%'";
				$w[] = "u.email    LIKE '%".$search."%'";
				$w[] = "a.id = '".$search."'";
				$where[] = '('. implode( ' OR ', $w ) .')';
			}
		}

		$where     = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '');

		return $where;
	}

	function _deleteItem()
	{
		$db =& JFactory::getDBO();

		$cid = Jrequest::getVar( 'cid');

		$query = 'DELETE FROM #__js_res_comments WHERE id IN ('.implode( ',', $cid ).')';

		$db->setQuery($query);
		$db->query();

	}

	function _saveItem()
	{
		$db =& JFactory::getDBO();

		$id        = Jrequest::getInt( 'id');
		$subject   = Jrequest::getString( 'subject');
		$comment   = Jrequest::getVar( 'comment', '','','string', 2 );
		$published = Jrequest::getString( 'published');
		$lang = Jrequest::getVar( 'langs');
		$subject = trim( $subject );
		if( !$subject ) {
			$this->_error_msg = JText::_('Subject is empty. Comment did`t save');
			return false;
		}

		$query = 'UPDATE #__js_res_comments SET `access` = '.Jrequest::getInt( 'access' ).',langs = "'.$db->getEscaped($lang).'", comment = "'.$db->getEscaped($comment).'", subject= "'.$db->getEscaped($subject).'", published= "'.$published.'" WHERE id ='.$id;

		//print $query; exit;

		$db->setQuery($query);
		$db->query();

		return true;
	}
}
