<?php
/**
 * $Id: field.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class ResModelField extends JModel
{
    var $_data = null;
    var $_id = 0;
    function __construct()
	{
		parent::__construct();

        $array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function getFields()
	{
	    if (empty($this->_data))
		{
			$query = $this->_Query();
			$this->_data = $this->_getList($query);
		}

		return $this->_data;
	}
	
	function _Query()
	{
		$orderby	= $this->_OrderBy();
		$type_id = JRequest::getInt('type_id');
		if(!$type_id) 
		{
			$array = JRequest::getVar('cid', array(0), '', 'array');
			//print_r($array);exit;
			//JError::raiseError('403', 'Important value do not set');
			$type_id = $array[0];
		}
	    $query = ' SELECT f.*, g.name as groupname '
			. ' FROM #__js_res_fields AS f '
			. ' LEFT JOIN #__groups AS g ON g.id = f.access '
			. ' WHERE type_id = '.$type_id
			. ' GROUP BY f.id'
			. $orderby
		;
        //echo $query;
		return $query;
	}
	function _OrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'fields.filter_order',		'filter_order',		'f.ordering',	'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'fields.filter_order_Dir',	'filter_order_Dir',	'ASC',		'word');
        
		$orderby = '';
		if($filter_order && $filter_order_Dir) $orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		
		return $orderby;
	}
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_Query();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	function move($direction)
	{
		$row =& $this->getTable();
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' type_id = '.(int) $row->type_id.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable();
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->type_id;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('type_id = '.(int) $group);
		}

		return true;
	}
	function &getData()
	{
		// Load the weblink data
		if ($this->_loadData())
		{

		}
		else  $this->_initData();

		return $this->_data;
	}

	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	function _loadData()
	{
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__js_res_fields WHERE id = '.(int) $this->_id;
			//echo $query; exit;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	function _initData()
	{
		if (empty($this->_data))
		{
			$field = new stdClass();
			
			$field->id					= 0;
			$field->title				= null;
			$field->description			= null;
			$field->published			= 1;
			$field->checked_out			= 0;
			$field->checked_out_time	= 0;
			$field->params				= null;
			$field->type_id				= 0;
			$field->type				= null;
			$field->ordering			= 0;
			$field->show_intro			= 0;
			$field->show_detail			= 0;
			$field->show_cart			= 0;
			$field->show_compare			= 0;
			$field->searchable			= 0;
			$field->filter				= 0;
			$field->access				= 0;
			
			$this->_data					= $field;
			return (boolean) $this->_data;
		}
		return true;
	}
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			$field = & $this->getTable();
			if(!$field->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function store($data)
	{
		$row =& $this->getTable();
   		$db = & JFactory::getDBO();
    
		if (!$row->bind($data)) {
			$this->setError($row->getError());
			return false;
		}

		if (!$row->check()) {
			$this->setError($row->getError());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$row->reorder( 'type_id='.$db->Quote( $row->type_id ) );
		$this->id = $row->id;

		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$field = & $this->getTable();
			if(! $field->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
}