<?php
/**
 * $Id: filters.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class ResModelFilters extends JModel
{
	var $_order_list  = null;
	var $_filter_list = null;
	var $_data        = array();
	var $_id          = 0;
	function __construct()
	{
		parent::__construct();
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId( ( int )$array[0] );
	}

	function getFilterPluginList()
	{
		if( !$this->_filter_list ) {
			$sql = "   SELECT REPLACE(element, 'filter_', '') as value, name as text #REPLACE(element, 'filter_', '') as text"
			."\n     FROM #__plugins"
			."\n    WHERE `folder` = 'joomsuite_content' AND published = 1 AND element REGEXP '^filter_'"
			."\n ORDER BY element ASC";
			$this->_filter_list = $this->_getList( $sql );
			if( is_array( $this->_filter_list ) ) array_unshift ( $this->_filter_list, JHTML::_('select.option', '', '- '.JText::_( "Select type" ).' -') );
		}
		return $this->_filter_list;
	}

	function getFiltersOrderList() {
		if( !$this->_order_list ) {
			$sql = "SELECT ordering as value, CONCAT('(', ordering,') ', title) as text FROM #__js_res_filters ORDER BY ordering ASC";
			$this->_order_list = $this->_getList( $sql );

			if( is_array( $this->_order_list ) ) array_unshift ( $this->_order_list, JHTML::_('select.option', '0', '(0) - first -') );
		}
		return $this->_order_list;
	}

	function setId( $id )
	{
		$this->_id    = $id;
		$this->_data  = null;
	}

	function getFilters()
	{
		if (empty($this->_data)) {
			$query = $this->_Query();
			$this->_data = $this->_getList($query);
		}

		return $this->_data;
	}

	function getFiltersForDisplaying( $cat_id, $section_id, $prm )
	{
		$filters = $this->getFilters();
		if(!$filters) return;

		$result = array();

		$dispatcher =& JDispatcher::getInstance();

		foreach( $filters as $filter ) {

			$params = new JParameter( $filter->params);

			if(!in_array($cat_id, $params->get('ext_filter_category'))) continue;

			$filter->exec_params = $params;

			$out = '';
			JPluginHelper::importPlugin( 'joomsuite_content', 'filter_'.$filter->type );
			$dispatcher->trigger( 'onFilterRender', array ($out, $filter, $cat_id, $prm ) );

			if( $out ){
				$filter->result = $out;
				$result[] = $filter;
			}
		}

		return $result;
	}
	/*
	 function getFiltersForFiltering( $cat_id, $section_id )
	 {
		$filters = $this->getFilters();
		if(!$filters) return;

		$result = array();
		$result['left_joines'] = array();
		$result['wheres'] = array();

		$dispatcher =& JDispatcher::getInstance();

		foreach( $filters as $filter ) {

		$params = new JParameter( $filter->params, JPATH_ROOT.DS."plugins".DS."joomsuite_content".DS.$filter->type.".xml" );
		$filter->exec_params = $params;
		$catsbysections = $params->get( 'catsbysections');
		if( !is_array( $catsbysections ) ) {
		$catsbysections = array( $catsbysections );
		}

		if( ( RES_MODE && in_array( $section_id."_".$cat_id, $catsbysections ) ) || ( !RES_MODE && in_array( $section_id."_".$section_id, $catsbysections ) ) ) {
		JPluginHelper::importPlugin( 'joomsuite_content', 'filter_'.$filter->type );

		$dispatcher->trigger( 'onFilterBuildQuery', array ( &$left_joines, &$wheres, $filter ) );
		if( is_array( $left_joines ) && count( $left_joines ) ) {
		$result['left_joines'] = array_merge( $result['left_joines'], $left_joines );
		}
		if( is_array( $wheres ) && count( $wheres ) ) {
		$result['wheres'] = array_merge( $result['wheres'], $wheres );
		}

		}
		}
		return $result;
		}
		*/

	function _Query()
	{
		$orderby  = $this->_OrderBy();

		$query = '   SELECT f.*, g.name as groupname '
		.'     FROM #__js_res_filters AS f '
		.'LEFT JOIN #__groups AS g ON g.id = f.access WHERE 1'
		.$orderby

		;
		return $query;
	}





	function _OrderBy()
	{
		global $mainframe, $option;

		$filter_order      = $mainframe->getUserStateFromRequest( $option.'ext_filters.filter_order',      'ext_filter_order',     'f.ordering', 'cmd');
		$filter_order_Dir  = $mainframe->getUserStateFromRequest( $option.'ext_filters.filter_order_Dir',  'ext_filter_order_Dir', 'ASC',        'word');

		$orderby = '';
		if($filter_order && $filter_order_Dir) $orderby   = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;

		return $orderby;
	}
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_Query();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			if(!(int) $cid[$i]) continue;
			$row->load( (int) $cid[$i] );
			// track categories

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		$row->reorder();
		return true;
	}
	function move($direction)
	{
		$row =& $this->getTable();
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	function &getData()
	{
		if ( !$this->_loadData() ) $this->_initData();

		return $this->_data;
	}

	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	function _loadData()
	{
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__js_res_filters WHERE id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	function _initData()
	{
		if (empty($this->_data))
		{
			$field = new stdClass();

			$field->id               = 0;
			$field->title            = null;
			$field->type             = null;
			$field->params           = null;
			$field->published        = 1;
			$field->checked_out      = 0;
			$field->checked_out_time = 0;
			$field->ordering         = 0;
			$field->description      = null;
			$field->access           = 0;

			$this->_data          = $field;
			return (boolean) $this->_data;
		}
		return true;
	}
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			if (is_null($uid)) {
				$user  =& JFactory::getUser();
				$uid  = $user->get('id');
			}
			$field = & $this->getTable();
			if(!$field->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function store($data)
	{
		$row =& $this->getTable();

		if (!$row->bind($data)) {
			$this->setError($row->getError());
			return false;
		}

		if (!$row->check()) {
			$this->setError($row->getError());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$this->_id = $row->id;

		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$field = & $this->getTable();
			if(! $field->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
}