<?php
/**
 * $Id: rating.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport('joomla.application.component.model');

class ResModelRating extends JModel
{

	var $_data = null;


	var $_total = null;


	var $_pagination = null;


	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		$limit      = $mainframe->getUserStateFromRequest( 'global.list.limit',   'limit',      $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0,                                'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit',      $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData()
	{
		if (empty($this->_data)) {

			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function getTotal()
	{

		if (empty($this->_total)) {

			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{

		if (empty($this->_pagination)) {
			jimport( 'joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQuery()
	{

		global $mainframe, $option;

		$search           = $mainframe->getUserStateFromRequest( $option.'.rating.search',           'search',           '',           'string');
		$search           = JString::strtolower( $search );

		$where    = $this->_buildContentWhere();
		$orderby  = $this->_buildContentOrderBy();

		$query = ' SELECT a.*, u.username, u.id AS userid, u.email AS useremail, r.title AS recordtitle'
		. ' FROM #__js_res_vote AS a '
		. ' LEFT JOIN #__users                  AS u ON u.id = a.user_id '
		. ' LEFT JOIN #__js_res_record          AS r ON r.id = a.record_id '
		. ' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id ';
		
		if(substr($search, 0 , 8) == 'country:')
		{
			$query .= "\n LEFT JOIN #__js_ip_2_country AS i ON i.ip_from <= inet_aton(a.ip) AND i.ip_to >= inet_aton(a.ip)";
		}
		
		$query .= $where
		. ' GROUP BY a.id '
		. $orderby
		;



		return $query;
	}

	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest( $option.'.rating.filter_order',     'filter_order',     'a.ctime',  'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.rating.filter_order_Dir', 'filter_order_Dir', '',         'word');

		if ($filter_order == 'a.ctime'){
			$orderby   = ' ORDER BY a.ctime '.$filter_order_Dir;
		} else {
			$orderby   = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.ctime ';
		}

		return $orderby;
	}

	function _buildContentWhere()
	{
		global $mainframe, $option;
		$db =& JFactory::getDBO();

		$filter_catid     = $mainframe->getUserStateFromRequest( $option.'.rating.filter_catid',     'filter_catid',     0,            'int');
		$filter_vote      = $mainframe->getUserStateFromRequest( $option.'.rating.filter_vote',      'filter_vote',      0,            'int');
		$search           = $mainframe->getUserStateFromRequest( $option.'.rating.search',           'search',           '',           'string');
		$search           = JString::strtolower( $search );

		$where = array();

		if ( $filter_catid > 0) {
			$where[] = 'c.catid = '.(int) $filter_catid;
		}

		if ( $filter_vote ) {
			$where[] = 'ROUND(a.vote/10)*10 = '.(int) $filter_vote;
		}

		if ( $search ) {
			if(substr($search, 0 , 8) == 'country:')
			{
				$code = strtoupper(substr($search, 8 , 11));
				$where[] = "i.code = '{$code}' ";
			}
			else
			{
				$w[] = implode( " LIKE '%".$search."%' OR ", array( 'r.title', 'u.username', 'u.name', 'u.email', 'a.ip' ))." LIKE '%".$search."%' ";
				$w[] = implode( " = '".$search."' OR ",      array(  'r.id', 'u.id' ) ) . " = '".$search."' ";
				$where[] = '('. implode( ' OR ', $w ) .')';
			}
		}

		$where     = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '');

		return $where;
	}

	function _deleteVote()
	{
		$db =& JFactory::getDBO();
		
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		$lmodel = & JModel::getInstance('List', 'ResModel');
		$model = & JModel::getInstance('Article', 'ResModel');
		
		$cid = Jrequest::getVar( 'cid');
		
		foreach ($cid as $id) {
			
			$sql = 'SELECT record_id FROM #__js_res_vote WHERE id = '.$id;
			$db->setQuery($sql);
			$result = $db->loadObject();
			$article = $result->record_id;
		
			$model->_id = $article;
			$article = $model->getRecord();
			$section_id = ResHelper::getArticleSection($article->id);
			$params = ResHelper::initListParams($section_id);
			$iparams = ResHelper::initArticleParams($article->type_id);
			$params->merge($iparams);
			$now = ResHelper::getDate();
			
			$query = 'DELETE FROM #__js_res_vote WHERE id = '.$id;

			$db->setQuery($query);
			$db->query();
			
			switch ($params->get('rate_smart'))
			{
				case 2:
					$votes = $lmodel->getAverage($section_id, $params);
					$sql = "SELECT COUNT(*) AS total, ((".$votes['avg_num_vote']." * ".$votes['avg_vote'].") + (COUNT(vote) * AVG(vote))) / (".$votes['avg_num_vote']." + COUNT(vote)) AS rating FROM #__js_res_vote WHERE  record_id = {$article->id} GROUP BY record_id";
					break;
				case 3:
					$sql = 	"SELECT COUNT(*) AS total, if(count(id) >= ".$params->get('rate_smart_minimum').", sum(vote) / count(id), 0) AS rating FROM ".
										"#__js_res_vote WHERE record_id = {$article->id} AND ctime > '{$now}' - INTERVAL ".$params->get('rate_smart_before')." DAY GROUP BY record_id";
					break;
				default:
					$sql = 	"SELECT COUNT(*) AS total, SUM(vote) / COUNT(*) AS rating FROM ".
										"#__js_res_vote WHERE record_id = {$article->id} GROUP BY record_id";
					break;
			}
			$db->setQuery($sql);
			$rating = $db->loadObject();
		
			$sql = "UPDATE #__js_res_record SET votes_result = ".(int)$rating->rating.",  votes = ".(int)$rating->total."  WHERE id = {$article->id}";
			$db->setQuery($sql);
			$db->query();

		}

		
	}
}
