<?php
/**
 * $Id: record.php 7767 2012-01-26 09:04:54Z kostya $
 * $LastChangedDate: 2012-01-26 15:04:54 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');
jimport('joomla.application.component.model');
require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

class ResModelRecord extends JModel
{
	var $_id = null;
	var $_data = null;
	var $_fields = null;
	/**
	 * Class constructor
	 */
	function __construct()
	{
		global $mainframe, $option;
		parent::__construct();

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int');
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order',		'filter_order',		'r.ctime',	'var');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order_Dir',	'filter_order_Dir',	'DESC',		'word');


		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit	= JRequest::getVar('edit',true);
		if($edit)
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Get list of the authors of the article. It returns list of the
	 * users who have Joomla rights to post articles and current author
	 * even if it is simple registered user
	 *
	 * @param integer $id Id of the user to add to list
	 * @param string $order ordering mode
	 * @return string Html element <SELECT> ready to use
	 */
	function getAuthor( $id, $order = 'name' )
	{
		$db =& JFactory::getDBO();

		$and[] = "usertype = 'Manager'";
		$and[] = "usertype = 'Administrator'";
		$and[] = "usertype = 'Super Administrator'";
		$and[] = "usertype = 'Author'";
		$and[] = "usertype = 'Publisher'";
		$and[] = "usertype = 'Editor'";
		if($id) $and[] = "id = {$id}";

		$add = ' AND ('.implode(' OR ', $and).')';
		$query = 'SELECT id AS value, name AS text'
		. ' FROM #__users'
		. ' WHERE block = 0'
		. $add
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query );

		$users = $db->loadObjectList();
		if(!$users) $users = array();
		array_unshift($users, JHTML::_('select.option', '0', '- ' . JText::_('No User') . ' -'));

		$users = JHTML::_('select.genericlist', $users, 'user_id', 'class="inputbox" size="1" ', 'value', 'text', $id );

		return $users;
	}

	function &getRecord()
	{
		// Load the weblink data
		if (!$this->_loadData())
		{
			$this->_initData();
		}

		return $this->_data;
	}
	function getTypes()
	{
		$query = "Select id as value, name as text, description FROM #__js_res_types WHERE published = 1";
		return  $this->_getList($query);
	}

	function getTypeName($id)
	{
		$query = "Select name FROM #__js_res_types WHERE id = $id";
		$this->_db->setQuery($query);
		return $this->_db->loadResult();

	}
	function getClients()
	{
		$query = "Select DISTINCT client AS text, client AS value FROM #__js_res_record";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();

	}
	function getRecords()
	{
		if (empty($this->_data))
		{
			$query = $this->_recordsQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		//print $query.'<br>';
		return $this->_data;
	}
	function _recordsQuery()
	{
		global $mainframe, $option;

		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string');
		$search				= JString::strtolower( $search );

		$where		= $this->_recordsWhere();
		$orderby	= $this->_recordsOrderBy();

		$query = ' SELECT r.*, g.name as groupname, t.name as type_name, r.ordering, uu.name as editor,
                  u.email, u.name AS author, u.id AS author_id, GROUP_CONCAT(DISTINCT c.id) as catid, GROUP_CONCAT(DISTINCT c.name SEPARATOR ":#:") as category'
                  . ' FROM #__js_res_record AS r '
                  . ' LEFT JOIN #__users AS u ON u.id = r.user_id '
                  . ' LEFT JOIN #__users AS uu ON uu.id = r.checked_out '
                  . " LEFT JOIN #__groups AS g ON g.id = r.access "
                  . " LEFT JOIN #__js_res_types AS t ON t.id = r.type_id "
                  . " LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id "
                  . ' LEFT JOIN #__js_res_category 	AS c ON c.id = rc.catid ';
                  if(substr($search, 0 , 8) == 'country:')
                  {
                  	$query .= "\n LEFT JOIN #__js_ip_2_country AS i ON i.ip_from <= inet_aton(r.ip) AND i.ip_to >= inet_aton(r.ip)";
                  }

                  $query .= $where
                  . ' GROUP BY r.id'
                  . $orderby
                  ;
                  //echo $query;
                  return $query;
	}
	function _recordsOrderBy()
	{
		global $mainframe, $option;

		$filter_order	    = $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order',	'filter_order',	'r.ctime', 'var');
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order_dir','filter_order_Dir',	'DESC',	'word');
		//echo $filter_order = 'r.ctime';
		//echo $filter_order_Dir;
		//exit();
		$orderby = '';
		if($filter_order == 'j.ordering') $filter_order = 'r.ctime';
		if($filter_order == 'a.ctime') $filter_order = 'r.ctime';
		if($filter_order && $filter_order_Dir) $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		//echo $orderby;
		return $orderby;
	}
	function _recordsWhere()
	{
		global $mainframe, $option;
		
		$now = ResHelper::getDate();

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_state',	'filter_state',	'',	'word');
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_catid',	'filter_catid',	0,	'int');
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_type',	'filter_type',	0,	'int');
		$filter_clients		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_clients',	'filter_clients',	'resource',	'var');
		$filter_status		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_status','filter_status', 0,'var');
		
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string');
		$search				= JString::strtolower( $search );

		$where = array();
		
		if($filter_status == 1)
		{
			$where[] = 'r.featured = 1';
		}
		if($filter_status == 2)
		{
			$where[] = '(r.extime != \'0000-00-00 00:00:00\' AND  r.extime < \''.$now.'\')';
		}

		if ($filter_type > 0) {
			$where[] = 'r.type_id = '.(int) $filter_type;
		}
		if ($filter_clients) {
			$where[] = 'r.client = \''.$filter_clients."'";
		}
		if ($filter_catid > 0) {
			$where[] = 'rc.catid = '.(int) $filter_catid;
		}
		if ($search) {

			if(substr($search, 0 , 8) == 'country:')
			{
				$code = strtoupper(substr($search, 8 , 11));
				$where[] = "i.code = '{$code}' ";
			}
			else
			{
				$search = str_replace('@', '\@', $search);
					

				$search = $this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );

				$w[] = "LOWER(r.title) LIKE $search";
				$w[] = "u.name LIKE $search";
				$w[] = "u.username LIKE $search";
				$w[] = "u.email LIKE $search";
				$w[] = "r.ip LIKE $search";
				if((int)$search > 0) $w[] = 'r.id = '.$search;

				$where[] = '('.implode(' OR ', $w).')';
			}
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'r.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'r.published = 0';
			} else if ($filter_state == 'A' ) {
				$where[] = 'r.published = -1';
			}
		}

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '');

		//echo $where;
		return $where;
	}

	function _getCategories($parent = 0, $level = 0)
	{
		$db = & JFactory::getDBO();
		$sql = "select id AS value, concat('".str_repeat('&nbsp;&nbsp;&nbsp;- ', $level)."',name) as text
		FROM #__js_res_category WHERE parent = $parent ORDER BY ordering";
		$db->setQuery($sql);
		$res = $db->loadObjectList();
		if($res)
		{
			foreach ($res AS $r)
			{
				$out[] = JHTML::_('select.option', $r->value, $r->text);
				//echo $r->parent;
				$add = $this->_getCategories($r->value, $level + 1);
				if(is_array($add)) $out = array_merge($out, $add);
			}
		}
		else
		{
			return false;
		}
		return  $out;

	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_recordsQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	/**
	 * Get list f fields based on record. This is user to buid form.
	 *
	 * @param obect $record
	 * @return array
	 */
	function getFields($record)
	{
		static $fields = array();

		if(!@$fields[$record->id])
		{
			$sql  = " SELECT f.`id`, ".$record->id." AS record_id, f.access, f.`type_id`, f.`searchable`,
			f.`type`, f.`params`, f.`title`, f.`filter`,
				v.`field_value`, v.`params` AS fparams FROM #__js_res_fields AS f ";
			$sql .= " LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id
				AND v.record_id = ".$record->id;
			$sql .= " WHERE f.type_id = ".$record->type_id;
			$sql .= " AND f.published > 0 ";
			$sql .= " GROUP BY f.id ";
			$sql .= " ORDER BY f.ordering ASC ";

			$fields[$record->id] = $this->_getList($sql);
		}
		return  $fields[$record->id];
	}

	/**
	 * Fet list of fields based on type_id
	 *
	 * @param integer $type_id
	 * @return array
	 */
	function getTypeFields($type_id)
	{
		$sql  = " SELECT f.`id`, '1=1' AS fparams, '' As field_value, f.access, f.`type_id`, f.`type`, f.`params`, f.`title` FROM #__js_res_fields AS f ";
		$sql .= " WHERE f.type_id = ".$type_id;
		$sql .= " AND f.published > 0 ";
		$sql .= " GROUP BY f.id ";
		$sql .= " ORDER BY f.ordering ASC ";
		return  $this->_getList($sql);
	}
	/**
	 * Tests if weblink is checked out
	 *
	 * @access	public
	 * @param	int	A user id
	 * @return	boolean	True if checked out
	 * @since	1.5
	 */
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	/**
	 * Method to checkin/unlock the weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function checkin()
	{
		if ($this->_id)
		{
			$record = & $this->getTable('record','Res');
			if(! $record->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	/**
	 * Method to checkout/lock the weblink
	 *
	 * @access	public
	 * @param	int	$uid	User ID of the user checking the article out
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$record = & $this->getTable('record','Res');
			if(!$record->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}

	function getTags($id = 0)
	{
		$this->_db->setQuery('SET group_concat_max_len = 8096');
		$this->_db->query();
		$sql = "SELECT GROUP_CONCAT(DISTINCT t.tag ORDER BY t.ctime ASC SEPARATOR ', ') as tagname  FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_tags AS t ON t.id = h.tag_id
		WHERE h.record_id = {$id}";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	/**
	 * Method to store the Record
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function store($data, $ignore = array())
	{
		global $mainframe;

		$row =& $this->getTable('record','Res');
		$user = & JFactory::getUser();

		if($data['id']) $row->load($data['id']);
		
		if($row->id && ($row->user_id != $data['user_id']))
		{
			$dispatcher =& JDispatcher::getInstance();
			JPluginHelper::importPlugin('joomsuite_content_fields');
			$dispatcher->trigger('onArticleAuthorChange', array(array($row), $data['user_id']));
		}

		$add = array();
		if(!$mainframe->isAdmin())
		{
			$add = array('ip','archive','hits','params','alias','votes','votes_result','favorite_num','mtime');
			if(!(($user->get('aid') > 1) && $user->get('gid') >= 23))
			{
				$add2 = array('featured', 'user_id');
				$add = array_merge($add, $add2);
			}
		}
		
		$ignore = array_merge($ignore, $add);
		

		if (!$row->bind($data, $ignore)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		

		//echo $data['access']; exit;
		if(count($data['categories']) <= 0)
		{
			$this->setError("No category selected");
			return false;
		}
		
		JArrayHelper::toInteger($data['categories']);
		
		$sql = "SELECT id, name FROM #__js_res_category WHERE id IN (".implode(',', $data['categories']).") ";
		$this->_db->setQuery( $sql );
		$record_categories = $this->_db->loadObjectList();
		foreach ($record_categories AS $category)
		{
			$store_categories[$category->id] = $category->name;
		}
		
		$row->categories = serialize($store_categories);
		// Create the timestamp for the date
		//$row->date = gmdate('Y-m-d H:i:s');

		// if new item, order last in appropriate group
		$is_new = false;
		if (!$row->id) {
			//$where = 'catid = ' . (int) $row->catid ;
			$row->ordering = $row->getNextOrder();
			$is_new = true;
		}

		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError( $row->getError() );
			return false;
		}

		// Store the web link table to the database

		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		//MECache::delete($row->id, 'record');
		$this->id = $row->id;
		$this->published = $row->published;
		$this->user_id = $row->user_id;
		$this->ucatid = $row->ucatid;
		$this->client = $row->client;
		$this->client_id = $row->client_id;


		// Save Categories


		$new_categories = implode(',', $data['categories']);
		$sql = "DELETE FROM #__js_res_record_category WHERE record_id = ".$row->id;
		$sql .= " AND catid NOT IN ({$new_categories})";

		$this->_db->setQuery( $sql );
		$this->_db->query();

		
		foreach($data['categories'] AS $categ)
		{
			$sql = "SELECT id FROM #__js_res_record_category WHERE record_id = ".$row->id. " AND catid = '{$categ}'";
			$this->_db->setQuery( $sql );
			$res = $this->_db->loadResult();
			if($res)
			{
				$sql = "UPDATE #__js_res_record_category SET record_id = {$row->id}, catid = '{$categ}' WHERE id = {$res}";
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
			else
			{
				$sql = "INSERT INTO  #__js_res_record_category (record_id, catid) VALUES ('{$row->id}', '{$categ}')";
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
		}
		

		$section_id = ResHelper::getCategorySection($data['categories'][0]);

		//jsRecalculationCategoryItemsNum( array( $section_id ) );

		// Save Tags

		if( isset( $data['tags'] ) ) {
			$tags = explode(",", $data['tags']);
		} else {
			$tags = Array();
		}

		$sql = "DELETE FROM #__js_res_tags_history WHERE user_id = ".(int)$row->user_id." AND record_id = {$row->id} AND section_id = {$section_id}";
		$this->_db->setQuery($sql);
		$this->_db->query($sql);
		foreach ($tags AS $tag)
		{
			$tag = JFilterOutput::cleanText($tag);
			$tag = trim($tag);

			if($tag == '') continue;

			$sql = "SELECT id FROM #__js_res_tags WHERE LOWER(`tag`) = '".JString::strtolower($tag)."'";
			//$sql = "SELECT id FROM #__js_res_tags WHERE LOWER(`tag`) = '".($tag)."'";
			$this->_db->setQuery($sql);
			$tid = $this->_db->loadResult();

			if(!$tid) {
				$slug = aliasConverter(JString::strtolower($tag));
				$slug = JString::strtolower(JString::str_ireplace(Array(" ", "--"), "-", $slug));
				$sql = "INSERT INTO #__js_res_tags VALUES(NULL, '$tag', NOW(), '$slug')";
				$this->_db->setQuery($sql);
				$this->_db->query($sql);
				$tid = $this->_db->insertid();
			}
			$sql = "INSERT INTO #__js_res_tags_history VALUES (NULL, {$row->id}, {$tid}, {$row->user_id}, NOW(), {$section_id}, 0)";
			$this->_db->setQuery($sql);
			$this->_db->query($sql);
		}
		//echo $data['tags']; exit;



		$fields = $this->getFields($row);
		//$addiional = $data['fields'];
		global $mainframe;
		
		$sql = "DELETE FROM #__js_res_category_filters WHERE record_id = {$row->id}";
		$this->_db->setQuery($sql);
		$this->_db->query();

		$fields_to_store = array();
		foreach ($fields AS $field)
		{
			$sql = false;//if(!$value) continue;
			$id = $field->id;

			$params = new JParameter($field->params); // ResHelper::getFieldParams($id, );
			$type   = $field->type; //ResHelper::getFieldType($id);
			$value = @$data['fields'][$id];
			
			$dispatcher    =& JDispatcher::getInstance();
			JPluginHelper::importPlugin('joomsuite_content_fields');
			$result = $dispatcher->trigger('onBeforeSave', array (&$value, &$params, $type, $id, $row, &$error) );
			
			foreach ($result AS $fparams)
			{
			    if($fparams)
			    {
			        if(is_array($fparams))
			        {
			            $fparams = serialize($fparams);
			        }
			        break;
			    }
			}
			//JArrayHelper::toString($result);
			//$result = array_flip($result);
			//$result = array_flip($result);
			//$result = array_values($result);
			//$fparams = $result[0];
			//var_dump($fparams);
			//exit;

			if( !$value && $params->get( "frequired" ) ){
				$error = JText::sprintf( "Field %s is required.", $field->title );
			}

			if( $error ) {
				if( $mainframe->isAdmin() ) {
					JRequest::setVar( 'task', 'apply');
				} else {
					if( JRequest::getInt( 'isNew' ) ){
						$row->delete();
					}
					$this->setError( $error );
					return;
				}
			}
			
			if($field->searchable)
			{
				$fields_to_store[$field->id] = $value; 
			}

			$sql = "SELECT id FROM #__js_res_record_values WHERE record_id = {$row->id} AND field_id = {$id}";
			$this->_db->setQuery($sql);
			$rid = $this->_db->loadResult();

			if($rid)
			{
				if(!$value) {
					$sql = "DELETE FROM #__js_res_record_values WHERE record_id = {$row->id} AND field_id = {$id}";
					$this->_db->setQuery($sql);
					$this->_db->query();
				} else {
					$record_value =& $this->getTable('record_values','Res');
					$record_value->bind( array('id'=>$rid, 'field_value'=>$value, 'record_id'=>$row->id, 'field_id'=>$id, 'params'=>$fparams  )  );
					$record_value->store();
				}
			}
			else
			{
				if($value) {
					$record_value =& $this->getTable('record_values','Res');
					$record_value->bind( array( null, 'field_value'=>$value, 'record_id'=>$row->id, 'field_id'=>$id, 'params'=>$fparams )  );
					$record_value->store();
				}
			}
			if($field->filter == 1)
			{
				foreach ($data['categories'] AS $category_id)
				{
					$sql = "INSERT INTO `#__js_res_category_filters` (`id`, `field_id`, `category_id`, `record_id`) VALUES (
							NULL,{$field->id}, {$category_id}, {$row->id});";
					$this->_db->setQuery($sql);
					$this->_db->query();
				}
			}
			//if($sql) $this->_db->setQuery($sql);
			//if($sql) $this->_db->query();
		}
		
		
		
		$fields_data = $this->_db->getEscaped(serialize($fields_to_store));
		$fields_data = serialize($fields_to_store);
		
		$sql = "UPDATE #__js_res_record SET fieldsdata = '$fields_data' WHERE id = $row->id";
		$this->_db->setQuery($sql);
		$this->_db->query();
		
		// add count to Member user subscritpion if submit protected by subscription.
		$tparams = ResHelper::initArticleParams($row->type_id);
		if($tparams->get('type_submit_subscription') && $is_new)
		{
			jscCountLimit($tparams->get('type_submit_subscription'), $tparams->get('type_submit_subscription_count'));
		}
		if($tparams->get('type_edit_subscription') && !$is_new)
		{
			jscCountLimit($tparams->get('type_edit_subscription'), $tparams->get('type_edit_subscription_count'));
		}
		return true;
	}

	function delete($cid = array())
	{
		$result = false;

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__js_res_record'
			. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__js_res_record'
			. ' SET published = '.(int) $publish
			. ' WHERE id IN ( '.$cids.' )'
			. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			//echo $query; exit;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}



	function getOrder($record_id, $catid)
	{
//		$query = 'SELECT ordering FROM #__js_res_record_category '
//		. " WHERE catid = '{$catid}' AND record_id = '{$record_id}'";
		$query = 'SELECT ordering FROM #__js_res_record '
		. " WHERE id = '{$record_id}'";
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
	function updateOrder($record_id, $catid, $neworder)
	{
//		$query = 'UPDATE #__js_res_record_category SET ordering = ' .$neworder
//		. " WHERE catid = '{$catid}' AND record_id = '{$record_id}'";
		$query = 'UPDATE #__js_res_record SET ordering = ' .$neworder
		. " WHERE id = '{$record_id}'";
		$this->_db->setQuery($query);
		$this->_db->query();
		echo $query;
	}
	function updateOrder2($record_id, $catid, $neworder)
	{
		$order = $this->getOrder($record_id, $catid);

		$neworder = $order + $neworder;

		$query = 'UPDATE #__js_res_record_category SET ordering = ' .$neworder.', otime = NOW() '
		. " WHERE catid = '{$catid}' AND record_id = '{$record_id}'";
		$this->_db->setQuery($query);
		$this->_db->query();
		//echo $query;
	}

	function saveorder($catid, $cid = array(), $order, $clients)
	{
		$row =& $this->getTable('record', 'Res');

		for( $i=0; $i < count($cid); $i++ )
		{
			$rorder = $this->getOrder($cid[$i], $catid);
//			echo $order. '-' .$order[$i].'-'.$i.'<br>';
			if ($rorder != $order[$i])
			{
				$this->updateOrder($cid[$i], $catid, $order[$i]);
			}
		}
		$row->reorder($catid, $clients);
		return true;
	}

	function move($direction, $catid, $clients)
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		//print_r($order);
		//print_r($cid);

		$row =& $this->getTable('record','Res');
		$this->updateOrder2($cid[0], $catid, $direction);
		/*
		 $row =& $this->getTable('record','Res');
		 if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
			}

			if (!$row->move( $direction, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
			}
			*/
		$row->reorder($catid, $clients, ', rc.otime '.($direction == 1 ? 'ASC' : 'DESC'));
		return true;
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT r.*, t.name as type_name '.
			' FROM #__js_res_record AS r' .
			' LEFT JOIN #__js_res_types AS t ON t.id = r.type_id' .
			' WHERE r.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			//echo $this->_db->_sql;
			return (boolean) $this->_data;
		}
		return true;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$user = & JFactory::getUser();
			$record = new stdClass();
			$record->id					= 0;
			$record->published			= 1;
			$record->ctime				= null;
			$record->title				= null;
			$record->access             = 0;
			$record->extime				= null;
			$record->type_id			= 0;
			$record->user_id			= $user->get('id');
			$record->hits				= 0;
			$record->checked_out		= 0;
			$record->checked_out_time	= 0;
			$record->ordering			= 0;
			$record->archived			= 0;
			$record->params				= null;
			$record->meta_descr			= null;
			$record->meta_key			= null;
			$record->featured			= null;
			$record->archive			= null;
			$record->ucatid				= 0;
			$record->langs				= null;
			$record->alias				= null;
			$record->client				= 'resource';
			$record->client_id			= 0;
			$record->ip			= '';
			$this->_data				= $record;
			return (boolean) $this->_data;
		}
		return true;
	}
}
?>
