<?php
/**
 * $Id: subtmplscopyrename.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model');
jimport( 'joomla.filesystem.file');

class ResModelSubtmplscopyrename extends JModel
{
	/** @var object JTable object */
	var $_table = null;

	/** @var object JTable object */
	var $_url = null;

	/**
	 * Overridden constructor
	 * @access  protected
	 */
	function __construct()
	{
		parent::__construct();


	}
	function change_name($file, $new_name)
	{
		$xmlFile = new JSimpleXML();
		if (!$xmlFile->loadFile($file))	{
			JError::raiseNotice(403, JText::_('Cannot load file'));
			return;
		}

		foreach ($xmlFile->document->_children as $k => $child)
		{
			if($child->_name == 'name')
			{
				$xmlFile->document->_children[$k]->_data = $new_name;
				//$child->_data = $new_name;
			}
		}
		JFile::write($file, $xmlFile->document->toString());

	}

	function rename( $tmpl, $new_name )
	{
		global $mainframe;

		$new_name = strtolower($new_name);

		$matches = array();

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

		$layouts_path = subTemplate::getTmplPath( $matches[2] );

		switch( $matches[2] ){
			case 'user_menu':
				$index_file_name    = "default_menu_".$new_name.".xml";
				$folder    			= "default_menu_".$new_name;
				$file_filter        = "^default_menu_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_menu_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'category':
				$index_file_name    = "default_cindex_".$new_name.".xml";
				$folder    			= "default_cindex_".$new_name;
				$file_filter        = "^default_cindex_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_cindex_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'itemlist':
				$index_file_name    = "default_subtmpl_".$new_name.".xml";
				$folder    			= "default_subtmpl_".$new_name;
				$file_filter        = "^default_subtmpl_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_subtmpl_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'filters':
				$index_file_name    = "default_filters_".$new_name.".xml";
				$folder    			= "default_filters_".$new_name;
				$file_filter        = "^default_filters_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_filters_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'comments':
				$index_file_name    = "default_comments_".$new_name.".xml";
				$folder    			= "default_comments_".$new_name;
				$file_filter        = "^default_comments_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_comments_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'article':
				$index_file_name    = "default_article_".$new_name.".xml";
				$folder    			= "default_article_".$new_name;
				$file_filter        = "^default_article_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_article_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'articleform':
				$index_file_name    = "form_articleform_".$new_name.".xml";
				$folder    			= "form_articleform_".$new_name;
				$file_filter        = "^form_articleform_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(form_articleform_).*(\..{2,3})$/", "\\1".$new_name."\\2" );
				break;
			case 'rating':
				$index_file_name       = "rating_".$new_name.".xml";
				$file_filter           = "^rating_".$matches[1]."\..{3}$";
				$folder_filter         = "^".$matches[1]."_img$";
				$file_new_ratig_name   = Array( "/^(rating_).*(\..{3})$/", "\\1".$new_name."\\2" );
				$folder_new_ratig_name = Array( "/^.*(_img)$/", $new_name."\\1" );
				break;
		}
			
		if( JFile::exists($layouts_path.DS.$index_file_name) ){
			JError::raiseWarning( 500, JText::_('Can`t rename template. This name already exist.') );
			return false;
		}


		switch( $matches[2] ){
			case 'itemlist':
			case 'user_menu':
			case 'filters':
			case 'category':
			case 'comments':
			case 'article':
			case 'articleform':
				$files = JFolder::files( $layouts_path, $file_filter );

				foreach( $files as $file ){
					JFile::move($layouts_path.DS.$file, $layouts_path.DS.preg_replace ($file_new_tmpl_name[0], $file_new_tmpl_name[1], $file ) );
				}

				if(JFolder::exists($layouts_path.DS.str_replace($new_name, $matches[1], $folder)))
				{
					JFolder::move($layouts_path.DS.str_replace($new_name, $matches[1], $folder), $layouts_path.DS.$folder);
				}

				break;
			case 'rating':

				$files   = JFolder::files( $layouts_path, $file_filter );
				foreach( $files as $file ){
					JFile::move( $layouts_path.DS.$file, $layouts_path.DS.preg_replace ( $file_new_ratig_name[0], $file_new_ratig_name[1], $file ) );
				}

				$folders = JFolder::folders( $layouts_path, $folder_filter );
				foreach( $folders as $folder ){
					JFolder::move( $layouts_path.DS.$folder, $layouts_path.DS.preg_replace ( $folder_new_ratig_name[0], $folder_new_ratig_name[1], $folder ) );
				}

				break;
		}
		return true;
	}

	function copy( $tmpl, $new_name )
	{
		global $mainframe;

		$new_name = strtolower($new_name);
		$new_name = ereg_replace("^[^a-z\-\_]$", "", $new_name);

		$matches = array();

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

		$layouts_path = subTemplate::getTmplPath( $matches[2] );
			
		switch( $matches[2] ){
			case 'user_menu':
				$index_file_name    = "default_menu_%s.xml";
				$folder    			= "default_menu_".$new_name;
				$file_filter        = "^default_menu_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_menu_).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'itemlist':
				$index_file_name    = "default_subtmpl_%s.xml";
				$folder    			= "default_subtmpl_".$new_name;
				$file_filter        = "^default_subtmpl_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_subtmpl).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'filters':
				$index_file_name    = "default_filters_%s.xml";
				$folder    			= "default_filters_".$new_name;
				$file_filter        = "^default_filters_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_filters).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'category':
				$index_file_name    = "default_cindex_%s.xml";
				$folder    			= "default_cindex_".$new_name;
				$file_filter        = "^default_cindex_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_cindex).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'comments':
				$index_file_name    = "default_comments_%s.xml";
				$folder    			= "default_comments_".$new_name;
				$file_filter        = "^default_comments_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_comments).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'article':
				$index_file_name    = "default_article_%s.xml";
				$folder    			= "default_article_".$new_name;
				$file_filter        = "^default_article_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(default_article).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'articleform':
				$index_file_name    = "form_articleform_%s.xml";
				$folder    			= "form_articleform_".$new_name;
				$file_filter        = "^form_articleform_".$matches[1]."\..{2,3}$";
				$file_new_tmpl_name = Array( "/^(form_articleform).*(\..{2,3})$/", "\\1_%s\\2" );
				break;
			case 'rating':
				$index_file_name       = "rating_%s.php";
				$file_filter           = "^rating_".$matches[1]."\..{3}$";
				$folder_filter         = "^".$matches[1]."_img$";
				$file_new_ratig_name   = Array( "/^(rating).*(\..{3})$/", "\\1_%s\\2" );
				$folder_new_ratig_name = Array( "/^.*(_img)$/", "%s\\1" );
				break;
		}

		switch( $matches[2] ){
			case 'user_menu':
			case 'itemlist':
			case 'filters':
			case 'category':
			case 'comments':
			case 'article':
			case 'articleform':
				if( !$new_name ){
					$new_name = $matches[1].'_copy';
					while( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name) ) ) {
						JError::raiseWarning( 500, JText::_('Can`t copy template. This name already exist.') );
						$new_name = $new_name.'_copy';
					}
				} else if( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name)) ) {
					JError::raiseWarning( 500, JText::_('Can`t copy template. This name already exist.') );
					return false;
				}

				$files = JFolder::files( $layouts_path, $file_filter );

				foreach( $files as $file ){
					$original_file = $layouts_path.DS.$file;
					$new_file      = $layouts_path.DS.preg_replace ($file_new_tmpl_name[0], sprintf($file_new_tmpl_name[1], $new_name), $file );
					//var_dump( sprintf($file_new_tmpl_name[1], $new_name));print'<br>';
					JFile::copy($original_file, $new_file);
					//var_dump( $original_file);print'<br>';
					//var_dump( $new_file);print'<br>';print'<br>';
				}
				if(JFolder::exists($layouts_path.DS.str_replace($new_name, $matches[1], $folder)))
				{
					JFolder::copy($layouts_path.DS.str_replace($new_name, $matches[1], $folder), $layouts_path.DS.$folder);
				}
				break;
			case 'rating':
				if( !$new_name ){
					$new_name = $matches[1].'_copy';
					while( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name) ) ) {
						JError::raiseWarning( 500, JText::_('Can`t copy template. This name already exist.') );
						$new_name = $new_name.'_copy';
					}
				} else if( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name)) ) {
					JError::raiseWarning( 500, JText::_('Can`t copy rating template. This name already exist.') );
					return false;
				}

				$files   = JFolder::files( $layouts_path, $file_filter );
				foreach( $files as $file ){
					JFile::copy( $layouts_path.DS.$file, $layouts_path.DS.preg_replace ( $file_new_ratig_name[0], sprintf($file_new_ratig_name[1], $new_name), $file ) );
				}

				$folders = JFolder::folders( $layouts_path, $folder_filter );
				foreach( $folders as $folder ){
					JFolder::copy( $layouts_path.DS.$folder, $layouts_path.DS.preg_replace ( $folder_new_ratig_name[0], sprintf($folder_new_ratig_name[1], $new_name), $folder ) );
				}
				break;
		}
		return true;
	}

}