<?php
/**
 * $Id: subtmplsinstall.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model');
jimport( 'joomla.installer.installer');
jimport( 'joomla.installer.helper');

class ResModelSubtmplsinstall extends JModel
{

	function __construct()
	{
		parent::__construct();
	}

	function install()
	{
		global $mainframe;

		$package = $this->_getPackageFromUpload();
		// Was the package unpacked?
		if ( !$package ) {
			$this->setState( 'message', JText::_('Unable to find install package' ) );
			return false;
		}
		$tmpl_types = subTemplate::getTmplTypes();

		$this->installFoundTemplates($package, $tmpl_types);

		JFolder::delete($package);

		return true;
	}

	function installFoundTemplates( $package, $types )
	{

		foreach( $types as $type ) {
			$mask = subTemplate::getTmplMask( $type );

			$files = JFolder::files( $package, $masks['index_file'], false, true );

			if($files)
			{
				foreach( $files as $file ) {
					JFile::copy( $file, subTemplate::getTmplPath( $type ).strrchr($file, DS) );
				}
			}
			if( isset( $mask['folder'] ) ) {
				$folders = JFolder::folders( $package, $mask['folder'], false, true );
				if($folders)
				{
					foreach( $folders as $folder ) {
						JFolder::copy( $folder, subTemplate::getTmplPath( $type ).strrchr($folder, DS), '', true );
					}
				}
			}


		}
	}

	function _getPackageFromUpload()
	{
		// Get the uploaded file information
		$userfile = JRequest::getVar('install_package', null, 'files', 'array');

		// Make sure that file uploads are enabled in php
		if (!(bool) ini_get('file_uploads')) {
			JError::raiseWarning(403, JText::_('The installer cannot continue until file uploads are enabled for the server.'));
			return false;
		}

		// Make sure that zlib is loaded so that the package can be unpacked
		if (!extension_loaded('zlib')) {
			JError::raiseWarning(403, JText::_('The installer cannot continue until Zlib is installed.'));
			return false;
		}

		// If there is no uploaded file, we have a problem...
		if (!is_array($userfile) ) {
			JError::raiseWarning(403, JText::_('No file selected'));
			return false;
		}

		// Check if there was a problem uploading the file.
		if ( $userfile['error'] || $userfile['size'] < 1 )
		{
			JError::raiseWarning(403, JText::_('There was an error uploading this file to the server.'));
			return false;
		}

		// Build the appropriate paths
		$config =& JFactory::getConfig();
		$tmp_dest 	= $config->getValue('config.tmp_path').DS.$userfile['name'];
		$tmp_src	= $userfile['tmp_name'];

		// Move uploaded file
		jimport('joomla.filesystem.file');

		if( !JFile::upload( $tmp_src, $tmp_dest ) ) {
			return false;
		}



		// Unpack the downloaded package file
		$package = $this->unpack($tmp_dest);

		return $package;
	}
	function unpack($p_filename)
	{
		$archivename = $p_filename;

		$tmpdir = uniqid('install_');
		$extractdir = JPath::clean(dirname($p_filename).DS.$tmpdir);
		$archivename = JPath::clean($archivename);


		jimport('joomla.filesystem.archive');

		// do the unpacking of the archive
		$result = JArchive::extract( $archivename, $extractdir);

		if ( $result === false ) {
			return false;
		}
		JFile::delete($archivename);
		return $extractdir;
	}
}