<?php
/**
 * $Id: tag.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport('joomla.application.component.model');

class ResModelTag extends JModel
{
  var $_item       = null;
  var $_data       = null;
  var $_total      = null;
  var $_pagination = null;


  function __construct()
  {
    parent::__construct();

    global $mainframe, $option;

    $limit      = $mainframe->getUserStateFromRequest( 'global.list.limit',   'limit',      $mainframe->getCfg('list_limit'), 'int');
    $limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0,                                'int');

    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    $this->setState('limit',      $limit);
    $this->setState('limitstart', $limitstart);
  }

  function getData()
  {
    if (empty($this->_data)) {

      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_data;
  }

  function getItem()
  {
    if (empty($this->_item)) {

      $id = JRequest::getInt('id');
      
      $query = $query = ' SELECT a.* FROM #__js_res_tags AS a WHERE a.id = '.$id;
      $this->_item = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
      $this->_item = $this->_item[0];
    }
    
    return $this->_item;
  }
  
  function getTotal()
  {

    if (empty($this->_total)) {

      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    
    if (empty($this->_pagination)) {
      jimport( 'joomla.html.pagination');
      $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    }

    return $this->_pagination;
  }

  function _buildQuery()
  {

    $where    = $this->_buildContentWhere();
    $orderby  = $this->_buildContentOrderBy();

    $query = ' SELECT a.*'
    . ' FROM #__js_res_tags AS a '
    . $where
    . $orderby
    ;
    
    return $query;
  }

  function _buildContentOrderBy()
  {
    global $mainframe, $option;

    $filter_order     = $mainframe->getUserStateFromRequest( $option.'.tags.filter_order',     'filter_order',     'a.ctime',  'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.tags.filter_order_Dir', 'filter_order_Dir', '',         'word');

    if ($filter_order == 'a.ctime'){
      $orderby   = ' ORDER BY a.ctime '.$filter_order_Dir;
    } else {
      $orderby   = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.ctime ';
    }

    return $orderby;
  }

  function _buildContentWhere()
  {
    global $mainframe, $option;
    $db =& JFactory::getDBO();
    
    $search           = $mainframe->getUserStateFromRequest( $option.'.tags.search',           'search',           '',           'string');
    $search           = JString::strtolower( $search );

    $where = array();
    
    if ( $search ) {
      $w[] = "a.tag LIKE '%".$search."%'";
      $w[] = "a.id = '".$search."'";
      $where[] = '('. implode( ' OR ', $w ) .')';
    }

    $where     = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '');

    return $where;
  }
  
  function _deleteTag()
  {
    $db =& JFactory::getDBO();
    
    $cid = Jrequest::getVar( 'cid');
    
    $query = 'DELETE FROM #__js_res_tags WHERE id IN ('.implode( ',', $cid ).')';
    
    $db->setQuery($query);
    $db->query();
    
    $query = 'DELETE FROM #__js_res_tags_history WHERE tag_id IN ('.implode( ',', $cid ).')';
    
    $db->setQuery($query);
    $db->query();
  }
  
  function _saveTag()
  {
    $db =& JFactory::getDBO();
    
    $id  = Jrequest::getVar( 'id');
    $tag = Jrequest::getVar( 'tag');
    
    $query = $query = ' SELECT a.* FROM #__js_res_tags AS a WHERE a.tag = "'.$tag.'"';
    $exist_item = $this->_getList($query);
    
    if( count( $exist_item ) > 1 || (count( $exist_item ) == 1 && $exist_item[0]->id != $id) ){
      $this->_error_msg = JText::_("This tag already exists.");
      return false;
    } 
    
    $query = 'UPDATE #__js_res_tags SET tag = "'.$tag.'" WHERE id ='.$id;

    $db->setQuery($query);
    $db->query();
    
    return true;
  }
}
