<?php
/**
 * $Id: type.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class ResModelType extends JModel
{
    var $_data = null;
    
    function __construct()
	{
		parent::__construct();

        $array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function getTypes()
	{
	    if (empty($this->_data))
		{
			$query = $this->_Query();
			$this->_data = $this->_getList($query);
		}

		return $this->_data;
	}
	
	function _Query()
	{
		$orderby	= $this->_OrderBy();
		
		$query = ' SELECT t.*, COUNT(f.id) as num'
			. ' FROM #__js_res_types AS t '
			. ' LEFT JOIN #__js_res_fields AS f ON f.type_id = t.id '
			. ' GROUP BY t.id '
			. $orderby
			
		;
        //echo $query; exit;
		return $query;
	}
	function _OrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'types.filter_order',		'filter_order',		't.name',	'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'types.filter_order_Dir',	'filter_order_Dir',	'ASC',		'word');
        
		$orderby = '';
		if($filter_order && $filter_order_Dir) $orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		//echo $orderby;
		return $orderby;
	}
	function &getData()
	{
		// Load the weblink data
		if ($this->_loadData())
		{

		}
		else  $this->_initData();

		return $this->_data;
	}

	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	function _loadData($id = 0)
	{
		if($id > 0) $this->_id = $id;
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__js_res_types WHERE id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			//print_r($this->_data);
			return $this->_data;
		}
		return true;
	}
	function _initData()
	{
		if (empty($this->_data))
		{
			$type = new stdClass();
			$type->id					= 0;
			$type->name				= null;
			$type->description			= null;
			$type->published			= 1;
			$type->checked_out			= 0;
			$type->checked_out_time	= 0;
			$type->params				= null;
			$type->ctime				= '';
			$this->_data					= $type;
			return (boolean) $this->_data;
		}
		return true;
	}
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			$type = & $this->getTable();
			if(!$type->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function store($data)
	{
		$row =& $this->getTable();

		if (!$row->bind($data)) {
			$this->setError($row->getError());
			return false;
		}

		if (!$row->check()) {
			$this->setError($row->getError());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$type = & $this->getTable();
			if(! $type->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
}