CREATE TABLE  IF NOT EXISTS  `#__js_res_alerts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `subject` varchar(255) NOT NULL default '',
  `body` text NOT NULL,
  `name` varchar(150) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `sender_name` varchar(150) NOT NULL default '',
  `sender_email` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_cache` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `ref_id` int(10) unsigned NOT NULL default '0',
  `key` varchar(36) NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `content` longtext NOT NULL,
  `type` varchar(45) NOT NULL default '',
  `section` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `main` USING BTREE (`ref_id`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_category` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) default NULL COMMENT 'Name as displayed on category list',
  `description` text NOT NULL COMMENT 'Description',
  `ordering` int(10) unsigned NOT NULL default '0' COMMENT 'Sorting',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `trash` tinyint(1) unsigned NOT NULL default '1' COMMENT 'Deleted or not',
  `icon` varchar(50) NOT NULL default '0' COMMENT 'Category Icon',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'Create Time',
  `mtime` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'Modified time',
  `parent` int(10) unsigned NOT NULL default '0',
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `access` tinyint(1) unsigned NOT NULL default '0',
  `clicks` int(10) unsigned NOT NULL default '0' COMMENT 'Nomber of clicks',
  `image` varchar(255) NOT NULL default '',
  `image_position` varchar(20) NOT NULL default '',
  `title` varchar(255) NOT NULL default '' COMMENT 'This is page title for this category',
  `params` text NOT NULL,
  `meta_descr` varchar(255) NOT NULL default '',
  `meta_key` varchar(255) NOT NULL default '',
  `section_id` int(10) unsigned NOT NULL default '0',
  `items_num` int(10) unsigned NOT NULL default '0',
  `alias` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `published` (`published`),
  KEY `trash` (`trash`),
  KEY `parent` (`parent`),
  KEY `access` (`access`),
  KEY `section_id` (`section_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_category_user` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `section_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime default NULL,
  `params` text NOT NULL,
  `name` varchar(150) NOT NULL default '',
  `ordering` int(10) unsigned NOT NULL default '0',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `access` tinyint(1) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL default '0',
  `rate` int(10) unsigned NOT NULL default '0',
  `rate_count` int(10) unsigned NOT NULL default '0',
  `icon` varchar(45) NOT NULL default '',
  `mtime` datetime default NULL,
  `alias` varchar(250) NOT NULL default '',
  `client_id` int(10) unsigned NOT NULL default '0',
  `client` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `user` (`user_id`,`section_id`),
  KEY `publish` (`published`),
  KEY `client_id` (`client_id`),
  KEY `client` (`client`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_comments` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `record_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `subject` varchar(250) NOT NULL default '',
  `comment` text NOT NULL,
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `email` varchar(200) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `langs` varchar(10) NOT NULL default 'en-GB',
  `access` tinyint(1) unsigned NOT NULL default '0',
  `rate` int(11) NOT NULL default '0',
  `parent` int(10) unsigned NOT NULL default '0',
  `level` tinyint(3) unsigned NOT NULL default '0',
  `hide` tinyint(1) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `attachment` varchar(250) NOT NULL default '',
  `attach_hit` int(10) unsigned NOT NULL default '0',
  `ip` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `published` (`published`),
  KEY `record` (`record_id`),
  KEY `user` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_download_hits` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `item_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `ip` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`),
  KEY `item_id` (`item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_favorite` (
  `user_id` int(10) unsigned NOT NULL default '0',
  `record_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`user_id`,`record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_field_extra` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `ref_id` varchar(255) NOT NULL default '' COMMENT 'Id of referenced object or field, or whatever you want to put',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `ip` varchar(45) NOT NULL default '',
  `value` longtext NOT NULL,
  `field_id` int(10) unsigned NOT NULL default '0',
  `record_id` int(10) unsigned NOT NULL default '0',
  `field_value_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ref_index` (`ref_id`),
  KEY `user_index` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_fields` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `type_id` int(10) unsigned NOT NULL default '0',
  `type` varchar(50) NOT NULL default '',
  `params` longtext NOT NULL,
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `ordering` tinyint(3) unsigned NOT NULL default '0',
  `title` varchar(250) NOT NULL default '',
  `show_intro` tinyint(1) unsigned NOT NULL default '0',
  `show_detail` tinyint(1) unsigned NOT NULL default '0',
  `searchable` tinyint(1) unsigned NOT NULL default '0',
  `filter` tinyint(1) unsigned NOT NULL default '0',
  `access` tinyint(1) unsigned NOT NULL default '0',
  `show_cart` tinyint(1) unsigned NOT NULL default '0',
  `show_compare` tinyint(1) unsigned NOT NULL default '0',
  `show_dummy1` tinyint(1) unsigned NOT NULL default '0',
  `show_dummy2` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `type_id` (`type_id`),
  KEY `intro` (`show_intro`),
  KEY `full` (`show_detail`),
  KEY `search` (`searchable`),
  KEY `filterable` (`filter`),
  KEY `access` (`access`),
  KEY `published` (`published`),
  KEY `cart` (`show_cart`),
  KEY `compre` (`show_compare`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_filters` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` text NOT NULL,
  `type` varchar(25) NOT NULL default '0',
  `params` text NOT NULL,
  `published` tinyint(3) unsigned NOT NULL default '0',
  `ordering` tinyint(3) unsigned NOT NULL default '0',
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `access` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_hits` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `record_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_id` int(10) unsigned NOT NULL default '0',
  `ip` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_polls` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `question` varchar(255) NOT NULL default '',
  `answer` varchar(255) NOT NULL default '',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_id` int(10) unsigned NOT NULL default '0',
  `record_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `record` (`record_id`),
  KEY `user` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_record` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `published` tinyint(1) NOT NULL default '0',
  `access` tinyint(1) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `user_id` int(10) unsigned NOT NULL default '0',
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `extime` datetime NOT NULL default '0000-00-00 00:00:00',
  `type_id` int(10) unsigned NOT NULL default '0',
  `hits` int(10) unsigned NOT NULL default '0',
  `ordering` int(10) unsigned NOT NULL default '0',
  `mtime` datetime NOT NULL default '0000-00-00 00:00:00',
  `meta_descr` varchar(255) NOT NULL default '',
  `meta_key` varchar(255) NOT NULL default '',
  `featured` tinyint(1) unsigned NOT NULL default '0',
  `archive` tinyint(1) unsigned NOT NULL default '0',
  `ucatid` int(10) unsigned NOT NULL default '0',
  `langs` varchar(10) NOT NULL default '',
  `alias` varchar(200) NOT NULL default '',
  `client` varchar(200) NOT NULL default 'resource',
  `client_id` int(10) unsigned NOT NULL default '0',
  `ip` varchar(20) NOT NULL default '',
  `votes` int(10) unsigned NOT NULL default '0',
  `favorite_num` int(10) unsigned NOT NULL default '0',
  `hidden` tinyint(3) unsigned NOT NULL default '0',
  `votes_result` int(10) unsigned NOT NULL default '0',
  `ftime` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'Time to expire featured',
  `exalert` tinyint(1) unsigned NOT NULL default '0' COMMENT 'flag if expiration alert was sent',
  `access_key` varchar(32) NOT NULL default '',
  `categories` MEDIUMTEXT NULL ,
  `fieldsdata` LONGTEXT NULL ,
  PRIMARY KEY  (`id`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `user_id` (`user_id`),
  KEY `type_id` (`type_id`),
  KEY `archive` (`archive`),
  KEY `client` (`client`),
  KEY `client_id` (`client_id`),
  KEY `ctime` (`ctime`),
  KEY `extime` (`extime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_record_category` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `catid` int(10) unsigned NOT NULL default '0',
  `record_id` int(10) unsigned NOT NULL default '0',
  `ordering` int(10) unsigned NOT NULL default '0',
  `otime` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `cat` (`catid`),
  KEY `rec` (`record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_record_values` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `field_id` int(10) unsigned NOT NULL default '0',
  `field_value` longtext NOT NULL,
  `record_id` int(10) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `rf` (`field_id`,`record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_sef` (
  `id` int(10) unsigned zerofill NOT NULL auto_increment,
  `sef_url` text NOT NULL,
  `original_url` varchar(255) NOT NULL default '',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `option` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `sef` (`original_url`,`option`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_tags` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `tag` varchar(50) NOT NULL default '',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `slug` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=50 DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_tags_history` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `record_id` int(10) unsigned NOT NULL default '0',
  `tag_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `section_id` int(10) unsigned NOT NULL default '0',
  `hits` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `record` (`record_id`),
  KEY `tag` (`tag_id`),
  KEY `user` (`user_id`),
  KEY `section` (`section_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_types` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `params` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `published` (`published`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS  `#__js_res_vote` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `record_id` int(10) unsigned NOT NULL default '0',
  `vote` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `ip` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `record` (`record_id`),
  KEY `user` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE  TABLE IF NOT EXISTS `#__js_res_category_filters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `field_id` int(11) DEFAULT NULL,
  `category_id` int(11) DEFAULT NULL,
  `record_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`) 
) ENGINE = MyISAM;