<?php
/**
 * $Id: record.php 7325 2011-08-24 10:07:02Z kostya $
 * $LastChangedDate: 2011-08-24 16:07:02 +0600 (Wed, 24 Aug 2011) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

// Include library dependencies
jimport('joomla.filter.input');

class ResRecord extends JTable
{


	var $id = '';
	var $title = '';
	var $published = '';
	var $access = '';
	var $params = '';
	var $user_id = '';
	var $checked_out = '';
	var $checked_out_time = '';
	var $ctime = '';
	var $extime = '';
	var $mtime = '';
	var $type_id = '';
	var $hits = '';
	var $ordering = '';
	var $meta_descr = '';
	var $meta_key = '';
	var $featured = '';
	var $archive = '';
	var $ucatid = 0;
	var $langs = '';
	var $alias = '';
	var $client = '';
	var $client_id = 0;
	var $ip = '';
	var $hidden = 0;
	var $votes = 0;
	var $favorite_num = 0;
	var $votes_result = 0;
	var $ftime = null;
	var $exalert = 0;
	var $access_key = '';
	var $categories = '';
	var $fieldsdata = '';


	function __construct(& $db) {
		parent::__construct('#__js_res_record', 'id', $db);
	}
	function reorder($catid, $clients, $order = "" )
	{
//		$query = 'SELECT r.id, rc.ordering, rc.id as rcid'
//		. ' FROM #__js_res_record AS r '
//		. ' LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id'
//		. ' WHERE r.client = \''.$clients.'\' AND rc.ordering >= 0 AND rc.catid = '. $catid
//		. ' GROUP BY r.id ORDER BY rc.ordering ASC'.$order
//		;

		$query = 'SELECT r.id, r.ordering'
		. ' FROM #__js_res_record AS r '
		. ' WHERE r.client = \''.$clients.'\' AND r.ordering >= 0 '
		. ' GROUP BY r.id ORDER BY r.ordering ASC'.$order
		;
		$this->_db->setQuery( $query );

		if (!($orders = $this->_db->loadObjectList()))
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		//print_r($orders);
		// compact the ordering numbers
		for ($i=0, $n=count( $orders ); $i < $n; $i++)
		{
			if ($orders[$i]->ordering >= 0)
			{
				if ($orders[$i]->ordering != $i+1)
				{
					$orders[$i]->ordering = $i+1;
					$query = 'UPDATE #__js_res_record '
					. ' SET ordering = '. (int) $orders[$i]->ordering
					. ' WHERE id = '. $this->_db->Quote($orders[$i]->id)
					;
					//echo $query;
					$this->_db->setQuery( $query);
					$this->_db->query();
				}
			}
		}

		return true;
	}
	function bind($array, $ignore = '')
	{
		if(is_array($array))
		{
			if (key_exists('params', $array )) {
				if(is_array($array['params']))
				{
					$registry = new JRegistry();
					$registry->loadArray($array['params']);
					$array['params'] = $registry->toString();
				}
			}
		}

		return parent::bind($array, $ignore);
	}

	function check()
	{
		if (trim($this->title) == '') {
			$this->setError('Your Content must contain a title.');
			return false;
		}
		if(!$this->client) $this->client = 'resource';
		if(!$this->ip) $this->ip = $_SERVER['REMOTE_ADDR'];

		if (!$this->langs) {
			$lang =& JFactory::getLanguage();
			$this->langs = $lang->getTag();
		}
		if (!$this->alias) {
			$this->alias = JString::strtolower(JString::str_ireplace(" ", "-", $this->title));
		}
		$this->alias = aliasConverter($this->alias);
		$this->alias = JString::strtolower(JString::str_ireplace(Array(" ", "--"), "-", $this->alias));

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		if ($this->ctime == '' || $this->ctime == '0000-00-00 00:00:00') {
			$this->ctime = ResHelper::getDate();//JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S');
		}
		$this->mtime = ResHelper::getDate();//JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S');

		if(!$this->user_id)
		{
			$user = JFactory::getUser();
			$this->user_id = (int)$user->get('id');
		}


		return true;
	}
}
?>
