<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access');

jimport ( 'joomla.application.component.view');
jimport ( 'joomla.filesystem.folder');

JHTML::_ ( 'behavior.modal', 'a.modal');

class ResViewComments extends JView {
	function display($tpl = null) {
		
		switch ($this->getLayout ()) {
			case "form" :
				$this->displayForm ( $tpl );
				break;
			default :
			case "default" :
				$this->displayDefault ( $tpl );
				break;
		}
	}
	
	function displayDefault($tpl = null) {
		global $mainframe, $option;
		
		$uri = & JFactory::getURI ();
		
		$filter_catid = $mainframe->getUserStateFromRequest ( $option . 'comments.filter_catid', 'filter_catid', 0, 'int');
		$filter_typeid = $mainframe->getUserStateFromRequest ( $option . 'comments.filter_typeid', 'filter_typeid', 0, 'int');
		$filter_order = $mainframe->getUserStateFromRequest ( $option . 'comments.filter_order', 'filter_order', 'a.ctime', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest ( $option . 'comments.filter_order_Dir', 'filter_order_Dir', 'DESC', 'word');
		$search = $mainframe->getUserStateFromRequest ( $option . 'comments.search', 'search', '', 'string');
		$search = JString::strtolower ( $search );
		
		$items = & $this->get ( 'Data');
		$total = & $this->get ( 'Total');
		$pagination = & $this->get ( 'Pagination');
		
		//$this->prepareItems ( &$items );
		
		$record_model = & JModel::getInstance ( 'Record', 'ResModel');
		
		// build list of categories
		$lists ['catid'] = '';
		if(RES_CATEGORIES_VIEW == 'tree'){
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration('
				function toggle_category(){
					if($("cat_filter").hasClass("cat_filter_close")){
						$("cat_filter").removeClass("cat_filter_close");
						$("cat_filter").addClass("cat_filter_open");
					}else{
						$("cat_filter").removeClass("cat_filter_open");
						$("cat_filter").addClass("cat_filter_close");
					}
				}
				
				function reset_category(){
					document.adminForm.filter_catid[0].checked = "checked";
					document.adminForm.filter_catid[0].value = "";
					submitform();
				}
			');
			
			$doc->addStyleDeclaration('
				.cat_filter_open{
					display:block;
					position:absolute;
					border:1px solid #cccccc;
					background-color:#ffffcc;
					overflow:auto;
					text-align:left;
				}
				.cat_filter_close{
					display:none;
				}
				
				#cat_filter input[type=radio]{
					border:none;
					outline:none;
				}
			');
			
			$lists['catid'] = '<button type="button" onclick="toggle_category();">'.JText::_('Category filter').'</button>'
							.'<div id="cat_filter" class="cat_filter_close" >'
							.ResHelper::getAjaxTreeCategoryList(0, array($filter_catid), false, array(), 'filter_catid')
							.'<button type="button" onclick="submitform();">'.JText::_('Submit').'</button>'
							.'<button type="button" onclick="reset_category();">'.JText::_('Reset').'</button>'
							.'</div>';
		}else{
			$c [] = JHTML::_ ( 'select.option', 0, JText::_ ( '- Select Category -' ) );
			$clist = $record_model->_getCategories ();
		
			if (is_array ( $clist )) {
				$c = array_merge ( $c, $clist );
			}
		
			$lists ['catid'] = JHTML::_ ( 'select.genericlist', $c, 'filter_catid', 'onchange="submitform()"', 'value', 'text', $filter_catid );
		}

		
		$types [] = JHTML::_ ( 'select.option', 0, JText::_ ( '- Select Type -' ) );
		$typelist = $record_model->getTypes ();
		$types = array_merge ( $types, $typelist );
		$lists ['typeid'] = JHTML::_ ( 'select.genericlist', $types, 'filter_typeid', 'onchange="submitform()"', 'value', 'text', $filter_typeid );
		
		$lists ['order_Dir'] = $filter_order_Dir;
		$lists ['order'] = $filter_order;
		
		$lists ['search'] = $search;
		
		$this->assignRef ( 'user', JFactory::getUser () );
		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'items', $items );
		$this->assignRef ( 'pagination', $pagination );
		
		parent::display ( $tpl );
	}
	
	function displayForm($tpl = null) {
		$uri = & JFactory::getURI ();
		
		$item = & $this->get ( 'Item');
		$lists = Array ();
		$lists ['published'] = JHTML::_ ( 'select.booleanlist', 'published', 'class="inputbox"', $item->published );
		
		jimport ( 'joomla.language.helper');
		$lang = & JFactory::getLanguage ();
		$lang->getTag ();
		$languages = JLanguageHelper::createLanguageList ( $lang->getTag (), JPATH_SITE, true );
		array_unshift ( $languages, JHTML::_ ( 'select.option', '', '- ' . JText::_ ( 'Select Language' ) . ' -' ) );
		
		$lists ['lang'] = JHTML::_ ( 'select.genericlist', $languages, 'langs', 'class="inputbox"', 'value', 'text', ($item->langs ? $item->langs : $lang->getTag ()) );
		$lists ['access'] = JHTML::_ ( 'list.accesslevel', $item );
		
		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'item', $item );
		
		parent::display ( $tpl );
	}
	
	function prepareItems(&$items) {
		foreach ( $items as $key => $item ) {
			if (JFolder::exists ( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_juser' )) {
				$item->user_href = JURI::root () . 'administrator/index.php?option=com_juser&view=user&task=edit&cid[]=' . $item->userid;
			} else {
				$item->user_href = JURI::root () . 'administrator/index.php?option=com_user&view=user&task=edit&cid[]=' . $item->userid;
			}
			
			$items [$key] = $item;
		}
	
	}

}