<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');

jimport( 'joomla.application.component.view');

class ResViewField extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		if($this->getLayout() == 'form'){
			$this->_form();
			return;
		}

		if($this->getLayout() == 'chose'){
			$this->_chose();
			return;
		}

		$tmodel = & JModel::getInstance ( 'Type', 'ResModel');
		$tname = $tmodel->_loadData(JRequest::getInt('type_id'));

		JSToolBar::title(   JText::_('Fields of type' ) . ' ('.$tname->name.')', 'generic.png');
		JToolBarHelper::custom( 'copyfields', 'copy.png', 'copy.png', 'Copy', true );
		JSToolBar::publish('js_res_fields', 1);
		JSToolBar::publish('js_res_fields', 0);
		JSToolBar::delete('js_res_fields');
		JSToolBar::editListX();
		JSToolBar::addNewX();
		JSToolBar::close('type');
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?fields.htm', 1000, 500);

		//JToolBarHelper::preferences('com_weblinks', '360');
		//JToolBarHelper::help( 'screen.weblink');

		JHTML::_('behavior.tooltip');
			
		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();
		$user = & JFactory::getUser();

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'fields.filter_order',		'filter_order',		'f.ordering',	'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'fields.filter_order_Dir',	'filter_order_Dir',	'',				'word');

		// Get data from the model
		$items =  $this->get('Fields');
		$pag =  $this->get('Pagination');


		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		$type_id = JRequest::getInt('type_id');
		if(!$type_id)
		{
			$array = JRequest::getVar('cid', array(0), '', 'array');
			//print_r($array);exit;
			//JError::raiseError('403', 'Important value do not set');
			$type_id = $array[0];
		}

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',		$pag);
		$this->assignRef('type_id',		$type_id);

		parent::display($tpl);
			
			
	}

	function _chose($tpl = null)
	{
		JSToolBar::title(JText::_('Chose Type'));
		JSToolBar::apply('copyfields');
		JToolBarHelper::cancel( 'cancel', 'Close');
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?copying_a_field.htm', 1000, 500);

		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$ids = implode(", ", $cid);

		$db		=& JFactory::getDBO();

		$sql = "SELECT * FROM #__js_res_fields WHERE id IN ({$ids})";
		$db->setQuery($sql);
		$fields = $db->loadObjectList();

		$sql = "SELECT id as value, name as text FROM #__js_res_types";
		$db->setQuery($sql);
		$types = $db->loadObjectList();
		$types = JHTML::_('select.genericlist', $types, 'new_type', null, 'value', 'text');


		$this->assignRef('ids',		$ids);
		$this->assignRef('fields',		$fields);
		$this->assignRef('types',		$types);
		parent::display();
	}

	function _form($tpl = '')
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$model	=& $this->getModel();

		$lang = &JFactory::getLanguage();
		$lang->load('com_content');
		
		$document = & JFactory::getDocument();
		$document->addScript( JURI::root()."plugins/joomsuite_content_fields/select_relate.js" );

		$lists = array();

		$field	=& $this->get('data');
		$isNew		= ($field->id < 1);

		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_('The Type' ), $type->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			$field->published = 1;
		}

		$params = new JParameter($field->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'fields.xml');

		$params->set('filter_enable', $field->filter);

		$sql = "SELECT element as value, REPLACE(element, '_', ' ') as text FROM #__plugins WHERE `folder` = 'joomsuite_content_fields' AND published = 1 ORDER BY element ASC";
		$db->setQuery($sql);
		$f = $db->loadObjectList();

		$lists['types'] 	= JHTML::_('select.genericlist', $f, 'type', "onchange=\"xajax_jcTypeParams(this.value);\"", 'value', 'text', $field->type );
		$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $field->published );
		$lists['show_intro']= JHTML::_('select.booleanlist', 'show_intro', 'class="inputbox"', $field->show_intro );
		$lists['show_full'] = JHTML::_('select.booleanlist', 'show_detail', 'class="inputbox"', $field->show_detail );
		$lists['show_cart'] = JHTML::_('select.booleanlist', 'show_cart', 'class="inputbox"', $field->show_cart );
		$lists['show_compare'] = JHTML::_('select.booleanlist', 'show_compare', 'class="inputbox"', $field->show_compare );
		$lists['search'] 	= JHTML::_('select.booleanlist', 'searchable', 'class="inputbox"', $field->searchable );
			
		//$lists['filter'] 	= JHTML::_('select.booleanlist', 'filter', 'class="inputbox"', $field->filter );
		$lists['access'] 	= JHTML::_('list.accesslevel', $field );

		$lists['frequired'] 	= JHTML::_('select.booleanlist', 'params[frequired]', 'class="inputbox"', $params->get('frequired') );
		$lists['sortable'] 	= JHTML::_('select.booleanlist', 'params[sortable]', 'class="inputbox"', $params->get('sortable')  );
		
		$lists['filter_params'] = '';
		$lists['jip_params'] = '';
		
		$dispatcher    =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields', $field->type);
		$dispatcher->trigger( 'onJip', array (&$jip, $field->type) );
		if($jip) $lists['jip_params'] = '<fieldset><legend>'.JText::_('Just In Place').'</legend>'.$params->render('params', 'jip').'</fieldset>';
		
		$dispatcher->trigger( 'onFilter', array (&$filter, $field->type) );
		if($filter) $lists['filter_params'] = '<fieldset><legend>'.JText::_('Filter').'</legend>'.$params->render('params', 'Filter').'</fieldset>';

		$sql = "SELECT ordering as value, CONCAT('(', ordering,') ', title) as text FROM #__js_res_fields WHERE type_id = ".JRequest::getInt('type_id')." ORDER BY ordering";
		$db->setQuery($sql);
		$res[] = JHTML::_('select.option', '0', '(0) - first -');
		$add = $db->loadObjectList();
		if(is_array($add)) $res = array_merge($res, $add);
		$lists['order'] = JHTML::_('select.genericlist', $res, 'ordering', '', 'value', 'text', $field->ordering );
			
			
		$field_params = new JParameter($field->params, JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.($field->type ? $field->type : 'address').'.xml');
		$slider = &JPane::getInstance('sliders', array('allowAllClose' => true));

		$tmodel = & JModel::getInstance ( 'Type', 'ResModel');
		$tname = $tmodel->_loadData(JRequest::getInt('type_id'));

		JSToolBar::title(JText::_('Add/Edit Field') . ' (' . JText::_('Content type').': '. $tname->name . ')');
		JSToolBar::save();
		JSToolBar::apply();
		if (!$isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close');
		}
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?adding_a_field.htm', 1000, 500);

		$lang = & JFactory::getLanguage();
		$lang->load('plg_joomsuite_content_fields_'.$field->type);

		$this->assignRef('row',		$field);
		$this->assignRef('lists',	$lists);
		$this->assignRef('params',	$params);
		$this->assignRef('fparams',	$field_params);
		$this->assignRef('slider',	$slider);
		$this->assignRef('slider',	$slider);
		parent::display();
	}
	function getNumValues($id)
	{
		$db = & JFactory::getDBO();
		$sql = ' SELECT count(*) FROM #__js_res_record_values WHERE field_id = '. $id;
		$db->setQuery($sql);
		return $db->loadResult();
	}
}
?>
