<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.view');
jimport( 'joomla.filesystem.folder');

class ResViewFilters extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		if( JRequest::getVar( "layout" ) == "form" ){
			$this->_form();
		} else{
			$this->_list();
		}

		parent::display( $tpl );
	}

	function _list() {
		global $mainframe, $option;

		JSToolBar::title(   JText::_('Filters' ), 'generic.png');
		JSToolBar::publish('js_res_filters', 1);
		JSToolBar::publish('js_res_filters', 0);
		JSToolBar::delete('js_res_filters');
		JSToolBar::editListX();
		JSToolBar::addNewX();
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?filters.htm', 1000, 500);

		//JToolBarHelper::preferences('com_weblinks', '360');
		//JToolBarHelper::help( 'screen.weblink');

		JHTML::_('behavior.tooltip');

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();
		$user =& JFactory::getUser();

		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'ext_filters.filter_order',		'filter_order',		'f.ordering',	'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'ext_filters.filter_order_Dir',	'filter_order_Dir',	'',				'word');

		// Get data from the model
		$items =  $this->get('Filters');
		$pag   =  $this->get('Pagination');

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order']     = $filter_order;

		$this->assignRef( 'user',		    JFactory::getUser());
		$this->assignRef( 'lists',		  $lists);
		$this->assignRef( 'items',		  $items);
		$this->assignRef( 'pagination',	$pag);
	}

	function _form()
	{

		global $mainframe;
		
		$filter      =& $this->get( 'data');
		$filter_list =& $this->get( 'FilterPluginList');
		$ord         =& $this->get( 'FiltersOrderList');
		
		if(!is_array($filter_list))
		{
			JError::raiseWarning(500, JText::_("You need to instal filter plugins and/or publish them"));
			$mainframe->redirect('index.php?option=com_resource&controller=filters');	
		}
		
		JSToolBar::title(JText::_('Add/Edit Filter'));
		JSToolBar::save();
		JSToolBar::apply();
		$isNew		= ($filter->id < 1);
		if (!$isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close');
		}
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?adding_a_new_filter.htm', 1000, 500);

		$lists['types']     = JHTML::_('select.genericlist', $filter_list, 'type', "onchange=\"xajax_jcFilterTypeParams(this.value);\"", 'value', 'text', $filter->type );
		$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $filter->published );
		$lists['order']     = JHTML::_('select.genericlist', $ord, 'ordering', '', 'value', 'text', $filter->ordering );
		$lists['access']    = JHTML::_('list.accesslevel', $filter );

		if( $filter->type ) {
			$filter_params = new JParameter( $filter->params, JPATH_PLUGINS.DS.'joomsuite_content'.DS."filter_". $filter->type.'.xml');
		} else $filter_params = null;

		$common_filter_params = new JParameter( $filter->params, JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'xml'.DS.'filters.xml');

		$slider = &JPane::getInstance('sliders', array('allowAllClose' => true));

		$this->assignRef( 'filter',               $filter );
		$this->assignRef( 'filter_params',        $filter_params );
		$this->assignRef( 'common_filter_params', $common_filter_params );
		$this->assignRef( 'lists',                $lists );
		$this->assignRef( 'slider',               $slider );

	}
}