<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.view');
jimport( 'joomla.filesystem.folder');

class ResViewRating extends JView
{
  function display($tpl = null)
  {
    global $mainframe, $option;

    $db  =& JFactory::getDBO();
    $uri =& JFactory::getURI();

    $filter_catid     = $mainframe->getUserStateFromRequest( $option.'.rating.filter_catid',     'filter_catid',     0,         'int');
    $filter_vote      = $mainframe->getUserStateFromRequest( $option.'.rating.filter_vote',      'filter_vote',      0,         'int');
    $filter_order     = $mainframe->getUserStateFromRequest( $option.'.rating.filter_order',     'filter_order',     'a.ctime', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.rating.filter_order_Dir', 'filter_order_Dir', '',        'word');
    $search           = $mainframe->getUserStateFromRequest( $option.'.rating.search',           'search',           '',        'string');
    $search           = JString::strtolower( $search );

    // Get data from the model
    $items      = & $this->get( 'Data');
    $total      = & $this->get( 'Total');
    $pagination = & $this->get( 'Pagination');
    
    $this->prepareItems( $items );
    
    $record_model = & JModel::getInstance('Record', 'ResModel');
    
    // build list of categories
		
		$c[] = JHTML::_('select.option', 0, JText::_('- Select Category -'));
		$clist = $record_model->_getCategories();
		if(is_array($clist)) $c = array_merge($c, $clist);
		$lists['catid'] = JHTML::_('select.genericlist',  $c, 
            'filter_catid', 'onchange="submitform()"', 'value', 'text', $filter_catid);
    
    $v[] = JHTML::_('select.option', 0,   JText::_('- Select Vote -'));
    $v[] = JHTML::_('select.option', 10,  10);
    $v[] = JHTML::_('select.option', 20,  20);
    $v[] = JHTML::_('select.option', 30,  30);
    $v[] = JHTML::_('select.option', 40,  40);
    $v[] = JHTML::_('select.option', 50,  50);
    $v[] = JHTML::_('select.option', 60,  60);
    $v[] = JHTML::_('select.option', 70,  70);
    $v[] = JHTML::_('select.option', 80,  80);
    $v[] = JHTML::_('select.option', 90,  90);
    $v[] = JHTML::_('select.option', 100, 100);
    
    $lists['vote'] = JHTML::_('select.genericlist',  $v, 
            'filter_vote', 'onchange="submitform()"', 'value', 'text', $filter_vote );
    
    // table ordering
    $lists['order_Dir'] = $filter_order_Dir;
    $lists['order']     = $filter_order;
    
    $lists['search']    = $search;
    
    $this->assignRef('user',       JFactory::getUser());
    $this->assignRef('lists',      $lists);
    $this->assignRef('items',      $items);
    $this->assignRef('pagination', $pagination);

    parent::display($tpl);
  }
  
  function prepareItems( &$items )
  {
    foreach( $items as $key => $item ) {
      if( JFolder::exists( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser' ) ) {
        $item->user_href = JURI::root().'administrator/index.php?option=com_juser&view=user&task=edit&cid[]='.$item->userid;
      } else {
        $item->user_href = JURI::root().'administrator/index.php?option=com_user&view=user&task=edit&cid[]='.$item->userid;
      }

      
      $item->record_href = JURI::root().'administrator/index.php?option=com_resource&view=record&task=edit&cid[]='.$item->record_id;
      
      
      $stars = round( $item->vote/10 );
      $item->vote = '';
      for( $i = 1; $i <= $stars; $i++ ) {
        $item->vote .= '<img src="'.JURI::root().'/administrator/components/com_resource/images/rating_star.png">';
      }
      for( $i = $i; $i <= 10; $i++ ) {
        $item->vote .= '<img src="'.JURI::root().'/administrator/components/com_resource/images/rating_star_blank.png">';
      }
      
      
      $items[$key] = $item;
    }
    
  }
}