<?php
/**
 * $Id: api.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
define('MRA_FIELD_MODE_LIST', 1);
define('MRA_FIELD_MODE_FULL', 2);

require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
ResControllerConfig::initialyze();


class MRDispatcher extends JObject
{
	function & getInstance() {
		static $instance = 0;
		if (empty($instance)) {
			$instance = new MRDispatcher();
		}

		return $instance;
	}

	function __construct() {
		parent::__construct();

		$this->dispatcher = & JDispatcher::getInstance();
		$this->fields = array();
		$this->_init();
	}

	/**
	 *
	 * @var JDispatcher
	 */
	var $dispatcher;

	var $fields;

	function _init()
	{
		for ($i = 0, $c = count($this->dispatcher->_observers); $i < $c; $i++)
		{
			$obs = & $this->dispatcher->_observers[ $i ];
			if (is_object($obs) && strpos(strtolower(get_class($obs)), 'joomsuite_content_fields') !== false)
			{
				$classname = strtolower(get_class($obs));
				$classname = str_replace('plgjoomsuite_content_fields', '', $classname);

				$this->fields[$classname] = & $obs;
			}
		}
	}

	function trigger($event, $args, $pluginName = false) {
		$observer = @$this->fields[strtolower($pluginName)];
		if (empty($observer)) {
			return false;
		}

		if (method_exists($observer, 'update'))
		{
			if (method_exists($observer, $event))
			{
				$args['event'] = $event;
				return $observer->update($args);
			}
		}

		return false;
	}
}

class MightyResourcesApi
{
	// TODO: additional Wheres and joins for relate fields and other interconnections.
	// do not forget to mention that if wheer and join are pathed then records_mode should be 2
	function getRecordList($options, $where = array(), $join = array(), &$model, &$out, $callback = null)
	{
		global $mainframe, $option, $Itemid;

		$options_ = array (
			'category' => 0,
			'limit' => 10,
			'order' => 'r.ctime DESC',
			'records_mode' => 1, // 0 = category, 1 = category and its subcategories, 2 = all section
			'view_what' => 'created',
			'client' => 'resource', // resource or modulle. If client module filters are not applied.
			'list_clients' => 0,
			'user_id' => '', // if present filter by user ID
			'template' => 'joomla_blog', // mixed. May be integer the number of template in list off section templates or string -  template name.
			'group_id' => '', // ID of the group. If given only group items displaied
			'group_name' => '', // ID of the group
			'group' => ''); // ID of the group

		//$options['user_id'] = 63;
		//$options['view_what'] = 'created';
		//$options['limit'] = 5;

		jimport ('joomla.utilities.date');
		jimport ('joomla.utilities.file');
//		jimport ('joomla.utilities.date');

		//if(JRequest::getInt('user_id') && JRequest::getVar('view_what') && !@$options['user_id'])
		//{
		//	$options['user_id'] = JRequest::getInt('user_id');
		//}
		//$options['order'] = 'r.ctime DESC';
		//$options['client'] = 'module';

		$category = @$options['category'];
		if(!$category) $category = JRequest::getInt('category_id');
		if(!$category && JRequest::getInt('article')) $category =  ResHelper::getArticleSection(JRequest::getInt('article'));
		if(!$category)
		{
			JError::raiseWarning(500, JText::_('No category'));
			return;
		}

		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		if(!$model) $model 	= & JModel::getInstance('list', 'ResModel');
			
		$itemid = JRequest::getInt('Itemid');
		if(@$options['client'] == 'resource') $state	= &$this->get('state', 'list');
		$config 	= JFactory::getConfig();
		$document = &JFactory::getDocument();
		$user = & JFactory::getUser();

		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');
		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'record.php');
		require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$section  = $model->getCategory(ResHelper::getCategorySection($category));
		$category = $model->getCategory($category);

		$document->addScript( JURI::root().'components/com_resource/library/js/script.js' );
		$document->addScript( JURI::root().'components/com_resource/library/js/felixrating.js' );
		$document->addScript(JURI::root().'includes/js/joomla.javascript.js');

		$url_params = &$mainframe->getParams();
		$params 	= ResHelper::initListParams($category->id);
		if(is_object($url_params)) $params->merge($url_params);

		if(isset($options['relate_tags'])) 	$params->set('relate_tags', $options['relate_tags']);
		if(!isset($options['view_what'])) 	$options['view_what'] = JRequest::getVar('view_what');
		if(!isset($options['group_id'])) 	$options['group_id'] = JRequest::getVar('client_id');
		if(!isset($options['group_name'])) 	$options['group_name'] = JRequest::getVar('client');
		if(@$options['user_id'] <= 0 && !(@$options['user_id'] === 0))
		{
			$options['user_id'] = JRequest::getVar('user_id');
		}

		$params->set('url_view_what', $options['view_what']);
		$params->set('url_user_id', $options['user_id']);
		$params->set('url_group_id', $options['group_id']);
		$params->set('url_group_name', $options['group_name']);
		$params->set('url_where', serialize($where));
		$params->set('url_join', serialize($join));

		//if($params->get('url_view_what') && !$params->get('url_user_id')) $params->set('url_user_id', $user->get('id'));
		//if($params->get('url_view_what') && !$params->get('url_user_id')) $params->set('url_view_what', '');

		if(@$options['records_mode'] == 2) 	$params->set('url_all', 1);
		if(JRequest::getInt('all') == 1) 	$params->set('url_all', 1);
		if(@$options['user_id']) 			$params->set('url_all', 1);
		if(@$options['group_id']) 			$params->set('url_all', 1);

		if(array_key_exists('list_clients', $options)) $params->set('list_clients', $options['list_clients']);
		if(array_key_exists('records_mode', $options)) $params->set('records_mode', $options['records_mode']);
		if(@$options['client'] == 'module')
		{
			$params->set('client', $options['client']);
			$params->set('featured_first', 0);
		}

		switch ($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_tmpl  = "{$option}.content.filter_tpl{$section->id}{$itemid}{$category->id}".$params->get('url_user_id');
				break;
			case 2:
				$fname_tmpl  = "{$option}.content.filter_tpl{$section->id}{$itemid}".$params->get('url_user_id');
				break;
		}

		$old_template = $mainframe->getUserState($fname_tmpl);
		$tpl_array = explode(",", $params->get('tmpl_list'));
		$default = JRequest::getVar('filter_tpl', $mainframe->getUserState($fname_tmpl));
		if(!trim($default) || is_array($default) || $default == 'Array') $default = $tpl_array[0];
		$mainframe->setUserState($fname_tmpl, $default);
		$params->set('tmpl_list', $mainframe->getUserState($fname_tmpl));

		if(@$options['template'])
		{
			if(is_int($options['template']) && array_key_exists($options['template'], $tpl_array))
			{
				$params->set('tmpl_list', $tpl_array[$options['template']]);
			}
			else
			{
				$params->set('tmpl_list', $options['template']);
			}
		}

		if (!$params->get('tmpl_list'))
		{
			$params->set('tmpl_list', $default);
		}
		if (!$params->get('tmpl_list') && !$default)
		{
			JError::raiseError(100, 'no template');
		}

		if(JRequest::getInt('compare'))
		{
			$params->set('tmpl_list', $params->get('tmpl_compare'));
		}


		if($old_template != $mainframe->getUserState($fname_tmpl))
		{
			JRequest::setVar('cal_date', 1);
		}

		if(count($tpl_array) > 1)
		{
			foreach ($tpl_array as $k => $tpl_) {

				$views[$k]->name = $tpl_;
				//$views[$k]->title = JString::ucfirst(str_replace("_", ' ', $tpl_));
				$views[$k]->title = $model->getTemplateName($tpl_);
			}
			$out['views'] = @$views;

		}

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.ini');
			$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}
		switch ($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_alpha  = "{$option}.content.filter_alpha{$itemid}{$category->id}".$params->get('url_user_id');
				$fname_tag    = "{$option}.content.filter_tag{$itemid}{$category->id}".$params->get('url_user_id');
				$fname_search = "{$option}.content.filter_search{$itemid}{$category->id}".$params->get('url_user_id');
				$fname_order = "filter_order{$itemid}{$category->id}".$params->get('url_user_id');
				$fname_order_dir =  "filter_order_dir{$itemid}{$category->id}".$params->get('url_user_id');
				break;
			case 2:
				$fname_alpha  = "{$option}.content.filter_alpha{$itemid}".$params->get('url_user_id');
				$fname_tag    = "{$option}.content.filter_tag{$itemid}".$params->get('url_user_id');
				$fname_search = "{$option}.content.filter_search{$itemid}".$params->get('url_user_id');
				$fname_order = "filter_order{$itemid}".$params->get('url_user_id');
				$fname_order_dir =  "filter_order_dir{$itemid}".$params->get('url_user_id');
				break;
		}
		$out['fname_tag'] = $fname_tag;


		$filter_order =  $params->get('orderby', 'r.ctime DESC');
		switch((string)$options['view_what'])
		{
			case "favorites":
				$filter_order = 'fv.ctime DESC';
				break;
			case "rated":
				$filter_order = 'vt.ctime DESC';
				break;
			case "commented":
				$filter_order = 'r.mtime DESC';
				break;
			case "last-visited":
				$filter_order = 'ht.ctime DESC';
				break;
			case "expired":
				$filter_order = 'r.extime DESC';
				break;
		}
		if(@$options['order']) $filter_order = $options['order'];
		$order = explode(" ", $filter_order);
		if($params->get('client') == 'module')
		{
			$order1 = $order[0];
			$order2 = $order[1];
		}
		else
		{
			$order1 = $mainframe->getUserStateFromRequest($fname_order, 'filter_order', $order[0]);
   			$order2 = $mainframe->getUserStateFromRequest($fname_order_dir, 'filter_order_Dir', $order[1]);
   			/*if(JRequest::getCmd('filter_order') || JRequest::getCmd('filter_order_Dir'))
			{
				$order_def = explode(" ", JRequest::getCmd('filter_order', $order[0]));
				$order_dir_def = explode(" ", JRequest::getCmd('filter_order_Dir', $order[1]));
				$mainframe->setUserState($fname_order, $order_def[0]);
				$mainframe->setUserState($fname_order_dir, $order_dir_def[0]);
			}
			else
			{
				$order_def[0] = $mainframe->getUserState($fname_order, $order[0],'cmd');
				$order_dir_def[0] = $mainframe->getUserState($fname_order_dir, $order[1], 'word');
				$mainframe->setUserState($fname_order, $order_def[0]);
				$mainframe->setUserState($fname_order_dir, $order_dir_def[0]);
			}

			$order1 = $mainframe->getUserState($fname_order, $order_def[0],'cmd');
			$order2 = $mainframe->getUserState($fname_order_dir, $order_dir_def[0], 'word');*/
		}

		/*$order = explode(" ", $params->get('orderby', 'r.ctime DESC'));
		 if(@$options['order']) $order = explode(" ", $options['order']);
		 if($params->get('client') == 'module')
		 {
			$order1 = $order[0];
			$order2 = $order[1];
			}
			else
			{
			$order_def = explode(" ", JRequest::getCmd('filter_order', $order[0]));
			$order_dir_def = explode(" ", JRequest::getCmd('filter_order_Dir', $order[1]));
			$order1 = $mainframe->getUserStateFromRequest($fname_order,	'filter_order', $order_def[0], 'cmd');
			$order2 =  $mainframe->getUserStateFromRequest($fname_order_dir, 'filter_order_Dir', $order_dir_def[0], 'word');
			}*/

		//echo $order1.$order2; exit;

		if($option['client'] == 'resource')
		{
			$state->set($fname_order, $order1);
			$state->set($fname_order_dir, $order2);
		}
		$model->setState($fname_order, $order1);
		$model->setState($fname_order_dir, $order2);

		$lists['order_Dir'] = $order2;
		$lists['order'] = $order1;

		$out['lists'] = @$lists;


		$limit = $mainframe->getUserState('com_resource.limit'.$itemid.$params->get('tmpl_list'));
		if(!$limit)
		{
			$limit = $params->get('limit', $config->getValue('config.list_limit'));
		}
		if(JRequest::getInt('limit') && $old_template && ($old_template == $mainframe->getUserState($fname_tmpl)))
		{
			$limit = JRequest::getInt('limit');
		}
		if(@$options['limit'])
		{
			$limit = $options['limit'];
		}
		else
		{
			$mainframe->setUserState('com_resource.limit'.$itemid.$params->get('tmpl_list'), $limit);
		}

		if($option['client'] == 'resource')
		{
			$state->set('limit', $limit);
		}
		$model->setState('limit', $limit);

		// Get Items
		$model->setParams($params);

		$oldcategory = JRequest::setVar('category_id', $category->id);
		$oldview = JRequest::setVar('view', 'list');
		$oldartcle = JRequest::setVar('article', 0);

		$items = $model->getData($category->id);

		MRRecordHelper::prepareItems($items, $params, $category, $callback);
		
		JRequest::setVar('category_id', $oldcategory);
		JRequest::setVar('view', $oldview);
		JRequest::setVar('article', $oldartcle);

		if($params->get('client') != 'module')
		{
			$alpha_default  = $mainframe->getUserStateFromRequest($fname_alpha,  'filter_alpha', JText::_('All'), 'word');
			$search_default = $mainframe->getUserStateFromRequest($fname_search, 'filter_search', '', 'String');
			$tag_default    = $mainframe->getUserStateFromRequest($fname_tag,    'filter_tag', 0, 'int');

			if(is_object($alpha_default)) 	$alpha_default 	= false;
			if(is_object($search_default)) 	$search_default = false;
			if(is_object($tag_default)) 	$tag_default 	= false;

			if($alpha_default  == 1) { $alpha_default 	= false; $mainframe->setUserState($fname_alpha, null);}
			if($search_default == 1) { $search_default 	= false; $mainframe->setUserState($fname_search, null);}
			if($tag_default    == 1) { $tag_default 	= false; $mainframe->setUserState($fname_tag, null);}

			$out['search_default'] = $search_default;
			$out['alpha_default'] = $alpha_default;
		}
		
		$new_items  = array();
		$nfields    = array();
		$columns	= array();
		
		settype($items, 'array');
		foreach ($items AS $key => $item)
		{
			if($item->fields)
			{
				foreach ($item->fields AS $field)
				{
					$columns[$field->type_id.$field->ordering]['title'] = $field->title;
					$columns[$field->type_id.$field->ordering]['id'] = $field->fid;
					$columns[$field->type_id.$field->ordering]['params'] = new JParameter( $field->params );
				}
			}

			// ---- LEGACY 1.4 ----
			$nfields[$item->id] = $item->fields;
			$ifields[$key] = $item->ifields;
		}
		ksort($columns);
		$out['columns'] = @$columns;

		// ------- LEGACY 1.4 ------
		if(count($columns) > 0)
		{
			ksort($columns);
			foreach ($columns AS $sort => $data)
			{
				$cols[$data['title']] = $data['id'];
				$cols_additional[$data['title']]['params'] = $data['params'];
			}
		}

		// link template CSSs and JSs
		MRRecordHelper::linkListFiles($params);

		// ------- LEGACY 1.4 ------
		$this->fields = $nfields;
		$this->ifields = @$ifields;
		$this->cols = @$cols;
		$this->cols_additional = @$cols_additional;


		// load template
		$this->params = $params;
		$this->columns = $columns;
		$this->items = $items;
		$this->section = $section;
		$this->category = $category;
		$this->user = JFactory::getUser();
		$this->mmodel = $model;
		$this->lists = $lists;
		//article
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.php';
		$html = ob_get_contents();
		ob_end_clean();

		return array($items, $html);
	}

	/**
	 * Get value of the field. usefull to add to activity, to article list or whatever.
	 *
	 * @param integer $mode - MRA_FIELD_MODE_LIST or MRA_FIELD_MODE_FULL
	 * @param integer $field_id - Id of the field
	 * @param integer $record_id - Id of the record
	 */
	function getField($field_id, $record_id, $category = null)
	{
		if(!$category) $category = JRequest::getInt('category_id');
		$db = & JFactory::getDBO();

		$sql = " SELECT f.access, f.`id`, ".$record_id." AS record_id, v.id AS vid, f.`type_id`, f.`type`, f.`params`, f.`title`, v.`field_value`, v.`params` AS fparams
			 FROM #__js_res_fields AS f
		LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id AND v.record_id = " . $record_id .
		  " WHERE f.id = " . $field_id;
			" AND v.record_id = ".$record_id;
		$db->setQuery($sql);
		$object = $db->loadObject();

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($record_id);

		$html = MightyResourcesApi::getFieldValue($object, $article, $category);
		return $html;
	}
	function getFieldValue(&$field, &$record, $category = null, $jip = 0)
	{
		static $stuff = false;

		if (empty($stuff))
		{
			jimport('joomla.application.component.model');
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models'.DS.'list.php';
				
				
			$stuff['model'] 		= &JModel::getInstance('list', 'ResModel');
			$stuff['user']			= & JFactory::getUser();

			JPluginHelper::importPlugin('joomsuite_content');
			JPluginHelper::importPlugin('joomsuite_content_fields');
			$stuff['dispatcher'] 	= & MRDispatcher::getInstance();
		}

		$model 		= & $stuff['model'];
		$dispatcher = & $stuff['dispatcher'];
		$cuser 		= & $stuff['user'];

		$params = ResHelper::initListParams($category);

		if (empty($stuff['field_params'][$field->fid]))
		{
			$stuff['field_params'][$field->fid] = new JParameter($field->params);
		}


		$field_params = & $stuff['field_params'][$field->fid];

		$get = '';
		$dispatcher->trigger( 'onRenderFieldValue', array (&$get, &$field, &$record, $category), $field->type);

		if($get)
		{
			/*if($jip == 0)
			{
				$dispatcher->trigger( 'onJip', array (&$jip, $field->type) );
				if($jip && (JRequest::getVar('option') == 'com_resource'))
				{
					// $params = ResHelper::initListParams($category);
					if((MEAccess::isAuthor($record->user_id, $field_params->get('jip_author')) ||
					($field_params->get('jip_author') && MEAccess::isAdmin()) ||
					($field_params->get('jip_moder') && MEAccess::isModerator($cuser->get('id'), 'moder_edit_fields', $params) )))
					{
						//$get = sprintf('<span id="jip_%d"><div class="jip">%s</div>%s</span>', $field->id, 123, $get);
						//$get = sprintf('<img class="jip" id="jip_image_%d" src="components/com_resource/images/jip.png" onclick="mrEditField(%d, %d, %d, %d)" /><form action="http://joomla/index.php" method="get" id="jip_form_%d" name="jip_form_%d"><span id="jip_%d">%s</span></form>', $field->id, $field->fid, $field->id, $record->id, $category, $field->id, $field->id, $field->id, $get);
						$get = sprintf('<img class="jip" id="jip_image_%d" src="components/com_resource/images/jip.png" onclick="mrEditField(%d, %d, %d, %d)" /><span id="jip_%d">%s</span>', $field->id, $field->fid, $field->id, $record->id, $category, $field->id, $get);

						//echo htmlspecialchars($get).'<br />';
					}
				}
			}*/
			//return 1;
//die;
			if(!$model->_fieldSubscriptionAccess($get, $field_params, $params, $record->user_id))
			{
				$model->_fieldGroupAccess($get, $field_params);
			}
			$model->_fieldKarmaAccess($get, $field_params, $params, $record->user_id);
		}
		return $get;
	}
	function getSectionId($category_id = 0)
	{
		if(!$category_id) $category_id = JRequest::getInt('category_id', ResHelper::getArticleSection(JRequest::getInt('article')));
		if(!$category_id) return false;
		return ResHelper::getCategorySection($category_id);
	}
	function initResourceConfig() {

		if (!defined('RES_GENERAL_UPLOAD'))
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();
		}
	}

}
?>