<?php
/**
 * $Id: article.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class ResControllerArticle extends JController
{
	function display()
	{
		if (!JRequest::getCmd('view'))
		{
			JRequest::setVar('view', 'article');
		}
		parent::display();
	}
	function delete()
	{
		ResController::delete();
	}
	function cancel()
	{
		$model = JModel::getInstance('record', 'ResModel');
		$model->checkin();

		if ($redirectURL = JRequest::getString('redirect'))
		{
			$url = re64($redirectURL);
			if(strstr($url, '?'))
			{
				$url .= '&lastid='.$model->id;
			}
			else
			{
				$url .= '?lastid='.$model->id;
			}

			$this->setRedirect($url);
			return;
		}
		if($model->id && $model->published)
		{
			$redirect = MEUrl::link_record($model, $catid);
			$this->setRedirect(MERoute::_($redirect, FALSE));
			return;
		}
		if(JRequest::getInt('category_id'))
		{
			$redirect = MEUrl::link_list(JRequest::getInt('category_id'));
			$this->setRedirect(MERoute::_($redirect, FALSE));
			return;
		}
		if (JRequest::getInt('category_idw'))
		{
			$redirect = MEUrl::link_list(JRequest::getInt('category_idw'));
			$redirect = MERoute::_($redirect, FALSE);

		}

		$this->setRedirect($redirect, @$msg);
		return;
	}
	function apply()
	{
		$this->add();
	}

	function add()
	{
		global $mainframe;
		$post = JRequest::get('post');
		$cid = JRequest::getVar('cid', array(0), 'post', 'array');
		$db = & JFactory::getDBO();
		$post['id'] = (int)$cid[0];
		$uri = JFactory::getURI();
		$model = JModel::getInstance('record', 'ResModel');
		$lmodel = JModel::getInstance('list', 'ResModel');
		$config = JFactory::getConfig();
		$isNew = ($post['id'] <= 0);
		$user = & JFactory::getUser();
		$section_id = ResHelper::getArticleSection(JRequest::getInt('article'));
		if (!$section_id) $section_id = ResHelper::getCategorySection(JRequest::getInt('category_id', $post['categories'][0]));

		if(!$section_id)
		{
			JError::raiseNotice(500, JText::_('Error: Section Not defined!'));
			parent::display();
			return;
		}

		$params = ResHelper::initListParams($section_id);
		$iparams = ResHelper::initArticleParams($post['type_id'], '');
		$params->merge($iparams);

		if (! $user->get('id') || ! $params->get('submit_captcha'))
		{
			require_once JPATH_COMPONENT_SITE . DS . 'library'.DS.'php' . DS . 'securimage.php';
			$img = new securimage();
			//$session = &JFactory::getSession();
			//echo $session->get('securimage_code_value').'-';
			//echo $session->getName().'-';
			//echo JRequest::getVar('captcha_text');


			if ($img->check(JRequest::getVar('captcha_text'), 'form') == false)
			{
				JError::raiseWarning(403, JText::_('Security spam protection code do not match'));
				parent::display();
				return;
			}
		}
		if ($params->def('record_submit_limit') && $isNew && (ResHelper::countUserCategoryRecords($section_id, $params) >= $params->def('record_submit_limit')))
		{
			JError::raiseWarning(403,  JText::_('Cannot add record. Maximum submission limit is reached.'));
			parent::display();
			return;
		}

		wordSensor($post['title']);

		$ignore = array();
		if($isNew && !(($user->get('aid') > 1) && $user->get('gid') >= 23))
		{
			$post['access'] = $iparams->get('access');
			$post['published'] = $iparams->get('autopublish');
		}
		if(!$isNew && !(($user->get('aid') > 1) && $user->get('gid') >= 23))
		{
			$ignore[] = 'access';
			$post['published'] = $iparams->get('edit_autopublish');
		}
		if($post['featured'] > 0 && MEAccess::isAdmin())
		{
			if($post['featured'] > 1){
				$send_featured = $post['featured'];
				$post['ftime'] =  ResHelper::getDate($send_featured * 86400);
			}
			$post['featured'] = 1;
		}
		else
		{
			$ignore[] = 'ftime';
			$ignore[] = 'featured';
		}
		if($new_user = JRequest::getInt('custom_user_id'))
		{
			$post['user_id'] = $new_user;
		}
		$post['acces_key'] = '';
		if(JRequest::getInt('client_id') && JRequest::getVar('client'))
		{
			$post['client'] = urldecode(stripslashes(JRequest::getVar('client')));
			$post['client_id'] = JRequest::getInt('client_id');
		}
		else
		{
			$ignore[] = 'client';
			$ignore[] = 'client_id';
		}
		//$ignore[] = 'acces_key';
		
		/*if($isNew && !$post['user_id'])
		{
			$post['acces_key'] = md5(time().'-'.$post['title']);
		}
		else
		{
			$ignore[] = 'acces_key';
		}*/

		if ($model->store($post, $ignore))
		{
			$model->checkin();

			MECache::delete($model->id, 'record');
			MECache::delete_section('filter', $section_id);
			MECache::delete_section('ext_filter', $section_id);
			
			$catid = $post['categories'][0] ? $post['categories'][0] : JRequest::getInt('category_id');

			$link = MEUrl::link_record($model, $catid);

			$art = & JModel::getInstance('article', 'ResModel');
			$art->_id = $model->id;
			$article = $art->getRecord();

			if($isNew)
			{
				if($params->get('activity_add_record'))
				{
					$param['text'] = JText::_($params->get('activity_text_record'));
					$param['text'] .= sprintf(' <a href="%s">%s</a>', MERoute::_($link), $post['title']);
					$param['type'] = JText::_('New'). ' ' . $art->getTypeName($post['type_id']);
					$param['icon'] = $params->get('activity_icon_record');
					MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
				}
				MECommunityHelper::increasKarma($model->user_id, $params->get('karma_add_record'));
				MEAlerts::new_record($article, $params);
			}
			else
			{
				if($params->get('activity_update_record'))
				{
					$param['text'] = JText::_($params->get('activity_text_record_update'));
					$param['text'] .= sprintf(' <a href="%s">%s</a>', MERoute::_($link), $post['title']);
					$param['type'] = JText::_('Updated'). ' ' . $art->getTypeName($post['type_id']);
					$param['icon'] = $params->get('activity_icon_record_update');
					MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
				}
				MECommunityHelper::increasKarma($model->user_id, $params->get('karma_update_record'));
				if(!MEAccess::isAuthor($article->user_id)) 
					MEAlerts::edit_record($article, $params);
			}

			if($user->get('id'))
			{
				$cookieName	= JUtility::getHash( $mainframe->getName() . 'DATAjsr' . $user->get('id'). 'r'. $model->id );
				setcookie($cookieName, time() + 10);
			}
			$msg = JText::_('Record Saved');
			if($iparams->get('edit_autopublish') == 0)
			{
				JError::raiseWarning(100, JText::_('Edited records require admin aproval, so it may not appear in the list immediately'));
			}
			if($iparams->get('autopublish') == 0)
			{
				JError::raiseWarning(100, JText::_('Created records require admin aproval, so it may not appear in the list immediately'));
			}

			if(@$send_featured)
			{
				//$offset = $send_featured * 86400;
				//$date = new JDate(time() + $offset);
				//$ftime = ResHelper::getDate($send_featured * 86400); //$params->get('default_extend') * 86400$date->toMySQL();
				//$sql = "UPDATE #__js_res_record SET ftime = '".$ftime."' WHERE id = {$model->id}";
				//$db->setQuery($sql);
				//$db->query();

				MEAlerts::now_featured($article, $params, $send_featured);

			}
			
			MEAlerts::new_record_admin($isNew, $article, $post, $params);

			if(JRequest::getVar('task') == 'apply')
			{
				if($isNew)
				{
					if($catid)
					{
						$redirect = "index.php?option=com_resource&controller=article&category_id={$catid}&article={$model->id}&layout=form&Itemid=" . MEUrl::itemid(NULL, $catid, $model->id);
						$redirect = MEUrl::linkAdditions($redirect);
						$this->setRedirect(MERoute::_($redirect, FALSE), @$msg);
						$this->redirect();
						return;
					}
				}
				else
				{
					$this->setRedirect($uri->toString(), @$msg);
					$this->redirect();
					return;
				}
			}
			
			switch($params->get('submission_redirect', 0))
			{
				case 0:
					if ($redirectURL = JRequest::getVar('redirect'))
					{
						$url = re64($redirectURL);
						if(strstr($url, '?'))
						{
							$url .= '&lastid='.$model->id;
						}
						else
						{
							$url .= '?lastid='.$model->id;
						}
					
						$this->setRedirect($url, @$msg);
						$this->redirect();
						return;
					}
					break;
					
				case 1:
					if($model->id && $model->published)
					{
						$redirect = MEUrl::link_record($model, $catid);
						$this->setRedirect(MERoute::_($redirect, FALSE), @$msg);
						$this->redirect();
						return;
					}
					break;
					
				case 2:
					if($catid)
					{
						$redirect = MEUrl::link_list($catid);
						$this->setRedirect(MERoute::_($redirect, FALSE), @$msg);
						$this->redirect();
						return;
					}
					break;
					
				case 3:
					if($params->get('redirect_url'))
					{
						$redirect = $params->get('redirect_url');
						$this->setRedirect($redirect, @$msg);
						$this->redirect();
						return;
					}
					break;
			}
			

			
			
			

			//echo $params->get('redirect_url'); exit;
			/*if(JRequest::getInt('article', $model->id) && $model->published)
			{
				$redirect = MEUrl::link_record($model, $catid);
				$this->setRedirect(MERoute::_($redirect, FALSE), @$msg);
				$this->redirect();
				return;
			}
			if($catid)
			{
				$redirect = MEUrl::link_list($catid);
				$this->setRedirect(MERoute::_($redirect, FALSE), @$msg);
				$this->redirect();
				return;
			}*/

			if (JRequest::getInt('category_idw'))
			{
				$redirect = MEUrl::link_list(JRequest::getInt('category_idw'));
				$redirect = MERoute::_($redirect, FALSE);

			}
			else
			{
				$redirect = $uri->toString();
			}

			$this->setRedirect($redirect, @$msg);
			$this->redirect();
			return;
		}
		else
		{
			$msg = JText::_('Error Saving Record') . $model->getError();
			JError::raiseWarning(500, $msg);

		}
		parent::display();
	}
	function add_comment()
	{

		global $mainframe;

		if (! JRequest::getCmd('view'))
		{
			JRequest::setVar('view', 'article');
		}

		$post = JRequest::get('post');

		$model 		= $this->getModel('article', 'ResModel');
		$row 		= JTable::getInstance('comments', 'Res');
		$user 		= & JFactory::getUser();
		$session 	= & JFactory::getSession();
		$article 	= $model->getRecord();
		$uri 		= &JFactory::getURI();
		$db 		= & JFactory::getDBO();

		$category_id = JRequest::getInt('category_id', ResHelper::getArticleSection(JRequest::getInt('article')));

		$params = ResHelper::initListParams($category_id);
		$iparams = ResHelper::initArticleParams($article->type_id, $article->params);
		$params->merge($iparams);

		if (! $user->get('id') || ! $params->get('comment_captcha'))
		{

			require_once JPATH_COMPONENT_SITE . DS . 'library'.DS.'php' . DS . 'securimage.php';
			$img = new securimage();
			if ($img->check(JRequest::getVar('captcha_text'), 'comment') == false)
			{
				JError::raiseWarning(100, JText::_('Security spam protection code do not match'));
				parent::display();
				return;
			}
		}
		if (($user->get('id') < 1) && ($params->def('comments_access') == 1))
		{
			JError::raiseWarning(100, JText::_('Cannot add comment: You must be registered'));
			parent::display();
			return;
		}

		$post['comment'] = JRequest::getVar('comment', '', 'post', 'string', JREQUEST_ALLOWRAW);
		wordSensor($post['comment']);
		wordSensor($post['subject']);

        JPluginHelper::importPlugin('joomsuite_content');
		$dispatcher = & JDispatcher::getInstance();
		$dispatcher->trigger('onCommentSubmit', array(&$post, $article, $iparams));

		if (!$post)
		{
			JError::raiseWarning(100, JText::_('Cannot add comment'));
			parent::display();
			return;
		}

		if (! $row->bind($post))
		{
			JError::raiseWarning(100, JText::_('Cannot add comment: Data binding error'));
			parent::display();
			return;
		}
		if($params->get('comment_attach') && $_FILES['attachment']['tmp_name'])
		{
			$tmp_name = $_FILES['attachment']['tmp_name'];
			$name	= $_FILES['attachment']['name'];
			$size	= $_FILES['attachment']['size'];
			$value 	= $db->getEscaped($name);
			$ext 	= strtolower(substr($name, strrpos($name, '.') + 1));
			$exts 	= explode(", ", strtolower($params->get('comments_allowed_formats')));
			$folder = RES_GENERAL_UPLOAD;

			if(!JFolder::exists($folder))
			{
				if(!JFolder::create($folder))
				{
					$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
					$message .= "<br>".JText::_('Folder').": ".$folder;
					JError::raiseWarning(403, $message);
					parent::display();
					return;
				}
			}
			$folder .= DS.$row->user_id;
			if(!JFolder::exists($folder))
			{
				if(!JFolder::create($folder))
				{
					$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
					$message .= "<br>".JText::_('Folder').": ".$folder;
					JError::raiseWarning(403, $message);
					parent::display();
					return;
				}
			}
			$folder .= DS.'attachments';
			if(!JFolder::exists($folder))
			{
				if(!JFolder::create($folder))
				{
					$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
					$message .= "<br>".JText::_('Folder').": ".$folder;
					JError::raiseWarning(403, $message);
					parent::display();
					return;
				}
			}
			if(!in_array($ext, $exts))
			{
				$msg = JText::_("File is not apropriate format");
				$msg .= "<br>".JText::_('File').": ".$name;
				$msg .= "<br>".JText::_('Allowed formats').": ".implode(", ", $exts);
				JError::raiseWarning(403, $msg);
				parent::display();
				return;
			}
			if(($size > $params->get('comments_attachment_max')) && $params->get('comments_attachment_max'))
			{
				$msg = JText::_("File size exceed allowed");
				$msg .= "<br>".JText::_('File').": ".$name;
				$msg .= "<br>".JText::_('Size').": ".number_format($size, 0, '', ',').' Byte';
				$msg .= "<br>".JText::_('Allowed size').": ".number_format($params->get('comments_attachment_max'), 0, '', ',').' Byte';
				JError::raiseWarning(403, $msg);
				parent::display();
				return;
			}

			if($params->get('comments_attachment_timestamp')){ $name = time().'_'.$name; $value = $name;}

			$dest = $folder.DS.$name;

			if(JFile::exists($dest) && !$params->get('comments_attachment_overwrite'))
			{
				$msg = JText::_("This File already Exists");
				$msg .= "<br>".JText::_('File').": ".$name;
				JError::raiseWarning(403, $msg);
				parent::display();
				return;
			}
			//echo $tmp_name.'<br>'.$dest;
			if(!JFile::upload($tmp_name, $dest))
			{
				$msg = JText::_("Could not upload the file");
				$msg .= "<br>".JText::_('File').": ".$name;
				JError::raiseWarning(403, $msg);
				parent::display();
				return;
			}
			else
			{
				$row->attachment = $name;
			}
		}

		$row->ctime = ResHelper::getDate();
		$row->record_id = JRequest::getInt('article');
		if(!$row->subject) $row->subject = JText::_('Comment for').": ". $article->title;

		if ($params->get('comments_approve'))
		{
			$row->published = 0;
		}
		else
		{
			$row->published = 1;
		}
		if($params->get('comments_hide') == 0)
		{
			$row->hide = $params->get('comments_hide_default');
		}
		if($user->get('aid') < 2)
		{
			$row->access = $params->get('comments_access_default');
		}

		if (! $row->check($params))
		{
			JError::raiseWarning(100, JText::_('Cannot add comment: ') . $row->getError());
			parent::display();
			return;
		}

		if (! $row->store())
		{
			JError::raiseWarning(100, JText::_('Cannot add comment: Store error'));
			parent::display();
			return;
		}
		else
		{

			$sql = "UPDATE #__js_res_record SET mtime = NOW() WHERE id = " . $article->id;
			$db->setQuery($sql);
			$db->query();

			MECache::delete($article->id, 'record');

			$session->set('unforld_comment_'.$row->id, 1);
			setcookie("unforld_comment_{$row->id}", 1, 86400 * 365);

			MECommunityHelper::increasKarma($row->user_id, $params->get('karma_add_comment'), $params->get('karma_add_comment'));
			MECommunityHelper::increasKarma($article->user_id, $params->get('karma_added_comment'), $params->get('karma_added_comment'));

			if(MECommunityHelper::isEnabled())
			{
				if($params->get('activity_add_comment') && $post['user_id'])
				{
					$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

					$param['text'] = JText::_($params->get('activity_text_comment'));
					$param['text'] .= sprintf(' <a href="%s">%s</a>', MERoute::_($link), $article->title);
					$param['type'] = JText::_('Comment For'). ' '.$model->getTypeName($article->type_id);
					$param['icon'] = $params->get('activity_icon_comment');
					$param['user_id'] = $post['user_id'];
					MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
				}
			}

			if ($params->get('type_comment_subscription'))
			{
				jscCountLimit($params->get('type_comment_subscription'), $params->get('type_comment_subscription_count'));
			}

			MEAlerts::comment($row, $article, $params);
			MEAlerts::comment_admin($row, $article, $params);

			JRequest::setVar('sbj', '');
			JRequest::setVar('comment', '');
			$uri->delVar('task');
			$uri->delVar('comment');

			$mainframe->enqueueMessage(JText::_('Your Comment added successfuly'));
			$mainframe->redirect($uri->toString());
		}

		parent::display();
	}

	function download_attachment()
	{
		$user = & JFactory::getUser();
		$id = JRequest::getInt('id');

		$browser =  $_SERVER['HTTP_USER_AGENT'];

		if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser)) {
			$browser =  'OPERA';
		} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser)) {
			$browser =  'IE';
		} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser)) {
			$browser =  'OMNIWEB';
		} else if(ereg('(Konqueror/)(.*)', $browser)) {
			$browser =  'KONQUEROR';
		} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser)) {
			$browser =  'MOZILLA';
		} else {
			$browser =  'OTHER';
		}

		$comment = & JTable::getInstance('Comments', 'Res');
		$comment->load($id);

		$file = RES_GENERAL_UPLOAD.DS.$comment->user_id.DS.'attachments';
		$file .= DS.$comment->attachment;

		if(file_exists($file))
		{
			header('Content-Type: '.(($browser=='IE' || $browser=='OPERA')?
			'application/octetstream':'application/octet-stream'));
			header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.filesize($file));
			header("Content-Encoding: none");
			if($browser=='IE') {
				header('Content-Disposition: attachment; filename="'.basename($comment->attachment).'"');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
			} else {
				header('Content-Disposition: attachment; filename="'.basename($comment->attachment).'"');
				header('Cache-Control: no-cache, must-revalidate');
				header('Pragma: no-cache');
			}

			JSFileManager::readFileChunked($file);

			$comment->attach_hit += 1;
			$comment->store();
		}
		exit;
	}

	function mail()
	{
		if (! JRequest::getCmd('view'))
		{
			JRequest::setVar('view', 'article');
		}
		global $mainframe;

		$prm = &$mainframe->getParams();
		$article_id = JRequest::getInt('article', $prm->get('item'));
		$id = JRequest::getInt('mail');
		$db = & JFactory::getDBO();
		$from = JRequest::getVar('email_from_' . $id);
		$name = JRequest::getVar('name_' . $id);
		$to = JRequest::getVar('email_to');
		$copy_to = JRequest::getVar('copy_to_sender_' . $id );
		$captcha = JRequest::getVar('module_captcha_text');
		$uri = &JFactory::getURI();
			
		$user = & JFactory::getUser();

		$config = JFactory::getConfig();
		$_from = $config->getValue('config.mailfrom');
		$_name = $config->getValue('config.fromname');

		$query = "SELECT v.id, v.field_value, v.params as vparams, f.params, f.title, f.type, r.user_id
		FROM #__js_res_record_values as v " . ' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' . ' LEFT JOIN #__js_res_record AS r ON r.id = v.record_id' . ' WHERE v.record_id = ' . $article_id . ' AND f.published = 1 ' . " AND v.id = '$id'";
		//echo $query;
		$db->setQuery($query);
		$field = $db->loadObject();

		if (! is_object($field) || ! $article_id)
		{
			JError::raiseError(403, JText::_('Cannot send email. Mail information not found'));
			sparent::display();
			return;
		}

		$params = new JParameter($field->params);

		if ($params->get('show_captcha'))
		{
			if(!$params->get('captcha_type') || ($params->get('captcha_type') && !$user->get('id')))
			{
				require_once JPATH_COMPONENT_SITE . DS . 'library'.DS.'php' . DS . 'securimage.php';
				$img = new securimage();
				if ($img->check(JRequest::getVar('mail_captcha_text')) == false)
				{
					JError::raiseWarning(100, JText::_('Security spam protection code do not match'));
					parent::display();
					return;
				}
			}

		}

		if ($params->get('show_email') && ! JMailHelper::isEmailAddress($from))
		{
			JError::raiseWarning(400, JText::_('Email entered not correctly'));
			parent::display();
			return;
		}

		$mail = JFactory::getMailer();
		//$mail = new JMail();

		$subject = (JRequest::getVar('subject_' . $id)!='') ? JRequest::getVar('subject_' . $id) : $params->get('subject');
		$message = JRequest::getVar('body_' . $id, $params->get('body'), 'post', 'string', JREQUEST_ALLOWRAW);

		$model = JModel::getInstance('Article', 'ResModel');
		$article = $model->getRecord();

		$body[] = '<table width="100%" cellpadding="2" cellspacing="2">';
		$body[] = '<tr><td>' . JText::_('Page URL') . ': </td><td>' . $uri->toString() . '</td></tr>';
		$body[] = '<tr><td>' . JText::_('Page Title') . ': </td><td>' . $article->title . '</td></tr>';
		$body[] = '<tr><td>' . JText::_('Mail from') . ': </td><td>' . $name . ' (' . $from . ')</td></tr>';
		$body[] = '<tr valign="top"><td>' . JText::_('Message') . ': </td><td>' . nl2br($message) . '</td></tr>';
		$body[] = '</table>';

		switch ($params->get('to'))
		{
			case 1 :
				$sql = "
				SELECT v.field_value AS email
				FROM #__js_res_record_values AS v
				LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
				LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
				WHERE v.record_id = $article_id
				AND f.type = 'email'";
				$db->setQuery($sql);
				$list = $db->loadObjectList();

				if (is_array($list))
				{
					foreach($list as $email_to)
					{
						$mail->AddAddress($email_to->email);
						//echo "mail to:".$email_to->email;
					}
				}
				break;
			case 2 :
				$mail->AddAddress($_from, $_name);
				//echo "mail to:".$mainframe->getCfg('sitename').$mainframe->getCfg('mailfrom').'<br>';
				break;
			case 3 :
				$author = JFactory::getUser($field->user_id);
				$mail->AddAddress($author->get('email'), $author->get('name'));
				//echo "mail to:".$author->get('email')." ". $author->get('name').'<br>';
				break;
			case 4 :
				if (($params->get('to') == 4) && (! $to || ! JMailHelper::isEmailAddress($to)))
				{
					JError::raiseWarning(400, JText::_('Send to email is missing or not correct'));
					parent::display();
					return;
				}
				$mail->AddAddress($to);
				//echo "mail to: ".$to.'<br>';
				break;
			case 5 :
				$mail->AddAddress($params->get('custom'));
				//echo "mail to:".$params->get('custom').'<br>';
				break;
					
			default :
				break;
		}
		$copy_send_msg = '';
		if ($copy_to)
		{
			$mail->AddCC($from);
			$copy_send_msg = '<li>'.JText::_("Email copy have been sent to sender").'</li>';
		}

		if ($_FILES['attachment_' . $id]['name'])
		{
			$aname = $_FILES['attachment_' . $id]['name'];

			$ext = strtolower(substr($aname, strrpos($aname, '.') + 1));
			$formats = explode(", ", $params->get('formats'));

			if (! in_array(strtolower($ext), $formats))
			{
				JError::raiseWarning(400, JText::_('Could nbot send mail. Wrong Attachment Format.'));
				parent::display();
				return false;
			}
			JFile::copy($_FILES['attachment_' . $id]['tmp_name'], JPATH_CACHE . DS . $aname);
			$mail->addAttachment(JPATH_CACHE . DS . $aname);

		}
		//$sender = '';
		if ($from && ! $name)
		$reply[0] = $from;
		if ($name && $from)
		{
			$reply[0] = $from;
			$reply[1] = $name;
		}
		if (! $reply)
		{
			$reply[0] = $_from;
			$reply[1] = $_name;
		}
		//echo $_name.' '.$_from;
		//print_r($reply);
		//var_dump($sender);
		$sender[0] = $_from;
		$sender[1] = $_name;

		$mail->setSender($sender);
		/*print "<pre>";
		 print_r($mail);
		 print "</pre>";
		 exit;*/
		$mail->addReplyTo($reply);
		$mail->isHTML(true);
		$mail->setBody(JMailHelper::cleanBody(implode("\n", $body)));
		$mail->setSubject(JMailHelper::cleanSubject($subject));

		if (! $mail->Send())
		{
			JError::raiseWarning(400, JText::_('Error: Mail not sent.'));
			parent::display();
			return false;
		}

		//if (!JUtility::sendMail($from, $fromname, $email, $subject, $body))
		//{
		//	JError::raiseWarning(400, 'Error: Mail not sent.');
		//	return false;
		//}
		//$mainframe->enqueueMessage(JText::_('Your mail have been sent successfuly'));
		$mainframe->redirect($uri->toString(), JText::_('Your mail have been sent successfully').$copy_send_msg);
		parent::display();
	}
	function hide_comment()
	{
		$this->unhide_comment('1');
	}
	function unhide_comment($what = '0')
	{
		global $mainframe;

		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$comment_id = JRequest::getInt('comment');
		$category_id = JRequest::getInt('category_id');

		$comment = & JTable::getInstance('Comments', 'Res');
		$comment->load($comment_id);

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($comment->record_id);

		$params = ResHelper::initArticleParams($article->type_id, $article->params);

		$url_params = &$mainframe->getParams();
		$params->merge($url_params);

		if($category_id)
		{
			$list_params = ResHelper::initListParams($category_id);
			$params->merge($list_params);
		}

		if(MEAccess::isAdmin() || MEAccess::isAuthor($comment->user_id, $params->get('comments_hide')))
		{
			$sql = "UPDATE #__js_res_comments SET hide = {$what} WHERE id = {$comment->id}";
			$db->setQuery($sql);
			if ($db->query())
			{
				$mainframe->enqueueMessage(JText::_('Comment Hide/Unhide Successfully'));
			}
		}
		else
		{
			JError::raiseWarning(403, 'You are not authorized to delete comment');
		}
		if($return = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($return));
		}
		parent::display();
	}

	function delete_comment()
	{
		global $mainframe;

		$user = &JFactory::getUser();

		if(!$user->get('id')) MEAccess::login();

		$db = &JFactory::getDBO();
		$comment_id = JRequest::getInt('comment');
		$category_id = JRequest::getInt('category_id');

		$comment = & JTable::getInstance('Comments', 'Res');
		$comment->load($comment_id);

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($comment->record_id);

		$params = ResHelper::initArticleParams($article->type_id, $article->params);

		$url_params = &$mainframe->getParams();
		$params->merge($url_params);

		$list_params = ResHelper::initListParams(JRequest::getInt('category_id'));
		$params->merge($list_params);

		$action = false;

		if(MEAccess::isAdmin()) $action = TRUE;
		if(MEAccess::isModerator($user->get('id'), 'moder_delete_comment', $params)) $action = TRUE;
		if(MEAccess::isAuthor($comment->user_id, $params->get('comments_delete'))) $action = TRUE;
		if(MEAccess::isAuthor($article->user_id, $params->get('comments_approve_author'))) $action = TRUE;

		if($action)
		{
			$karma = $params->get('karma_add_comment');
			if($karma > 0) MECommunityHelper::increasKarma($comment->user_id, ($karma - $karma - $karma));

			$sql = "DELETE FROM #__js_res_comments WHERE id = {$comment->id}";
			$db->setQuery($sql);
			if ($db->query())
			{
				if(!MEAccess::isAuthor($comment->user_id)) MEAlerts::comment_deleted($comment, $article, $params, $user);
				$mainframe->enqueueMessage(JText::_('Comment deleted'));
			}
		}
		else
		{
			JError::raiseWarning(403, 'You are not authorized to delete comment');
		}
		if($return = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($return));
		}
		parent::display();
	}
	function publish_comment()
	{
		global $mainframe;

		$user = &JFactory::getUser();

		if(!$user->get('id')) MEAccess::login();

		$db = &JFactory::getDBO();
		$comment_id = JRequest::getInt('comment');
		$category_id = JRequest::getInt('category_id');

		$comment = & JTable::getInstance('Comments', 'Res');
		$comment->load($comment_id);

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($comment->record_id);

		$params = ResHelper::initArticleParams($article->type_id, $article->params);

		$url_params = &$mainframe->getParams();
		$params->merge($url_params);

		$list_params = ResHelper::initListParams(JRequest::getInt('category_id'));
		$params->merge($list_params);

		if(MEAccess::isAdmin()
		|| MEAccess::isModerator($user->get('id'), 'moder_publish_comment', $params)
		|| MEAccess::isAuthor($article->user_id, $params->get('comments_approve_author')))
		{
			$sql = "UPDATE #__js_res_comments SET published = 1 WHERE id = {$comment->id}";
			$db->setQuery($sql);
			if ($db->query())
			{
				$mainframe->enqueueMessage(JText::_('Comment published'));
			}
		}
		else
		{
			JError::raiseWarning(403, 'You are not authorized to publish comment');
		}
		if($return = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($return));
		}

		parent::display();
	}
}
?>
