<?php
/**
 * $Id: category.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class ResControllerCategory extends JController
{
	function display()
	{
		if ( ! JRequest::getCmd( 'view' ) ) {
			JRequest::setVar('view', 'category' );
		}
		//$this->registerTask('publish', 'unpublish');echo "here"; exit;
		parent::display();
	}
	function add_user_category()
    {
    	ResController::add_user_category();
    }
    
	function cancel()
    {
    	ResController::cancel();
    }
    
	function apply()
    {
    	ResController::apply();
    }
    
	function unpublish()
	{
		global $mainframe;
		
		$db = & Jfactory::getDBO();
		
		$cid = JRequest::getVar('cid', array(), 'post', 'array');
		if(count($cid) <= 0)
		{
			JError::raiseNotice(100, JText::_('No Item selected'));
			parent::display();
			return;
		}
		$ids = implode(", ", $cid);
		
		$sql = "UPDATE #__js_res_category_user SET published = 0 WHERE id IN ($ids)";
		$db->setQuery($sql);
		if($db->query())
		{
			$mainframe->enqueueMessage(JText::_('Category unpublished'));
		}
		parent::display();
	}
	function publish()
	{
		global $mainframe;
		
		$db = & Jfactory::getDBO();
		
		$cid = JRequest::getVar('cid', array(), 'post', 'array');
		if(count($cid) <= 0)
		{
			JError::raiseNotice(100, JText::_('No Item selected'));
			parent::display();
			return;
		}
		$ids = implode(", ", $cid);
		
		$sql = "UPDATE #__js_res_category_user SET published = 1 WHERE id IN ($ids)";
		$db->setQuery($sql);
		if($db->query())
		{
			$mainframe->enqueueMessage(JText::_('Category published'));
		}
		parent::display();
	}
	function remove()
	{
		global $mainframe;
		
		$db = & Jfactory::getDBO();
		$user = & JFactory::getUser();
		$cid = JRequest::getVar('cid', array(), 'post', 'array');
		
		if(count($cid) <= 0)
		{
			JError::raiseNotice(100, JText::_('No Item selected'));
			parent::display();
			return;
		}
		
		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		if($params->get('pcat_submit', 2) > $user->get('aid', 0))
		{
			JError::raiseNotice(100, JText::_('You do not have rights to delete category'));
			parent::display();
			return;
		}
		
		$ids = implode(",", $cid);
		
		$sql = "DELETE FROM #__js_res_category_user WHERE id IN ($ids)";
		$db->setQuery($sql);
		if($db->query())
		{
			$afected = $db->getAffectedRows();
			$mainframe->enqueueMessage(JText::_('Category Deleted'). " [$afected]");
		}
		$sql = "DELETE FROM #__js_res_record WHERE ucatid IN ($ids)";
		$db->setQuery($sql);
		if($db->query())
		{
			$afected = $db->getAffectedRows();
			$mainframe->enqueueMessage(JText::_('Records Deleted'). " [$afected]");
		}
		parent::display();
	}
	function orderup()
	{
		$model = $this->getModel('ucategory');
		$model->move(-1);
		
		$msg = JText::_('Moved up');
		$uri = & JFactory::getURI();
		$this->setRedirect($uri->toString(), $msg);
	}

	function orderdown()
	{
		$model = $this->getModel('ucategory');
		$model->move(1);

		$msg = JText::_('Moved down');
		$uri = & JFactory::getURI();
		$this->setRedirect($uri->toString(), $msg);
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('ucategory');
		$model->saveorder($cid, $order);

		$msg = JText::_('New ordering saved');
		$uri = & JFactory::getURI();
		$this->setRedirect($uri->toString(), $msg);
	}
}
?>
