<?php
/**
 * $Id: jsdirectories.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJsdirectories extends JElement
{

	var	$_name = 'Jsdirectories';

	function fetchElement($name, $value, &$node, $control_name)
	{
		jimport( 'joomla.filesystem.folder' );

		$_ds = '/';

		// path to images directory
		$path		= JPATH_ROOT.$_ds.$node->attributes('directory');

		$path = preg_replace("#([\\\/]*)$#", '', $path);
		if( $path ) {
			$path = realpath( $path );


			$path = str_replace(array('\\', '/'), $_ds, $path );
		} else {
			$path=$_ds;
		}

		$filter		           = $node->attributes('filter');
		$exclude	           = $node->attributes('exclude');
		$levels              = $node->attributes('levels');
		$levels              = ( $levels == '' ) ? -1 : $levels;
		$relative_path       = $node->attributes('relative_path');
		$relative_path_value = $node->attributes('relative_path_value');
		$invite_label        = $node->attributes('invite_label');
		$folders             = $this->JS_folders($path, $path, $filter, $levels);

		$options = array ();

		foreach ( $folders as $key => $folder ){
			$folders[$key] = str_replace( array('\\', '/'), $_ds, $folder );
		}

		foreach ($folders as $folder){
			if ($relative_path == 1) {
				$folder_label = str_replace($path.$_ds, '', $folder);
			} else {
				$folder_label = str_replace(JPATH_ROOT.$_ds, '', $folder);
			}
			if( $relative_path_value == 'root' ){

				$folder = str_replace( $path.$_ds, '', $folder );
			} else if ( $relative_path_value == 'absolute' ){
				//doing nothing
			} else {

				$folder = str_replace(JPATH_ROOT.$_ds, '', $folder);
			}

			if ($exclude){
				if (preg_match( chr( 1 ) . $exclude . chr( 1 ), $folder_label )) {
					continue;
				}
			}
			$folder_temp='';
			while($folder_temp != $folder) { //if in path exist '..' cut this
				$folder_temp = $folder;
				$folder = preg_replace( '#(\\'.$_ds.'[^\\'.$_ds.']*\\'.$_ds.'\\.\\.)#', '', $folder);
			}

			$options[] = JHTML::_('select.option', $folder, $folder_label);
		}

		if (!$node->attributes('hide_none')) {
			if(!$invite_label){
				$invite_label = 'Do not use';
			}
			array_unshift($options, JHTML::_('select.option', '-1', '- '.JText::_($invite_label).' -'));
		}

		if (!$node->attributes('hide_default')) {
			array_unshift($options, JHTML::_('select.option', '', '- '.JText::_('Use default').' -'));
		}

		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']', 'class="inputbox"', 'value', 'text', $value, "param$name");
	}

	function JS_folders($path, $init_path, $filter = '.', $levels = -1, $exclude = array('.svn', 'CVS'))
	{

		$arr = array ();

		// Check to make sure the path valid and clean
		$path = JPath::clean($path);

		// Is the path a folder?
		if (!@is_dir($path)) {
			JError::raiseWarning(21, JText::_('Error: Directory element: Path is not a folder').' '.$path);
			return false;
		}

		// read the source directory
		$handle = opendir($path);
		while (($file = readdir($handle)) !== false)
		{
			$dir = $path.DS.$file;
			$isDir = @is_dir($dir);
			if (($file != '.') && ($file != '..') && (!in_array($file, $exclude)) && $isDir) {
				// removes SVN directores from list
				if (preg_match("/$filter/", $file)) {
					$arr[] = $dir;
					/*if ($relative_path == 0) {
					$arr[] = str_replace(JPATH_ROOT.DS, '', $dir);
					} else {
					$arr[] = str_replace($init_path.DS, '', $dir);
					}*/
				}
				if ( $levels == -1 || $levels > 0) {
					if (is_integer($levels*1) && $levels > 0) {
						$down_levels = $levels - 1;
					} else {
						$down_levels = $levels;
					}

					$arr2 = $this->JS_folders($dir, $init_path, $filter, $down_levels );
					$arr = array_merge($arr, $arr2);
				}
			}
		}
		closedir($handle);
		/*foreach( $arr as $fkey => $folder ){
			$arr[$fkey] = preg_replace("#(^[\\\/])#", '', $folder);
		}*/
		asort($arr);
		return $arr;
	}

}