<?php
/**
 * $Id: sectiontemplate.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Restricted access');

class JElementSectionTemplate extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		$pluginName = $node->attributes('plugin_name');
			
		$template = new JS_People_Touch_Resource_Section_Template($pluginName, $value);
		
		return $template->getTemplateHTMLList($control_name.'['.$name.']');
	}
}

/**
 * The helper class that fethces list of templates.
 * @author Nurlan
 *
 */
class JS_People_Touch_Resource_Section_Template extends JObject {
	/**
	 * The plugin name.
	 * @var string
	 */
	var $_pluginName;
	
	/**
	 * The 
	 * @var string
	 */
	var $_template;
	
	function __construct($pluginName, $template) {
		parent::__construct();
		jimport ('joomla.filesystem.file');
		
		$this->_pluginName = $pluginName;
		$this->_template = JFile::makeSafe($template);
	}
	
	/**
	 * Returns the current template file path.
	 * @return string
	 */
	function getTemplatePath() {
		if (!$this->_template) 
			return JPATH_PLUGINS.DS.'community'.DS.'resource'.DS.$this->_getDefaultTemplate().'.php';
		
		$this->_template = JFile::makeSafe($this->_template);
		 
		return JPATH_PLUGINS.DS.'community'.DS.'resource'.DS.$this->_pluginName.DS.$this->_template.'.php';
	}
	
	function getTemplateHTMLList($name) {
		return JHTML::_('select.genericlist', $this->getTemplateHTMLOptions(), $name, array('class' => 'inputbox'), 'value', 'text', $this->_template);
	}
	
	/**
	 * 
	 * @return array ready for JHTMLSelect::genericlist
	 */
	function getTemplateHTMLOptions() {
		jimport ('joomla.filesystem.folder');
		
		$options = array();
		
		$files = JFolder::files(JPATH_PLUGINS.DS.'community'.DS.'resource'.DS.$this->_pluginName, '.php');
		
		$defTmpl = new stdClass;
		$defTmpl->value = 0;
		$defTmpl->text = '-- '.JText::_('Default').' --';
		
		$options [] = $defTmpl;
		
		foreach ($files as $tmpl) {
			$tmpl = JFile::stripExt($tmpl);
			$tmplName = str_replace('_', ' ', JString::ucfirst($tmpl));
			$options [] = JHTML::_('select.option', $tmpl, $tmplName);
		}
			
		return $options;
	}
	
	/**
	 * Fetches section template for
	 * @access private 
	 * @return string
	 */
	function _getDefaultTemplate() {
		static $templates = 0;
		if (!$templates) {
			$templates = array(
				'resource_created_articles' => 'created',
				'resource_comments' => 'comments',
				'resource_favourite_articles' => 'favourite',
				'resource_visited_articles' => 'visited',
				'resource_rated_articles' => 'rated',
				'resource_user_tags' => 'tags'
			);
		}
		
		return @$templates[$this->_pluginName];
	}
	
	function setPluginNameFromViewWhat($viewWhat) {
		$templates = array(
			'created' => 'resource_created_articles',
			'commented' => 'resource_comments',
			'favorites' => 'resource_favourite_articles',
			'last-visited' => 'resource_visited_articles',
			'rated' => 'resource_rated_articles',
			'tags' => 'resource_user_tags' 
		);
		
		if (!empty($templates[ $viewWhat ]))
			$this->_pluginName = $templates[ $viewWhat ];
	}
}

?>