<?php
/**
 * $Id: alerts.php 7556 2011-11-29 11:53:47Z sergey $
 * $LastChangedDate: 2011-11-29 17:53:47 +0600 (Tue, 29 Nov 2011) $
 * $LastChangedBy: sergey $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.mail.helper');
class MEAlerts
{

	function new_record_admin($isnew, $article, $post, $params)
	{
		$to = array();

		$emails = explode(",", $params->get('alert_record_custom'));
		foreach ($emails AS $email)
		{
			if(JMailHelper::isEmailAddress(trim($email)))
			{
				$to[$email] = array(trim($email), 'Custom');
			}
		}

		$ids = explode(',', $params->get('moder_delete_record'));

		$add = explode(',', $params->get('moder_publish_record'));
		$ids = array_merge($ids, $add);

		$add = explode(',', $params->get('moder_edit_record'));
		$ids = array_merge($ids, $add);

		$ids = array_flip($ids);
		$ids = array_flip($ids);

		foreach ($ids AS $id)
		{
			$id = trim($id);
			if(!$id) continue;
			$moder = JFactory::getUser($id);
			if(!$moder) continue;
			$to[$moder->get('email')] = array($moder->get('email'), $moder->get($params->get('item_author_mode', 'username')));
		}

		if($params->get('alert_record_admin'))
		{
			$admin = JFactory::getUser($params->get('alert_record_admin'));
			$to[$admin->get('email')] = array($admin->get('email'), $admin->get($params->get('item_author_mode', 'username')));
		}
		
		$user = JFactory::getUser();
		unset($to[$user->get('email')]);
		
		if(empty($to)) return; 
		
		$model = & JModel::getInstance('Article', 'ResModel');
		$lmodel = JModel::getInstance('list', 'ResModel');

		$access = array(JText::_('Public'), JText::_('Registered'), JText::_('Special'));
		$published = array(JText::_('No'), JText::_('Yes'));
		$author = JFactory::getUser($article->user_id);

		$article_link = MEUrl::link_record($article, JRequest::getInt('category_id'));
		$category = JRequest::getInt('category_id', ResHelper::getArticleSection($article->id));
		$return = base64_encode(MEUrl::link_list($category));
		$message = MEAlerts::_get_alert_file('admin_new_record', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link(JURI::root().JRoute::_($article_link), $article->title), $message);		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[AUTHOR]', $author->get($params->get('item_author_mode', 'username'), JText::_('Anonymous')), $message);
		$message = str_replace('[EMAIL]', $author->get('email', JText::_('No Email')), $message);
		$message = str_replace('[IP]', $_SERVER['REMOTE_ADDR'], $message);
		$message = str_replace('[PUBLISHED]', $published[$article->published], $message);
		$message = str_replace('[ACCESS]', $access[$article->access], $message);
		$message = str_replace('[LANG]', $article->langs, $message);

		$body = array(); $k = 0;
		foreach($post['fields'] as $key => $val)
		{
			if(!is_int($key)) continue;
			$value = $lmodel->getFieldValue2( $key, $article, $article->user_id, $category );
			if (!$value)	continue;
			$k = 1 - $k;
			$body[] = sprintf('<tr valign="top" class="%d"><td class="key">%s:</td><td>%s</td></tr>', ($k + 1), $lmodel->getFieldName($key), $value);
		}
		$message = str_replace('[FIELDS]', implode("\n", $body), $message);

		$link = 'index.php?option=com_resource&task='.($article->published ? 'unpublish' : 'publish' ).'&id='.$article->id.'&category_id='.$category.'&return='.base64_encode(MERoute::_($article_link, FALSE));
		if($article->published && $params->get('alert_unpublish')) 
			$link = 'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link);

		$actions[] = JHTML::link(JURI::root().$link, ($article->published ? JText::_('Unpublish record') : JText::_('Approve record') ));

		$link = 'index.php?option=com_resource&task=delete&id='.$article->id.'&category_id='.$category.'&return='.$return;
		if($params->get('alert_delete'))
			$link = 'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode(MERoute::_($link, FALSE));
		$actions[] = JHTML::link(JURI::root().$link, JText::_('Delete Record'));
		$uri = &JFactory::getURI();
		$article_link .= "&layout=form&redirect=".base64_encode(MERoute::_($article_link, FALSE));
		$actions[] = JHTML::link($uri->toString( array('scheme', 'host', 'port') ).JRoute::_($article_link), JText::_('Edit Record'));

		$message = str_replace('[DELETE]', implode(', ', $actions), $message);

		if($isnew)
		{
			$subject = '!'.JText::_('New record');
		}
		else
		{
			$subject = '!'.JText::_('Edited record');
		}
		$subject .= ' ('.$model->getTypeName($article->type_id).') '.$article->title;


		if($author->get('id'))
		{
			$sender[] = $author->get('email');
			$sender[] = $author->get($params->get('item_author_mode', 'username'));
		}
		
		/*$db = & JFactory::getDBO();
		$sql = "SELECT v.field_value AS email, r.user_id
		FROM #__js_res_record_values AS v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
		WHERE v.record_id = $article->id
		AND (f.type = 'email' OR f.type = 'notifyuser')";
		$db->setQuery($sql);
		$emails = $db->loadObjectList();
		
		foreach($emails as $email)
		{
			if(preg_match('/^[0-9]*$/iU', $email))
			{
				$u = & JFactory::getUser($email);
				if(!JMailHelper::isEmailAddress($u->get('email'))) continue;
				$to[$u->get('email')] = array($u->get('email'), $u->get('username'));
			}
			else
			{
				$email = strtolower($email->email);
				if(!JMailHelper::isEmailAddress($email)) continue;
				$to[$email] = array($email, JText::_('Anonymous'));
			}
		}*/
			
		

		MEAlerts::_send($article->type_id, $to, $message, $subject, @$sender);
	}
	function comment_vote_admin($comment, $article, $params, $mode)
	{
		$model = & JModel::getInstance('Article', 'ResModel');

		$user = JFactory::getUser();
		if(!$user->get('id')) return;

		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));
		$category = JRequest::getInt('category_id', ResHelper::getArticleSection($article->id));
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('admin_comment_rating', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link).'#comment_'.$comment->id, $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[RATE_AMOUNT]', $mode, $message);
		$message = str_replace('[VOTER]', $user->get($params->get('item_author_mode', 'username'), JText::_('Anonymous')), $message);
		$message = str_replace('[EMAIL]', $user->get('email', JText::_('No Email')), $message);
		$message = str_replace('[IP]', $_SERVER['REMOTE_ADDR'], $message);
		$message = str_replace('[COMMENT]', $comment->comment, $message);
		$message = str_replace('[COMMENTER]', $comment->name, $message);
		$message = str_replace('[COM_EMAIL]', $comment->email, $message);
		$link = JURI::root().'index.php?option=com_resource&task=delete_comment_vote&user_id='.$user->get('id').'&id='.$comment->id.'&mode='.urlencode($mode).'&category_id='.$category.'&return='.base64_encode($link);
		$message = str_replace('[DELETE]', JHTML::link(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link), JText::_('Delete Vote')), $message);

		$subject = '!'.JText::_('New comment vote').' ('.$model->getTypeName($article->type_id).') ['.$mode.'1] '.$article->title;

		$to = array();

		$emails = explode(",", $params->get('alert_comment_rating_custom'));
		foreach ($emails AS $email)
		{
			if(JMailHelper::isEmailAddress(trim($email)))
			{
				$to[$email] = array(trim($email), 'Custom');
			}
		}

		$ids = explode(',', $params->get('moder_delete_comment_vote'));

		foreach ($ids AS $id)
		{
			$id = trim($id);
			if(!$id) continue;
			$moder = JFactory::getUser($id);
			$to[$moder->get('email')] = array($moder->get('email'), $moder->get($params->get('item_author_mode', 'username')));
		}

		if($params->get('alert_comment_rating_admin'))
		{
			$admin = JFactory::getUser($params->get('alert_comment_rating_admin'));
			$to[$admin->get('email')] = array($admin->get('email'), $admin->get($params->get('item_author_mode', 'username')));
		}

		if($user->get('id'))
		{
			$sender[] = $user->get('email');
			$sender[] = $user->get($params->get('item_author_mode', 'username'));
		}

		if($to) MEAlerts::_send($article->type_id, $to, $message, $subject, @$sender);
	}
	function comment_admin($comment, $article, $params)
	{
		$model = & JModel::getInstance('Article', 'ResModel');
		$category = JRequest::getInt('category_id', ResHelper::getArticleSection($article->id));
		$author = JFactory::getUser($article->user_id);
		$link = MEUrl::link_record($article, $category);
		$access = array(JText::_('Public'), JText::_('Registered'), JText::_('Special'));

		$commenter = JFactory::getUser($comment->user_id);
		
		$uri = &JFactory::getURI();

		$message = MEAlerts::_get_alert_file('admin_comment', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link).'#comment_'.$comment->id, $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[COMMENTER]', $commenter->get($params->get('item_author_mode', 'username'), JText::_('Anonymous')), $message);
		$message = str_replace('[IP]', $_SERVER['REMOTE_ADDR'], $message);

		$link_delete = JURI::root().'index.php?option=com_resource&controller=article&task=delete_comment&comment='.$comment->id.'&category_id='.$category.'&return='.base64_encode(MERoute::_($link, FALSE));
		$adminlinks[] = JHTML::link(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link_delete), JText::_('Delete Comment'));
		if($comment->published == 0)
		{
			$link_publish = JURI::root().'index.php?option=com_resource&controller=article&task=publish_comment&comment='.$comment->id.'&category_id='.JRequest::getInt('category_id').'&return='.base64_encode(MERoute::_($link, FALSE));
			$adminlinks[] = JHTML::link($link_publish, JText::_('Publish Comment'));

		}
		$message = str_replace('[DELETE]', implode(', ', $adminlinks), $message);

		$uri = &JFactory::getURI();
		$uri->setVar('task', 'download_attachment');
		$uri->setVar('id', $comment->id);
		
		$message = str_replace('[SUBJECT]', $comment->subject, $message);
		$message = str_replace('[BODY]', $comment->comment, $message);
		$message = str_replace('[ACCESS]', $access[$comment->access], $message);
		$message = str_replace('[ATTACHMENT]', JHTML::link($uri->toString(), $comment->attachment), $message);

		$uri->delVar('task', 'download_attachment');
		$uri->delVar('id', $comment->id);
					
		$subject = '!'.JText::_('New Comment').' ('.$model->getTypeName($article->type_id).') '.$article->title;

		$to = array();

		$emails = explode(",", $params->get('alert_comment_custom'));
		foreach ($emails AS $email)
		{
			if(JMailHelper::isEmailAddress(trim($email)))
			{
				$to[$email] = array(trim($email), 'Custom');
			}
		}

		$ids = explode(',', $params->get('moder_delete_comment'));

		if($comment->published == 0)
		{
			$add = explode(',', $params->get('moder_publish_comment'));
			$ids = array_merge($ids, $add);
		}

		$ids = array_flip($ids);
		$ids = array_flip($ids);

		foreach ($ids AS $id)
		{
			$id = trim($id);
			if(!$id) continue;
			$moder = JFactory::getUser($id);
			$to[$moder->get('email')] = array($moder->get('email'), $moder->get($params->get('item_author_mode', 'username')));
		}

		if($params->get('comments_approve_author') && $author->get('id'))
		{
			$to[$author->get('email')] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));
		}

		if($params->get('alert_comment_admin'))
		{
			$admin = JFactory::getUser($params->get('alert_comment_admin'));
			$to[$admin->get('email')] = array($admin->get('email'), $admin->get($params->get('item_author_mode', 'username')));
		}
		if($commenter->get('id'))
		{
			$sender[] = $commenter->get('email');
			$sender[] = $commenter->get($params->get('item_author_mode', 'username'));
		}

		if($to) MEAlerts::_send($article->type_id, $to, $message, $subject, @$sender);

	}
	function rating_admin($article, $link, $vote, $params, $insertid)
	{
		$model = & JModel::getInstance('Article', 'ResModel');
		$category = JRequest::getInt('category_id', ResHelper::getArticleSection($article->id));

		$user = JFactory::getUser();

		$message = MEAlerts::_get_alert_file('admin_rating', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($link, $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[RATE_AMOUNT]', $vote, $message);
		$message = str_replace('[RATE_USER]', $user->get($params->get('item_author_mode', 'username'), JText::_('Anonymous')), $message);
		$message = str_replace('[EMAIL]', $user->get('email', JText::_('No Email')), $message);
		$message = str_replace('[IP]', $_SERVER['REMOTE_ADDR'], $message);
		$link = JURI::root().'index.php?option=com_resource&task=delete_vote&id='.$insertid.'&category_id='.$category.'&return='.base64_encode($link);
		$message = str_replace('[DELETE]', JHTML::link(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link), JText::_('Delete Vote')), $message);


		$subject = '!'.JText::_('New vote').' ('.$model->getTypeName($article->type_id).') ['.$vote.'%] '.$article->title;

		$to = array();

		$emails = explode(",", $params->get('alert_rating_custom'));
		foreach ($emails AS $email)
		{
			if(JMailHelper::isEmailAddress(trim($email)))
			{
				$to[$email] = array(trim($email), 'Custom');
			}
		}

		// moder_delete_record
		// moder_publish_record
		// moder_edit_record
		// moder_publish_comment
		// moder_delete_comment
		// moder_delete_vote
		// moder_delete_comment_vote

		$ids = explode(',', $params->get('moder_delete_vote'));

		//$add = explode(',', $params->get(''));
		//$ids = array_merge($ids, $add);

		//$add = explode(',', $params->get(''));
		//$ids = array_merge($ids, $add);

		foreach ($ids AS $id)
		{
			$id = trim($id);
			if(!$id) continue;
			$moder = JFactory::getUser($id);
			$to[$moder->get('email')] = array($moder->get('email'), $moder->get($params->get('item_author_mode', 'username')));
		}

		if($params->get('alert_rating_admin'))
		{
			$admin = JFactory::getUser($params->get('alert_rating_admin'));
			$to[$admin->get('email')] = array($admin->get('email'), $admin->get($params->get('item_author_mode', 'username')));
		}

		if($user->get('id'))
		{
			$sender[] = $user->get('email');
			$sender[] = $user->get($params->get('item_author_mode', 'username'));
		}

		if($to) MEAlerts::_send($article->type_id, $to, $message, $subject, @$sender);

	}
	function rating($article, $link, $vote, $params)
	{
		if($params->get('alert_rating') <= 0) return;

		$author = JFactory::getUser($article->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$user = JFactory::getUser();
		$uname = $user->get($params->get('item_author_mode', 'username'));
		if(!$uname) $uname = JText::_('Anonymous');

		$message = MEAlerts::_get_alert_file('rating', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($link, $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[RATE_AMOUNT]', $vote, $message);
		$message = str_replace('[RATE_USER]', str_replace("\n", '', $uname), $message);

		if(!$message) return;

		$subject = JText::_('New vote').' ('.$model->getTypeName($article->type_id).') ['.$vote.'%]  '.$article->title;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		$email = MEAlerts::_get_record_email($article->id);
		if($email && ($email != $author->get('email')))
		{
			$to[] = $email;
		}
		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function rating_delete($row, $params)
	{
		if($params->get('alert_rating_delete') === 0) return;

		$author = JFactory::getUser($row->user_id);
		if(!$author->get('email')) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$link = MEUrl::link_record($row, JRequest::getInt('category_id'));
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('rating_deleted', $row->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $row->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($row->type_id), $message);

		if(!$message) return;

		$subject = JText::_('Vote deleted').' ('.$model->getTypeName($row->type_id).') '.$row->title;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		MEAlerts::_send($row->type_id, $to, $message, $subject);
	}
	function comment_rating_delete($id, $params)
	{
		if($params->get('alert_comment_rate_delete') === 0) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$comment = & JTable::getInstance('Comments', 'Res');
		$comment->load($id);

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($comment->record_id);

		$author = JFactory::getUser(JRequest::getInt('user_id'));
		if(!$author->get('email')) return;

		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('comment_rating_deleted', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ). MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[COMMENT]', '<div class="email_note email_paragraph">'.$comment->comment.'</div><br />', $message);
		$message = str_replace('[COMMENTER]', $comment->name, $message);

		if(!$message) return;

		$subject = JText::_('Comment vote deleted').' ('.$model->getTypeName($article->type_id).') '.$article->title;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}

	function featured_finished($item, $iparams, $params)
	{
		$params->merge($iparams);

		if(!$params->get('alert_fetured_finished', 1)) return;
		if(!$item->user_id) return;

		$user = JFactory::getUser($item->user_id);
		if(!JMailHelper::isEmailAddress($user->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$subject = JText::_('[Record is not featured any more]:').' ('.$model->getTypeName($item->type_id).') '.$item->title;

		$message = MEAlerts::_get_alert_file('feature_finished', $item->type_id);
		$message = str_replace('[RECORD]', JHTML::link($item->link, $item->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($item->type_id), $message);
		if(!$message) return;

		$to[] = array($user->get('email'), $user->get($iparams->get('item_author_mode', 'username')));

		MEAlerts::_send($item->type_id, $to, $message, $subject);
	}
	function now_featured($item, $iparams, $days)
	{
		if(!$iparams->get('alert_now_featured', 1)) return;
		if(!$item->user_id) return;
		
		$user = JFactory::getUser($item->user_id);
		if(!JMailHelper::isEmailAddress($user->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($item, JRequest::getInt('category_id'));
		
		$time =  time() + ($days * 86400);
		$time = JFactory::getDate($time);

		$subject = JText::_('Record is now featured').' ('.$model->getTypeName($item->type_id).') '.$item->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('now_featured', $item->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ). MERoute::_($link), $item->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($item->type_id), $message);
		$message = str_replace('[DAYS]', $days, $message);
		$message = str_replace('[TIME]', $time->toFormat('%d %B %Y'), $message);
		if(!$message) return;

		$to[] = array($user->get('email'), $user->get($iparams->get('item_author_mode', 'username')));

		MEAlerts::_send($item->type_id, $to, $message, $subject);
	}
	function expire($item, $iparams, $params)
	{
		$params->merge($iparams);

		if(!$params->get('alert_expire', 1)) return;
		if(!$item->user_id) return;

		$user = JFactory::getUser($item->user_id);
		if(!JMailHelper::isEmailAddress($user->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$subject = JText::sprintf('Record Expire in %s days', $iparams->get('alert_expire_day', 1)).' ('.$model->getTypeName($item->type_id).') '.$item->title;

		$message = MEAlerts::_get_alert_file('expire', $item->type_id);
		$message = str_replace('[RECORD]', JHTML::link($item->link, $item->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($item->type_id), $message);
		$message = str_replace('[ID]', $item->id, $message);
		$message = str_replace('[RETURN]', base64_encode(MEUrl::link_record($item, JRequest::getInt('category_id'))), $message);
		$message = str_replace('[HTTP_ROOT]', JURI::root(), $message);
		$message = str_replace('[DAYS]', $iparams->get('alert_expire_day', 1), $message);
		if(!$message) return;

		$to[] = array($user->get('email'), $user->get($iparams->get('item_author_mode', 'username')));

		MEAlerts::_send($item->type_id, $to, $message, $subject);
	}
	function extended($item, $iparams, $time)
	{
		//$params->merge($iparams);

		if(!$iparams->get('alert_extended', 1)) return;
		if(!$item->user_id) return;
		if(!is_object($time)) $time = JFactory::getDate($time);

		$user = JFactory::getUser($item->user_id);
		if(!JMailHelper::isEmailAddress($user->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($item, JRequest::getInt('category_id'));

		$subject = JText::_('Record Extended').' ('.$model->getTypeName($item->type_id).') '.$item->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('extended', $item->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $item->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($item->type_id), $message);
		$message = str_replace('[DAYS]', $iparams->get('default_extend'), $message);
		$message = str_replace('[TIME]', $time->toFormat('%d %B %Y'), $message);
		if(!$message) return;

		$to[] = array($user->get('email'), $user->get($iparams->get('item_author_mode', 'username')));

		MEAlerts::_send($item->type_id, $to, $message, $subject);
	}
	function expired($item, $iparams, $params)
	{
		$params->merge($iparams);

		if(!$params->get('alert_expire', 1)) return;
		if(!$item->user_id) return;

		$user = JFactory::getUser($item->user_id);
		if(!JMailHelper::isEmailAddress($user->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');

		$subject = JText::_('Record Expired').' ('.$model->getTypeName($item->type_id).') '.$item->title;

		$message = MEAlerts::_get_alert_file('expired', $item->type_id);
		$message = str_replace('[RECORD]', JHTML::link($item->link, $item->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($item->type_id), $message);
		$message = str_replace('[ID]', $item->id, $message);
		$message = str_replace('[RETURN]', base64_encode(MEUrl::link_record($item, JRequest::getInt('category_id'))), $message);
		$message = str_replace('[HTTP_ROOT]', JURI::root(), $message);
		if(!$message) return;

		$to[] = array($user->get('email'), $user->get($iparams->get('item_author_mode', 'username')));

		MEAlerts::_send($item->type_id, $to, $message, $subject);
	}
	function favorite($article, $params)
	{
		if(!$params->get('alert_favorite', 1)) return;
		if(!$article->user_id) return;

		$author = JFactory::getUser($article->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;

		$user = JFactory::getUser();
		$uname = $user->get($params->get('item_author_mode', 'username'));
		if(!$uname) $uname = JText::_('Anonymous');

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('Added to favorites').' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('favorited', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ). MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[FAV_USER]', str_replace("\n", '', $uname), $message);
		if(!$message) return;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function custom($article, $subject, $body, $params = null, $options = array())
	{
		$options_ = array(
			'cusotm_email' => 'ser@ser.de, fert@er.fg',
			'email_field'	=> 1,
			'immediate'	=> 1
		);
		$to = array();

		if(!$article) return;
		jimport('joomla.application.component.model');
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		$model = & JModel::getInstance('Article', 'ResModel');

		if(is_integer($article)) $article = $model->getArticle((int)trim($article));
		
		if(!$params) $params = ResHelper::initArticleParams($article->type_id);

		if($article->user_id)
		{
			$author = JFactory::getUser($article->user_id);
			//if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;
		}

		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_($subject).' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('custom_email', $article->type_id);
		$message = str_replace('[CUSTOM]', $body, $message);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		if($article->user_id)
		{
			$message = str_replace('[USER_NAME]', str_replace("\n", '', $author->get($params->get('item_author_mode', 'username'))), $message);
		}
		else
		{
			$message = str_replace('[USER_NAME]', JText::_('Anonymous'), $message);
		}
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		if(!$message) return;

		if($article->user_id) $to[$author->get('email')] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));


		if(@$options['cusotm_email'])
		{
			$emails = explode(",", $options['cusotm_email']);
			foreach ($emails AS $email)
			{
				if(JMailHelper::isEmailAddress(trim($email)))
				{
					$to[trim($email)] = array(trim($email), 'Custom');
				}
			}
		}
		if(@$options['email_field'])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT v.field_value AS email, r.user_id
			FROM #__js_res_record_values AS v
			LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			WHERE v.record_id = $article->id
			AND f.type = 'email'";
			$db->setQuery($sql);
			$emails = $db->loadObjectList();

			foreach($emails as $email)
			{
				$email = strtolower($email->email);
				if(!JMailHelper::isEmailAddress($email)) continue;
				$to[$email] = array($email, ($article->user_id ? $author->get($params->get('item_author_mode', 'username')) : JText::_('Anonymous')));
			}
		}

		MEAlerts::_send($article->type_id, $to, $message, $subject, null, @$options['immediate']);
	}

	function publish($article, $what)
	{
		$params = ResHelper::initArticleParams($article->type_id);

		if($what == 1)
		{
			if(!$params->get('alert_publish', 1)) return;
		}
		elseif($what == -1)
		{
			if(!$params->get('alert_archive', 1)) return;
		}
		else
		{
			if(!$params->get('alert_unpublish', 1)) return;
		}
		if(!$article->user_id) return;

		$user = JFactory::getUser();

		$author = JFactory::getUser($article->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_(($what == 1 ? 'Approved' : ($what == -1 ? 'Archived' : 'Unpublished'))).' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file(($what == 1 ? 'approved' : ($what == -1 ? 'archive' : 'unpublished')), $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		$message = str_replace('[WHO]', str_replace("\n", '', $user->get($params->get('item_author_mode', 'username'))), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);

		if(!$message) return;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function delete($article)
	{
		$params = ResHelper::initArticleParams($article->type_id);

		if(!$params->get('alert_delete', 1)) return;
		if($article->user_id && !MEAccess::isAuthor($article->user_id))
		{
    		$author = JFactory::getUser($article->user_id);
    		if(JMailHelper::isEmailAddress($author->get('email', '123'))) 
    		{
        		$to[$author->get('email')] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));
    		}
		    
		}
	    
		$emails = explode(",", $params->get('alert_delete_custom'));
		foreach ($emails AS $email)
		{
			if(JMailHelper::isEmailAddress(trim($email)))
			{
				$to[$email] = array(trim($email), 'Custom');
			}
		}
		
		if($params->get('alert_delete_admin'))
		{
			$admin = JFactory::getUser($params->get('alert_delete_admin'));
			$to[$admin->get('email')] = array($admin->get('email'), $admin->get($params->get('item_author_mode', 'username')));
		}
		
		$user = JFactory::getUser();
		
		unset($to[$user->get('email')]);

		if(empty($to))
		{
		    return;
		}
		
		$model = & JModel::getInstance('Article', 'ResModel');

		$subject = JText::_('Deleted').' ('.$model->getTypeName($article->type_id).') '.$article->title;

		$message = MEAlerts::_get_alert_file('deleted', $article->type_id);
		$message = str_replace('[RECORD]', $article->title, $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);

		if(!$message) return;

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}

	function edit_record($article, $params)
	{
		if(!$params->get('alert_edit', 1)) return;
		if(!$article->user_id) return;

		$author = JFactory::getUser($article->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;

		$user = JFactory::getUser();

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('Edited').' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('edited', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ). MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[EDITOR]', $user->get($params->get('item_author_mode', 'username')), $message);

		if(!$message) return;

		$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function new_record($article, $params)
	{
		if(!$params->get('alert_new', 1)) return;
		
		if($article->user_id)
		{
			$author = JFactory::getUser($article->user_id);
			if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;
		}

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('New Record').' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('new_record', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		if($article->user_id)
		{
			$message = str_replace('[USER_NAME]', str_replace("\n", '', $author->get($params->get('item_author_mode', 'username'))), $message);
		}
		else
		{
			$message = str_replace('[USER_NAME]', JText::_('Anonymous'), $message);
		}
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);

		$note = array();
		if($params->get('autopublish') == 0)
		{
			$note[] = '<div class="email_note email_paragraph">'.JText::_('This message is going to path moderation process before it become publicly available.').'</div><br />';
		}
		if(!$article->user_id)
		{
			$note[] = '<div class="email_note email_paragraph">'.JText::_('Although you are not registered, here is the link to edit this record.').
			' <a href="'.JURI::root().'index.php?option=com_resource&controller=utility&task=edit&id='.$article->id.'">'.JText::_('Edit').'</a></div><br />';
		}

		$message =  str_replace('[NOTE]', implode('', $note), $message);
		if(!$message) return;

		$to = array();
		if($article->user_id)
		{
			$to[] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));
		}
		else
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT v.field_value AS email, r.user_id
			FROM #__js_res_record_values AS v
			LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			WHERE v.record_id = $article->id
			AND f.type = 'email'";
			$db->setQuery($sql);
			$emails = $db->loadObjectList();

			foreach($emails as $email)
			{
				$email = strtolower($email->email);
				if(!JMailHelper::isEmailAddress($email)) continue;
				$to[$email] = array($email, JText::_('Anonymous'));
			}
		}

		if($to) MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function comment_rate($comment, $article, $params, $voter, $mode)
	{
		if(!$params->get('alert_comment_rate', 1)) return;

		$author = JFactory::getUser($comment->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('New Comment Vote').' ('.$model->getTypeName($article->type_id).') ['.$mode.'1] '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('comment_rate', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[COMMENT]', '<div class="email_note email_paragraph">'.$comment->comment.'</div><br />', $message);
		$message = str_replace('[VOTER]', $voter->get($params->get('item_author_mode', 'username')), $message);
		$message = str_replace('[VOTE]', $mode.'1', $message);

		if(!$message) return;

		$to[] = array($comment->email, $comment->name);

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function comment_deleted($comment, $article, $params, $user)
	{
		if(!$params->get('alert_comment_delete', 1)) return;

		$author = JFactory::getUser($comment->user_id);
		if(!JMailHelper::isEmailAddress($author->get('email', '123'))) return;

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('Comment Deleted').' ('.$model->getTypeName($article->type_id).') '.$article->title;
		$uri = &JFactory::getURI();
		$message = MEAlerts::_get_alert_file('comment_deleted', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[COMMENT]', '<div class="email_note email_paragraph">'.$comment->comment.'</div><br />', $message);
		$message = str_replace('[DELETER]', $user->get($params->get('item_author_mode', 'username')), $message);

		if(!$message) return;

		$to[] = array($comment->email, $comment->name);

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}
	function comment($comment, $article, $params)
	{
		if(!$params->get('alert_comment', 1)) return;

		$db = & JFactory::getDBO();

		$author = JFactory::getUser($article->user_id);
		if(JMailHelper::isEmailAddress($author->get('email', '123')))
		{
			$to[$author->get('email')] = array($author->get('email'), $author->get($params->get('item_author_mode', 'username')));
		}

		$sql = "SELECT * FROM #__js_res_comments WHERE record_id = " . $comment->record_id." GROUP BY email";
		$db->setQuery($sql);
		$users = $db->loadObjectList();
		foreach($users as $commenter)
		{
			$commenter->email = strtolower($commenter->email);
			$comp = new JParameter($commenter->params);

			if($comp->get('alert_replay', 0) == 0)
			{
				if(key_exists($commenter->email, $to))
				{
					unset($to[$commenter->email]);
				}
				continue;
			}
			if($commenter->email == $author->get('email')) continue;
			if(!JMailHelper::isEmailAddress($commenter->email)) continue;
			$to[$commenter->email] = array($commenter->email, $commenter->name);
		}

		$sql = "SELECT v.field_value AS email, r.user_id
		FROM #__js_res_record_values AS v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
		WHERE v.record_id = $comment->record_id
		AND f.type = 'email'";
		$db->setQuery($sql);
		$emails = $db->loadObjectList();

		foreach($emails as $email)
		{
			$email = strtolower($email->email);
			if(!JMailHelper::isEmailAddress($email)) continue;
			$to[$email] = array($email, $author->get($params->get('item_author_mode', 'username'), JText::_('Anonymous')));
		}

		$model = & JModel::getInstance('Article', 'ResModel');
		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		$subject = JText::_('New Comment').' ('.$model->getTypeName($article->type_id).') '.$article->title;
		
		$uri = &JFactory::getURI();
		
		$message = MEAlerts::_get_alert_file('comment', $article->type_id);
		$message = str_replace('[RECORD]', JHTML::link($uri->toString( array('scheme', 'host', 'port') ).MERoute::_($link), $article->title), $message);
		$message = str_replace('[TYPE]', $model->getTypeName($article->type_id), $message);
		$message = str_replace('[COMMENTER]', $comment->name, $message);

		if($params->get('alert_comment_insert') == 1)
		{
			$message = str_replace('[COMMENT]', '<div class="email_note email_paragraph">'.$comment->comment.'</div><br />', $message);
		}
		else
		{
			$message =  str_replace('[COMMENT]', '', $message);
		}
		if(!$message) return;

		MEAlerts::_send($article->type_id, $to, $message, $subject);
	}

	function _send($type_id, $to, $message, $subject, $sender = array(), $immediate = 0)
	{
		settype($to, 'array');

		$params = ResHelper::initArticleParams($type_id);

		$mail = JFactory::getMailer();
		$config = JFactory::getConfig();

		if(!$sender)
		{
			$sender[0] = $config->getValue('config.mailfrom');
			$sender[1] = $config->getValue('config.fromname');
		}

		$message = str_replace('[SUBJECT]', $subject, $message);
		$message = str_replace('[SITE_NAME]',  $config->getValue('config.sitename'), $message);
		$message = str_replace('[SITE_URL]',  JURI::root(), $message);
		if(JRequest::getVar('reason'))
		{
			$message = str_replace('[REASON]',  '<div class="email_paragraph email_reason"><b>Reason:</b> '.nl2br(JRequest::getVar('reason')).'</div><br />', $message);
		}
		else
		{
			$message = str_replace('[REASON]',  '', $message);
		}

		$mail->setSender($sender);
		if (JString::strlen(strip_tags($message)) < JString::strlen($message))
		{
			$mail->IsHTML(true);
		}
		else
		{
			$mail->IsHTML(false);
		}
		$temp_message = $message;
		if($immediate) $params->set('alert_send_mode', 0);
		foreach ($to as $resip) {
			$message = $temp_message;
			settype($resip, 'array');
			$resip[1] = @str_replace("\n", '', @$resip[1]);
			if($resip[1]) 
				$nsubject = '['.$resip[1].']: '.$subject;
			else 
				$nsubject = '[admin]: '.$subject;

			$message = str_replace('[USER_NAME]',  $resip[1], $message);

			JPluginHelper::importPlugin('joomsuite_content');
			$dispatcher = & JDispatcher::getInstance();
			$dispatcher->trigger('onBeforeSendAlert', array($nsubject, $message, $resip, $sender, $params));
			
			if($params->get('alert_send_mode') == 1)
			{
				$post['subject'] = $nsubject;
				$post['body'] = $message;
				$post['name'] = $resip[1];
				$post['email'] = $resip[0];
				$post['sender_name'] = $sender[1];
				$post['sender_email'] = $sender[0];

				$alert = & JTable::getInstance('Alerts', 'Res');
				$alert->bind($post);
				$alert->check();
				$alert->store();
			}
			else
			{
				$mail->setBody(JMailHelper::cleanBody($message));
				$mail->setSubject(JMailHelper::cleanSubject($nsubject));

				$mail->ClearAllRecipients();
				$mail->AddAddress($resip[0], $resip[1]);
				$mail->Send();
			}
		}
	}

	function _get_alert_file($name, $id = null)
	{
		$lang = &JFactory::getLanguage();
		$lang_tag = $lang->getTag();

		$config = JFactory::getConfig();

		$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.$lang_tag.DS.$id.'-'.$name.'.html';
		if(!JFile::exists($file))
		{
			$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.'en-GB'.DS.$id.'-'.$name.'.html';
			if(!JFile::exists($file))
			{
				$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.$lang_tag.DS.$name.'.html';
				if(!JFile::exists($file))
				{
					$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.'en-GB'.DS.$name.'.html';
				}
			}
		}
		//echo $file; exit;

		if(!JFile::exists($file)) return;

		$content = JFile::read($file);

		$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.$lang_tag.DS.'sign.html';
		if(!JFile::exists($file))
		{
			$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.'en-GB'.DS.'sign.html';
		}
		$sign =  JFile::read($file);

		$sign = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $sign);
		$content = str_replace('[SIGN]', $sign, $content);

		$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.$lang_tag.DS.'style.html';
		if(!JFile::exists($file))
		{
			$file = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'alerts'.DS.'en-GB'.DS.'style.html';
		}
		$style =  JFile::read($file);
		$content = str_replace('[STYLE]', $style, $content);

		return $content;
	}
	function _get_record_email($id)
	{
		$db = &JFactory::getDBO();
		
		$sql = "
		SELECT v.field_value AS email, f.params
		FROM #__js_res_record_values AS v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		WHERE v.record_id = $id
		AND f.type = 'email'";
		
		$db->setQuery($sql);
		$list = $db->loadObject();
		
		$params = new JParameter($list->params);
		
		if ($params->get('send_alerts', 1))
		{
			if(JMailHelper::isEmailAddress(@$list->email)) return $list->email;
		}

	}
}

?>