<?php
/**
 * $Id: community.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

if(MECommunityHelper::isEnabled())
{
	require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
}

class MECommunityHelper
{
	function isEnabled()
	{
		static $result = null;
		
		if($result !== null)
			return $result;
		
		jimport('joomla.filesystem.file');
		
		require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();
        
		if(!defined('RES_COMMUNITY'))
		{
			$result = FALSE;
			return $result;	
		}
		
		if(substr(RES_COMMUNITY, 0, -4) != 'com_resource') {
			$result = false;
			return $result;
		}
		
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php')) 
		{
		    include_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		    $result = true;
		    return $result;
		}
		$result = false;
		
		return $result;
	}
	
	function loadApi()
	{
		static $loaded = false;
		if( !$loaded && MECommunityHelper::isEnabled()){
			require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
			$loaded = true;
		}
	}

	function getKarma($user_id)
	{
		if(!MECommunityHelper::isEnabled()) return;
		if($user_id == 0) return;

		$karma = JSCommunityApi::getUserCarma($user_id);
		return $karma;
	}

	function increasKarma($user_id, $amount, $increas = 1)
	{
		if(!MECommunityHelper::isEnabled()) return;
		if($increas == 0) return;
		if((int)$amount === 0) return;
		if(!$user_id) return;

		JSCommunityApi::increaseKarma($user_id, $amount);
	}

	function registerActivity($param, $client)
	{
		if(!MECommunityHelper::isEnabled()) return;
		
		$icon = 'components/com_resource/images/activity/'.$param['icon'];
		if($client)
		{
			$gicon = 'components/com_resource/images/activity/g.'.$param['icon'];
			$mode = 'community';
			if(JFile::exists($gicon))
			{
				$icon = $gicon;
			}
		}
		else
		{
			$mode = 'user';
		}
		if(!key_exists('user_id', $param))
		{
			$user = &JFactory::getUser();
			if(!$user->get('id')) return;
			$param['user_id'] = $user->get('id');
		}
		JSCommunityApi::registerActivity($client, $param['text'], $param['user_id'], $icon, $mode, null, 'com_resource', '', $param['type']);
	}
	function getAvatar($id, $params = null, $prefix = '')
	{

		static $class = null;

		if($id)
		{
			$user = &JFactory::getUser($id);
			if(!$class)
			{
				$files = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community', '.php');
				foreach ($files as $file)
				{
					$component = substr(basename($file), 0, -4);
					if(JComponentHelper::isEnabled($component))
					{
						require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community'.DS.basename($file);
						$classname = 'MRCommunity'.ucfirst($component);
						$class = new $classname();
					}
				}
			}

			if(MECommunityHelper::isEnabled())
			{
				$link = JURI::root().'index2.php?option=com_community&controller=profile&task=avatar&no_ajax=1&user_id='.$id;
				if(is_object($params))
				{
					$link .= '&width='.$params->get($prefix.'avatar_width', 100).'&height='.$params->get($prefix.'avatar_height', 100);
				}
				$avatar = JHTML::image($link, $user->get('username'). JText::_('Avatar'));
				return $avatar;
			}
			elseif (JComponentHelper::isEnabled(substr(RES_COMMUNITY, 0, -4)))
			{
				require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community'.DS.RES_COMMUNITY;
				$classname = 'MRCommunity'.ucfirst(substr(RES_COMMUNITY,0, -4));
				$class = new $classname();
				If(method_exists($class, 'userAvatar'))
				{
					$avatar = $class->userAvatar($id, $params, $prefix);
					if($avatar) return $avatar;
					return JHTML::image(JURI::base().'/components/com_resource/images/avatar.gif','avatar');			}
			}
			return JHTML::image(JURI::base().'/components/com_resource/images/avatar.gif','avatar');
		}
		else
		{
			return JHTML::image(JURI::root().'/components/com_resource/images/avatar0.gif','avatar');
		}
		return $avatar;
	}

}
?>