<?php
/**
 * $Id: helper.php 7333 2011-09-06 05:07:50Z peter $
 * $LastChangedDate: 2011-09-06 11:07:50 +0600 (Tue, 06 Sep 2011) $
 * $LastChangedBy: peter $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.database.table');

require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'community.php');

JHTML::addIncludePath(JPATH_COMPONENT.DS.'library'.DS.'php'.DS.'html');

JModel::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'models');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'tables');

function jsGetAvatar($id, $params = null, $prefix = '')
{

	static $class = null;

	if($id)
	{
		$user = &JFactory::getUser($id);
		if(!$class)
		{
			$files = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community', '.php');
			foreach ($files as $file)
			{
				$component = substr(basename($file), 0, -4);
				if(JComponentHelper::isEnabled($component))
				{
					require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community'.DS.basename($file);
					$classname = 'MRCommunity'.ucfirst($component);
					$class = new $classname();
				}
			}
		}

		if(MECommunityHelper::isEnabled())
		{
			$link = JURI::root().'index2.php?option=com_community&controller=profile&task=avatar&no_ajax=1&user_id='.$id;
			if(is_object($params))
			{
				$link .= '&width='.$params->get($prefix.'avatar_width', 100).'&height='.$params->get($prefix.'avatar_height', 100);
			}
			$avatar = JHTML::image($link, $user->get('username'). JText::_('Avatar'));
			return $avatar;
		}
		elseif (JComponentHelper::isEnabled(substr(RES_COMMUNITY, 0, -4)))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community'.DS.RES_COMMUNITY;
			$classname = 'MRCommunity'.ucfirst(substr(RES_COMMUNITY,0, -4));
			$class = new $classname();
			If(method_exists($class, 'userAvatar'))
			{
				$avatar = $class->userAvatar($id, $params, $prefix);
				if($avatar) return $avatar;
				return JHTML::image(JURI::base().'/components/com_resource/images/avatar.gif','avatar');			}
		}
		return JHTML::image(JURI::base().'/components/com_resource/images/avatar.gif','avatar');
	}
	else
	{
		return JHTML::image(JURI::root().'/components/com_resource/images/avatar0.gif','avatar');
	}
	return $avatar;
}
function getFilterWhere($params)
{
	$db = &JFactory::getDBO();
	
	$now = ResHelper::getDate();

	$where[] = 'r.hidden = 0';
	$where[] = "r.published = 1";
	if($params->get('show_future_records') == 0)
	{
		$where[] = "r.ctime < '{$now}'";
	}
	if($params->get('show_past_records') == 0)
	{
		$where[] = "(r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')";
	}
	if(JRequest::getInt('user_id'))
	{
		$where[] = 'r.user_id = '.JRequest::getInt('user_id');
	}
	if(($params->get('show_restrict') == 0))
	{
		$user = & JFactory::getUser();
		$where[] = '(r.access <= '.$user->get('aid', 0).' OR r.user_id = '.$user->get('id', 0).')';
	}
	
	if(JRequest::getInt('client_id'))
	{
		$where[] = 'r.client_id = '.JRequest::getInt('client_id');
		$where[] = "r.client = '".$db->getEscaped(JRequest::getVar('client'))."'";
	}
	else
	{
		if($params->get('list_clients') == 0)
		$where[] = "r.client = 'resource'";
	}

	$where = ' AND '.implode(" AND ", $where);

	return $where;

}

function iconResize($name, $file, $max_width, $max_height, $quality, $app)
{
	global $mainframe;

	$user = &JFactory::getUser();

	jimport('joomla.filesystem.file');
	jimport('joomla.filesystem.folder');

	$file = JPath::clean($file);

	$folder = JPATH_ROOT.DS.'images'.DS.'icons';
	if(!JFolder::exists($folder))
	{
		if(!JFolder::create($folder))
		{
			JError::raiseWarning(500, JText::_('Cannot Create directory'), $folder);
			return false;
		}
	}

	$folder .= DS.$user->get('id');
	if(!JFolder::exists($folder))
	{
		if(!JFolder::create($folder))
		{
			JError::raiseWarning(500, JText::_('Cannot Create directory'), $folder);
			return false;
		}
	}

	$size = getimagesize($file);
	//exit;
	if(($size[0] <= $max_width) && ($size[1] <= $max_height))
	{
		JError::raiseNotice(01, JText::_('No Resize Needed'));
		if(!JFile::exists($folder.DS.$name)) JFile::copy($file, $folder.DS.$name);
		return;
	}

	if(($size[0] > $max_width) && ($size[0] > $size[1]))
	{
		$width  = $max_width;
		$k = $size[0] / $max_width;
		$height = ($size[1] / $k);
	}
	else
	{
		$width  = $size[0];
		$height = $size[1];
	}

	if($height > $max_height)
	{
		$k = $height / $max_height;
		$height = $max_height;
		$width = ($width / $k);
	}


	$width  = round($width);
	$height = round($height);

	switch(strtolower($app))
	{
		case "image/gif":
			$img = imagecreatefromgif($file);
			break;
		case "image/png":
			$img = imagecreatefrompng($file);
			break;
		case "image/pjpeg":
		case "image/jpeg":
			$img = imagecreatefromjpeg($file);
			break;
	}
	if(!$img)
	{
		JError::raiseWarning(240, JText::_('Cannot create Image'), $file.$add);
		return ;
	}

	$mini  = imagecreatetruecolor($width, $height);
	$white = imagecolorallocate  ($mini,255,255,255);

	imagefilledrectangle($mini,0,0,$width,$height,$white);
	imagecopyresampled($mini,$img,0,0,0,0,$width,$height,$size[0],$size[1]);

	imagejpeg($mini, JPATH_CACHE.DS.$name, $quality);
	JFile::copy(JPATH_CACHE.DS.$name, $folder.DS.$name);
	@unlink(JPATH_CACHE.DS.$name);

	imagedestroy($mini);
	imagedestroy($img);
}
function cleanURI()
{
	$uri = & JFactory::getURI();

	foreach ($uri->_vars as $key => $var)
	{
		if(preg_match("/^filter([0-9]*)/iU", $key))
		{
			$uri->delVar($key);
		}
		if($key == 'cal_date')  { $uri->delVar($key); }
		if($key == 'cal_view')  { $uri->delVar($key); }
		if($key == 'lastid') 	{ $uri->delVar($key); }
		//if($key == 'child_id')  { $uri->delVar($key); }
		if($key == 'filter_reset')  { $uri->delVar($key); }
		if($key == 'filter_tag')  { $uri->delVar($key); }
		if($key == 'compare')  { $uri->delVar($key); }
		if($key == 'limitstart')  { $uri->delVar($key); }
	}
}

function load_module_position( $position, $style = 'xhtml')
{
	switch($style)
	{
		case 'table':
			$style = 1;
			break;
		case 'horz':
			$style = 1;
			break;
		case 'none':
			$style = -1;
			break;
		case 'xhtml':
			$style = -2;
			break;
		case 'rounded':
			$style = -3;
			break;
		default:
			$style = -2;
			break;
	}

	$document	= &JFactory::getDocument();
	$renderer	= $document->loadRenderer('module');
	$params		= array('style'=>$style);

	$contents = '';
	foreach (JModuleHelper::getModules($position) as $mod)  {
		$contents .= $renderer->render($mod, $params);
	}
	return $contents;
}
function re64($url)
{
	$url = str_replace(' ', '+', $url);
	$url = base64_decode($url);
	return $url;
}
function getNumbers($type, $user_id, $section_id, $params)
{
	static $info = array();
	$key = $type.$user_id;

	if(array_key_exists($key, $info)) return $info[$key];
	$now = ResHelper::getDate();

	$db = &JFactory::getDBO();
	$user = &JFactory::getUser();

	if(JRequest::getInt('client_id'))
	{
		$and = ' AND r.client_id = '.JRequest::getInt('client_id');
	}
	else
	{
		$and = " AND r.client = 'resource' AND r.client_id = 0";
	}
	//echo $params->get('moder_publish_record');

	switch($type)
	{
		case 'expired':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' WHERE 1 '.
			((MEAccess::isModerator($user->get('id'), 'moder_extend_record', $params) || MEAccess::isAdmin())  ? null : ' AND r.user_id = '.$user_id).
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime != '0000-00-00 00:00:00' AND r.extime < '{$now}') AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY r.id";
			
			//echo $params->get('moder_extend_record');
			//echo var_dump((MEAccess::isModerator($user->get('id'), 'moder_extend_record', $params)));
			break;
		case 'unpublished':
			//echo $params->get('moder_publish_record');
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' WHERE 1 '.
			((MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor()) ? NULL : ' AND r.user_id = '.$user_id ).
		" AND r.hidden = 0 AND r.published = 0 AND (rc.id = $section_id OR section_id = $section_id)". $and .
		" GROUP BY r.id";
			//echo $user->get('id');
			//var_dump(MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params));
			//echo $query;
			break;
		case 'hidden':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' WHERE r.user_id = '.$user_id .
		" AND r.hidden = 1 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY r.id";
			//echo $query;
			break;

		case 'created':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' WHERE r.user_id = '.$user_id .
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY r.id";
			break;
				
		case 'rated':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' LEFT JOIN #__js_res_vote AS v ON v.record_id = c.record_id AND v.user_id = '.$user_id .
		' WHERE v.user_id = '.$user_id .
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY c.record_id";
			//echo $query;
			break;
				
		case 'visited':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' LEFT JOIN #__js_res_hits AS v ON v.record_id = c.record_id AND v.user_id = '.$user_id .
		' WHERE v.user_id = '.$user_id .
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY c.record_id";
			//echo $query;
			break;
				
		case 'favorited':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' LEFT JOIN #__js_res_favorite AS v ON v.record_id = r.id AND v.user_id = '.$user_id .
		' WHERE v.user_id = '.$user_id .
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY r.id";
			//echo $query;
			break;
				
		case 'commented':
			$query = 'SELECT r.id'.//, u.name as username' .
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id' .
		' LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid'.
		' LEFT JOIN #__js_res_comments AS v ON v.record_id = r.id AND v.user_id = '.$user_id .
		' WHERE v.user_id = '.$user_id .
		" AND r.hidden = 0 AND r.published = 1 AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}')  AND (rc.id = $section_id OR rc.section_id = $section_id)". $and .
		" GROUP BY r.id";
			//echo $query;
			break;
				
	}

	$db->setQuery($query);
	$db->query();
	$info[$key] = $db->getNumRows();

	return $info[$key];
}
function spiffy_css($document, $color){

	static $include = true;
	if($include){
		$document->addStyleDeclaration("
		.spiffy{display:block}
		.spiffy *{
		display:block;
		height:1px;
		overflow:hidden;
		font-size:.01em;
		background:$color;
	}
	.spiffy b{
	border-color:$color;
	}
	.spiffy1{
	margin-left:3px;
	margin-right:3px;
	padding-left:1px;
	padding-right:1px;
	border-left:1px solid;
	border-right:1px solid;
	}
	.spiffy2{
	margin-left:1px;
	margin-right:1px;
	padding-right:1px;
	padding-left:1px;
	border-left:1px solid;
	border-right:1px solid;
	}
	.spiffy3{
	margin-left:1px;
	margin-right:1px;
	border-left:1px solid;
	border-right:1px solid;
	}
	.spiffy4{
	border-left:1px solid;
	border-right:1px solid;
	}
	.spiffy5{
	border-left:1px solid;
	border-right:1px solid;
	}
	.spiffyfg{
	background:$color;
	text-align: center;
	text-transform: uppercase;
	}
	.spiffyadvsearch{
	border: 8px solid $color;
	background-color: white;
	padding: 8px;
	}
	.forum_modern_tb{
	border-left: 1px solid $color;
	border-right: 1px solid $color;
	}");
	$include = false;
	}
}
?>