<?php
/**
 * $Id: file_helper.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php');

class JS_File_Helper extends JObject
{
    var $errors = array();

    function __construct()
    {
        parent::__construct();

        $this->_initResourceConfig();
    }
    /**
     *
     * @return JS_File_Helper
     */
    function & getInstance()
    {
        static $instance = 0;
        if (!$instance)
        {
            $instance = new JS_File_Helper();
        }

        return $instance;
    }

    /**
     * Reassign files to a new author for fields that store files in old manner
     * @param $records array
     * @param $oldAuthor int
     * @param $newAuthor int
     * @param $type string field type
     * @return unknown_type
     */
    function reassignFilesOld(&$records, $newAuthor, $type, $additional = array())
    {
        if (!$type)
            return false;

        $type = JFolder::makeSafe($type);
        $newAuthor = (int)$newAuthor;


        $db = & JFactory::getDBO();

        $recordIds 		= array();
        $recordsById 	= array();
        for ($i = 0, $count = count($records); $i < $count; $i++)
        {
            $rid = $records[ $i ]->id;
            $recordIds [] = $rid;
            $recordsById[$rid] 	= $records[ $i ];
        }

        if (!count($recordIds))
            return;


        $q = 'SELECT record_id, field_value FROM #__js_res_record_values WHERE record_id IN ('.implode(',', $recordIds).')';
        $db->setQuery( $q );
        $fieldValues = $db->loadObjectList();

        for($i = 0, $count = count($fieldValues); $i < $count; $i++)
        {
            $value 	= & $fieldValues[ $i ]->field_value;
            $rid 	= & $fieldValues[ $i ]->record_id;

            $oldAuthor = (int)$recordsById[$rid]->user_id;


            $destDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$newAuthor.DS.$type);

            if (!JFolder::exists($destDir))
                JFolder::create($destDir, 0755);

            $oldFile = JPath::clean(RES_GENERAL_UPLOAD.DS.$oldAuthor.DS.$type.DS.$value);
            if (JFile::exists($oldFile))
            {
                $dest = JPath::clean($destDir.DS.$value);
                JFile::move($oldFile, $dest);
            }
            if(is_array($additional) && count($additional))
            {
                foreach ($additional as $add)
                {
                    $destDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$newAuthor.DS.$type.DS.$add);

                    if (!JFolder::exists($destDir))
                        JFolder::create($destDir, 0755);

                    $oldFile = JPath::clean(RES_GENERAL_UPLOAD.DS.$oldAuthor.DS.$type.DS.$add.DS.$value);
                    if (JFile::exists($oldFile))
                    {
                        $dest = JPath::clean($destDir.DS.$value);
                        JFile::move($oldFile, $dest);
                    }

                }


            }
        }
    }

    /**
     *
     * @param $recordId
     */
    function getRecordOwner($recordId)
    {
        $ownerId = -1;

        $record = & JTable::getInstance('record','Res');
        if (!$record)
        {
            JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
            $record = & JTable::getInstance('record','Res');
        }

        if ($record->load($recordId))
            $ownerId = (int)$record->user_id;

        return $ownerId;
    }

    /**
     * Reassign files to a new author for fields that store files in new manner (fields that use flash uploader)
     * @param $records
     * @param $oldAuthor
     * @param $newAuthor
     * @param $type
     * @param $subFolder
     * @return unknown_type
     */
    function reassignFilesNew(&$records, $newAuthor, $type, $subFolder = '')
    {
        $db = & JFactory::getDBO();

        $recordIds = array();
        $oldAuthors = array();

        for ($i = 0, $count = count($records); $i < $count; $i++)
        {
            $recordIds [] = $records[ $i ]->id;
            $oldAuthors[ $records[ $i ]->id ] = $records[ $i ]->user_id;
        }

        if (!count($recordIds))
            return;

        $q = 'SELECT rv.record_id, rv.field_value FROM #__js_res_record_values rv '.
                ' LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                ' WHERE f.type = '.$db->Quote($type).' AND rv.record_id IN ('.implode(',', $recordIds).')';

        $db->setQuery( $q );
        $fieldValues = $db->loadObjectList();
		$fileManager = & JSFileManager::getInstance();

        for($i = 0, $count = count($fieldValues); $i < $count; $i++)
        {
            $fieldValue = & $fieldValues[ $i ];

            $files = @unserialize($fieldValue->field_value);
            $files = isset($files['files']) ? $files['files'] : array();

            $oldAuthor = $oldAuthors[ $fieldValue->record_id ];

            $fileManager->reassignFiles($files, $fieldValue->record_id, $oldAuthor, $newAuthor, $subFolder);
        }
    }


    /**
     * Initializes com_resource settings
     * @return void
     */
    function _initResourceConfig()
    {
        static $isInitialized = 0;

        if (!$isInitialized)
        {
            jimport ('joomla.filesystem.file');
            jimport ('joomla.filesystem.folder');

            require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
            ResControllerConfig::initialyze();

            // Include the com_resource main controller to access it's methods
            require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'controller.php';

            $isInitialized = 1;
        }
    }


    function removeFiles($path)
    {
        if(is_array($path))
        {
            foreach ($path as $p)
            {
                $this->_removeFile($p);
            }

        }
        else
        {
            $this->_removeFile($path);

        }

    }


    function _removeFile($path)
    {
        jimport ('joomla.filesystem.file');
        jimport ('joomla.filesystem.folder');
        $path = JPath::clean($path);
        if(JFile::exists($path))
        {
            if(!JFile::delete($path))
            {
                $this->setError(JText::sprintf('Could not delete file %s', $path));
            }
        }
        else
        {
            $this->setError(JText::sprintf('File %s does not exists', $path));
        }
    }

    function checkSubscription($ini, $download = true)
    {
        $params = new JParameter($ini);

        // Check subscriptions
        $subscriptions = $params->get('viewSp', null);
        if ($subscriptions !== null)
        {
            $isPublic = !is_array($subscriptions) && $subscriptions == -1;
            if (!$isPublic && !jscCheckSubscription(
                    $subscriptions,
                    $params->get('alertText', ''),
                    $params->get('Itemid'),
                    false,
                    $params->get('count_mode')) )
            {
            	if($download)
                	jscCountLimit($subscriptions, $params->get('count_mode'));
                return true;
            }
            else if($isPublic)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        return true;
    }

    function getFileMetaData($recordValueId)
    {
        $db = & JFactory::getDBO();
        $sql = 'SELECT f.field_value, r.user_id, rf.params, rf.type, r.id as record_id, rf.id AS fid
		FROM #__js_res_record_values AS f
		LEFT JOIN #__js_res_record AS r ON r.id = f.record_id
		LEFT JOIN #__js_res_fields AS rf ON rf.id = f.field_id
		WHERE f.id = '.$recordValueId;

        $db->setQuery($sql);
        $res = $db->loadObject();

        return $res;
    }

    function modifyUsersCarma($ini, $owner_id, $user_id)
    {
        $params = new JParameter($ini);
        if($user_id != $owner_id)
        {
            if($params->get('karma_increase', 0))
            {
                $amount = $params->get('karma_increase_amount', 0);
                MECommunityHelper::increasKarma($owner_id, $amount, 1);
            }

            if($params->get('karma_decrease', 0) && $user_id)
            {
                $amount = $params->get('karma_decrease_amount', 0);
                MECommunityHelper::increasKarma($user_id, $amount, 1);
            }
        }
    }


}