<?php
/**
 * $Id: html_stripper.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');


class JSHTMLStripper  
{
	function substr($string, $length, $addstring="")
	{
		if (!$length)
			return $string;
		
		$addstring = " " . $addstring;

		if (JString::strlen($string) > $length) {
			if( !empty( $string ) && $length>0 ) {
				$isText = true;
				$ret = "";
				$i = 0;

				$currentChar = "";
				$lastSpacePosition = -1;
				$lastChar = "";

				$tagsArray = array();
				$currentTag = "";
				$tagLevel = 0;

				$noTagLength = JString::strlen( strip_tags( $string ) );

				// Parser loop
				$strLen = JString::strlen( $string );
				for( $j=0; $j < $strLen; $j++ ) {

					$currentChar = JString::substr( $string, $j, 1 );
					$ret .= $currentChar;

					// Lesser than event
					if( $currentChar == "<") $isText = false;

					// Character handler
					if( $isText ) {

						// Memorize last space position
						if( $currentChar == " " ) { $lastSpacePosition = $j; }
						else { $lastChar = $currentChar; }

						$i++;
					} else {
						$currentTag .= $currentChar;
					}

					// Greater than event
					if( $currentChar == ">" ) {
						$isText = true;

						// Opening tag handler
						if( ( JString::strpos( $currentTag, "<" ) !== FALSE ) &&
						( JString::strpos( $currentTag, "/>" ) === FALSE ) &&
						( JString::strpos( $currentTag, "</") === FALSE ) ) {

							// Tag has attribute(s)
							if( JString::strpos( $currentTag, " " ) !== FALSE ) {
								$currentTag = JString::substr( $currentTag, 1, JString::strpos( $currentTag, " " ) - 1 );
							} else {
								// Tag doesn't have attribute(s)
								$currentTag = JString::substr( $currentTag, 1, -1 );
							}

							array_push( $tagsArray, $currentTag );

						} else if( JString::strpos( $currentTag, "</" ) !== FALSE ) {
							array_pop( $tagsArray );
						}

						$currentTag = "";
					}

					if( $i >= $length) {
						break;
					}
				}

				// Cut HTML string at last space position
				if( $length < $noTagLength ) {
					if( $lastSpacePosition != -1 ) {
						$ret = JString::substr( $string, 0, $lastSpacePosition );
					} else {
						$ret = JString::substr( $string, $j );
					}
				}

				// Close broken XHTML elements
				while( sizeof( $tagsArray ) != 0 ) {
					$aTag = array_pop( $tagsArray );
					$ret .= "</" . $aTag . ">\n";
				}

			} else {
				$ret = "";
			}

			// only add 'tail' string if text was cut
			if ( JString::strlen($string) > $length ) {
				return( $ret.$addstring );
			}
			else {
				return ( $res );
			}
		}
		else {
			return ( $string );
		}
	}
}
?>