<?php
/**
 * $Id: jsfilemanager.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class JSFileManager extends JObject
{
    var $_types = array('image'=>array('jpg', 'jpeg', 'bmp', 'gif', 'png', 'svg', 'tiff'),
            'video'=>array("swf", "avi", "mov", "wmv", "mpeg", "mpg", "mpe", 'flv', 'mp4'),
            'music'=>array("mp3", 'mpg3', 'ogg'));

    var $_blackList = array('php', 'ini', 'html', 'htm');
    var $_error = "";
    var $_allowed = array();
    var $_maxSize = 0;

    function JSFileManager()
    {
        parent::__construct();

    }

    function &getInstance()
    {
        static $instance = null;
        if(empty($instance))
        {
            $instance = new JSFileManager();
        }
        return $instance;

    }

    function getFileType($file)
    {
        $ext = strtolower(JFile::getExt($file));
        foreach($this->_types as $key=>$val)
        {
            if(in_array($ext, $val))
            {
                return $key;
            }

        }
        return '';

    }

    function getDownloadUrl($valueId, $additionalParams = array(), $route = true)
    {
    	$url = 'index2.php?option=com_resource&task=show_file&id='.$valueId;
        $add= "";
        if(count($additionalParams))
        {
            $add = "&".JURI::buildQuery($additionalParams);
        }
        $url.=$add;
        if($route)
        {
            return MERoute::_($url);
        }
        return $url;
    }



    function upload($file, $dst)
    {
        if(!$this->checkFileForUpload($file, $err))
        {
            JError::raiseNotice('FileManager', $err);
            return false;
        }
        JFile::upload($file['tmp_name'],$dst );
    }


    function copyFile($src, $dst)
    {
        if(JFile::exists($src))
        {
            if(JFile::exists($dst))
            {
                JError::raiseNotice('FileManager', JText::_('Destination file already exists'));
                return false;
            }

            JFile::copy($src, $dst);
            return true;
        }
        else
        {
            JError::raiseNotice('FileManager', JText::_('Could not find the source file'));
            return false;
        }

    }

    function moveFile($src, $dst)
    {
        if(JFile::exists($src))
        {
            if(JFile::exists($dst))
            {
                JError::raiseNotice('FileManager', JText::_('Destination file already exists'));
                return false;
            }

            JFile::move($src, $dst);
            return true;
        }
        else
        {
            JError::raiseNotice('FileManager', JText::_('Could not find the source file'));
            return false;
        }


    }

    function checkFileForUpload($file, &$err)
    {
        if(empty($file['name']))
        {
            $err = JText::_('Please input a file for upload');
            return false;
        }

        $format = strtolower(JFile::getExt($file['name']));

        $allowable = $this->_allowed;
        $blackList = $this->_blackList;
        if (!in_array($format, $allowable) || in_array($format,$blackList))
        {
            $err = JText::_('This file type is not allowed to upload');
            return false;
        }

        $maxSize = $this->_maxSize;
        if ($maxSize > 0 && (int) $file['size'] > $maxSize)
        {
            $err = JText::_('The size of the file is larger than allowed');
            return false;
        }

        return true;


    }

    function downloadFile($path)
    {
//        $extension = JFile::getExt($path);
        $fileType = $this->getFileType($path);
        $fdown = JRequest::getInt('fdown', 0);

        if(JFile::exists($path))
        {
            @ob_end_clean();
            switch($fileType)
            {
                case 'image':
                    $imageInfo = @getimagesize($path);
                    if (is_array($imageInfo) && $mimeType = $imageInfo['mime'])
                    {

                        header("Content-Type: ".$mimeType);
                        if ($fdown)
                        {
	                       $contdsp = 'attachment';
                        }
                        else
                        {
	                       $contdsp = 'inline';
                        }
                        header('Content-disposition: '.$contdsp.'; filename='.basename($path));
                        header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
                        header('Pragma: private');
                    }
                    JSFileManager::readFileChunked($path);
                    exit();
                    break;
#This was attempt to show video files on dynamic link, unfortunately it failed, so left it for the next time, and marked it as @todo
//                case 'video':
//                		$type = mime_content_type($path);
//                		if (!$type)
//                		{
//	                		switch($extension)q
//							{
//							  case "flv":
//							    $type = "video/x-flv";
//							    break;
//							  case "mp4":
//							    $type = "video/mp4";
//							    break;
//							  case "wmv":
//							    $type = "video/x-ms-wmv";
//							    break;
//							  case "mov":
//							    $type = "video/quicktime";
//							    break;
//							  default:
//	                   		    $type = 'video/'.$extension;
//							    break;
//							}
//                		}
//                		$fp = fopen($path, "rb") or die("Could not open file");
//                		$etag = md5(serialize(fstat($fp)));
//                        fclose($fp);
//                		header("Content-Type: ".$type);
//                		header("Cache-Control: no-cache, no-store, max-age=0, must-revalidate");
//						header("Cache-Control: post-check=0, pre-check=0", false);
//                        header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
//                        header("Pragma: no-cache");
//						header("Content-Transfer-Encoding: binary");
//						header("Content-Description: File Transfer");
//                        header('Content-Length: '.filesize($path));
//                        header('ETag: "'.$etag.'"');
//                        
//                        //header('Accept-Ranges: bytes');
//	                    //header("Connection: none");
//	                    //header("Keep-Alive: none");
//	                    //var_dump(headers_list());die;
//	                    //header("Content-Encoding: none");
//                        //header('Pragma: private');  
//                	break;
                default:
                    $browser =  $_SERVER['HTTP_USER_AGENT'];

                    if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser))
                    {
                        $browser =  'OPERA';
                    } else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser))
                    {
                        $browser =  'IE';
                    } else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser))
                    {
                        $browser =  'OMNIWEB';
                    } else if(ereg('(Konqueror/)(.*)', $browser))
                    {
                        $browser =  'KONQUEROR';
                    } else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser))
                    {
                        $browser =  'MOZILLA';
                    } else
                    {
                        $browser =  'OTHER';
                    }


                    // Prevent inclusion of Xajax scripts, and other stuff...

                    header('Content-Type: '.(($browser=='IE' || $browser=='OPERA')?'application/octetstream':'application/octet-stream'));
                    header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
                    header('Content-Transfer-Encoding: binary');
                    header('Content-Length: '.filesize($path));
                    header("Content-Encoding: none");
                    if($browser=='IE')
                    {
                        header('Content-Disposition: attachment; filename="'.basename($path).'"');
                        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                        header('Pragma: public');
                    } else
                    {
                        header('Content-Disposition: attachment; filename="'.basename($path).'"');
                        header('Cache-Control: no-cache, must-revalidate');
                        header('Pragma: no-cache');
                    }
                    JSFileManager::readFileChunked($path);
                    break;
            }
        }
    }



    /**
     * Assigns files to new user.
     * @param $files array
     * @param $articleId string
     * @param $prevAuthor int
     * @param $currentAuthor int
     * @param $directory string
     * @return unknown_type
     */
    function reassignFiles($files, $articleId, $prevAuthor, $newAuthor, $directory = '')
    {
        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');

        settype($files, 'array');
        $prevAuthor 	= (int)$prevAuthor;
        $newAuthor 	= (int)$newAuthor;

        $folder = RES_GENERAL_UPLOAD;

        foreach($files as $f)
        {
            if (!$f)
                continue;

            $f = basename( $f );
            $ext = JString::strtolower(JFile::getExt( $f ));
            if ($ext == 'jpeg')
                $ext = 'jpg';

            $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

            $infile = JPath::clean($folder.DS.$prevAuthor.DS.$ext.DS.$directory.DS. $articleId.'_'.$f);

            $destFile = JPath::clean($folder.DS.$newAuthor.DS.$ext.DS .$directory.DS.$articleId.'_'.$f);

            $dir = dirname($destFile);
            $this->_createSecureFolder($dir);

            if (JFile::exists($infile))
            {
                if (JFile::exists($destFile))
                    JFile::delete($destFile);

                JFile::copy($infile, $destFile);
                JFile::delete($infile);

                // set the file permissions
            }
        }
    }

    function _createSecureFolder($folder)
    {
        $mode = $this->folderMode ? $this->folderMode :  0755;

        if (!JFolder::exists($folder))
            return JFolder::create($folder, $mode);
        else
            return JPath::canChmod($folder) && @chmod($folder, $mode);
    }

    /**
     * Copies <b>newly</b> uploaded file to it's predefined place
     *
     * @param $filename string The file name
     * @param $destName string The destination file name
     * @param $userId int The owner of the file
     * @param $dir string The nested directory
     * @param $move boolean
     * @return mixed Saved file name, null on bad args.
     */
    function storeFile($filename, $destName, $userId, $dir = '', $move = false)
    {
        // userId may be 0
        if (!$filename || is_null($userId))
            return null;

        if (!$destName)
            $destName = $filename;

        $userId = (int)$userId;

        $inFile = $this->getPath($filename, $userId);
        $destFile = $this->getPath($destName, $userId, $dir);

        if (!$inFile || !$destFile)
        {
            return false;
        }

        if ($inFile == $destFile)
            return $destFile;

        if (JFile::exists($inFile))
        {
            $folder = dirname($destFile);
            $this->_createSecureFolder($folder);

            if (!JFile::copy($inFile, $destFile))
            {
                JError::raiseError(JText::_('Cannot copy').' <b>'.$inFile.'</b> '.JText::_('to').' <b> '.$destFile.'</b>');
            }
            if ($move)
                JFile::delete($inFile);
            return $destFile;
        }

        return false;
    }

    function getPath($file, $userId, $dir = '')
    {
        $file = JFile::makeSafe($file);
        $userId = (int)$userId;

        $ext = strtolower(JFile::getExt( $file ));
        if ($ext == 'jpeg')
        {
            $ext = 'jpg';
            $file = JFile::stripExt($file).'.'.$ext;
        }

        $ret = RES_GENERAL_UPLOAD.DS.$userId.DS.$ext;
        if ($dir)
            $ret .= DS.$dir;
        $ret .= DS. $file;


        return $ret;
    }



    function getFileTypes()
    {
        return $this->_types;

    }

    function getFileExtensions($type)
    {
        return $this->_types[$type];
    }

    function addFileExtension($type, $extension)
    {
        array_push($this->_types[$type], $extension);
    }

    function addFileType($type)
    {
        array_push($this->_types, $type);

    }

    function addToWhiteList($ext)
    {
        if(!in_array($ext, $this->_allowed))
        {
            array_push($this->_allowed, $ext);
        }
    }

    function addToBlackList($ext)
    {
        if(!in_array($ext, $this->_blackList))
        {
            array_push($this->_blackList, $ext);
        }
    }

    function setWhiteList($extensions=array())
    {
        $this->_allowed = $extensions;
    }

    function setBlackList($extensions=array())
    {
        $this->_blackList = $extensions;

    }


    function setMaxFileSize($size)
    {
        $this->_maxSize = intval($size);
    }

    function readFileChunked($filename,$retbytes=true)
    {
        error_reporting(0);
        //ignore_user_abort(true);
        set_time_limit(0);
        $chunksize = 1*(1024*1024); // how many bytes per chunk
        $buffer = '';
        $cnt =0;
        // $handle = fopen($filename, 'rb');
        $handle = fopen($filename, 'rb');
        if ($handle === false)
        {
            echo "Cannot open file";
            exit;
            return false;
        }
        while (!feof($handle))
        {
            $buffer = @fread($handle, $chunksize);
            echo $buffer;
            if ($retbytes)
            {
                $cnt += strlen($buffer);
            }
        }
        $status = fclose($handle);
        if ($retbytes && $status)
        {
            return $cnt; // return num. bytes delivered like readfile() does.
        }
        return $status;
    }

}
