<?php
/**
 * $Id: uploader.php 7947 2012-03-13 06:28:04Z kostya $
 * $LastChangedDate: 2012-03-13 12:28:04 +0600 (Tue, 13 Mar 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

/*
 * Class for generating playlists for JWPlayer
 */
class JSJWPlaylistGenerator {
	/*
	 * Generates MRSS
	 * 
	 * $files = array(
	 * 		'uploads/62/mp3/mywildsong.mp3'
	 * ),
	 * $options = array(
	 * 		'title' => 'My cute title',
	 * 		'link' => 'http://www.mysite.com/' ;)
	 * )
	 */
	function generateRSS($files, $url, $id, $options = array()) {
		$title 	= isset($options['title']) ? $options['title'] : '';
		$link 	=  isset($options['link']) ? $options['link'] : '';
		$userId = (int)@$options['userId'];
		
		
		$fileManager = & JSFileManager::getInstance();
		$ru = $fileManager->set('routeURL', false);
		$eu = $fileManager->set('encodeURL', false);
		
		$str = "<feed xmlns='http://www.w3.org/2005/Atom' xmlns:media='http://search.yahoo.com/mrss/'>".
				"<title>".$title."</title>".
				"<link rel='alternate' type='text/html' href='".JFilterOutput::ampReplace($link)."' />";


		foreach ($files as $file) {
			$lastSlash = strrpos($file, '/');
			if ($lastSlash !== false) {
				$fileUrl = substr($file, 0, $lastSlash);
				$file = substr($file, $lastSlash + 1);
			}
			else
				$fileUrl = '';
			$title = basename($file);
			$pos = strpos(basename($file), '_');
			if ($pos !== false)
                    		$title = substr(basename($file), strpos(basename($file), '_') + 1);
                        
			$str .= '<entry>';
			$str .= '<title>'.$title.'</title>';
			$str .= '<link>'.JURI::root().'</link>';
			$str .= '<summary>'.$title.'</summary>';
			$str .= '<media:group>';
			$str .= '<media:content url="'.
				JURI::root().JFilterOutput::ampReplace($fileManager->getDownloadUrl($id, array('hash'=>md5($file))))
				.'" ';
			if ($type = JSJWPlaylistGenerator::_getMimeType($file))
				$str .= 'type="'.$type.'" ';
			$str .= ' />';
			$str .= '</media:group>';
			
			$ext = JString::strtolower(JFile::getExt($file));
			if ($ext == 'mp4')
				$str .= '<meta rel="type">video/x-flv</meta>';
			$str .= '</entry>';
		}
		$str .= '</feed>';
		
		
		return $str;
	}
	
	/**
	 * Generates RSS with given URL
	 * @param $url Properly encoded URL :)
	 * @param $info stdClass
	 * @return unknown_type
	 */
	function generateRSSForURL($url, $info) {
		if (!$url)
			return false;
		if (!isset($info->file, $info->link, $info->title))
			return false;
		
		JFilterOutput::objectHTMLSafe($info);
		
		$str = "<feed xmlns='http://www.w3.org/2005/Atom' xmlns:media='http://search.yahoo.com/mrss/'>".
			"<title>".@$info->title."</title>".
			"<link rel='alternate' type='text/html' href='".@$info->link."' />";
		
		$str .= '<entry>';
		$str .= '<title>'.@$info->title.'</title>';
		$str .= '<link>'.@$info->link.'</link>';
		$str .= '<summary>'.@$info->title.'</summary>';
		$str .= '<media:group>';
		$str .= '<media:content url="'.$url.'" ';
		if ($type = JSJWPlaylistGenerator::_getMimeType($info->file))
			$str .= 'type="'.$type.'" ';
		$str .= ' />';
		$str .= '</media:group>';
		
		$ext = strtolower(JFile::getExt($info->file));
		if ($ext == 'mp4')
			$str .= '<meta rel="type">video/x-flv</meta>';
		$str .= '</entry>';
		$str .= '</feed>';
		
		return $str;
	}
	
	function _getFileSize($file) {
		/* php hack for files, larger than 2GiB */
		if (JFile::exists($file))
			return sprintf("%u", filesize($file));
		return 0;
	}
	
	/**
	 * Returns type of the file. Note that this method recognizes only the file types
	 * which are used with JW FLV player.
	 * Returns null if cannot match type.
	 */
	function _getMimeType($file) {
		static $types = array(
			'jpg' => 'image/jpeg',
			'jpeg' => 'image/jpeg',
			'flv' => 'video/x-flv',
			'mp3' => 'audio/mpeg',
			'mp4' => 'video/mp4',
			'aac' => 'audio/aac',
			'png' => 'image/png',
			'gif' => 'image/gif'
		);
		
		$ext = JString::strtolower(JFile::getExt($file));
		if (array_key_exists($ext, $types))
			return $types[$ext];
		
		return null;
	}
}
/**
 * This class is used to display flash uploader. 
 *
 */
class JHTMLJsmedia_new
{
	function scripts() {
		static $included = 0;
		if (!$included) {
			$doc = & JFactory::getDocument();
			
			$scriptDir = JURI::root().'components/com_resource/library/js/uploader/';
			$scripts = array(
				'uploader.js',
				'media_swfobject.js'
			);
			
			foreach ($scripts as $s) {
				$doc->addScript($scriptDir .$s);
			}
						
			$included = 1;
		}
	}
	
	/**
	 * Fetches the URL that is used with swiff uploader.
	 * 
	 * @param $obj The field object
	 * @param $type The field type ex: 'text'
	 * @param $record_id The record id
	 * @return string The url
	 */
	function getUploadUrl($obj, $type, $record_id = null) {
		$session 	= & JFactory::getSession();
		$user		= & JFactory::getUser();
		$lang 		= & JFactory::getLanguage();
		$owner 		= null;
		
		if (is_numeric($record_id)) {
			$db = & JFactory::getDBO();
			$q = 'SELECT user_id FROM #__js_res_record WHERE id = '.$record_id;
			$db->setQuery( $q );
			$owner = $db->loadObject();
		}
		
		$tag 		= $lang->getTag();
		$theLang 	= explode('-', $tag);
		
		if (!empty($theLang[ 0 ]))
			$theLang = $theLang[ 0 ];
		else
			$theLang = JRequest::getCmd('lang');
		
		// The url to submit
		$url = JURI::root() .'index.php?option=com_resource&task=uploadMedia'.
			'&fieldId='.$obj->id. 
			'&'.$session->getName().'='.$session->getId().'&'.JUtility::getToken().'=1';
		
		if ($theLang)
			$url .= '&lang='.$theLang; 
		
		
		// The url to submit
//		$url = JURI::root() .'index.php?option=com_resource&task=uploadMedia'.
//			'&fieldId='.$obj->id. 
//			'&'.$session->getName().'='.$session->getId().'&'.JUtility::getToken().'=1';
		
		
		if (isset($owner->user_id))
			$url .= '&user_id='.$owner->user_id;
		else
			$url .= '&user_id='.$user->get('id');
		
		$url .= '&recordId='.$record_id;
			
		return $url;
	}
	
	/**
	 * Returns the record id, storing in the session if it does not exist.
	 * Used to get the record id, when uploading files using flash uploader.
	 * 	
	 * @param $obj
	 * @param $type
	 * @return unknown_type
	 */
	function getRealRecordId($obj, $type) {
		if (isset($obj->record_id) && $obj->record_id)
			return $obj->record_id;
		
		$session = & JFactory::getSession();
		// Look in the session.
		$record_id = $session->get('new_article_prefix', null, $type);
		if (!$record_id) {
			// If the article is newly created, store some unique prefix in thi session
			$record_id = JFile::makeSafe(uniqid('p'));
			$session->set('new_article_prefix', $record_id, $type);
		}
		
		return $record_id;
	}
	
	/**
	 * Renders flash uploader with table of uploaded files.
	 * 
	 * @param $obj The field object.
	 * @param $options
	 * @return string
	 */
	function getUploaderWithFilesTable($obj, $options) {
		$uid 				= isset($options['uid']) ? $options['uid'] : uniqid('fancy_2_');
		$files 				= isset($options['files']) ? $options['files'] : array();
		$files_limit 		= isset($options['maxFiles']) ? $options['maxFiles'] : 0;
		$current_num_files 	= is_array($files) ? count($files) : 0;
		 
		$filterExts			= isset($options['filters']) ? $options['filters'] : array();
		$recordId			= isset($options['recordId']) ? $options['recordId'] : 0;
		$callbacks			= isset($options['callbacks']) ? $options['callbacks'] : false;
		
		$pluginGroup		= isset($options['pluginGroup']) ? $options['pluginGroup'] : false;
        $pluginName			= isset($options['pluginName']) ? $options['pluginName'] : false;
        
		if (!$recordId)
			JError::raiseWarning('UPL01', JText::_('No record id for getUploaderWithFilesTable()'));
			
		// IFRAME UPLOADER
		if (isset($options['uploader']) && $options['uploader'] == 'iframe') {
        	return JS_IFrame_Uploader::getUploaderWithFilesTable($obj, $options); 
        }
		
		
		$mh 		= 'MediaHelper'.$uid;
		$tbodyId 	= 'body_'.$uid; // id for table body, for files to be inserted :)
		
		// Handle callback overriding.
		$options['callbacks'] = array(
			'fileComplete' => $mh .'.fileComplete',
			'validateFile' => $mh .'.validateFile',
			'fileInvalid' => $mh .'.fileInvalid',
			'fileCreate' => $mh .'.fileCreate',
			'fileRemove' => $mh .'.fileRemove'
		);
		if (is_array($callbacks))
			$options['callbacks'] = array_merge($options['callbacks'], $callbacks);
		
		
		$quotedExts = array();
		foreach ($filterExts as $e) 
			$quotedExts[] = '".'. $e. '"';
		
		ob_start();
		?>
<script>
var MediaHelper<?php echo $uid ?> = {
	<?php if ($files_limit) : ?>
	maxFiles: <?php echo $files_limit; ?>,
	curFiles: <?php echo $current_num_files; ?>,
	<?php endif; ?> 

	fieldId: <?php echo $obj->id; ?>,
	recordId: '<?php echo $recordId; ?>',
	tbodyId: '<?php echo $tbodyId; ?>',
	prefix: '<?php echo $uid; ?>_',
	filePrefix: '<?php echo $recordId; ?>_',
	remove: function(file) 
	{	
		var mh = MediaHelper<?php echo $uid ?>;
		var parts = file.split('_');
		parts.shift();
		var thefile = parts.join('_');

		xajax_jsCallPlugin(
			'<?php echo $pluginGroup?>', 
			'<?php echo $pluginName; ?>', 
			'onXajaxDeleteFile',
			[thefile, '<?php echo $recordId; ?>', 0, '<?php echo $obj->id; ?>']
		);

		mh.onSuccess(mh.prefix + file);
	},
	removeListener: function ( e ) {
		var theEvent = e ? e : window.event;
		var theSrc = theEvent.target ? theEvent.target : theEvent.srcElement;
		
		MediaHelper<?php echo $uid ?>.remove(theSrc.rel);
	},
	onSuccess: function(id) {
		var parent = document.getElementById(MediaHelper<?php echo $uid ?>.tbodyId);
		var mh = MediaHelper<?php echo $uid ?>;
		
		if (parent) {
			var child = document.getElementById(id);
			if (child) {
				//alert('I am killing your ' + id);
				parent.removeChild(child);
				if (mh.maxFiles) {
					mh.curFiles--;
				}
			}
		}
	},
	fileComplete: function(file, response) {
		this.log('Starting my ugly code ;)');
		var mh = null;
		if (MediaHelper<?php echo $uid ?>) {
			mh = MediaHelper<?php echo $uid ?>;
			this.log('Got the media helper');
		}
			
		if (mh && mh.tbodyId != null) {
			var body = $(mh.tbodyId);
			if (body != null) {
				// Insertion flag.
				var fInsert = true;
				
				// Check if the file already exists in the fileList.
				var tds = $$('#' + mh.tbodyId + ' td.js_uploader_files');
				for (var i = 0; i < tds.length; i++) {
					if (file.name == tds[ i ].innerHTML) {
						fInsert = false;
						this.log('Found duplicate file, will not create new node');
						break;
					}
				}
				
				// If ok to insert, insert the new nodes.
				if (fInsert) {
					var tr = document.createElement('tr');
					var td1 = document.createElement('td');
					var td2 = document.createElement('td');
					var txt1 = document.createTextNode(file.name);
					
					var a = document.createElement('a');
					
					a.setAttribute('rel', mh.filePrefix + file.name);
					a.setAttribute('href', 'javascript:void(0);');
					
					this.log('Created "a": ' + a.href + ' ' + a.rel);
					
					if (a.addEventListener) {
						a.addEventListener("click", mh.removeListener, false);
						this.log('eventListener ok');
					}
					else if (a.attachEvent) {
						a.attachEvent("onclick", mh.removeListener);
						this.log('attachEvent ok');
					}
					
					var labelText = this.options.texts['remove'] || '<?php echo addslashes(JText::_('Remove')); ?>';
					a.appendChild(document.createTextNode(labelText));
					
					var fieldValue = document.createElement('input');
					fieldValue.setAttribute('type', 'hidden');
					fieldValue.setAttribute('name', 'fields[' + mh.fieldId +'][files][]');
					fieldValue.setAttribute('value', file.name);
					
					td2.appendChild( a );
					td2.appendChild( fieldValue );
					
					td1.appendChild(txt1);
					tr.appendChild(td1);
					tr.appendChild(td2);
					tr.setAttribute('id', mh.prefix + mh.filePrefix + file.name);
					
					body.appendChild(tr);
					
					var dumm = document.getElementById('<?php echo 'dummy___', $uid; ?>');
					if (dumm)
						dumm.value = '1';
					else
						this.log('Cannot find dummy');
				}
			}
		}
	},
	
	fileCreate: function(file) {
		this.log('Custom fileCreate');
		var mh = <?php echo $mh; ?>;
		if (mh.maxFiles) {
			this.log('maxFiles = ' + mh.maxFiles);
			this.log('curFiles = ' + mh.curFiles);
			mh.curFiles++;
			this.log('curFiles = ' + mh.curFiles);
		}
		
		this.log('Calling original');
		this.fileCreate(file);
	},
	
	fileRemove: function(file) {
		this.log('Removing file [custom]');
		var mh = <?php echo $mh; ?>;
		if (mh.maxFiles) {
			this.log('curFiles : ' + mh.curFiles);
			if (!file.finished)
				mh.curFiles--;
			this.log('curFiles : ' + mh.curFiles);
		}
		this.log('Calling original method');
		this.fileRemove(file);
	},
	
	validateFile: function(file, errors) {
		this.log('Validating file [custom]');
		var exts = [<?php echo implode(',', $quotedExts); ?>];
		var mh = <?php echo $mh; ?>;
		
		this.log('setting error flags');
		mh.errorPicLimit = false;
		mh.errorBadExt = false;
		this.log('Completed  setting error flags');
		var extOK = false;
		var limitOK = true;
		
		this.log('looping');
		for (var i = 0; i < exts.length; i++)
			if (exts[ i ].toLowerCase() == file.type.toLowerCase())
				extOK = true;
		
		this.log('looking for maxFiles');
		if (mh.maxFiles) {
			this.log('Gotcha');
			if (mh.curFiles + 1 > mh.maxFiles) {
				this.log('Bad limit');
				limitOK = false;
			}
		}
		
		mh.errorBadExt = !extOK;
		mh.errorPicLimit = !limitOK;
		
		this.log('Flags: ' + mh.errorBadExt + ' ' + mh.errorPicLimit);
		
		return limitOK && extOK;
	},
	
	errorBadExt: 0,
	errorPicLimit: 0,
	
	fileInvalid: function(file, errors) {
		var badExt = this.options.texts['badExtension'] || '<?php echo addslashes(JText::_('File format is not allowed')); ?>';
		var badSize = this.options.texts['fileTooBig'] || '<?php echo addslashes(JText::_('The file is too large')); ?>';
		var maxSizeIs = this.options.texts['maxSizeIs'] || '<?php echo addslashes(JText::_('the maximum allowed size is')); ?>'; 
		var duplicatesNot = this.options.texts['duplicateNotAllowed'] || '<?php echo addslashes(JText::_('Duplicate files are not allowed'));?>';
		var filesLimit = '<?php echo addslashes(JText::_('Maximum number of files')); ?>';
		
		var errorMsg = [];
		
		this.log('Custom fileInvalid');
		
		var mh = <?php echo $mh; ?>;
		
		for(var i = 0; i < errors.length; i++) {
			if (errors[ i ] == 'size') {
				errorMsg.push(badSize + ' ' + maxSizeIs + ' ' + this.sizeToKB(this.options.limitSize));
			}
			if (errors[ i ] == 'custom') { // Invalid extension
				if (mh.errorBadExt)
					errorMsg.push( badExt + ' : *' + file.type );
				if (mh.errorPicLimit)
					errorMsg.push( filesLimit + ' : ' + mh.maxFiles );
			}
			// entodo: Hmm, this never get's executed. 
			if (errors[ i ] == 'duplicate') {
				errorMsg.push( duplicatesNot + ' : ' + file.name);
			}
		}
		if (errorMsg.length > 0)
			alert(errorMsg.join('\n'));	
	}
};
</script>
		<?php
		
		// echo '<br>' . JText::_ ( 'Allowed formats are' ) . ': '.implode(', ', $filterExts)."</span>";
		
		// insert the uploader
		JHTMLJsmedia_new::uploader($options);
		
		echo '<div>&nbsp;</div>';
		echo '<p>', JText::_('Files to save'), ':</p>';
		if ($tbodyId)
			echo '<table><tbody id="', $tbodyId,'">';
		else
			echo '<table><tbody>';
				
		if (is_array($files)) {
			foreach ($files as $file) {
				echo '<tr id="', $uid, '_', $recordId, '_', $file, '">';
				echo '<td class="js_uploader_files">', $file, '</td>';
				?>
				<td>
					<a rel="<?php echo $recordId, '_', $file ?>" href="javascript:void(0);" onclick="<?php echo $mh; ?>.remove(this.rel)">
						<?php echo JText::_('Remove'); ?>
					</a>
					<input type="hidden" name="fields[<?php echo $obj->id ?>][files][]" value="<?php echo $file ?>" />
				</td>
				<?php
				echo '</tr>';
			}
		}
		else
			echo '<input id="dummy___', $uid,'" type="hidden" name="fields[', $obj->id, '][dummy]" value="" />';
		echo '</tbody></table>';
		echo JHTML::_('form.token');
		
		return ob_get_clean();
	}
	
	/**
	 * Renders flash uploader with table of uploaded files with titles.
	 * 
	 * @param $obj The field object.
	 * @param $options
	 * @return string
	 */
	function getUploaderWithFilesAndTitleTable($obj, $options) {
		$uid 				= isset($options['uid']) ? $options['uid'] : uniqid('fancy_2_');
		$files 				= isset($options['files']) ? $options['files'] : array();
		$files_limit 		= isset($options['maxFiles']) ? $options['maxFiles'] : 0;
		if (isset ($files['name']) ){
			if(is_array($files['name']))
				$current_num_files = count($files['name']);
			else
				$current_num_files = 0;
		}else{
			// $files['name'] = $files;  //was commented to resolve empty array issue in the uploader fields ()gallery2, files, media).
			if(is_array($files['name']))
				$current_num_files = count($files['name']);
			else
				$current_num_files = 0;
		}
		 
		$filterExts			= isset($options['filters']) ? $options['filters'] : array();
		$recordId			= isset($options['recordId']) ? $options['recordId'] : 0;
		$callbacks			= isset($options['callbacks']) ? $options['callbacks'] : false;
		
		$pluginGroup		= isset($options['pluginGroup']) ? $options['pluginGroup'] : false;
        $pluginName			= isset($options['pluginName']) ? $options['pluginName'] : false;
        
		if (!$recordId)
			JError::raiseWarning('UPL01', JText::_('No record id for getUploaderWithFilesTable()'));
			
		// IFRAME UPLOADER
		if (isset($options['uploader']) && $options['uploader'] == 'iframe') {
        	return JS_IFrame_Uploader::getUploaderWithFilesAndTitleTable($obj, $options); 
        }
		
		
		$mh 		= 'MediaHelper'.$uid;
		$tbodyId 	= 'body_'.$uid; // id for table body, for files to be inserted :)
		
		// Handle callback overriding.
		$options['callbacks'] = array(
			'fileComplete' => $mh .'.fileComplete',
			'validateFile' => $mh .'.validateFile',
			'fileInvalid' => $mh .'.fileInvalid',
			'fileCreate' => $mh .'.fileCreate',
			'fileRemove' => $mh .'.fileRemove'
		);
		if (is_array($callbacks))
			$options['callbacks'] = array_merge($options['callbacks'], $callbacks);
		
		
		$quotedExts = array();
		foreach ($filterExts as $e) 
			$quotedExts[] = '".'. $e. '"';
		
		ob_start();
		?>
<script>
var MediaHelper<?php echo $uid ?> = {
	<?php if ($files_limit) : ?>
	maxFiles: <?php echo $files_limit; ?>,
	curFiles: <?php echo $current_num_files; ?>,
	<?php endif; ?> 

	fieldId: <?php echo $obj->id; ?>,
	recordId: '<?php echo $recordId; ?>',
	tbodyId: '<?php echo $tbodyId; ?>',
	prefix: '<?php echo $uid; ?>_',
	filePrefix: '<?php echo $recordId; ?>_',
	remove: function(file) 
	{	
		var mh = MediaHelper<?php echo $uid ?>;
		var parts = file.split('_');
		parts.shift();
		var thefile = parts.join('_');

		xajax_jsCallPlugin(
			'<?php echo $pluginGroup?>', 
			'<?php echo $pluginName; ?>', 
			'onXajaxDeleteFile',
			[thefile, 
			'<?php echo $recordId; ?>']
		);

		mh.onSuccess(mh.prefix + file);
	},
	removeListener: function ( e ) {
		var theEvent = e ? e : window.event;
		var theSrc = theEvent.target ? theEvent.target : theEvent.srcElement;
		
		MediaHelper<?php echo $uid ?>.remove(theSrc.rel);
	},
	onSuccess: function(id) {
		var parent = document.getElementById(MediaHelper<?php echo $uid ?>.tbodyId);
		var mh = MediaHelper<?php echo $uid ?>;
		
		if (parent) {
			var child = document.getElementById(id);
			if (child) {
				//alert('I am killing your ' + id);
				parent.removeChild(child);
				if (mh.maxFiles) {
					mh.curFiles--;
				}
			}
		}
	},
	fileComplete: function(file, response) {
		this.log('Starting my ugly code ;)');
		var mh = null;
		if (MediaHelper<?php echo $uid ?>) {
			mh = MediaHelper<?php echo $uid ?>;
			this.log('Got the media helper');
		}
			
		if (mh && mh.tbodyId != null) {
			var body = $(mh.tbodyId);
			if (body != null) {
				// Insertion flag.
				var fInsert = true;
				
				// Check if the file already exists in the fileList.
				var tds = $$('#' + mh.tbodyId + ' td.js_uploader_files');
				for (var i = 0; i < tds.length; i++) {
					if (file.name == tds[ i ].innerHTML) {
						fInsert = false;
						this.log('Found duplicate file, will not create new node');
						break;
					}
				}
				
				// If ok to insert, insert the new nodes.
				if (fInsert) {
					var tr = document.createElement('tr');
					var td1 = document.createElement('td');
					var td2 = document.createElement('td');
					var td3 = document.createElement('td');
					var txt1 = document.createTextNode(file.name);
					
					var a = document.createElement('a');
					
					a.setAttribute('rel', mh.filePrefix + file.name);
					a.setAttribute('href', 'javascript:void(0);');
					
					this.log('Created "a": ' + a.href + ' ' + a.rel);
					
					if (a.addEventListener) {
						a.addEventListener("click", mh.removeListener, false);
						this.log('eventListener ok');
					}
					else if (a.attachEvent) {
						a.attachEvent("onclick", mh.removeListener);
						this.log('attachEvent ok');
					}
					
					var labelText = this.options.texts['remove'] || '<?php echo addslashes(JText::_('Remove')); ?>';
					a.appendChild(document.createTextNode(labelText));
					
					var fieldValue = document.createElement('input');
					fieldValue.setAttribute('type', 'hidden');
					fieldValue.setAttribute('name', 'fields[' + mh.fieldId +'][files][name][]');
					fieldValue.setAttribute('value', file.name);

					var fieldTitle = document.createElement('input');
					fieldTitle.setAttribute('type', 'text');
					fieldTitle.setAttribute('name', 'fields[' + mh.fieldId +'][files][title][]');
					fieldTitle.setAttribute('size', '50');
					fieldTitle.setAttribute('value', '<?php echo JText::_('Untitled')?>');

					td3.appendChild( document.createTextNode('<?php echo JText::_('Title')?>:') );
					td3.appendChild( fieldTitle );
					td2.appendChild( a );
					td2.appendChild( fieldValue );
					
					td1.appendChild(txt1);
					tr.appendChild(td1);
					tr.appendChild(td3);
					tr.appendChild(td2);
					tr.setAttribute('id', mh.prefix + mh.filePrefix + file.name);
					
					body.appendChild(tr);
					
					var dumm = document.getElementById('<?php echo 'dummy___', $uid; ?>');
					if (dumm)
						dumm.value = '1';
					else
						this.log('Cannot find dummy');
				}
			}
		}
	},
	
	fileCreate: function(file) {
		this.log('Custom fileCreate');
		var mh = <?php echo $mh; ?>;
		if (mh.maxFiles) {
			this.log('maxFiles = ' + mh.maxFiles);
			this.log('curFiles = ' + mh.curFiles);
			mh.curFiles++;
			this.log('curFiles = ' + mh.curFiles);
		}
		
		this.log('Calling original');
		this.fileCreate(file);
	},
	
	fileRemove: function(file) {
		this.log('Removing file [custom]');
		var mh = <?php echo $mh; ?>;
		if (mh.maxFiles) {
			this.log('curFiles : ' + mh.curFiles);
			if (!file.finished)
				mh.curFiles--;
			this.log('curFiles : ' + mh.curFiles);
		}
		this.log('Calling original method');
		this.fileRemove(file);
	},
	
	validateFile: function(file, errors) {
		this.log('Validating file [custom]');
		var exts = [<?php echo implode(',', $quotedExts); ?>];
		var mh = <?php echo $mh; ?>;
		
		this.log('setting error flags');
		mh.errorPicLimit = false;
		mh.errorBadExt = false;
		this.log('Completed  setting error flags');
		var extOK = false;
		var limitOK = true;
		
		this.log('looping');
		for (var i = 0; i < exts.length; i++)
			if (exts[ i ].toLowerCase() == file.type.toLowerCase())
				extOK = true;
		
		this.log('looking for maxFiles');
		if (mh.maxFiles) {
			this.log('Gotcha');
			if (mh.curFiles + 1 > mh.maxFiles) {
				this.log('Bad limit');
				limitOK = false;
			}
		}
		
		mh.errorBadExt = !extOK;
		mh.errorPicLimit = !limitOK;
		
		this.log('Flags: ' + mh.errorBadExt + ' ' + mh.errorPicLimit);
		
		return limitOK && extOK;
	},
	
	errorBadExt: 0,
	errorPicLimit: 0,
	
	fileInvalid: function(file, errors) {
		var badExt = this.options.texts['badExtension'] || '<?php echo addslashes(JText::_('File format is not allowed')); ?>';
		var badSize = this.options.texts['fileTooBig'] || '<?php echo addslashes(JText::_('The file is too large')); ?>';
		var maxSizeIs = this.options.texts['maxSizeIs'] || '<?php echo addslashes(JText::_('the maximum allowed size is')); ?>'; 
		var duplicatesNot = this.options.texts['duplicateNotAllowed'] || '<?php echo addslashes(JText::_('Duplicate files are not allowed'));?>';
		var filesLimit = '<?php echo addslashes(JText::_('Maximum number of files')); ?>';
		
		var errorMsg = [];
		
		this.log('Custom fileInvalid');
		
		var mh = <?php echo $mh; ?>;
		
		for(var i = 0; i < errors.length; i++) {
			if (errors[ i ] == 'size') {
				errorMsg.push(badSize + ' ' + maxSizeIs + ' ' + this.sizeToKB(this.options.limitSize));
			}
			if (errors[ i ] == 'custom') { // Invalid extension
				if (mh.errorBadExt)
					errorMsg.push( badExt + ' : *' + file.type );
				if (mh.errorPicLimit)
					errorMsg.push( filesLimit + ' : ' + mh.maxFiles );
			}
			// entodo: Hmm, this never get's executed. 
			if (errors[ i ] == 'duplicate') {
				errorMsg.push( duplicatesNot + ' : ' + file.name);
			}
		}
		if (errorMsg.length > 0)
			alert(errorMsg.join('\n'));	
	}
};
</script>
		<?php
		
		// echo '<br>' . JText::_ ( 'Allowed formats are' ) . ': '.implode(', ', $filterExts)."</span>";
		
		// insert the uploader
		JHTMLJsmedia_new::uploader($options);
		
		echo '<div>&nbsp;</div>';
		echo '<p>', JText::_('Files to save'), ':</p>';
		if ($tbodyId)
			echo '<table><tbody id="', $tbodyId,'">';
		else
			echo '<table><tbody>';
				
		if (isset($files['name']) && is_array($files['name'])) {
			foreach ($files['name'] as $key => $file) {
				echo '<tr id="', $uid, '_', $recordId, '_', $file, '">';
				echo '<td class="js_uploader_files">', $file, '</td>';
				echo '<td class="inputbox">Title:<input type="text" size="30" name="fields['.$obj->id.'][files][title][]" value="'.(isset($files['title'][$key])? $files['title'][$key] : JText::_('Untitled')).'" /></td>';
				?>
				<td>
					<a rel="<?php echo $recordId, '_', $file ?>" href="javascript:void(0);" onclick="<?php echo $mh; ?>.remove(this.rel)">
						<?php echo JText::_('Remove'); ?>
					</a>
					<input type="hidden" name="fields[<?php echo $obj->id ?>][files][name][]" value="<?php echo $file ?>" />
				</td>
				<?php
				echo '</tr>';
			}
		}
		else
			echo '<input id="dummy___', $uid,'" type="hidden" name="fields[', $obj->id, '][dummy]" value="" />';
		echo '</tbody></table>';
		echo JHTML::_('form.token');
		
		return ob_get_clean();
	}

	
	/*
	 * $options = array(
	 * 		'title' => 'The title to display',
	 * 		'url' => 'The URL to submit to',
	 * 		'uploadFileName' => 'The name of upload file, "<input type=file />" which will be submitted to server'
	 *		'limitSize' => 'The file upload limit (in bytes)',
	 *		'debug' => 'Debug javascript', // optional
	 * 		'callbacks' => array(
	 * 			'onLoad' => 'MyObject.onLoad'
	 * 		), // Callbacks, optional
	 *		'backgroundColor' => ':)', // opional
	 *		'filters' => array(
	 *			'.jpeg', '.gif'
	 *		),
	 *		'uid' => 'Unique id for decorating names', // required
	 * 		'processResponse' => true / false, // optional.
	 * 		'limitFiles' => 5 // The size of uploader (Num of files that can fit)
	 * );
	 */
	function uploader($options = array()) {
		JHTMLJsmedia_new::scripts();
		
		$imageDir = JURI::root() .'components/com_resource/images/jsmedia/';
		
		$uri 			= & JURI::getInstance();
		$document		= & JFactory::getDocument();
		
		$title			= isset($options['title']) ? $options['title'] : '';
		$url 			= isset($options['url']) ? $options['url'] : $uri->toString();		
		$uploadFileName = isset($options['uploadFileName']) ? $options['uploadFileName'] : 'upload';
		$limitSize 		= isset($options['limitSize']) ? (int)$options['limitSize'] : 2 * 1024 * 1024; // 2 MiB
		$debug 			= isset($options['debug']) ? (bool)$options['debug'] : false;
		$debug 			= $debug ? 'true' : 'false';
		$filters	 	= isset($options['filters']) ? $options['filters'] : false;
		$bgColor		= isset($options['backgroundColor']) ? $options['backgroundColor'] : '#F9F7ED';
		$uid 			= isset($options['uid']) ? $options['uid'] : uniqid('fancy_2_');
		$hiddenClass 	= isset($options['hiddenClass']) ? $options['hiddenClass'] : $uid.'js_media_invisible';
		$callbacks		= isset($options['callbacks']) ? $options['callbacks'] : false;
		$processResponse= isset($options['processResponse']) ? $options['processResponse'] : false;
		$limitFiles 	= isset($options['limitFiles']) ? $options['limitFiles'] : false;
		$url 			= addslashes($url);
		
		settype($filters, 'array');
		for ($i = 0, $count = count($filters); $i < $count; $i++) {
			if (strpos($filters[ $i ], '*.') !== 0)
				$filters[ $i ] = '*.'.$filters[ $i ]; 
		}
		$filters = implode('; ', $filters);
		
		?>
<script>
var <?php echo $uid; ?>swiffy = null;

var options<?php echo $uid; ?> = {
	url: '<?php echo $url; ?>',
	method: 'POST',
	debug: <?php echo $debug; ?>,
	fieldName: '<?php echo $uploadFileName; ?>',
	varName: '<?php echo $uid; ?>swiffy',
	limitSize: <?php echo $limitSize; ?>,
	limitFiles: 5,
	allowDuplicates: false,
	multiple: true,
	queued: true,
	typeFilter: {
		'<?php echo $filters ? $filters : '*.*'; ?>' : '<?php echo $filters ? $filters : '*.*'; ?>'
	},
	target: '<?php echo $uid; ?>js_fancy_uploader-browse',
	<?php 
		if ($limitFiles)
			echo 'limitFiles: ', $limitFiles, ',';
	?>
	processResponse: <?php echo $processResponse ? $processResponse : 'null'?>,
	swf: {
		id: "<?php echo $uid; ?>swfcont",
		outerContainer: '<?php echo $uid; ?>flashContainer',
		width: '100%',
		height: '100%',
		movie: '<?php echo JURI::root(), 'components/com_resource/library/swf/'?>Swiff.Uploader.swf'
	},
	texts: {
		'fileProgress': '<?php echo addslashes(JText::_('File progress')); ?>',
		'uploadWith': '<?php echo addslashes(JText::_('Upload with')); ?>',
		'remove': '<?php echo addslashes(JText::_('Remove')); ?>',
		'uploadComplete': '<?php echo addslashes(JText::_('Upload Complete')); ?>',
		'overallProgress': '<?php echo addslashes(JText::_('Overall Progress')); ?>',
		'badExtension': '<?php echo addslashes(JText::_('Format is not allowed')); ?>',
		'fileExistsOverwrite': '<?php echo addslashes(JText::_('File already exists, do you want to replace it?')); ?>',
		'fileTooBig': '<?php echo addslashes(JText::_('File size is too large')); ?>',
		'maxSizeIs': '<?php echo addslashes(JText::_('maximum allowed size is')); ?>',
		'duplicateNotAllowed': '<?php echo addslashes(JText::_('Duplicate files are not allowed')); ?>'
	}
	<?php 
	if ($callbacks && is_array($callbacks)) {
		foreach ($callbacks as $name => $value) {
			echo ', ', $name, ': ', $value;
		}
	}
	?>
};

window.addEvent('load', function() {

	var flashDiv = document.createElement('div');
	flashDiv.style.position = 'absolute';
	flashDiv.style.zIndex = '99999';
	flashDiv.style.overflow = 'hidden';
	flashDiv.style.width = '15px';
	flashDiv.style.height = '15px';
	flashDiv.id = "<?php echo $uid; ?>flashContainer";
	//flashDiv.innerHTML = '<div id="<?php echo $uid; ?>swfcont"></div>';


	var contDiv = new Element('div', {
		'id': "<?php echo $uid; ?>swfcont"
	});
	flashDiv.appendChild(contDiv);
	
	document.body.appendChild(flashDiv);

	<?php echo $uid; ?>swiffy = new Lib01.uploader(
		document.getElementById('<?php echo $uid; ?>js_fancy_uploader-status'),
		document.getElementById('<?php echo $uid; ?>js_fancy_uploader-list'),
		options<?php echo $uid; ?>
	);
	setTimeout(function() {
		<?php echo $uid; ?>swiffy.init();
	}, 1000);

	$('<?php echo $uid; ?>js_fancy_uploader-browse').addEvent('click', function() {
		<?php echo $uid; ?>swiffy.reposition();
		try {
			<?php echo $uid; ?>swiffy.browse();
		}
		catch ( e ) {
		}
		return false;
	});

	$('<?php echo $uid; ?>js_fancy_uploader-clear').addEvent('click', function() {
		<?php echo $uid; ?>swiffy.removeFile();
		return false;
	});

	$('<?php echo $uid; ?>js_fancy_uploader-upload').addEvent('click', function() {
		<?php echo $uid; ?>swiffy.upload();
		return false;
	});

});
</script>
<?php
	ob_start();
?>
.<?php echo $uid; ?>js_media_invisible {
	display: none;
}
#<?php echo $uid; ?>js_fancy_uploader-status
{
	background-color:		<?php echo $bgColor; ?>;
	padding:				10px 15px;
	width:					420px;
}

#<?php echo $uid; ?>js_fancy_uploader-status .progress
{
	background:				white url(<?php echo $imageDir; ?>progress-bar/progress.gif) no-repeat;
	background-position:	+50% 0;
	margin-right:			0.5em;
}

#<?php echo $uid; ?>js_fancy_uploader-status .progress-text
{
	font-size:				0.9em;
	font-weight:			bold;
}

#<?php echo $uid; ?>js_fancy_uploader-list
{
	padding-left: 			0px;
	list-style:				none;
	width:					450px;
	margin:					0;
}

#<?php echo $uid; ?>js_fancy_uploader-list li.file
{
	border-bottom:			1px solid #eee;
	background:				url(<?php echo $imageDir; ?>file.png) no-repeat 4px 4px;
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file.file-uploading
{
	background-image:		url(<?php echo $imageDir; ?>uploading.png);
	background-color:		#D9DDE9;
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file.file-success
{
	background-image:		url(<?php echo $imageDir; ?>success.png);
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file.file-failed
{
	background-image:		url(<?php echo $imageDir; ?>failed.png);
}

#<?php echo $uid; ?>js_fancy_uploader-list li.file .file-name
{
	font-size:				1.0em;
	margin-left:			44px;
	display:				block;
	clear:					left;
	line-height:			40px;
	height:					40px;
	font-weight:			bold;
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file .file-size
{
	font-size:				0.9em;
	line-height:			18px;
	float:					right;
	margin-top:				2px;
	margin-right:			6px;
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file .file-info
{
	display:				block;
	margin-left:			44px;
	font-size:				0.9em;
	line-height:			20px;
	
}
#<?php echo $uid; ?>js_fancy_uploader-list li.file .file-remove
{
	clear:					right;
	float:					right;
	line-height:			18px;
	margin-right:			6px;
}
<?php
	$css = ob_get_clean();
	$document->addStyleDeclaration($css);
?>
	<!-- 
	<fieldset id="<?php echo $uid; ?>js_fancy_uploader-fallback">
		<legend><?php echo JText::_($title); ?></legend>
		<p>Selected your file to upload.</p>
		<label for="<?php echo $uid; ?>js_fancy_uploader-photoupload">
			<?php echo JText::_('Upload Photos'); ?>
			<input type="file" name="<?php echo $uploadFileName; ?>" id="<?php echo $uid; ?>js_fancy_uploader-photoupload" />
		</label>
	</fieldset>
	-->
	
	<div id="<?php echo $uid; ?>js_fancy_uploader-status">
		<p>
			<input type="button" class="button" id="<?php echo $uid; ?>js_fancy_uploader-browse" value="<?php echo JText::_('Browse Files');?>" />
			<input type="button" class="button" id="<?php echo $uid; ?>js_fancy_uploader-upload" value="<?php echo JText::_('Upload'); ?>" />
			<input type="button" class="button" id="<?php echo $uid; ?>js_fancy_uploader-clear" value="<?php echo JText::_('Clear List'); ?>" />
		</p>
		<div>
			<strong class="overall-title"><?php JText::_('Overall progress'); ?></strong><br />
			<img src="<?php echo $imageDir; ?>progress-bar/bar.gif" class="progress overall-progress" />
		</div>
		<div>
			<strong class="current-title"><?php JText::_('File Progress'); ?></strong><br />
			<img src="<?php echo $imageDir; ?>progress-bar/bar.gif" class="progress current-progress" />
		</div>
		<div class="current-text"></div>
	</div>
	<ul id="<?php echo $uid; ?>js_fancy_uploader-list"></ul>
		<?php
	}
}


/**
 * Uploader helper.
 * 
 * @author Nurlan
 *
 */
class JS_Res_FancyUploaderHelper 
{
	/**
	 * Gets helper instance.
	 * @return JS_Res_FancyUploaderHelper
	 */
	function & getInstance() {
		static $instance = 0;
		if (!$instance) {
			$instance = new JS_Res_FancyUploaderHelper(); 
		}
		
		return $instance;
	}
	
	function JS_Res_FancyUploaderHelper() {
		$this->_initResourceConfig();
	}
	
	
	/**
	 * Fetches author id using article id.
	 * @param $articleId int
	 * @return int Author id or 0 for no author.
	 */
	function getAuthorIdByArticleId($articleId) {
		static $ids = 0;
		
		if ($ids == 0)
			$ids = array();	
			
		$articleId = (int)$articleId;
		
		if (!$articleId)
			return -1;
	
		if (!isset($ids[$articleId]))
		{		
			$db = & JFactory::getDBO();
			
			$db->setQuery('SELECT user_id FROM #__js_res_record WHERE id = '.$articleId);
			
			$userId = $db->loadResult();
			if (is_null($userId))
				$userId = -1;
			
			$ids[$articleId] = $userId;
		} 
		
		return $ids[$articleId];
	}
	
	/**
	 * Initializes com_resource settings 
	 * @return void
	 */
	function _initResourceConfig() {
		static $isInitialized = 0;
		
		if (!$isInitialized)
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();
			
			$isInitialized = 1;
		}
	}
}

class JS_IFrame_Uploader {
	function getUploaderWithFilesTable($obj, $options) {
        $uid                = isset($options['uid']) ? $options['uid'] : uniqid('fancy_2_');
        $files              = isset($options['files']) ? $options['files'] : array();
        $files_limit        = isset($options['maxFiles']) ? $options['maxFiles'] : 0;
        $current_num_files  = is_array($files) ? count($files) : 0;
         
        $filterExts         = isset($options['filters']) ? $options['filters'] : array();
        $recordId           = isset($options['recordId']) ? $options['recordId'] : 0;
        $callbacks          = isset($options['callbacks']) ? $options['callbacks'] : false;
        
        $url 				= isset($options['url']) ? $options['url'] : $uri->toString();
        
        $pluginGroup		= isset($options['pluginGroup']) ? $options['pluginGroup'] : false;
        $pluginName			= isset($options['pluginName']) ? $options['pluginName'] : false;
        
        if (!$recordId)
            JError::raiseWarning('UPL01', JText::_('No record id for getUploaderWithFilesTable()'));
        
        $url = addslashes( $url );    
        
        $quotedExts = array();
        foreach ($filterExts as $e) 
            $quotedExts[] = '"'. $e. '"';
            
        $document = & JFactory::getDocument();
		$document->addScript(JURI::root().'components/com_resource/library/js/uploader/ajax_file_uploader.js');
		$document->addStyleSheet(JURI::root().'components/com_resource/library/css/iframe_uploader_style.css');

        ob_start();
        ?>
        <div class="uploader_container">
            <div id="content<?php echo $uid; ?>" class="content">
				 <div style="padding-bottom: 5px">
					<input type="button" id="submitFiles<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Upload'); ?>"/>
					<input type="button" id="addMore<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Add'); ?>" />
					<input type="button" id="removeExtra<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Remove'); ?>" />
				 </div>
             </div>
             <table class="filetable">
	             <tbody id="filetable<?php echo $uid; ?>">
        	     </tbody>
             </table>
         </div>
<script>
<?php ob_start(); ?>
var JS_Uploader_Watcher = {
	createResultItem: function( span ) {
		var p = span.parentNode;
		(function() {
			var fxBlur = new Fx.Style(p, 'opacity', {duration: 400});
			
			fxBlur.start(1, 0).chain(function() {
				var fxHei = new Fx.Style(p, 'height', {duration: 1000});

				fxHei.start(p.offsetHeight, 0)
				.chain(
					function() {
						p.parentNode.removeChild( p );
					}
				);
			});
		}).delay(1000);
	
		return false;
	}
};
<?php $document->addScriptDeclaration(ob_get_clean()); ?>
var uploader<?php echo $uid; ?> = null;

window.addEvent('domready', function()
{
	uploader<?php echo $uid; ?> = new JS_IFrame_Uploader('uploader<?php echo $uid; ?>');
	uploader<?php echo $uid; ?>.strings.UNKNOWN_ERROR = '<?php echo addslashes(JText::_('Error')); ?>';

	
	var domHelper = new UploaderDomHelper(
		uploader<?php echo $uid; ?>, 
		$('filetable<?php echo $uid; ?>'), 
		'fields[<?php echo $obj->id; ?>][files][]',
		'<?php echo $url; ?>',
		'<?php echo JURI::root().'components/com_resource/images/iframe_uploader/loader.gif'; ?>'
	);

	function deleteFiles( e ) {
		var p = e.parentNode.parentNode;
		if (p && p.parentNode) {
			xajax_jsCallPlugin('<?php echo $pluginGroup?>', '<?php echo $pluginName; ?>', 'onXajaxDeleteFile', [e.filename, '<?php echo $recordId; ?>']);
			domHelper.removeFromFileList(p, e.filename);
		}
	}

	// reference to function to delete files
	domHelper.onDeleteFile = deleteFiles;

	domHelper.watcher = JS_Uploader_Watcher;
	domHelper.strings = {
		UNKNOWN_ERROR: '<?php echo addslashes(JText::_('Error')); ?>',
		FILE_LIMIT_ERROR: '<?php echo addslashes(JText::_('Maximum allowed files: %d')); ?>',
		REMOVE: '<?php echo addslashes(JText::_('Remove')); ?>',
		FILE: '<?php echo addslashes(JText::_('File')); ?>'
	};
	
	var validator = new JS_FileValidator(uploader<?php echo $uid; ?>, {
		ext: [<?php echo implode(', ', $quotedExts); ?>],
		max: <?php echo (int)$files_limit; ?>,
		current: <?php echo $current_num_files; ?>
	});

	validator.strings.BAD_EXT = '<?php echo addslashes(JText::_('Extension is not allowed : ')); ?>';

	
	uploader<?php echo $uid; ?>.addValidator(validator);

	uploader<?php echo $uid; ?>.addListener('onSubmit', 			domHelper.onSubmit, 			domHelper);
	uploader<?php echo $uid; ?>.addListener('onAfterFileUpload', 	validator.onAfterFileUpload, 	validator);
	uploader<?php echo $uid; ?>.addListener('onAfterFileUpload', 	domHelper.onAfterFileUpload, 	domHelper);
	uploader<?php echo $uid; ?>.addListener('onUploadFail', 		domHelper.onUploadFail, 		domHelper);
	uploader<?php echo $uid; ?>.addListener('onFileLimit', 			domHelper.onFileLimit, 			domHelper);

	uploader<?php echo $uid; ?>.addListener('onFormAdd', function(forms, form) {
		document.getElementById('content<?php echo $uid; ?>').appendChild( form.parentNode );
		return false;
	});
	

<?php if (isset($files) && is_array($files) && count($files)) : ?>
	<?php foreach ($files as $file) : ?>
    domHelper.addToFileList('<?php echo addslashes($file); ?>');
	<?php endforeach; ?>
<?php endif; ?>
	
	$('submitFiles<?php echo $uid; ?>').addEvent('click', function() {
		uploader<?php echo $uid; ?>.uploadForms();
		//return false;
	});
	$('addMore<?php echo $uid; ?>').addEvent('click', function() {
		var el = domHelper.createNewItem();
		
		uploader<?php echo $uid; ?>.addForm(el.firstChild);
		return false;
	});
	$('removeExtra<?php echo $uid; ?>').addEvent('click', function() {
		var f = uploader<?php echo $uid; ?>.popForm();
		if ( f ) {
			var el = f.parentNode;
			el.parentNode.removeChild( el );
		}
		return false;
	});

	if (validator.validateCount( 1 )) {
		var el = domHelper.createNewItem();
		uploader<?php echo $uid; ?>.addForm(el.firstChild);
	}
});
</script>
		<?php
		
		return ob_get_clean();
    }
    
    function getUploaderWithFilesAndTitleTable($obj, $options) {
        $uid                = isset($options['uid']) ? $options['uid'] : uniqid('fancy_2_');
        $files              = isset($options['files']) ? $options['files'] : array();
        $files_limit        = isset($options['maxFiles']) ? $options['maxFiles'] : 0;
        //$current_num_files  = is_array($files) ? count($files) : 0;
        $current_num_files 	= (isset ($files['name']) && is_array($files['name'])) ? count($files['name']) : 0;
         
        $filterExts         = isset($options['filters']) ? $options['filters'] : array();
        $recordId           = isset($options['recordId']) ? $options['recordId'] : 0;
        $callbacks          = isset($options['callbacks']) ? $options['callbacks'] : false;
        
        $url 				= isset($options['url']) ? $options['url'] : $uri->toString();
        
        $pluginGroup		= isset($options['pluginGroup']) ? $options['pluginGroup'] : false;
        $pluginName			= isset($options['pluginName']) ? $options['pluginName'] : false;
        
        if (!$recordId)
            JError::raiseWarning('UPL01', JText::_('No record id for getUploaderWithFilesTable()'));
        
        $url = addslashes( $url );    
        
        $quotedExts = array();
        foreach ($filterExts as $e) 
            $quotedExts[] = '"'. $e. '"';
            
        $document = & JFactory::getDocument();
		$document->addScript(JURI::root().'components/com_resource/library/js/uploader/ajax_file_uploader.js');
		$document->addStyleSheet(JURI::root().'components/com_resource/library/css/iframe_uploader_style.css');

        ob_start();
        ?>
        <div class="uploader_container">
            <div id="content<?php echo $uid; ?>" class="content">
				 <div style="padding-bottom: 5px">
					<input type="button" id="submitFiles<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Upload'); ?>"/>
					<input type="button" id="addMore<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Add'); ?>" />
					<input type="button" id="removeExtra<?php echo $uid; ?>" class="button" value="<?php echo JText::_('Remove'); ?>" />
				 </div>
             </div>
             <table class="filetable">
	             <tbody id="filetable<?php echo $uid; ?>">
        	     </tbody>
             </table>
         </div>
<script>
<?php ob_start(); ?>
var JS_Uploader_Watcher = {
	createResultItem: function( span ) {
		var p = span.parentNode;
		(function() {
			var fxBlur = new Fx.Style(p, 'opacity', {duration: 400});
			
			fxBlur.start(1, 0).chain(function() {
				var fxHei = new Fx.Style(p, 'height', {duration: 1000});

				fxHei.start(p.offsetHeight, 0)
				.chain(
					function() {
						p.parentNode.removeChild( p );
					}
				);
			});
		}).delay(1000);
	
		return false;
	}
};
<?php $document->addScriptDeclaration(ob_get_clean()); ?>
var uploader<?php echo $uid; ?> = null;

window.addEvent('domready', function()
{
	uploader<?php echo $uid; ?> = new JS_IFrame_Uploader('uploader<?php echo $uid; ?>');
	uploader<?php echo $uid; ?>.strings.UNKNOWN_ERROR = '<?php echo addslashes(JText::_('Error')); ?>';

	
	var domHelper = new UploaderDomHelperWithTitle(
		uploader<?php echo $uid; ?>, 
		$('filetable<?php echo $uid; ?>'), 
		'fields[<?php echo $obj->id; ?>][files]',
		'<?php echo $url; ?>',
		'<?php echo JURI::root().'components/com_resource/images/iframe_uploader/loader.gif'; ?>'
	);

	function deleteFiles( e ) {
		var p = e.parentNode.parentNode;
		if (p && p.parentNode) {
			xajax_jsCallPlugin('<?php echo $pluginGroup?>', '<?php echo $pluginName; ?>', 'onXajaxDeleteFile', [e.filename, '<?php echo $recordId; ?>']);
			domHelper.removeFromFileList(p, e.filename);
		}
	}

	// reference to function to delete files
	domHelper.onDeleteFile = deleteFiles;

	domHelper.watcher = JS_Uploader_Watcher;
	domHelper.strings = {
		UNKNOWN_ERROR: '<?php echo addslashes(JText::_('Error')); ?>',
		FILE_LIMIT_ERROR: '<?php echo addslashes(JText::_('Maximum allowed files: %d')); ?>',
		REMOVE: '<?php echo addslashes(JText::_('Remove')); ?>',
		FILE: '<?php echo addslashes(JText::_('File')); ?>',
		TITLE: '<?php echo addslashes(JText::_('Title')); ?>',
		UNTITLED: '<?php echo addslashes(JText::_('Untitled')); ?>'
	};
	
	var validator = new JS_FileValidator(uploader<?php echo $uid; ?>, {
		ext: [<?php echo implode(', ', $quotedExts); ?>],
		max: <?php echo (int)$files_limit; ?>,
		current: <?php echo $current_num_files; ?>
	});

	validator.strings.BAD_EXT = '<?php echo addslashes(JText::_('Extension is not allowed : ')); ?>';

	
	uploader<?php echo $uid; ?>.addValidator(validator);

	uploader<?php echo $uid; ?>.addListener('onSubmit', 			domHelper.onSubmit, 			domHelper);
	uploader<?php echo $uid; ?>.addListener('onAfterFileUpload', 	validator.onAfterFileUpload, 	validator);
	uploader<?php echo $uid; ?>.addListener('onAfterFileUpload', 	domHelper.onAfterFileUpload, 	domHelper);
	uploader<?php echo $uid; ?>.addListener('onUploadFail', 		domHelper.onUploadFail, 		domHelper);
	uploader<?php echo $uid; ?>.addListener('onFileLimit', 			domHelper.onFileLimit, 			domHelper);

	uploader<?php echo $uid; ?>.addListener('onFormAdd', function(forms, form) {
		document.getElementById('content<?php echo $uid; ?>').appendChild( form.parentNode );
		return false;
	});
	

<?php if (isset($files['name']) && is_array($files['name']) && count($files['name'])) : ?>
	<?php foreach ($files['name'] as $key => $file) : ?>
    domHelper.addToFileList('<?php echo addslashes($file); ?>', '<?php echo addslashes($files['title'][$key]); ?>');
	<?php endforeach; ?>
<?php endif; ?>
	
	$('submitFiles<?php echo $uid; ?>').addEvent('click', function() {
		uploader<?php echo $uid; ?>.uploadForms();
		//return false;
	});
	$('addMore<?php echo $uid; ?>').addEvent('click', function() {
		var el = domHelper.createNewItem();
		
		uploader<?php echo $uid; ?>.addForm(el.firstChild);
		return false;
	});
	$('removeExtra<?php echo $uid; ?>').addEvent('click', function() {
		var f = uploader<?php echo $uid; ?>.popForm();
		if ( f ) {
			var el = f.parentNode;
			el.parentNode.removeChild( el );
		}
		return false;
	});

	if (validator.validateCount( 1 )) {
		var el = domHelper.createNewItem();
		uploader<?php echo $uid; ?>.addForm(el.firstChild);
	}
});
</script>
		<?php
		
		return ob_get_clean();
    }
}
?>