<?php
/**
 * $Id: article.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class ResModelArticle extends JModel
{
	var $_id = null;
	var $_data = null;
	var $_fworn = false;
	var $_total = null;
	var $_category = null;
	var $_pagination = null;
	var $_fields = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe;

		$config = JFactory::getConfig();

		$id = JRequest::getVar('article', 0, '', 'int');
		if(!$id)
		{
			$cid = JRequest::getVar('cid', array(0), 'post', 'array');
			$id = $cid[0];
		}
		$this->setId((int)$id);
		$this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));

	}
	function setId($id)
	{
		$this->_id = $id;
		$this->_category = null;
	}
	function getTags($id = 0)
	{
		if($id == 0) return '';
		$this->_db->setQuery('SET group_concat_max_len = 8096');
		$this->_db->query();
		$sql = "SELECT GROUP_CONCAT(DISTINCT t.tag ORDER BY t.ctime ASC SEPARATOR ', ') as tagname  FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_tags AS t ON t.id = h.tag_id
		WHERE h.record_id = {$id} GROUP BY h.record_id";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	function getPCategoryName($id)
	{
		//if(!$id) return array();

		$sql = "SELECT name FROM #__js_res_category_user WHERE id = {$id}";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	
	function getCommerceParams($user_id, $section_id)
	{
		$sql = "SELECT params FROM #__jc_users WHERE user_id='$user_id' AND section_id = ".$section_id;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	
	function getAuthor($id, $order = 'name')
	{
		$db = & JFactory::getDBO();

		$and[] = "usertype = 'Manager'";
		$and[] = "usertype = 'Administrator'";
		$and[] = "usertype = 'Super Administrator'";
		$and[] = "usertype = 'Author'";
		$and[] = "usertype = 'Publisher'";
		$and[] = "usertype = 'Editor'";
		if($id) $and[] = "id = {$id}";

		$add = ' AND ('.implode(' OR ', $and).')';


		$query = 'SELECT id AS value, name AS text' . ' FROM #__users' . ' WHERE block = 0' . $add . ' ORDER BY ' . $order;
		$db->setQuery($query);

		$users = $db->loadObjectList();
		if(!$users) $users = array();
		array_unshift($users, JHTML::_('select.option', '0', '- ' . JText::_('No User') . ' -'));

		$users = JHTML::_('select.genericlist', $users, 'user_id', 'class="inputbox" size="1" ', 'value', 'text', $id);

		$users .= ' '.JText::_('Or').' <input type="text" size="2" name="custom_user_id" class="inputbox" />';

		return $users;
	}
	function getCategory($id)
	{
		Global $mainframe;

		$user = &JFactory::getUser();
		if(! $id)
		{
			$cat = new stdClass();
			$cat->title = '';
			$cat->image = '';
			$cat->description = '';
			$cat->id = '';
			$cat->parent = '';
			$cat->params = '';
			return $cat;
		}
		$category = ResHelper::getSection($id);
		if(! $category->published)
		{
			JError::raiseError(404, JText::_("Category Not Found"), $id);
			return false;
		}
		if($category->access > $user->get('aid', 0))
		{
			if($category->access == 1) $msg = JText::_('Only Registered Users can access this page');
			if($category->access == 2) $msg = JText::_('Only Publishers or Authors can access this page');
			JError::raiseWarning(403, $msg);
			$mainframe->redirect(MERoute::_('index.php?option=com_resource&view=list&Itemid=' . JRequest::getInt('Itemid'), FALSE));
			return;
		}

		return $category;
	}
	function _getCategories($parent = 0, $level = 0, $params, $record, $ids = '')
	{
		$db = & JFactory::getDBO();
		$user = &JFactory::getUser();
		/*		$sql = "select id AS value, params, `name` as text
		 FROM #__js_res_category WHERE parent = $parent AND published = 1 ORDER by `ordering` ASC";
		 $db->setQuery($sql);
		 $res = $db->loadObjectList();*/
		$out = array();
		$res = ResHelper::getSectionParent($parent, $params, $ids);
		if($res)
		{
			$layout = JRequest::getString('layout');
			foreach($res as $r)
			{
				if($layout == 'form'){
					$cp = new JParameter($r->params);
					$cp->def('submission', $params->def('submission'));
					if($cp->get('submission') == 'none') continue;
					if($cp->get('submission') > $user->get('aid')) continue;
				}
				/*if(is_object($record))
				{
					if($record->user_id && ($record->user_id != $user->get('id')))
					{
						if(($user->get('gid') != 20) && ($user->get('aid') < 2))
						{
							if($cp->get('submission') == 'none') continue;
							if($cp->get('submission') > $user->get('aid')) continue;
						}
					}
				}*/
				$out[] = JHTML::_('select.option', $r->value,  str_repeat('&nbsp;&nbsp;&nbsp;- ', $level).$r->name);
				//echo $r->parent;
				$add = $this->_getCategories($r->value, $level + 1, $params, $record, $ids);
				if(is_array($add)) $out = array_merge($out, $add);
			}
		}
		else
		{
			return false;
		}
		return $out;

	}
	function isCheckedOut($uid = 0)
	{
		if($this->_loadData())
		{
			if($uid)
			{
				return ($this->_data[$this->_id]->checked_out && $this->_data[$this->_id]->checked_out != $uid);
			}
			else
			{
				return $this->_data[$this->_id]->checked_out;
			}
		}
	}
	function checkout($uid = null)
	{
		if($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if(is_null($uid))
			{
				$user = & JFactory::getUser();
				$uid = $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$record = & $this->getTable('record', 'Res');
			if(! $record->checkout($uid, $this->_id))
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function getTypeName($id)
	{
		if(!$id)
		{
			JError::raiseWarning(501, JText::_('Submission Type not set in section parameters'));
			return;
		}
		$query = "Select id, name FROM #__js_res_types WHERE id = $id";
		$this->_db->setQuery($query);
		$res = $this->_db->loadObject();
		return $res->name;

	}
	function &getRecord($id = null)
	{
		if($id) $this->_id = $id;
		if(!$this->_id) $this->_id = JRequest::getInt('article');
		// Load the weblink data
		if(!$this->_loadData())
		{
			$this->_initData();
		}

		return $this->_data[$this->_id];
	}
	function getFields($record)
	{
		$user = &JFactory::getUser();
		//echo $user->get( 'aid', 0 );
		$sql = " SELECT f.access, f.`id`, ".$record->id." AS record_id, v.id AS vid, f.`type_id`, f.`type`, f.`params`, f.`title`,
				v.`field_value`, v.`params` AS fparams FROM #__js_res_fields AS f ";
		$sql .= " LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id
				AND v.record_id = " . $record->id;
		$sql .= " WHERE f.type_id = " . $record->type_id;
		$sql .= " AND f.published > 0 ";
		//$sql .= " AND f.access <= ".(int) $user->get( 'aid', 0 );
		$sql .= " ORDER BY f.ordering ASC ";
		//$sql .= " AND v.record_id = ".$record->id;
		//echo $sql;
		if(! isset($this->_fields[$record->id]) || ! $this->_fields[$record->id]) $this->_fields[$record->id] = $this->_getList($sql);

		return $this->_fields[$record->id];
	}
	function hit($params)
	{
		global $mainframe;

		$user = & JFactory::getUser();
		$id = JRequest::getInt('article');
		$session = & JFactory::getSession();
		$now = ResHelper::getDate();

		if($session->get('hit_record_'.$id)) return;

		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		$model = & JModel::getInstance('Article', 'ResModel');
		$model->_id = $id;
		$article = $model->getRecord();

		$link = MEUrl::link_record($article, JRequest::getInt('category_id'));

		if(MECommunityHelper::isEnabled() && $user->get('id'))
		{

			MECommunityHelper::loadApi();
			$sql = "SELECT id FROM #__js_res_hits WHERE record_id = {$article->id} AND user_id = ".$user->get('id');
			$this->_db->setQuery($sql);
			$visited = $this->_db->loadResult();

			MECommunityHelper::increasKarma($user->get('id'), $params->get('karma_add_view'), ($params->get('karma_add_view') && $visited == 0));
			MECommunityHelper::increasKarma($article->user_id, $params->get('karma_added_view'), ($params->get('karma_added_view') && $visited == 0));

			if($params->get('activity_add_view') && $user->get('id'))
			{

				$param['icon'] = $params->get('activity_icon_view');
				$param['type'] = JText::_('View').' '. $model->getTypeName($article->type_id);
				$param['text'] = JText::_($params->get('activity_text_view'));
				$param['text'] .= sprintf(' <a href="%s">%s</a>', MERoute::_($link), $article->title);

					
				$sql = sprintf("SELECT id FROM #__community_activity WHERE client = '%s' AND user_id = %d
				AND text = '%s' AND ctime > '{$now}' - INTERVAL 1 DAY",
				JRequest::getInt('client_id'), $user->get('id'), $this->_db->getEscaped($param['text']));
				$this->_db->setQuery($sql);
				$res = $this->_db->loadResult();
				if(!$res)
				{
					MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
				}
			}
		}

		$sql = "UPDATE #__js_res_record SET hits = hits + 1 WHERE id = $id";
		$this->_db->setQuery($sql);
		$this->_db->query($sql);

		$session->set('hit_record_'.$id, time());
		$_COOKIE['hit_record_'.$id] = time();

		if($params->get('item_hits') == 0) return;

		$sql = "INSERT INTO #__js_res_hits VALUES (NULL, $id, '{$now}', " . ($user->get('id') ? (int)$user->get('id') : 0) . ", '" . $_SERVER['REMOTE_ADDR'] . "')";

		$this->_db->setQuery($sql);
		$this->_db->query($sql);

		//$link = "index.php?option=com_resource&controller=article";
		//$link .= "&article=".$article->id."&Itemid=".MEUrl::itemid(NULL, JRequest::getInt('category_id'), $article->id);
		//if(JRequest::getInt('category_id')) $link .= "&category_id=".JRequest::getInt('category_id');
		//$link = MEUrl::linkAdditions($link);
	}
	function getArticle($id = null)
	{
		global $mainframe;
		static $out = array();

		if(! isset($id))
		{
			$id = JRequest::getInt('article');
		}

		if(@$out[$id]) return $out[$id];

		$uri = & JFactory::getURI();
		$params = &$mainframe->getParams();
		$user = & JFactory::getUser();


		//$key = 'record'.JRequest::getVar('view').JRequest::getInt('Itemid', 0).$user->get('id', 0);
		$key = MECache::getKey('record');

		$sql = "SELECT r.*,rc.name AS rcname, rc.id AS rcid, uc.access as cat_access, ch.content, uc.name as user_category,  GROUP_CONCAT(DISTINCT rc.id) as catid, GROUP_CONCAT(DISTINCT rc.name SEPARATOR ':#:') as category 
			FROM #__js_res_record AS r
			LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id
			LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid
			LEFT JOIN #__js_res_category_user AS uc ON uc.id = r.ucatid 
			LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = r.id AND ch.key = ".$this->_db->Quote($key) . 
			" WHERE r.id = $id GROUP BY r.id";
		$this->_db->setQuery($sql);
		$out[$id] = $this->_db->loadObject();
		$article = $out[$id];


		/*		if($forRoute == 0 && $article->access > $user->get('aid', 0) && ($article->user_id != $user->get('id')))
		 {
			JError::raiseWarning('403', JText::_('You do nor have rights to see this article'));
			$return = $uri->toString();

			$url = 'index.php?option=com_user&view=login&Itemid=' . JRequest::getInt('Itemid');
			$url .= '&return=' . base64_encode($return);

			$mainframe->redirect(MERoute::_($url, FALSE));
			return false;
			}
			*/
		return $article;
	}
	function getPagination($params)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$url = &JFactory::getURI();
			$this->_pagination = new JPagination( $this->getCommentTotal($params), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	function getCommentTotal($params)
	{
		$parent = 0; $cid = 0; $leveled = True;
		$user = & JFactory::getUser();
		$id = JRequest::getInt('article');
		$article = & JTable::getInstance('Record', 'Res');
		$article->load($id);
		$url = JFactory::getURI();

		$lang = & JFactory::getLanguage();
		$session = & JFactory::getSession();

		$where = '';
		if($user->get('usertype') != 'Super Administrator') $where .= ' AND published = 1 ';
		if($params->get('comments_lang_mode')) $where .= " AND langs = '" . $lang->getTag() . "' ";

		$where .= " AND `access` <= " . (int)$user->get('aid');
		if($leveled) {
			if(!$cid) {$where .= " AND `parent` = ".$parent;} else {$where .= " AND `id` = ".$cid;}
		}

		if($params->get('comments_sort') == 'date')
		$order = 'ctime ASC';
		else
		$order = 'ctime DESC';

		$sql = "SELECT * FROM #__js_res_comments WHERE record_id = $id $where ORDER BY $order";
		$this->_db->setQuery($sql);
		$comments = $this->_db->loadObjectList();
		return count($comments);
	}

	function getComments($params, $category, $parent = null, $cid = 0, $leveled = True)
	{
		$user = & JFactory::getUser();
		$id = JRequest::getInt('article');
		$article = & JTable::getInstance('Record', 'Res');
		$article->load($id);
		$url = JFactory::getURI();

		$lang = & JFactory::getLanguage();
		$session = & JFactory::getSession();

		$where = '';
		if(!(MEAccess::isAdmin() || MEAccess::isModerator($user->get('id'), 'moder_publish_comment', $params))) $where .= ' AND published = 1 ';
		if($params->get('comments_lang_mode')) $where .= " AND langs = '" . $lang->getTag() . "' ";

		if(!(MEAccess::isAdmin() || MEAccess::isModerator($user->get('id'), 'moder_publish_comment', $params))) $where .= " AND `access` <= " . (int)$user->get('aid');
		if($leveled) {
			if(!$cid) {$where .= " AND `parent` = ".(int)@$parent->id;} else {$where .= " AND `id` = ".$cid;}
		}

		if($params->get('comments_sort') == 'date')
		$order = 'ctime ASC';
		else
		$order = 'ctime DESC';

		$sql = "SELECT * FROM #__js_res_comments WHERE record_id = $id $where ORDER BY $order";

		if(@$parent->id) $this->_db->setQuery($sql);
		else $this->_db->setQuery($sql, $this->getState('limitstart'), $this->getState('limit'));

		$comments = $this->_db->loadObjectList();

		if(is_array($comments))
		{
			//$k = 10;
			//var_dump(abs((int)"-{$k}"));
			foreach($comments as $k => $comment)
			{
				$regex = "/<pre>[^\{]*\{([a-zA-Z0-9\:\-_\|]*)\}(.*)<\/pre>/isU";
				preg_match($regex, $comment->comment, $match);
				if(is_array($match))
				{
					$comments[$k]->comment = preg_replace_callback($regex, 'jsGeshiHighlite', $comment->comment);
					$comment->comment = $comments[$k]->comment;
				}
				$regex = "/<pre lang=\"([a-zA-Z0-9\-_\|]*)\">(.*)<\/pre>/isU";
				preg_match($regex, $comment->comment, $match);
				if(is_array($match))
				{
					$comments[$k]->comment = preg_replace_callback($regex, 'jsGeshiHighlite', $comment->comment);
					$comment->comment = $comments[$k]->comment;
				}

				if(JString::strlen($comments[$k]->comment))

				if($params->get('comments_rate_delete') > 0)
				{
					$level = "-".$params->get('comments_rate_delete');
					if((int)$level >= $comment->rate)
					{
						$comment_table = & JTable::getInstance('Comments', 'Res');
						$comment_table->load($comment->id);
						$comment_table->published = 0;
						$comment_table->store();
						unset($comments[$k]);
						continue;
					}
				}

				$subject = JString::str_ireplace(JText::_('RE:').' ', '', $comment->subject);

				$comments[$k]->subject = '<a name="comment_'.$comment->id.'"></a>'.htmlspecialchars($subject, ENT_QUOTES, 'UTF-8');

				if($comment->attachment)
				{
					$url->setVar('task', 'download_attachment');
					$url->setVar('id', $comment->id);
						
					$file = RES_GENERAL_UPLOAD.DS.$comment->user_id.DS.'attachments';
					$file .= DS.$comment->attachment; $m = array();

					if($params->get('comments_attachment_size')) $m[] = JText::_('Size') .': '. ResHelper::jsFormatSize(filesize($file));
					if($params->get('comments_attachment_hit')) $m[] = JText::_('Hits') .': '. $comment->attach_hit;

					$attach = '<p><span class="small">%s: <a href="%s">%s</a> %s</span></p>';

					$comments[$k]->comment .= sprintf($attach, JText::_('Attachment'), $url->toString(), $comment->attachment, (@$m ? '('.implode(' | ', $m).')' : NULL));
					$url->delVar('task', 'download_attachment');
					$url->delVar('id', $comment->id);
						
				}


				$comment_rate = true;
				if($session->get('user_rate_comment_'.$comment->id)) $comment_rate = false;
				if(isset($_COOKIE["user_rate_comment_{$comment->id}"])) $comment_rate = false;
				if($params->get('comments_rate_access') > $user->get('aid')) $comment_rate = false;
				if($params->get('comments_rate') == 0) $comment_rate = false;
				if(JRequest::getVar('option') != 'com_resource') $comment_rate = false;
				if(MEAccess::isAuthor($comment->user_id)) $comment_rate = false;

				$comments[$k]->can_rate = $comment_rate;

				$edit = false; $delete = FALSE; $comments[$k]->control = '';

				if($params->get('comments_style') == 2 && ($user->get('aid') >= $params->get('comments_access')))
				{
					$img = JHTML::image(JURI::root().'components/com_resource/images/com_replay.png', '', array('align' => 'absmiddle'));
					$comments[$k]->control .= "<button onclick=\"comment_replay('{$comment->id}', '".
					htmlspecialchars(addslashes($subject), ENT_QUOTES, 'UTF-8')."', $comment->level);\" class=\"button replybutton\">{$img} ".JText::_('Reply')."</button> ";
				}
				if(MEAccess::isAuthor($article->user_id, $params->get('comments_approve_author')))
				{
					$edit = true; $delete = TRUE;
				}
				if(MEAccess::isAdmin())
				{
					$edit = true; $delete = TRUE;
				}
				if(MEAccess::isAuthor($comment->user_id, $params->get('comments_delete')))
				{
					$delete = TRUE;
				}
				if(MEAccess::isAuthor($article->user_id, $params->get('comments_approve_author')))
				{
					$delete = TRUE;
				}
				if(MEAccess::isAuthor($comment->user_id, $params->get('comments_edit')))
				{
					$edit = TRUE;
				}
				if(MEAccess::isModerator($user->get('id'), 'moder_delete_comment', $params)) $delete = TRUE;
				if($delete) $comments[$k]->control .= $this->commentLink('delete_comment', $comment->id, $id, JURI::root().'components/com_resource/images/com_delete.png', JText::_('Delete'));
				//if($edit) $comments[$k]->control .= $this->commentLink('edit_comment', $comment->id, $id, JURI::root().'components/com_resource/images/com_edit.png', JText::_('Edit'));
				if((MEAccess::isAdmin() || MEAccess::isModerator($user->get('id'), 'moder_publish_comment', $params)) && $comment->published == 0)
				{
					$comments[$k]->control .= $this->commentLink('publish_comment', $comment->id, $id, JURI::root().'components/com_resource/images/com_publish.png', JText::_('Publish'));
				}
				if($params->get('comments_hide') && ($comment->user_id == $user->get('id')) && $comment->user_id)
				{
					if($comment->hide == 0 )
					{
						$comments[$k]->control .= $this->commentLink('hide_comment', $comment->id, $id, JURI::root().'components/com_resource/images/com_hide.png', JText::_('Hide'));
					}
					else
					{
						$comments[$k]->control .= $this->commentLink('unhide_comment', $comment->id, $id, JURI::root().'components/com_resource/images/com_unhide.png', JText::_('Unhide'));
					}
				}


				if($comment->user_id)
				{
					$comment_author = JFactory::getUser($comment->user_id);
					switch ($params->get('comments_author'))
					{
						case 1:
							$comments[$k]->name = $comment_author->get('name');
							break;
						case 2:
							$comments[$k]->name = $comment_author->get('username');
							break;
					}

				}

				if($params->get('comments_avatar_link') && $comment->user_id)
				{
					$name = $comments[$k]->name;
					if( JComponentHelper::isEnabled('com_comprofiler'))
					{
						$user_profile_link = MERoute::_("index.php?option=com_comprofiler&task=userProfile&user={$comment->user_id}&Itemid=" . $params->get('comments_author_itemid', JRequest::getInt('Itemid')));
						$comments[$k]->name = JHTML::link($user_profile_link, $name);
					}
					if( MECommunityHelper::isEnabled())
					{
						$user_profile_link = MERoute::_("index.php?option=com_community&controller=profile&user_id={$comment->user_id}&Itemid=" . $params->get('comments_author_itemid', JRequest::getInt('Itemid')));
						$comments[$k]->name = JHTML::link($user_profile_link, $name);
					}
				}
				MECommunityHelper::loadApi();
				if(MECommunityHelper::isEnabled() && $comment->user_id)
				{
					$ddm = FALSE;
					if($session->get('unforld_comment_'.$comment->id) || isset($_COOKIE["unforld_comment_{$comment->id}"]) || ($params->get('comemnts_fold') == 0))
					{
						$ddm = TRUE;
					}

					$links = array();
					if(($params->get('category_mode') == 2 || $params->get('category_mode') == 3) && (JRequest::getInt('user_id', 0) == 0 ))
					{
						$link = MEUrl::link_list($category->id, array('user_id'=> $comment->user_id));
						$links[0]->link = MERoute::_($link);
						$links[0]->icon = 'components/com_resource/images/user_record.png';
						$links[0]->alt = JText::_($params->get('item_show_all_label', 'Show all records by this user'));
					}
					if($params->get('comments_avatar')) $uparams['avatar'] = true; else $uparams['avatar'] = false;
					If($params->get('comments_author') == 1) $uparams['name'] = 'name'; else  $uparams['username'] = 'name';
					$comments[$k]->name = JSCommunityApi::getUserSlideMenu($comment->user_id, $comment->name, $links, $uparams, $ddm);
				}

				$comments[$k]->avatar = MECommunityHelper::getAvatar($comment->user_id, $params, 'comments_');

				$hide = $comment->hide;

				if(MEAccess::isAdmin()) $hide = 0;
				if(MEAccess::isModerator($user->get('id'), 'moder_delete_comment', $params)) $hide = 0;
				if(MEAccess::isModerator($user->get('id'), 'moder_publish_comment', $params)) $hide = 0;
				if(MEAccess::isAuthor($article->user_id, $params->get('comments_hide_access'))) $hide = 0;
				if(MEAccess::isAuthor($comment->user_id)) $hide = 0;
				if($comment->parent && MEAccess::isAuthor(@$parent->user_id)) $hide = 0;

				if($hide)
				{
					$comments[$k]->comment = '<blockquote>'.JText::_('Comment hidden').'</blockquote>';
				}
				if(!$hide && $comment->hide)
				{
					$comments[$k]->comment = '<blockquote>'.JText::_('Comment hidden').'</blockquote>'.$comments[$k]->comment;
				}
			}
		}
		return $comments;
	}
	function commentLink($task, $comment, $article, $img, $text)
	{
		$img = JHTML::image($img, '', array('align' => 'absmiddle'));

		$uri = & JFactory::getURI();

		$get['task'] = $task;
		$get['option'] = JRequest::getVar('option');
		$get['view'] = 'article';
		$get['controller'] = 'article';
		$get['article'] = $article;
		$get['comment'] = $comment;
		$get['return'] = base64_encode($uri->toString());
		$get['category_id'] = JRequest::getInt('category_id');

		foreach($get as $key => $val)
		$url[] = "$key=$val";
		//return JHTML::link(MERoute::_('index.php?' . implode("&", $url)), $img, array('title' => $text));
		$out = '<button class="button" onclick="window.location = \'%s\' ">%s %s</button> ';
		$out = sprintf($out, JURI::root().'index.php?' . implode("&", $url), $img, $text);
		return $out;
	}
	function getPdf($params, $article)
	{
		if($params->get('item_pdf') > 0)
		{
			$link = JURI::root()."index.php?option=com_resource&controller=article&article={$article->id}&format=pdf";
			if($params->get('item_button') == 'Icons')
			$lable = JHTML::image(JURI::root() . '/images/M_images/pdf_button.png', JText::_('PDF'));
			else
			$lable = JText::_('PDF');
			return JHTML::link(MERoute::_(JURI::root() . $link), $lable, array("onclick" =>"window.open(this.href,'win2','status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no'); return false;", 'rel' =>"nofollow"));
		}
	}
	function getPrint($params)
	{

	}
	function getSend($params)
	{

	}
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if(empty($this->_data[$this->_id]))
		{
			$user = & JFactory::getUser();
			$record = new stdClass();
			$record->id = 0;
			$record->published = 1;
			$record->ctime = null;
			$record->title = null;
			$record->access = 0;
			$record->extime = null;
			$record->type_id = 0;
			$record->user_id = $user->get('id');
			$record->hits = 0;
			$record->checked_out = 0;
			$record->checked_out_time = 0;
			$record->ordering = 0;
			$record->archived = 0;
			$record->params = null;
			$record->meta_descr = null;
			$record->meta_key = null;
			$record->featured = null;
			$record->ucatid = null;
			$record->langs = null;
			$record->alias = null;
			$record->client = null;
			$record->client_id = null;
			$record->ip = null;
			$record->votes = null;
			$record->favorite_num = null;
			$record->hidden = null;
			$record->votes_result = null;
			$record->ftime = null;
			$record->exalert = null;

			$this->_data[$this->_id] = $record;
			return (boolean)$this->_data[$this->_id];
		}
		return true;
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if(empty($this->_data[$this->_id]))
		{
			$user = & JFactory::getUser();
			if(!$this->_id) $this->_id = JRequest::getInt('article');

			$this->_data[$this->_id] = ResHelper::getArticle($this->_id);
			/*			if(!$this->_id)
			 {
				//JError::raiseWarning(400, JText::_('ID not set lo load record'));
				//return false;
				}

				$query = 'SELECT r.*, t.name as type_name
				FROM #__js_res_record AS r
				LEFT JOIN #__js_res_types AS t ON t.id = r.type_id
				WHERE r.id = ' . (int)$this->_id;

				$this->_db->setQuery($query);
				$this->_data = $this->_db->loadObject();
				//echo $query;
				*/
			return (boolean)$this->_data[$this->_id];
		}
		return true;
	}
}
?>