<?php
/*
 * $Id: utility.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Access Restricted');


class ResModelUtility extends JModel 
{
	function getData() {
		$what = $this->getState('what');
		$q = false;
		
		if ($what == 'related') {
			$id 		= $this->getState('id');
			$article 	= $this->getState('record_id');
			
			$q = $this->_buildRelationQuery($id, $article);
			
			if ( ! $q)
				return false;
			
			return $this->_getList($q, $this->getState('limitstart'), $this->getState('limit'));
		}
		
		return false;
	}
	
	var $_total;
	
	function getTotal() {
		$what = $this->getState('what');
		
		if ($what == 'related') {
			if (!is_null($this->_total))
				return $this->_total;
			
			$id 		= $this->getState('id');
			$article 	= $this->getState('record_id');
			
			$q = $this->_buildRelationQuery($id, $article);
			
			if ( ! $q)
				return 0;
			
			$this->_total = $this->_getListCount($q);
			
			return $this->_total;
		}
		
		return 0;
	}
	
	function getPagination() {
		jimport ('joomla.html.pagination');
		return new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
	}
	
	function _buildRelationQuery($fieldId, $articleId) {
		$field = & JTable::getInstance('Field', 'Table');
		if ( ! $field->load($fieldId)) {
			$this->setError(JText::_('Cannot load relation field'));
			return false;
		}
		
		$category 	= $this->getState('category');
		$clientId 	= $this->getState('client_id');
		$userId 	= $this->getState('user_id');
		
		$user = null;
		if ($userId)
			$user = & JFactory::getUser($userId);
		
		if ($field->type == 'relate_parent3')
			return $this->_buildParentRelationQuery($articleId, $field, $category, $clientId, $user);
			
		if ($field->type == 'relate_child3')
			return $this->_buildChildRelationQuery($articleId, $field, $category, $clientId, $user);
			
		$this->setError(JText::_('Invalid relation field'));
		return false;
	}
	
	function _buildParentRelationQuery($articleId, &$field, $categoryId = 0, $clientId = null, $user = null) {
		static $cache = array();
		
		
		if (empty($user))
			$user = & JFactory::getUser();
		if (empty($categoryId))
			$categoryId = JRequest::getInt('category_id');
		if (is_null($clientId))
			$clientId = JRequest::getInt('client_id', 0);
		
		$db = & JFactory::getDBO();
			
		$clientId 	= (int)$clientId;
		$categoryId = (int)$categoryId;
		
		$params = new JParameter($field->params);
		$article = JTable::getInstance('Record', 'Res');
		
		if ($articleId)
		{
			if (!isset($cache[$articleId.'_'.$field->id]))
			{
				$q = 'SELECT * FROM #__js_res_record_values WHERE record_id = '.$articleId.' AND field_id = '.$field->id;
				$db->setQuery($q, 0, 1);
				$cache[$articleId.'_'.$field->id] = $db->loadObject();
			}
			
			$recordValue = $cache[$articleId.'_'.$field->id];
			
			// Check, whether parent can add children
			if (!$recordValue) {
				return false;
			}
			
			if ( ! $article->load($articleId) )
				return false;
		}		
		
		$where = array();
		
		$where [] = "rv.field_id = ".$params->get('relate_field');

		if (!MEAccess::isAdmin())
		{
			$where[] = 'r.published = 1';
		}
		
		$strictToUser = $params->get('strict_to_user', array());
		settype($strictToUser, 'array');
		$strictToUser = in_array($user->get('gid'), $strictToUser);
		if (MEAccess::isAdmin()) $strictToUser = false;
		if ($user->get('id') && $strictToUser)
		{
			$where[] = 'r.user_id = '.$user->get('id');
		}

		$sec_params = new JParameter('');
		
		if ($categoryId) {
			$where [] = 'rc.`catid` = '.$categoryId;
			$section_id = ResHelper::getCategorySection($categoryId);
			$sec_params = ResHelper::getSectionParams($section_id);
		}else{
			$where [] = '(c.id = '.$params->get('parent_section').' OR c.section_id = '.$params->get('parent_section').')';
			$sec_params = ResHelper::getSectionParams($params->get('parent_section'));
		}
		
		if ($sec_params->get('list_clients') == 0) {
			$where[] = 'r.client_id = '.$clientId;
		}
		if($sec_params->get('show_past_records') == 0) {
			$now = ResHelper::getDate();
			$where['ex'] = " (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}') ";	
		}

		$search = $this->getState('search');
		if ($search)
			$where [] = 'r.title LIKE '.$this->_db->Quote('%'.$search.'%');
		
		$where[] = 'r.type_id = '.$this->typeIdByField($params->get('relate_field'));
		if (count($where))
		{
			$where = ' AND '.implode(' AND ', $where);
		}
		else
		{
			$where = '';
		}
		
		

		$orderby = $this->getState('orderby') ? $this->getState('orderby') : $params->get('parent_ordering', 'r.ctime ASC');

		if ($articleId)
			$q = "SELECT fe.field_value_id AS id ".
				'FROM #__js_res_field_extra AS fe '.
				'WHERE fe.field_id = '.$params->get('relate_field')." AND ".
				'fe.record_id = '.$articleId.' AND '.
	            'fe.user_id = '. $article->type_id;
		else
			$q = false;

		$sql = "SELECT r.id, r.title "
		."\n  FROM       #__js_res_record      		AS r "
		."\n  INNER JOIN  #__js_res_types       		AS t ON t.id = r.type_id "
		.($categoryId ? 
		' 	  INNER JOIN #__js_res_record_category 	AS  rc ON r.id = rc.record_id ' : 
		'	INNER JOIN #__js_res_record_category 	AS  rc ON r.id = rc.record_id
			INNER JOIN #__js_res_category AS c ON c.id = rc.catid '
		)
		."\n  INNER JOIN #__js_res_record_values 	AS rv ON rv.record_id = r.id AND rv.field_id = ".$params->get('relate_field')
		."\n      WHERE t.published = 1 " //.($q ? " AND r.id NOT IN (". $q .") " : "")
		.$where
		.' GROUP BY r.id '
		." ORDER BY $orderby ";
		return $sql;
	}
	
	function _buildChildRelationQuery($articleId, &$field, $categoryId = 0, $clientId = null, $user = null) 
	{
		static $cache = array();
		
		
		if (empty($user))
			$user = & JFactory::getUser();
		if (empty($categoryId))
			$categoryId = JRequest::getInt('category_id');
		if (is_null($clientId))
			$clientId = JRequest::getInt('client_id', 0);
		
		$db = & JFactory::getDBO();
			
		$clientId 	= (int)$clientId;
		$categoryId = (int)$categoryId;
		
		$params = new JParameter($field->params);
		
		$where = array();
		/*if ($articleId)
		{
			if (!isset($cache[$articleId.'_'.$field->id]))
			{
				$q = 'SELECT * FROM #__js_res_record_values WHERE record_id = '.$articleId.' AND field_id = '.$field->id;
				$db->setQuery($q, 0, 1);
				$cache[$articleId.'_'.$field->id] = $db->loadObject();
			}
			
			$recordValue = $cache[$articleId.'_'.$field->id];
			
			if ($recordValue) {
				$fieldValue = $recordValue->field_value;
				$fieldValue = explode(',', trim($fieldValue, ', '));
				JArrayHelper::toInteger($fieldValue);
				
				if (count($fieldValue))
					$where [] = ' r.`id` NOT IN ('.implode(', ', $fieldValue).') ';
			}
		}*/
		
		

		if (!MEAccess::isAdmin())
		{
			$where[] = 'r.published = 1';
			
			if($groups = $params->get('strict_to_user'))
			{
				settype($groups, 'array');
				if(!in_array($user->get('gid'), $groups))
				{
					$where[] = 'r.user_id = '.$user->get('id', 999999);
				}
			}
		}
	
		$sec_params = new JParameter('');
		
		if ($categoryId) {
			$where [] = 'rc.`catid` = '.$categoryId;
			$section_id = ResHelper::getCategorySection($categoryId);
			$sec_params = ResHelper::getSectionParams($section_id);
		}else{
			$where [] = '(c.id = '.$params->get('parent_section').' OR c.section_id = '.$params->get('parent_section').')';
			$sec_params = ResHelper::getSectionParams($params->get('parent_section'));
		}
		
		if ($sec_params->get('list_clients') == 0) {
			$where[] = 'r.client_id = '.$clientId;
		}
		if($sec_params->get('show_past_records') == 0) {
			$now = ResHelper::getDate();
			$where['ex'] = " (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}') ";	
		}

		$search = $this->getState('search');
		if ($search)
			$where [] = 'r.title LIKE '.$this->_db->Quote('%'.$search.'%');
		
		if (count($where))
		{
			$where = ' AND '.implode(' AND ', $where);
		}
		else
		{
			$where = '';
		}
		

		$orderby = $this->getState('orderby') ? $this->getState('orderby') : $params->get('parent_ordering', 'r.ctime ASC');

		

		$sql = "SELECT r.id, r.title "
		."\n    FROM    #__js_res_record      AS r "
		."\n  LEFT JOIN #__js_res_types       AS t ON t.id = r.type_id"
		.($categoryId ? ' LEFT JOIN #__js_res_record_category rc ON r.id = rc.record_id ' : 
		' 	LEFT JOIN #__js_res_record_category rc ON r.id = rc.record_id
			LEFT JOIN #__js_res_category AS c ON c.id = rc.catid 		
		')
		."\n      WHERE t.published = 1 AND r.type_id = ".(int)$params->get('parent_type')
		.$where
		.' GROUP BY r.id '
		." ORDER BY $orderby ";
		
		
		return $sql;
	}
	function typeIdByField($field)
	{
		$db	= &JFactory::getDBO();
		$sql = "SELECT type_id FROM #__js_res_fields WHERE id = ".$field;
		$db->setQuery($sql);
		return (int)$db->loadResult();
	}
}
