<?php
/**
 * $Id: router_new.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');

function category_route($cid, $model)
{
	if(!$cid) return;
	if(RES_SEF_CATEGORY == 'full')
	{
		$txt = $model->_getCategoryRoutePath($cid);
		return aliase_text($txt, $txt, false);
	}
	else
	{
		$category = $model->getCategory($cid);
		return $cid . '-' . aliase_text($category->alias, $category->name);
	}
}

function my_unset($str, &$query)
{
	$vars = explode(',', $str);
	foreach($vars as $var)
	{
		if(@$query[$var]) unset($query[$var]);
	}
}

function aliase_text($ali, $txt, $del = true)
{
	if(RES_SEF_ALIASES == 1)
	{
		return $ali;
	}
	$txt = str_replace(array(' ', '?', '#', '!', '@', '"', "'", '\\', '{', '}', '[', ']', '*', '&', '^', '_', '+', '=', '%', '`', '~', '<', '>', ',', '.'), '-', $txt);
	if($del) $txt = str_replace('/', '-', $txt);
	while(strpos($txt, '--'))
		$txt = str_replace('--', '-', $txt);
	return urldecode(JString::strtolower($txt));
}

function is_view_what($vw)
{
	$view_whats = array("favorites", "rated", "last-visited", "created", "commented", "related", "expired", "unpublished", "hidden");
	foreach($view_whats as $return => $alias)
	{
		//echo JText::_($alias) .' - '.urldecode($vw).'<br>';
		if(JText::_(str_replace('-', '_', $alias)) == urldecode($vw)) return $alias;
	}
	return 0;
}

function ResourceBuildRoute(&$query)
{
	global $mainframe;
	static $init = false;
	static $list_model, $article_model, $tags_model, $ucategory_model;
	if(! $init)
	{
		require_once (JPATH_BASE . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
		require_once (JPATH_BASE . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
		if(!$list_model){
			require_once (JPATH_BASE . DS . 'components' . DS . 'com_resource' . DS . 'models' . DS . 'list.php');
			$list_model = new ResModelList();
		}
		ResControllerConfig::initialyze();
		define('S', '-');
		JModel::addIncludePath(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'models');
		
		$article_model = JModel::getInstance('article', 'ResModel');
		$tags_model = JModel::getInstance('tags', 'ResModel');
		$ucategory_model = JModel::getInstance('ucategory', 'ResModel');
		$init = true;
	}
	$vw_array = array('favorites', 'rated', 'last-visited', 'created', 'commented', 'related', 'expired', 'unpublished', 'hidden');
	$segments = array();
	if(@$query['user_id'])
	{
		$user = JFactory::getUser($query['user_id']);
	}
	if(@$query['article'])
	{
		$article = $article_model->getRecord($query['article']);
	}
	if(@$query['ucid'] || @$query['cid'][0])
	{
		$ucategory_model->setId(@$query['ucid'] ? $query['ucid'] : $query['cid'][0]);
		$ucategory = $ucategory_model->getData();
	}
	if(@$query['view'] == 'list')
	{
		if(@$query['client_id'])
		{
			if(@$query['ucid'])
			{
				$segments[] = urlencode(JText::_('group-category'));
			}
			else
			{
				$segments[] = urlencode(JText::_('group-items'));
			}
			$segments[] = category_route($query['category_id'], $list_model);
			
			if(@$query['ucid'])
			{
				$segments[] = $query['ucid'] . S . aliase_text($ucategory->alias, $ucategory->name);
			}
			if(in_array(@$query['view_what'], $vw_array))
			{
				$segments[] = urlencode(JText::_(str_replace('-', '_', $query['view_what'])));
			}
			my_unset('view,category_id,view_what,ucid', $query);
		}
		else
		{
			if(@$query['user_id'] && @$query['ucid'])
			{
				$segments[] = urlencode(JText::_('user-category'));
			}
			elseif(@$query['user_id'])
			{
				$segments[] = urlencode(JText::_('user-items'));
			}
			else
			{
				$segments[] = urlencode(JText::_('items'));
			}
			$segments[] = category_route($query['category_id'], $list_model);
			
			if(@$query['user_id'])
			{
				$segments[] = $query['user_id'] . S . urlencode($user->username);
			}
			if(@$query['ucid'])
			{
				$segments[] = $query['ucid'] . S . aliase_text($ucategory->alias, $ucategory->name);
			}
			if(in_array(@$query['view_what'], $vw_array))
			{
				$segments[] = urlencode(JText::_(str_replace('-', '_', $query['view_what'])));
			}
			my_unset('view,category_id,view_what,user_id,ucid', $query);
		}
		
	}
	elseif(@$query['controller'] == 'article' && @$query['layout'] == 'form' && @$query['type_id'])
	{
		if(@$query['article'])
		{
			$segments[] = urlencode(JText::_('edit'));
			$segments[] = $query['article'] . S . aliase_text($article->alias, $article->title);
		}
		else
		{
			$segments[] = urlencode(JText::_('submit'));
		}
		$segments[] = $query['type_id'] . S . urldecode($list_model->getTypeName($query['type_id']));
		$segments[] = category_route($query['category_id'], $list_model);
		my_unset('view,category_id,controller,layout,type_id,article', $query);
	}
	elseif(@$query['controller'] == 'article')
	{
		if(@$query['user_id'] && @$query['ucid'])
		{
			$segments[] = urlencode(JText::_('user-category-article'));
		}
		elseif(@$query['user_id'])
		{
			$segments[] = urlencode(JText::_('user-article'));
		}
		else
		{
			$segments[] = urlencode(JText::_('article'));
		}
		$segments[] = category_route(@$query['category_id'], $list_model);
		if(@$query['user_id'])
		{
			$segments[] = $query['user_id'] . S . urlencode($user->username);
		}
		if(@$query['ucid'])
		{
			$segments[] = $query['ucid'] . S . aliase_text($ucategory->alias, $ucategory->name);
		}
		$segments[] = $query['article'] . S . aliase_text($article->alias, $article->title);
		if(in_array(@$query['view_what'], $vw_array))
		{
			$segments[] = urlencode(JText::_(str_replace('-', '_', $query['view_what'])));
		}
		my_unset('view,category_id,controller,article,user_id,ucid,view_what', $query);
	}
	elseif(@$query['view'] == 'category' && @$query['layout'] == 'form')
	{
		if(@$query['cid'][0])
		{
			$segments[] = urlencode(JText::_('edit-category'));
			$segments[] = $query['cid'][0] . S . aliase_text($ucategory->alias, $ucategory->name);
		}
		else
		{
			$segments[] = urlencode(JText::_('new-category'));
		}
		$segments[] = category_route($query['category_id'], $list_model);
		my_unset('view,category_id,controller,user_id,ucid,view_what,layout,cid', $query);
	}
	elseif(@$query['view'] == 'category')
	{
		$segments[] = urlencode(JText::_('manage-categories'));
		$segments[] = category_route($query['category_id'], $list_model);
		my_unset('view,category_id,controller,user_id,ucid,view_what', $query);
	}
//	if( count($segments) > 0 ){
//		$segments[] = $query['Itemid'].'-Itemid';
//	}
	if(@$query['client'])
	{
		$query['client'] = stripslashes($query['client']);
	}
	return $segments;
}

function ResourceParseRoute($segments)
{
	global $mainframe;
	static $init = false;
	if(! $init)
	{
		require_once (JPATH_BASE . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
		ResControllerConfig::initialyze();
	}
	$vars = array();
	$last_segment = count($segments) - 1;
//	if(mb_strpos($segments[$last_segment], 'Itemid')){
//		$parts = explode(':', $segments[$last_segment]);
//		$vars['Itemid'] = $parts[0];
//		$last_segment --;
//	}
	$vw = is_view_what($segments[$last_segment]);
	if($vw)
	{
		$vars['view_what'] = $vw;
		$last_segment --;
	}
	if(@$vars['client']) $vars['client'] = stripslashes($vars['client']);
	//echo urldecode($segments[0]).'<br>';
	//echo JText::_(RES_SEO_USER_CATEGORY);
	switch(urldecode(str_replace(':', '-', $segments[0])))
	{
		case JText::_('user-category'):
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 2], 'INT');
			$vars['user_id'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['ucid'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('group-category'):
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['ucid'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('user-items'):
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['user_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('items'):
		case JText::_('group-items'):
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('submit'):
			$vars['view'] = 'article';
			$vars['controller'] = 'article';
			$vars['layout'] = 'form';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
			$vars['type_id'] = JFilterInput::clean($segments[1], 'INT');
		break;
		case JText::_('edit'):
			$vars['view'] = 'article';
			$vars['controller'] = 'article';
			$vars['layout'] = 'form';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
			$vars['type_id'] = JFilterInput::clean($segments[2], 'INT');
			$vars['article'] = JFilterInput::clean($segments[1], 'INT');
		break;
		case JText::_('user-category-article'):
			$vars['view'] = 'article';
			$vars['controller'] = 'article';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 3], 'INT');
			$vars['user_id'] = JFilterInput::clean($segments[$last_segment - 2], 'INT');
			$vars['ucid'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['article'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('user-article'):
			$vars['view'] = 'article';
			$vars['controller'] = 'article';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 2], 'INT');
			$vars['user_id'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['article'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('article'):
			$vars['view'] = 'article';
			$vars['controller'] = 'article';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment - 1], 'INT');
			$vars['article'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('manage-categories'):
			$vars['view'] = 'category';
			$vars['controller'] = 'category';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
		case JText::_('edit-category'):
			$vars['view'] = 'category';
			$vars['controller'] = 'category';
			$vars['layout'] = 'form';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
			$vars['cid'][0] = JFilterInput::clean($segments[1], 'INT');
		break;
		case JText::_('new-category'):
			$vars['view'] = 'category';
			$vars['controller'] = 'category';
			$vars['layout'] = 'form';
			$vars['category_id'] = JFilterInput::clean($segments[$last_segment], 'INT');
		break;
	}
	//print_r( $vars);	
	return $vars;
}
