<?php
/**
 * $Id: view.feed.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');

class ResViewArticle extends JView
{
	function display($tpl = null)
	{
		global $mainframe;

		$doc    =& JFactory::getDocument();
		$uri	= &JFactory::getURI();
		
		// avoid site domain doubling in rss link and guid.
		$baseurl	= $uri->toString(array('scheme', 'user', 'pass', 'host', 'port'));
		$feedUrl	= str_replace($baseurl, '', JRoute::_($uri->toString()));
		$doc->link 	= htmlentities($feedUrl, ENT_QUOTES, 'UTF-8');
		
		//$doc->title = html_entity_decode($doc->title);
		$model 	= JModel::getInstance('article', 'ResModel');
		$itemid = JRequest::getInt('Itemid');
		$user	= &JFactory::getUser();
		$config = JFactory::getConfig();

		$url_params = &$mainframe->getParams();
		$params 	= ResHelper::initListParams(JRequest::getInt('category_id', JRequest::getInt('section_id')));
		$params->merge($url_params);
		 
		if ($params->get('access_section') == 'none')
		{
			JError::raiseWarning(404, JText::_('Section Offline'));
			echo '<div class="componentheading">' . $params->get('access_msg') . '</div>';
			return;
		}

		if (($params->get('access_section') > $user->get('aid')))
		{
			JError::raiseWarning(404, JText::_('Access Denied'));
			echo '<div class="componentheading">' . JText::_('You do not have enough rights') . '</div>';
			if ($params->get('access_section') == 1)
			{
				JError::raiseWarning(404, JText::_('This section accessible only for Registered users'));

				$return = $uri->toString();

				$url = 'index.php?option=com_user&view=login&Itemid=' . JRequest::getInt('Itemid');
				$url .= '&return=' . base64_encode($return);

				$mainframe->redirect(MERoute::_($url, FALSE));
			}
			if ($params->get('access_section') == 2)
			{
				echo '<p>' . JText::_('This section accessible only for users with administrator rights') . '</p>';
			}
			return;
		}
		
		$article = $model->getRecord(JRequest::getInt('article'));
		
		
		$category->id = JRequest::getInt('category_id', JRequest::getInt('section_id'));
		$section = ResHelper::getCategorySection($category->id);
		
		$items[0] = $article;
		MRRecordHelper::prepareItems($items, $params, $category);
		$article = $items[0];		

		$doc->description = JText::_('RSS comment feed for:').' '.$article->title;
		
		$rows = $model->getComments($params, $category, 0, 0, FALSE);
		$link = $article->link;
		
		$doc->link = $link;
		$doc->title = htmlentities($article->title);
		
		foreach ( $rows as $row )
		{
			// strip html from feed item title
			$title = htmlspecialchars( $row->subject );
			$title = html_entity_decode( $title );
			$author	= $row->name;
			$date 	= $row->ctime;
			
			// load individual item creator class
			$item = new JFeedItem();
			$item->title 		= $title;
			$item->link 		= $link.'#comment_'.$row->id;
			$item->description 	= $row->comment;
			$item->date			= $date;
			
			$doc->addItem( $item );
		}
	}
}
?>
