<?php
/**
 * $Id: view.html.php 7947 2012-03-13 06:28:04Z kostya $
 * $LastChangedDate: 2012-03-13 12:28:04 +0600 (Tue, 13 Mar 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

class ResViewArticle extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $option;
		if(JRequest::getWord('layout') == 'form')
		{
			$this->_form($tpl);
			return;
		}
		JHTML::_('behavior.tooltip');
		$url_params = &$mainframe->getParams();

		$category_id = $url_params->def('category_id');
		if(! $category_id) $category_id = JRequest::getInt('category_id');
		if(! $category_id) $category_id = ResHelper::getArticleSection(JRequest::getInt('article'));
		$url_params->set('category_id', $category_id);

		if(! $category_id || ! JRequest::getInt('article'))
		{
			JError::raiseWarning(403, JText::_('URL is not complete'));
			return;
		}
		$params = ResHelper::initListParams($category_id);

		$params->merge($url_params);

		if((JRequest::getInt('user_id') || JRequest::getInt('ucid')) && $params->get('category_mode') == 1)
		{
			$uri = &JFactory::getURI();
			$uri->delvar('user_id');
			$uri->delvar('ucid');
			$mainframe->redirect($uri->toString());
		}

		$document = &JFactory::getDocument();
		$uri = &JFactory::getURI();
		$pathway = &$mainframe->getPathway();
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();

		$model = $this->getModel();
		$state = &$this->get('state', 'article');
		require_once (JPATH_BASE . DS . 'components' . DS . 'com_resource' . DS . 'models' . DS . 'list.php');
		$list = new ResModelList();

		$menus = &JSite::getMenu();
		$menu = $menus->getActive();

		$article = $this->get('article');


		if(! $article)
		{
			JError::raiseNotice(404, JText::_('Article Not Found'));
			if(JRequest::getInt('category_id'))
			{
				$link = MERoute::_(MEUrl::link_list(JRequest::getInt('category_id')));
			}
			else
			{
				$link = JRoute::_('index.php');
			}
			$mainframe->redirect(MERoute::_($link, FALSE));
			return;
		}
		if((($article->published == 0) && ! (MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params) || MEAccess::isAdmin() || MEAccess::isAuthor($article->user_id))))
		{
			JError::raiseNotice(404, JText::_('Article Unpublished'));

			$link = MEUrl::link_list($category_id);
			$mainframe->redirect(MERoute::_($link, FALSE));

			return;
		}
		///////////////
		$now = ResHelper::getDate();
		$date1 = JFactory::getDate($now);
		$date2 = JFactory::getDate($article->extime);
		if($article->extime != '0000-00-00 00:00:00' && $date2->toUnix() < $date1->toUnix())
		{
			JError::raiseNotice(404, JText::_('Article expired'));

			$link = MEUrl::link_list($category_id);
			$mainframe->redirect(MERoute::_($link, FALSE));

			return;
		}
		///////////////
		if(($article->access == 1 || $article->cat_access == 1) && ! $user->get('id'))
		{
			MEAccess::login(NULL, JText::_('You have to be logged in to access this article'));
		}

		if(($article->hidden == 1) && ! (MEAccess::isAdmin() || MEAccess::isAuthor($article->user_id)))
		{
			JError::raiseNotice(404, JText::_('This article is hidden by author, that is why you cannot access it.'));

			$link = MEUrl::link_list($category_id);
			$mainframe->redirect(MERoute::_($link, FALSE));

			return;
		}
		if(($article->access == 2) && ! (MEAccess::isAdmin() || MEAccess::isAuthor($article->user_id)))
		{
			JError::raiseNotice(404, JText::_('You do nor have rights to access this article'));

			$link = MEUrl::link_list($category_id);
			$mainframe->redirect(MERoute::_($link, FALSE));

			return;
		}

		if($article->client_id && (($article->client_id != JRequest::getInt('client_id')) || (stripslashes($article->client) != stripslashes(urldecode(JRequest::getVar('client'))))))
		{
			$link = MEUrl::link_record($article, $category_id, array(
				'client' => $article->client, 'client_id' => $article->client_id
			));
			$mainframe->redirect(MERoute::_($link, FALSE));
			return;
		}

		$iparams = ResHelper::initArticleParams($article->type_id, $article->params);

		$params->merge($iparams);

		$article_user = JFactory::getUser($article->user_id);

		if($iparams->get('type_display_subscription') && $article->user_id)
		{
			IF(jscCheckSubscription($iparams->get('type_display_subscription'), $iparams->get('type_display_subscription_msg', JText::_('Author of this article run out of subscription.')),
			$iparams->get('subscription_iid', JRequest::getInt('Itemid')), FALSE, $iparams->get('type_display_subscription_count'), $article->user_id))
			{
				JError::raiseWarning(404, JText::_('Author of this article run out of subscription.'));
				$link = JURI::root();
				if(JRequest::getInt('category_id'))
				{
					$link = MEUrl::link_list(JRequest::getInt('category_id'));
				}
//				return;
				$sql = "UPDATE #__js_res_record SET extime = '{$now}' - INTERVAL 1 DAY WHERE id = {$article->id}";
				$db->setQuery($sql);
				$db->query();
 				$mainframe->redirect(MERoute::_($link, FALSE));
			}
			else
			{
				jscCountLimit($iparams->get('type_display_subscription'), $iparams->get('type_display_subscription_count'), $article->user_id);
			}
		}

		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_article_' . $params->get('tmpl_article') . '.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_article_' . $params->get('tmpl_article') . '.ini');
			$tmpl_xml = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_article_' . $params->get('tmpl_article') . '.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}
		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_comments_' . $params->get('tmpl_comment') . '.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_comments_' . $params->get('tmpl_comment') .
			 '.ini');
			$tmpl_xml = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_comments_' . $params->get('tmpl_comment') . '.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}
		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_articleform_' . $params->get('tmpl_articleform') . '.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_articleform_' . $params->get('tmpl_articleform') .
			 '.ini');
			$tmpl_xml = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_articleform_' . $params->get('tmpl_articleform') . '.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}

		$this->linkFiles($params);

		if($params->get('access_section') == 'none' && ! MEAccess::isAdmin())
		{
			echo '<div class="componentheading">' . JText::_('Section Offline') . '</div>';
			echo '<div class="contentpaneopen">' . $params->get('access_msg') . '</div>';
			return;
		}
		if($params->get('access_section') == 'none')
		{
			JError::raiseNotice(100, JText::_('Section Offline'));
		}
		if($params->get('access_section') == 1 && ! $user->get('id'))
		{
			MEAccess::login(null, JText::_('You have to be registered and logged in in order to access this record'));
		}
		if($params->get('access_section') == 2 && ($user->get('aid') < 2))
		{
			JError::raiseNotice(404, JText::_('Only special users may access this record'));
			$link = JURI::root();
			if(JRequest::getInt('category_id'))
			{
				$link = MEUrl::link_list(JRequest::getInt('category_id'));
			}
			$mainframe->redirect(MERoute::_($link, FALSE));
		}

		if(MECommunityHelper::isEnabled() && $params->get('karma_deny_view'))
		{
			if(! $user->get('id'))
			{
				MEAccess::login(null, JText::_('In order to access this record you have to be registered and logged in'));
			}
			MECommunityHelper::loadApi();
			$karma = JSCommunityApi::getUserCarma($user->get('id'));

			if($karma->points < $params->get('karma_deny_view'))
			{
				JError::raiseWarning(404, JText::_('You do not have enough Karma Points to access this record'));
				$link = JURI::root();
				if(JRequest::getInt('category_id'))
				{
					$link = MEUrl::link_list(JRequest::getInt('category_id'));
				}
				$mainframe->redirect(MERoute::_($link, FALSE));
				return;
			}
		}

		$category1 = $list->getCategory($category_id);
		$category2 = $list->getCategory(JRequest::getInt('category_id', JRequest::getInt('section_id', $category_id)));

		$items[0] = $article;
		MRRecordHelper::prepareItems($items, $params, $category2);
		$article = $items[0];

		$oldlimit = $mainframe->getUserState('com_resource.limit_comment');
		$limit = $mainframe->getUserStateFromRequest('com_resource.limit_comment', 'limit', $params->get('comments_pagination'), 'int');

		if($oldlimit != $limit) JRequest::setVar('limitstart', 0);

		$state->set('limit', $limit);
		$model->setState('limit', $limit);

		$model->hit($params);

		if($user->get('usertype') == 'Super Administrator') $iparams->set('comments_hide', 1);
		if($user->get('usertype') == 'Administrator') $iparams->set('comments_hide', 1);
		if(! $user->get('id')) $iparams->set('comments_hide', 0);

		$sql = "SELECT COUNT(*) FROM #__js_res_vote WHERE record_id = $article->id AND user_id = " . $user->get('id');
		$db->setQuery($sql);
		$article->show_vote = $db->loadResult() ? false : true;

		$nfields = $article->fields;
		$ifields = $article->ifields;

		if(JRequest::getInt('category_id') && ($params->get('category_mode') == 1 || $params->get('category_mode') == 3)) $this->drowPath($pathway,
		JRequest::getInt('category_id', $params->get('category_id')), 0, $list, $params);


		if(JRequest::getInt('client_id'))
		{
			$link = MEUrl::link_list($category2->id, array(
				'ucid' => 0
			));
			/*if(JRequest::getInt('ucid'))
			 {
				$link = str_replace('&ucid='.JRequest::getInt('ucid'), '', $link);
				}*/
			$pathway->addItem(stripslashes(JRequest::getVar('client', $user->get($params->get('item_author_mode', 'username')))), MERoute::_($link));
		}
		elseif(JRequest::getInt('user_id') && $params->get('category_mode') > 1)
		{
			//$user = &JFactory::getUser();
			//echo $user->get($params->get('item_author', 'username'));
			$link = MEUrl::link_list($category_id, array(
				'ucid' => 0
			));
			/*if(JRequest::getInt('ucid'))
			 {
				$link = str_replace('&ucid='.JRequest::getInt('ucid'), '', $link);
				}*/
			$pathway->addItem($article_user->get($params->get('item_author_mode', 'username')), MERoute::_($link));
		}
		if(JRequest::getInt('ucid') && $params->get('category_mode') > 1)
		{
			$link = MEUrl::link_list($category_id);
			$pathway->addItem($model->getPCategoryName(JRequest::getInt('ucid')), MERoute::_($link));
		}


		$pathway->addItem($article->title, '');

		$title[] = $article->title;
		if(JRequest::getVar('client')) $title[] = JRequest::getVar('client');
		if(JRequest::getVar('user_id'))
		{
			$tuser = JFactory::getUser(JRequest::getVar('user_id'));
			$title[] = $tuser->get($params->get('item_author_mode', 'username'));
		}

		@$category1->title ? $title[] = $category1->title : $title[] = $category1->name;
		($params->get('page_title') && $params->get('show_page_title') ? $title[] = $params->get('page_title') : NULL);

		$document->setTitle(implode(" - ", $title));

		//$document->setTitle(. ($params->get('page_title') && $params->get('show_page_title') ? ' - ' . $params->get('page_title') : NULL));
		if($article->meta_descr)
		{
			$document->setDescription($article->meta_descr);
		}
		if($article->meta_key)
		{
			$document->setMetadata('keywords', $article->meta_key);
		}

		$comments = $model->getComments($params, $category1);
		if(count($comments) && ($params->get('comments_rss', 0) == 1))
		{

			$link = '&format=feed&limitstart=';
			$title = Jtext::_('Comments');
			$attribs = array(
				'type' => 'application/rss+xml', 'title' => 'RSS 2.0 ' . $title
			);
			$document->addHeadLink(MERoute::_($link . '&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array(
				'type' => 'application/atom+xml', 'title' => 'Atom 1.0 ' . $title
			);
			$document->addHeadLink(MERoute::_($link . '&type=atom'), 'alternate', 'rel', $attribs);
		}
		//$comment_event = $dispatcher->trigger('onArticleComment', array($article));


		$events['onAfterArticleRender'] = array();
		$events['onBeforeArticleRender'] = array();
		$events['onCommentsRender'] = array();
		$dispatcher = & JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content');
		$events['onCommentsRender'] = $dispatcher->trigger('onCommentsRender', array(
			$article, $comments, $iparams
		));
		$events['onCommentsFormRender'] = $dispatcher->trigger('onCommentsFormRender', array(
			&$article, $comments, &$params
		));
		$events['onAfterArticleRender'] = $dispatcher->trigger('onAfterArticleRender', array(
			&$article, &$params
		));
		$events['onBeforeArticleRender'] = $dispatcher->trigger('onBeforeArticleRender', array(
			&$article, &$params
		));

		$pagnav = $model->getPagination($params);

		//$captcha = rand(111, 999);
		//$captcha = str_replace("0", "1", $captcha);
		//settype($captcha, 'string');
		//$session =& JFactory::getSession();
		//$session->set('comment_captcha', $captcha);


		if(! @$fields) $fileds = array();

		$this->assignRef('pagnav', $pagnav);
		$this->assignRef('events', $events);
		$this->assignRef('category', $category1);
		//$this->assignRef('captcha', $captcha);
		$this->assignRef('comments', $comments);
		$this->assignRef('params', $params);
		$this->assignRef('fields', $nfields);
		$this->assignRef('ifields', $ifields);
		$this->assignRef('article', $article);
		$this->assignRef('user', $user);
		$this->assign('action', $uri->toString());

		parent::display($tpl);
	}

	function drowPath(&$path, $catid, $home, $model, $params)
	{
		if($catid == $home) return;

		$category = $model->getCategory($catid);
		if($category->parent <= 0) return;
		//echo $category->parent;
		$this->drowPath($path, $category->parent, $home, $model, $params);
		//$link = "index.php?option=com_resource&view=list&category_id={$category->id}&Itemid="
		//.MEUrl::itemid(NULL, $category->id);
		$link = MEUrl::link_list($category->id);
		$path->addItem($category->name, $link);

	}

	function drowPath2(&$path, $catid, $home, $model)
	{
		if($catid == $home)
		{
			//$link = "index.php?option=com_resource&view=list&category_id={$catid}&Itemid=" . MEUrl::itemid(NULL, $catid);;
			$link = MEUrl::link_list($catid);
			$path->addItem($category->title, $link);
			return;
		}

		$category = $model->getCategory($catid);

		if($category->parent <= 0)
		{
			//$link = "index.php?option=com_resource&view=list&category_id={$category->id}&Itemid=" . MEUrl::itemid(NULL, $catid);;
			$link = MEUrl::link_list($category->id);
			$path->addItem($category->title, $link);
			return;
		}
		//echo $category->parent;



		$this->drowPath($path, $category->parent, $home, $model);

		//$link = "index.php?option=com_resource&view=list&category_id={$category->id}&Itemid=" . MEUrl::itemid(NULL, $category->id);;
		$link = MEUrl::link_list($category->id);

		$path->addItem($category->title, $link);
	}

	function _form($tpl = null)
	{
		global $mainframe;
		JHTML::_('behavior.tooltip');
		$hidden_fields = array();

		$section_id = ResHelper::getArticleSection(JRequest::getInt('article'));
		if(! $section_id && JRequest::getInt('category_id')) $section_id = ResHelper::getCategorySection(JRequest::getInt('category_id'));

		$category_id = JRequest::getInt('category_id', $section_id);

		//$session = &JFactory::getSession();
		//echo $session->get('securimage_code_value').'-';
		//echo $session->getName().'-';


		if(! $category_id)
		{
			JError::raiseWarning(403, JText::_('URL is not complete'));
			return;
		}


		include_once (JPATH_COMPONENT_ADMINISTRATOR . DS . 'views' . DS . 'record' . DS . 'view.html.php');

		$document = &JFactory::getDocument();
		$session = & JFactory::getSession();
		$db = &JFactory::getDBO();
		$uri = &JFactory::getURI();
		$pathway = &$mainframe->getPathway();
		$params = ResHelper::initListParams($category_id);
		$model = $this->getModel();
		$user = &JFactory::getUser();
		$list = JModel::getInstance('list', 'ResModel');
		$lists = array();
		$record = &$model->getRecord();
		$lang = & JFactory::getLanguage();
		$isNew = ($record->id < 1);

		$document->addScript(JURI::root() . 'includes/js/joomla.javascript.js');

		$types = explode(",", $params->get('type'));
		if((! $params->get('type') || (! in_array(JRequest::getInt('type_id', $record->type_id), $types))) && ! MEAccess::isAdmin())
		{
			$this->assign('message', JText::_('Given type is not allowed into this section.'));
			parent::display('error');
			return;
		}
		$params->set('type', JRequest::getInt('type_id', $record->type_id)); //, $params->get('type', $record->type_id)));


		if(! $params->get('type') && ! $record->type_id)
		{
			$this->assign('message', JText::_('No type defined. Please, check menu link parameters.'));
			parent::display('error');
			return;
		}

		$fparams = ResHelper::initArticleParams($params->get('type'), @$record->params);
		$params->merge($fparams);

		if($params->def('record_submit_limit') && $isNew && (ResHelper::countUserCategoryRecords($section_id, $params) >= $params->def('record_submit_limit')))
		{
			$this->assign('message', JText::_('You have reached maximum level of records you can submit to this section'));
			parent::display('error');
			return;
		}
		if($params->def('record_submit_limit') && $isNew)
		{
			$mainframe->enqueueMessage(
			JText::sprintf('There is a limit of %d records to submit to this section. You already submited %d', $params->def('record_submit_limit'),
			ResHelper::countUserCategoryRecords($section_id, $params)));
		}

		$ini = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'form_articleform_' . $params->get('tmpl_articleform', 'default') . '.ini';
		if(JFile::exists($ini))
		{
			$tmpl_ini = JFile::read($ini);
			$tmpl_xml = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'form_articleform_' . $params->get('tmpl_articleform', 'default') .
			 '.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}

		if(($params->get('submission') == 'none') && ! MEAccess::isAdmin())
		{
			$this->assign('message', JText::_('Error: Submission of records to this section restricted'));
			parent::display('error');
			return;
		}
		if($params->get('submission') == 1 && ! $user->get('id'))
		{
			MEAccess::login(null, JText::_('In order to submit you have to be registered and logged in'));
		}
		if($params->get('submission') > 1 && ($user->get('aid') < $params->get('submission')))
		{
			$this->assign('message', JText::_('Error: You have to be special user to submit this record'));
			parent::display('error');
			return;
		}

		if($isNew)
		{
			if($params->get('comm_enabled', 0))
			{
				$commerce_params = $model->getCommerceParams($user->get('id'), $section_id);

				if(!$commerce_params)
				{
					$msg = JText::_('Before submit article you must save Seller Configuration in Commerce Cpanel');
					$link = 'index.php?option=com_commerce&view=cpanel&section_id='.$section_id.'&Itemid='.JRequest::getInt('Itemid');
					$mainframe->redirect( JRoute::_($link, false),  $msg);
				}
			}
			if($fparams->get('type_submit_subscription') && ! ($params->get('subscription_admin_skip') && MEAccess::isAdmin()))
			{
				jscCheckSubscription($fparams->get('type_submit_subscription'), $fparams->get('type_submit_subscription_msg', JText::_('To submit you need to subscribe')),
				$fparams->get('subscription_iid', JRequest::getInt('Itemid')), TRUE, $fparams->get('type_submit_subscription_count'));
			}
			if(MECommunityHelper::isEnabled() && $params->get('karma_deny_submit'))
			{
				if(! $user->get('id'))
				{
					MEAccess::login(null, JText::_('In order to submit you have to be registered and logged in'));
				}
				MECommunityHelper::loadApi();
				$karma = JSCommunityApi::getUserCarma($user->get('id'));

				if($karma->points < $params->get('karma_deny_submit'))
				{
					$msg = JText::_('You do not have enough Karma Points to submit this item');
					$this->assign('message', $msg);
					parent::display('error');
					return;
				}
			}
		}
		else
		{
			$can_edit = FALSE;
			if(MEAccess::isModerator($user->get('id'), 'moder_edit_record', $params)) $can_edit = TRUE;
			if(MEAccess::isAuthor($record->user_id, $fparams->get('item_edit'))) $can_edit = TRUE;
			if(MEAccess::isAdmin()) $can_edit = TRUE;
			if(MEAccess::isEditor()) $can_edit = TRUE;
			if(MEAccess::isPublisher()) $can_edit = TRUE;
			if($session->get('access_' . $record->id)) $can_edit = TRUE;

			if($can_edit == FALSE)
			{
				$msg = JText::_('You cannot edit this record');
				$this->assign('message', $msg);
				parent::display('error');
				return;
			}
			if($fparams->get('type_edit_subscription') && ! ($params->get('subscription_admin_skip') && $user->get('usertype') == 'Super Administrator'))
			{
				jscCheckSubscription($fparams->get('type_edit_subscription'), $fparams->get('type_edit_subscription_msg', JText::_('To edit you need to subscribe')),
				$fparams->get('subscription_iid', JRequest::getInt('Itemid')), TRUE, $fparams->get('type_edit_subscription_count'));
			}
			if(MECommunityHelper::isEnabled() && $params->get('karma_deny_edit'))
			{
				if(! $user->get('id'))
				{
					MEAccess::login(null, JText::_('In order to submit you have to be registered and logged in'));
				}
				MECommunityHelper::loadApi();
				$karma = JSCommunityApi::getUserCarma($user->get('id'));

				if($karma->points < $params->get('karma_deny_edit'))
				{
					$msg = JText::_('You do not have enough Karma Points to edit this item');
					$this->assign('message', $msg);
					parent::display('error');
					return;
				}
			}
		}

		$this->drowPath($pathway, $category_id, $section_id, $list, $params);


		if($model->isCheckedOut($user->get('id')))
		{
			$msg = JText::_('Record is edited at this moment');
			$mainframe->redirect($_SERVER['HTTP_REFERER'], $msg);
		}

		if(! $isNew)
		{
			$model->checkout($user->get('id'));
			$record->mtime = ResHelper::getDate(); //JHTML::_('date', 0, '%Y-%m-%d %H:%M:%S');
			if($params->get('edit_autopublish') == 0) $record->published = 0;
		}
		else
		{
			$record->client_id = JRequest::getVar('client_id');
			$record->client = addslashes(stripslashes(JRequest::getVar('client')));
			$record->type_id = $params->get('type');
			$record->type_name = $model->getTypeName($record->type_id);
			$record->ctime = ResHelper::getDate(); //JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S');
			$record->mtime = ResHelper::getDate(); //JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S');
			$record->user_id = $user->get('id');
			$record->access = $params->get('access');
			$record->featured = 0;
			$record->archive = 0;
			$record->alias = '';
			$record->published = $params->get('autopublish'); // === 0 ? 1 : 0;
			if($params->get('default_expire') > 0) $record->extime = ResHelper::getDate(($params->get('default_expire') * 86400)); //date('Y-m-d H:i:s', time() + ($params->get('default_expire') * 86400));//JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S', ($params->get('default_expire') * 86400)); //date('Y-m-d H:i:s', time() + ($params->get('default_expire') * 86400));
			else $record->extime = '0000-00-00 00:00:00';
			$record->langs = $lang->getTag();
		}
		JPluginHelper::importPlugin('joomsuite_content');
		$dispatcher = &JDispatcher::getInstance();
		$article_event = $dispatcher->trigger('onArticleSubmit', array(
			$record, $params
		));

		$fields = $model->getFields($record);

		$nfields = array();
		$custom_categories = false;
		foreach($fields as $key => $field)
		{
			ResViewRecord::renderField2($field, $out, $params, $record, $category_id);
			if($field->type == 'custom_categories'){
				$custom_categories = true;
				$custom_categories_content = $out;
				continue;
			}
			if($out)
			{
				if(substr(trim($out), 0, 20) == '<input type="hidden"') //("/<input type=\"hidden\"/iU", $out))
				{
					$hidden_fields[] = $out;
					unset($fields[$key]);

				}
				else
				{
					$ifields[$field->title] = $out;
					$nfields[$field->id] = $field;
					$nfields[$field->id]->result = $out;
				}
			}
		}

		//$params = new JParameter($record->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'config.xml');



//		$query = 'SELECT ordering AS value, title AS text' . ' FROM #__js_res_record' . //' WHERE catid = ' . (int) $row->catid .
////' AND state >= 0' .
//		' ORDER BY ordering';
//		if($isNew) $lists['ordering'] = JHTML::_('list.specificordering', $record, '', $query, 1);
//		else $lists['ordering'] = JHTML::_('list.specificordering', $record, $record->id, $query, 1);

		if($params->get('expire_time') || (($user->get('aid') > 1) && $user->get('gid') >= 23))
		{
			$lists['extime'] = JHTML::_('calendar', $record->extime ? $record->extime : 'Never', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array(
				'class' => 'inputbox'
			));
		}
		if($params->get('create_time') || (($user->get('aid') > 1) && $user->get('gid') >= 23))
		{
			$lists['ctime'] = JHTML::_('calendar', $record->ctime, 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array(
				'class' => 'inputbox'
			));
		}
		$lists['publish'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $record->published);
		$lists['access'] = JHTML::_('list.accesslevel', $record);
		$lists['author'] = $model->getAuthor($record->user_id); //JHTML::_('list.users', 'user_id', $record->user_id);
		//$lists['featured'] = JHTML::_('select.booleanlist', 'featured', 'class="inputbox"', $record->featured);


		JHTML::addIncludePath(JPATH_COMPONENT . DS . 'library' . DS . 'php' . DS . 'html');
		$lists['tags'] = JHTML::_('tags.form', $record, $section_id);
		$tags = $model->getTags($record->id);

		//$lists['tags'] = $model->getTags($record->id); //JHTML::_('list.users', 'user_id', $record->user_id);



		jimport('joomla.language.helper');
		$languages = JLanguageHelper::createLanguageList(JLanguageHelper::detectLanguage(), constant('JPATH_SITE'), true);
		array_unshift($languages, JHTML::_('select.option', '', '- ' . JText::_('Select Language') . ' -'));

		$lists['lang'] = JHTML::_('select.genericlist', $languages, 'langs', 'class="inputbox"', 'value', 'text', ($record->langs ? $record->langs : $lang->getTag()));

		$sql = "SELECT catid AS value FROM #__js_res_record_category WHERE record_id = " . $record->id;
		$db->setQuery($sql);

		if(RES_CATEGORIES_VIEW == 'list'){
			$def = $db->loadObjectList();
			if(! $def) $def[]->value = JRequest::getInt('category_id');

			$catids = JRequest::getVar('categories', array(0), 'default', 'array');
			if($catids[0])
			{
				$def = array();
				foreach($catids as $cids)
				{
					$def[]->value = $cids;
				}
			}
		}else{
			$def = $db->loadResultArray();
			if(! $def) $def[] = JRequest::getInt('category_id');

			$catids = JRequest::getVar('categories', array(), 'default', 'array');
			if(isset($catids[0]))
			{
				$def = array();
				foreach($catids as $cids)
				{
					$def[] = $cids;
				}
			}
		}
		$lists['category'] = '';
		if(!$custom_categories){
			if(MEAccess::isAdmin())
			{
				if(RES_CATEGORIES_VIEW != 'tree'){
					$categories = $model->_getCategories(0, 0, $params, $record);
					if(count($categories) > 7) $n = 7;
					else $n = count($categories);
					$multiple = 'multiple="multiple"';
					$lists['category'] = JHTML::_('select.genericlist', $categories, 'categories[]', $multiple . ' class="inputbox" size="' . $n . '" ', 'value', 'text', $def);
				}else{
					$lists['category'] = ResHelper::getAjaxTreeCategoryList(0 , $def, true);
				}
			}
			else
			{
				$n = $params->get('size_category_select', 1);
				$multiple = ' ';
				$m = false;
				$c = array();
				$limits = array();
				$disabled = array();
				if($params->get('multi_category'))
				{
					$multiple = ' multiple="multiple" ';
					$m = true;
				}
				if(RES_CATEGORIES_VIEW != 'tree'){
					$category = $model->getCategory($section_id);

					if($params->get('first_category'))
					{
						if(! ((count($limits) > 0) && (! in_array($category->id, $limits)))){
							$c[] = JHTML::_('select.option', $category->id, $category->name);
						}
					}
					$hidden_categories = explode(',', base64_decode(JRequest::getVar('hc')));
					if($hidden_categories[0]) $limits = array_merge($limits, $hidden_categories);
					JArrayHelper::toInteger($limits);

					$categories = $model->_getCategories($section_id, 1, $params, $record);
					if($categories) $c = array_merge($c, $categories);

					if(count($limits) > 0)
					{
						foreach($c as $ck => $cat)
						{
							if(! in_array($cat->value, $limits)) {
								unset($c[$ck]);
							}
						}
					}

					if($params->get('item_category_limit'))
					{
						$limits = explode(',', $params->get('item_category_limit'));
						foreach($c as $ck => $cat)
						{
							if(! in_array($cat->value, $limits))
							{
								$c[$ck]->disable = true;
							}
						}
					}

					if(count($c) == 0)
					{
						$params->set('allow_category', 0);
					}
					elseif(count($c) == 1)
					{
						foreach($c as $k => $c1)
							$lists['category'] = sprintf('<input type="hidden" name="categories[]" value="%d" /> %s', $c[$k]->value, $c[$k]->text);
					}
					else
					{
						array_unshift($c, JHTML::_('select.option', '', JText::_('- Select Category -')));
						$lists['category'] = JHTML::_('select.genericlist', $c, 'categories[]', $multiple . ' class="inputbox" size="' . $n . '"', 'value', 'text', $def);
					}
				}else{
					$hidden_categories = explode(',', base64_decode(JRequest::getVar('hc')));
					if($hidden_categories[0]) $limits = array_merge($limits, $hidden_categories);
					JArrayHelper::toInteger($limits);

					if($params->get('item_category_limit'))
					{
						$limits = array_merge( $limits, explode(',', $params->get('item_category_limit')) );
					}

					$lists['category'] = ResHelper::getAjaxTreeCategoryList($section_id , $def, $m, $limits);
				}
			}
		}else{
			$lists['category'] = $custom_categories_content;
		}

		$pcategories = $list->getPCategories($record->user_id, $section_id, null, JRequest::getInt('client_id'));
		$lists['usercategory'] = JHTML::_('select.genericlist', $pcategories, 'ucatid', null, 'value', 'text', $record->ucatid);
		//http://joomla/index.php?option=com_resource&view=category&layout=form&category_id=74&layout=form&Itemid=91
		$adnew = 'index.php?option=com_resource&view=category&layout=form&category_id=' . $category_id . '&Itemid=' . MEUrl::itemid(NULL, $category_id);
		$adnew = MEUrl::linkAdditions($adnew);
		$adnew .= '&return=' . base64_encode($uri->toString());
		$lists['usercategory'] .= '&nbsp;&nbsp;(' . JHTML::link(MERoute::_($adnew), JText::sprintf('Add New %s', $params->get('pcat_mean'))) . ')';

		$type = $model->getTypeName($record->type_id ? $record->type_id : $params->get('type'));

		if($params->get('category_mode') >= 2)
		{
			if((JRequest::getVar('client', 'resource') != 'resource') && JRequest::getInt('client_id'))
			{
				//$link = sprintf('index.php?option=com_resource&view=list&category_id=%d&Itemid=%d', $section_id, MEUrl::itemid(NULL, $section_id));
				//$link = MEUrl::linkAdditions($link);
				$link = MEUrl::link_list($section_id);
				$pathway->addItem(stripslashes(JRequest::getVar('client', $user->get($params->get('item_author_mode', 'username')))), MERoute::_($link, FALSE));
			}
			else
			{
				$link = sprintf('index.php?option=com_resource&view=list&category_id=%d&Itemid=%d&user_id=%d', $section_id, MEUrl::itemid(NULL, $section_id), $user->get('id'));
				//$olduserid = JRequest::setVar('user_id', $user->get('id'));
				//$link = MEUrl::linkAdditions($link);
				$link = MEUrl::link_list($category_id, array(
					'user_id' => $user->get('id')
				));

				$pathway->addItem($user->get($params->get('item_author_mode', 'username')), MERoute::_($link, FALSE));
			}
		}
		$pathway->addItem(JText::_('Submit New Item') . ': ' . $type, $uri->toString());

		if($params->get('public_alert') && ! $user->get('id'))
		{
			$url = 'index.php?option=com_user&view=login&Itemid=' . JRequest::getInt('Itemid');
			$url .= '&return=' . base64_encode($uri->toString());
			$url = JHTML::link($url, JText::_('Login'));
			JError::raiseNotice(100, JText::_('You are submiting whitout being loged-in. You will not be able to edit this record later.') . ' ' . $url);
		}

		// detect if we show category select or not
		$shows['category'] = true;
		if($params->get('category_mode') == 2) $shows['category'] = false;
		if($params->get('list_clients') == 0 && JRequest::getInt('client_id')) $shows['category'] = false;
		if($params->get('allow_category') == 0) $shows['category'] = false;
		if($user->get('usertype') == 'Super Administrator') $shows['category'] = true;
		if($custom_categories) $shows['category'] = true;


		$shows['ucategory'] = true;
		if($params->get('category_mode') == 1 && (! JRequest::getInt('client_id'))) $shows['ucategory'] = false;
		if($params->get('pcat_submit') == 'none') $shows['ucategory'] = false;


		JRequest::setVar('category_id', @$def[0]->value);
		if($params->get('allow_category') == 0 && count(@$limits))
		{
			JRequest::setVar('category_id', $limits[0]);
		}
		$this->assignRef('tagnums', explode(", ", $tags));
		$this->assignRef('shows', $shows);
		$this->assignRef('type', $type);
		$this->assignRef('article_event', $article_event);
		$this->assignRef('user', JFactory::getUser());
		$this->assignRef('lists', $lists);
		$this->assignRef('params', $params);
		$this->assignRef('item', $record);
		$this->assignRef('fields', $nfields);
		$this->assignRef('ifields', $ifields);
		$this->assignRef('hidden_fields', $hidden_fields);
		$this->assignRef('isNew', $isNew);
		$this->assign('action', $uri->toString());
		$this->assign('category_id', $category_id);
		$this->assign('section_id', $section_id);

		parent::display($tpl);
	}

	function linkFiles($params)
	{
		$document = & JFactory::getDocument();

		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_article_' . $params->get('tmpl_article', 'default') . '.css'))
		{
			$document->addStyleSheet(JURI::root() . 'components/com_resource/views/article/tmpl/default_article_' . $params->get('tmpl_article', 'default') . '.css');
		}
		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_article_' . $params->get('tmpl_article', 'default') . '.js'))
		{
			$document->addScript(JURI::root() . 'components/com_resource/views/article/tmpl/default_article_' . $params->get('tmpl_article', 'default') . '.js');
		}

		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_comments_' . $params->get('tmpl_comment', 'default') .
		 '.css'))
		{
			$document->addStyleSheet(JURI::root() . 'components/com_resource/views/article/tmpl/default_comments_' . $params->get('tmpl_comment', 'default') . '.css');
		}
		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_comments_' . $params->get('tmpl_comment', 'default') . '.js'))
		{
			$document->addScript(JURI::root() . 'components/com_resource/views/article/tmpl/default_comments_' . $params->get('tmpl_comment', 'default') . '.js');
		}

		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_articleform_' . $params->get('tmpl_articleform', 'default') .
		 '.css'))
		{
			$document->addStyleSheet(JURI::root() . 'components/com_resource/views/article/tmpl/default_articleform_' . $params->get('tmpl_articleform', 'default') . '.css');
		}
		if(JFile::exists(JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'article' . DS . 'tmpl' . DS . 'default_articleform_' . $params->get('tmpl_articleform', 'default') .
		 '.js'))
		{
			$document->addScript(JURI::root() . 'components/com_resource/views/article/tmpl/default_articleform_' . $params->get('tmpl_articleform', 'default') . '.js');
		}
	}

	function getFieldValue($field, $user)
	{
		$list = JModel::getInstance('list', 'ResModel');
		return $list->getFieldValue($field, $user);
	}

	function favorite($id)
	{
		$db = &JFactory::getDBO();
		$sql = "";
		return "#";
	}

	function _commentDelete($comment)
	{
		$img = JHTML::image(JURI::root() . 'components/com_resource/images/delete.png', 'Delete comment');
		$_GET['task'] = 'delete_comment';
		$_GET['view'] = 'article';
		$_GET['controller'] = 'article';
		$_GET['comment'] = $comment->id;
		foreach($_GET as $key => $val)
			$url[] = "$key=$val";
		echo JHTML::link(MERoute::_('index.php?' . implode("&", $url)), $img);
	}

	function _commentPublish($comment)
	{
		$img = JHTML::image(JURI::root() . 'components/com_resource/images/publish.png', 'Publish comment');
		$_GET['task'] = 'publish_comment';
		$_GET['view'] = 'article';
		$_GET['controller'] = 'article';
		$_GET['comment'] = $comment->id;
		foreach($_GET as $key => $val)
			$url[] = "$key=$val";
		echo JHTML::link(MERoute::_('index.php?' . implode("&", $url)), $img);
	}
}
?>