<?php
/**
 * $Id: view.feed.php 8086 2012-04-24 05:12:25Z kostya $
 * $LastChangedDate: 2012-04-24 11:12:25 +0600 (Tue, 24 Apr 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');
jimport('joomla.utilities.date');

class ResViewList extends JView
{
	function display($tpl = null)
	{
		global $mainframe;
		$model = JModel::getInstance('list', 'ResModel');
		$uri 	= JFactory::getURI();
		$user = JFactory::getUser();
		$config = JFactory::getConfig();

		$category = JRequest::getInt('category_id', JRequest::getInt('section_id'));
		$section = ResHelper::getCategorySection($category);

		$url_params = &$mainframe->getParams();
		$params 	= ResHelper::initListParams(JRequest::getInt('category_id', JRequest::getInt('section_id')));
		$params->merge($url_params);

		$model->setParams($params);

		if($params->get('access_section') == 'none')
		{
			JError::raiseWarning(404, JText::_('Section Offline'));
			echo '<div class="componentheading">'.$params->get('access_msg').'</div>';
			return;
		}
		if($params->get('access_section') > $user->get('aid'))
		{
			JError::raiseWarning(404, JText::_('Access Denied'));
			echo '<div class="componentheading">'.JText::_('You do not have enough rights').'</div>';
			if($params->get('access_section') == 1)
			{
				JError::raiseWarning(404, JText::_('This section accessible only for Registered users'));

				$return		= $uri->toString();

				$url  = 'index.php?option=com_user&view=login&Itemid='.JRequest::getInt('Itemid');
				$url .= '&return='.base64_encode($return);

				$mainframe->redirect( JRoute::_($url, FALSE) );

			}
			if($params->get('access_section') == 2)
			{
				echo '<p>'.JText::_('This section accessible only for users with administrator rights').'</p>';
			}
			return;
		}

		$options['category'] = $category;
		$options['limit'] = JRequest::getInt('limit', $params->get('feed_limit', $mainframe->getCfg('feed_limit', 50)));
		$options['order'] = JRequest::getVar('order', $params->get('orderby_rss', 'r.ctime DESC'));
		//$options['client'] = 'module';
		if(JRequest::getInt('all') == 1)
		{
			$options['records_mode'] = 2;
		}
		else
		{
			$options['records_mode'] = 1;
		}

		$items = MightyResourcesApi::getRecordList($options, array(), array(), $model, $o);

		if(JRequest::getVar('type') == 'xml')
		{
			$files = array();
			foreach ($items[0] AS $key => $row)
			{
				$files[$key] = "\t<record>\n";
				$files[$key] .= "\t\t<id>{$row->id}</id>\n";
				$files[$key] .= "\t\t<create_date>".$row->ctime->toFormat()."</create_date>\n";
				$files[$key] .= "\t\t<modify_date>".($row->mtime ? $row->mtime->toFormat() : '')."</modify_date>\n";
				$files[$key] .= "\t\t<title>".$this->escape($row->title)."</title>\n";
				foreach ($row->fields AS $k => $field)
				{
					$field_params = new JParameter($field->params);
					$tag = JString::strtolower($field->title);
					$tag = preg_replace("/[^a-z_-]/iU", "_", $tag);
					while (strstr($tag, "__"))
					$tag = str_replace("__", "_", $tag);
					$tag = $field_params->get('xml_tag_name', $tag);

					$files[$key] .= "\t\t<{$tag}><![CDATA[	".$field->result."  ]]></$tag>\n";
				}
				$files[$key] .= "\t</record>\n";
			}
			header('content-type: text/xml');
			echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<records>\n".implode("\n", $files)."</records>";
			exit;
		}

		$cat = $model->getCategory($section);

		$doc     = &JFactory::getDocument();
		$doc->link = htmlentities($uri->toString());
		$doc->title = htmlentities($doc->title, ENT_NOQUOTES, 'UTF-8');
		$doc->description = JText::_('RSS feed for:').' '.htmlspecialchars($cat->title). ' '. JText::_('On'). ' '. htmlspecialchars($config->getValue('config.sitename'));

		foreach ($items[0] as $row )
		{
			$title = strip_tags( $row->title );

			$description = array();
			foreach ($row->fields AS $k => $field)
			{
				$fparams = new JParameter($field->params);

				if($fparams->get('show_lable') == 0)
				{
					$description[] = sprintf('<tr valign="top"><td colspan="2">%s</td></tr>', $field->result);
				}
				else
				{
					$description[] = sprintf('<tr valign="top"><td><b>%s</b>:</td><td>%s</td></tr>', $field->title, $field->result);
				}
			}
			$description = '<table>'.implode(" ", $description).'</table>';

			$date = substr($options['order'], 0, 7) == 'r.mtime' ? $row->mtime : $row->ctime;
			if(!is_object($date))
			{
				$date = JFactory::getDate((string)$date);
			}
			$date = $date->toMySQL();

			$item = new JFeedItem();
			$item->title 		= htmlspecialchars(strip_tags($row->title));
			$item->link 		= $row->link;
			$item->description 	= $description;
			$item->date			= $date;
			$item->author		= $row->username;
			//$item->category   	= $row->category;

			// loads item info into rss array
			$doc->addItem( $item );
		}
	}
}
?>