<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ResViewList extends JView
{
	function display( $tpl = null )
	{
		global $mainframe, $option;

		$catid	= JRequest::getInt('category_id', JRequest::getInt('section_id'));
		if(!$catid)
		{
			JError::raiseWarning(404, JText::_('Cannot get category ID of the section'));
			return;
		}

		JHTML::_('behavior.tooltip');
		JHTML::_('behavior.modal');
		JHTML::_('behavior.mootools');
		JHTML::_('behavior.tooltip', '.myTip', array('fixed' => 1, 'hideDelay' => 2000, 'className'=>'mytipdrop'));


		$user 	= &JFactory::getUser();
		$url_params = &$mainframe->getParams();
		$params = ResHelper::initListParams($catid);
		if(is_object($url_params)) $params->merge($url_params);

		if((JRequest::getInt('user_id') || JRequest::getInt('ucid') || JRequest::getInt('view_what') ) && $params->get('category_mode') == 1)
		{
			$link = MEUrl::link_list($catid, array('user_id'=>0, 'ucid'=>0, 'view_what'=>0));
			$mainframe->redirect(MERoute::_($link, FALSE));
		}

		if($params->get('access_section') == 'none' && !MEAccess::isAdmin())
		{
			JError::raiseWarning(404, JText::_('Section Offline'));
			echo '<div class="componentheading">'.$params->get('access_msg').'</div>';
			return;
		}
		else
		{
			if($params->get('access_section') == 'none')
			{
				JError::raiseWarning(404, JText::_('Section Offline: Administrator access only'));
			}
		}
		if($params->get('access_section') == 1 && !$user->get('aid'))
		{
			MEAccess::login(null, JText::_($params->get('access_msg', 'You have to be registered and logged in to acess this section or category')));
		}
		if($params->get('access_section') == 2 && $user->get('aid') < 2)
		{
			JError::raiseWarning(404, JText::_($params->get('access_msg', 'This section accessible only for special users')));
			return;
		}

		if(JRequest::getVar('view_what'))
		{
			if(JRequest::getVar('view_what') != 'related')
			{
				if(!JRequest::getInt('user_id', JRequest::getInt('client_id')) && $user->get('id'))
				{
					$link = MEUrl::link_list($catid, array('user_id' => $user->get('id'),'view_what'=>JRequest::getVar('view_what')));
					$mainframe->redirect(MERoute::_($link, FALSE));
					return;
				}
					
				if(!JRequest::getInt('user_id', JRequest::getInt('client_id')) && !$user->get('id'))
				{
					MEAccess::login();
					//$link = MEUrl::link_list($catid,);
					//$mainframe->redirect(MERoute::_($link, FALSE));
					//return;
				}
			}
			switch (JRequest::getVar('view_what'))
			{
				case 'hidden':
					if(!MEAccess::isAuthor(JRequest::getInt('user_id')))
					{
						JError::raiseWarning(404, JText::_('Access Denied'));
						echo '<p>'.JText::_('This page is accessible only by authors').'</p>';
						return;
					}
					break;
				case 'unpublished':
					if(!(MEAccess::isAdmin() || MEAccess::isAuthor(JRequest::getInt('user_id')) || MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params) || MEAccess::isPublisher() || MEAccess::isEditor()))
					{
						JError::raiseWarning(404, JText::_('Access Denied'));
						echo '<p>'.JText::_('This page is accessible only for administrators and moderators').'</p>';
						return;
					}
					break;
			}
		}

		$model = &JModel::getInstance('List','ResModel');
		$filters_model = &JModel::getInstance('Filters','ResModel');
		$article_model = &JModel::getInstance('Article','ResModel');

		$this->setModel($model);

		$itemid = JRequest::getInt('Itemid');
		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$config 	= JFactory::getConfig();
		$state	= &$this->get('state', 'list');
		$menus 	= &JSite::getMenu();
		$menu  	= $menus->getActive();
		$action = $uri->toString();
		$session = & JFactory::getSession();

		$section  = $model->getCategory(ResHelper::getCategorySection($catid));
		$category = $model->getCategory($catid);

		//$children = $model->getChildren2($categories, $params);
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_cindex_'.$params->get('tmpl_category', 'default').'.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_cindex_'.$params->get('tmpl_category', 'default').'.ini');
			$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_cindex_'.$params->get('tmpl_category', 'default').'.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_filters_'.$params->get('tmpl_filters', 'default').'.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_filters_'.$params->get('tmpl_filters', 'default').'.ini');
			$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_filters_'.$params->get('tmpl_filters', 'default').'.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_menu_'.$params->get('tmpl_menu', 'default').'.ini'))
		{
			$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_menu_'.$params->get('tmpl_menu', 'default').'.ini');
			$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_menu_'.$params->get('tmpl_menu', 'default').'.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);
		}
		$document->addScript(JURI::root().'includes/js/joomla.javascript.js');
		$categories	= $model->getCategoriesList(($params->get('cat_type') == 'Static' ? $section->id : $category->id), $params);

		if(JRequest::getInt('filter_tag'))
		{
			$tag = JModel::getInstance('tags', 'ResModel');
			$tag->hit(JRequest::getInt('filter_tag'), $section->id);
			$title[] = $model->tagName(JRequest::getInt('filter_tag'));
		}

		if($compare = JRequest::getInt('compare'))
		{
			$compare_ids = $session->get('compare');
			settype($compare_ids, 'array');
			if(!is_array($compare_ids[$compare])) $compare_ids[$compare] = array();

			if(count($compare_ids[$compare]) > 1)
			{
				$params->set('filters', 0);
				$params->set('pagination', 0);
			}
			else
			{
				JError::raiseNotice(400, JText::_('Not enough records to compare. There should be at least 2 records. Please add more records and try again'));
				JRequest::setVar('compare', 0);
			}
		}

		MECache::cleanCache((int)$params->get('cache_days', 5), $section->id);

		if(JRequest::getInt('user_id', JRequest::getInt('client_id')) && $params->get('pcat_require') && !JRequest::getInt('ucid') && !(JRequest::getVar('view_what') == 'unpublished'))
		{
			//echo 123;
			$items 		= array();
			$pagination	= null;
			$total 		= 0;
			$filters	= array();
			$titems     = array();
			$filters	= array();

			$this->assign('filters_list', $filters);

		}
		else
		{
			//$items 		= $model->getData($catid, $params);
			$options = array();
			$options['client'] = 'resource';
			if($params->get('client') == 'module') $options['client'] = 'module';
			$items 		= MightyResourcesApi::getRecordList($options, array(), array(), $model, $out);
			$views  	= @$out['views'];
			$columns 	= @$out['columns'];
			$lists 		= @$out['lists'];
			$search_default	= @$out['search_default'];
			$alpha_default	= @$out['alpha_default'];
			$fname_tag	= @$out['fname_tag'];
			$total 		= $model->getTotal($category->id);
			if($params->get('pagination')) $pagination	= $model->getPagination($category->id, $total);

			$filters = array();
			$hidden = array();
			$ext_filters = array();
				
			if($model->_types > 1)
			{
				$params->set('filters_fields', 0);
				$params->set('filters_ext', 0);
			}
			else
			{
				if( $params->get('filters_fields') ) {
					$filters = $model->getFilters($category->id, $params);
				}

				foreach ($filters AS $k => $filter)
				{
					$hidden[] = $filter;
					if(!$filter['values'])
					{
						unset($filters[$k]);
						continue;
					}
					$fparams = new JParameter($filter['filter']->params);
					if($fparams->get('filter_hide') == 1)
					{
						unset($filters[$k]);
					}
				}
				settype($filters, 'array');

				if( $params->get('filters_ext') ) {
					$ext_filters = $model->getExtFilters($category->id, $params);
				}
			}

			$this->assign('hidden_filters', $hidden);
			$this->assign('filters_list', $filters);
			$this->assignRef( 'ifilters_ext', $ext_filters);
		}
		$fworn = & $model->_fworn;
		
		foreach ($fworn AS $worn)
		{
			if(is_array($worn['value'])) $title[] = $worn['name'].': '.implode(", ", $worn['value']); else $title[] =  $worn['name'].': '.$worn['value'];
		}

		$category->total = $total;


		$filter_category = array();
		if(JRequest::getInt('client_id') || JRequest::getInt('user_id') )
		{
			$params->set('filters_category', 0);
		}
		if($params->get('filters_category'))
		{

			$filter_category = $article_model->_getCategories($section->id, 0, $params, null);
			if(is_array($filter_category))
			{
				foreach ($filter_category AS $key => $temp_category)
				{
					$cp = new JParameter(@$temp_category->params);
					$filter_category[$key]->value = MERoute::_(MEUrl::link_list($temp_category->value));
				}
				if($section->id == JRequest::getInt('category_id'))
				{
					$fc_add[] = JHTML::_('select.option', '', '- '.JText::_('Change Category').' -');
				}
				else
				{
					$fc_add[] = JHTML::_('select.option', MERoute::_(MEUrl::link_list($section->id)), ' - '.$section->name.' - ');
				}
				$filter_category = array_merge($fc_add, $filter_category);
			}
			if(!$filter_category)
			{
				$params->set('filters_category', 0);
			}
			$this->assignRef('filter_category', $filter_category);
		}

		$aindex = explode(" ", JText::_('q w e r t y u i o p a s d f g h j k l z x c v b n m'));
		sort($aindex); $lists['alpha'] = $aindex;

		//if($cur_user = JRequest::getInt('user_id', JRequest::getInt('client_id')) && $params->get('pcat_index'))
		if($cur_user = JRequest::getInt('user_id', JRequest::getInt('client_id')) && ($params->get('pcat_submit') != 'none'))
		{
			$pcategories = $model->getPCategories(JRequest::getInt('user_id'), $section->id, $params, JRequest::getInt('client_id'));

			if(JRequest::getInt('user_id'))
			{
				$user2 = JFactory::getUser(JRequest::getInt('user_id'));
				$link = MEUrl::link_list($category->id, array('ucid' => 0));
				$link = MERoute::_($link);

				$pathway->addItem($user2->get('name'), $link);
			}
			if(JRequest::getVar('client_id'))
			{
				$link = MEUrl::link_list($category->id, array('ucid' => 0));
				$link = MERoute::_($link);

				$pathway->addItem(JRequest::getVar('client'), $link);
			}


			if(JRequest::getInt('ucid') && is_array($pcategories))
			{
				foreach ($pcategories as $pcategory) {

					if($pcategory->id == JRequest::getInt('ucid'))
					{
						$pers_category = $pcategory;
						$pcat_params = new JParameter($pcategory->params);

						if($pcategory->access > $user->get('aid'))
						{
							MEAccess::login(null, JText::_('Only registered users may access this category'));
							return;
						}

						$pathway->addItem($pcategory->name);

						if ($pcat_params->get('meta_descr')) {
							$document->setDescription( $pcat_params->get('meta_descr') );
						}
						if ($pcat_params->get('meta_key')) {
							$document->setMetadata('keywords', $pcat_params->get('meta_key'));
						}
					}
				}
			}


		}
		else
		{
			$pcategories = array();
			$this->drowPath($pathway, JRequest::getInt('category_id', $params->get('category_id')), $section->id, $model, $params);
		}

		if(JRequest::getVar('client')) $title[] = JRequest::getVar('client');
		if(JRequest::getVar('user_id'))
		{
			$tuser = JFactory::getUser(JRequest::getVar('user_id'));
			$title[] = $tuser->get($params->get('item_author_mode', 'username'));
		}
		if(JRequest::getVar('ucid') && ($params->get('pcat_submit') != 'none'))
		{
			$title[] = $pers_category->name;
		}
		$category->title ? $title[] = $category->title : $title[] = $category->name;
		($params->get('page_title') && $params->get('show_page_title') ?  $title[] = $params->get('page_title') : NULL);

		$document->setTitle(implode(" - ", $title));

		if ($category->meta_descr) {
			$document->setDescription( $category->meta_descr );
		}
		if ($category->meta_key) {
			$document->setMetadata('keywords', $category->meta_key);
		}

		if(($params->get('feed_link', 0) == 1) || ($params->get('feed_link2', 0) == 1))
		{

			$link	= '&format=feed&limitstart=';
			if ($params->get('feed_link_type') == 1) {
				$link = '&all=1'.$link;
				$title = JText::_('Any article in section:').' '.$section->title;
			}
			else
			{
				$title = JText::_('Only current category:').' '.$category->title;
			}
			if($params->get('feed_link', 0) == 1)
			{
				$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0 '.$title);
				$document->addHeadLink(MERoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			}
			if($params->get('feed_link2', 0) == 1)
			{
				$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0 '.$title);
				$document->addHeadLink(MERoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
			}
		}

		$this->assign('filter_rss', 0);
		if($fworn && $params->get('filters_feed'))
		{
			$link = $this->getRSS($model->_rss).'&format=feed&limitstart=';
			$this->assign('filter_rss', MERoute::_($link.'&type=rss'));
			$title = JText::_('Feed current search');
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0 '.$title);
			$document->addHeadLink(MERoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);

			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0 '.$title);
			$document->addHeadLink(MERoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		$events['onBeforeListRender'] = array();

		$event_data = '';
		$dispatcher	   =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content');
		$events['onBeforeListRender'] = $dispatcher->trigger('onBeforeListRender', array (&$params, $items ));

		$this->assignRef('alpha', $alpha_default);
		//$this->assign('type',	$model->getTypeName($params->get('type')));
		$this->assign('action',	$action);
		//$this->assign('titems',		count($titems));

		$shows['category'] = true;
		if($params->get('category_mode') == 2) $shows['category'] = false;
		if(!$params->get('cat_index')) $shows['category'] = false;
		if($params->get('list_clients') == 0 && JRequest::getInt('client_id')) $shows['category'] = false;
		if(JRequest::getInt('user_id', JRequest::getInt('client_id'))) $shows['category'] = false;
		if(count($categories) <= 0) $shows['category'] = false;

		if((count($fworn) && ($params->get('filters_mode') == 2)) || JRequest::getInt('compare'))
		{
			$shows['category'] = false;
			$params->set('descr_image', 0);
			$params->set('description', 0);
			$params->set('filters_category', 0);
			$category->name = $params->get('page_title', $category->name);
		}

		$shows['ucategory'] = true;
		if($params->get('category_mode') == 1 && !JRequest::getInt('client_id')) $shows['ucategory'] = false;
		if($params->get('pcat_submit') == 'none')  	$shows['ucategory'] = false;
		if(!JRequest::getInt('user_id', JRequest::getInt('client_id'))) $shows['ucategory'] = false;
		if(JRequest::getVar('view_what') && (JRequest::getVar('view_what') != 'created') ) $shows['ucategory'] = false;
		//if(!$user->get('id')) $shows['ucategory'] = false;
		$user_category =  $shows['ucategory'];
		if($user->get('id') && ($user->get('id') != JRequest::getInt('user_id')) && !JRequest::getInt('client_id')) $user_category = false;
		if($params->get('pcat_index') == 0) $shows['ucategory'] = false;

		$menu_element = null;
		if ($user_category)
		{
			$link = "index.php?option=com_resource&view=category&controller=category&category_id={$category->id}&Itemid=".$params->get('category_itemid', JRequest::getVar('Itemid')).'&user_id='.$user->get('id');
			$link = MEUrl::linkAdditions($link);
			$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_category')));
			$session->set('cat_back', base64_encode($uri->toString()));
		}
		if($params->get('menu_icon_category') && $params->get('menu_show_icons') && $menu_element && $user->get('id'))
		{
			$menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_category').'" align="absmiddle" /> '.$menu_element;
			$user_menu['category'] = $menu_element;
		}

		$user_menu['my'] = array(); $total_nums = 0;
		if(JRequest::getInt('user_id'))
		{

			$num = getNumbers('created', JRequest::getInt('user_id'), $section->id, $params);
			if($num)
			{
				$total_nums += $num;
				$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'created'));
				if(JRequest::getVar('view_what') == 'created')
				{
					$menu_element = '<b>'.JText::_($params->get('menu_label_created')).'</b>';
				}
				else
				{
					$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_created')));
				}
				if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
				if($params->get('menu_icon_created') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_created').'" align="absmiddle" /> '.$menu_element;
				$user_menu['my']['created'] = $menu_element;
			}

			$num = getNumbers('rated', JRequest::getInt('user_id'), $section->id, $params);
			if($num)
			{
				if($params->get('menu_show_rated'))
				{
					$total_nums += $num;
					$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'rated'));
					if(JRequest::getVar('view_what') == 'rated')
					{
						$menu_element = '<b>'.JText::_($params->get('menu_label_rated')).'</b>';
					}
					else
					{
						$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_rated')));
					}
					if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
					if($params->get('menu_icon_rated') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_rated').'" align="absmiddle" /> '.$menu_element;
					$user_menu['my']['rated'] = $menu_element;
				}
			}
			$num = getNumbers('favorited', JRequest::getInt('user_id'), $section->id, $params);
			if($num)
			{
				if($params->get('menu_show_favorited'))
				{
					$total_nums += $num;
					$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'favorites'));
					if(JRequest::getVar('view_what') == 'favorites')
					{
						$menu_element = '<b>'.JText::_($params->get('menu_label_favorited')).'</b>';
					}
					else
					{
						$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_favorited')));
					}
					if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
					if($params->get('menu_icon_favorited') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_favorited').'" align="absmiddle" /> '.$menu_element;
					$user_menu['my']['favorited'] = $menu_element;
				}
			}
			$num = getNumbers('visited', JRequest::getInt('user_id'), $section->id, $params);
			if($num)
			{
				if($params->get('menu_show_visited'))
				{
					$total_nums += $num;
					$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'last-visited'));
					if(JRequest::getVar('view_what') == 'last-visited')
					{
						$menu_element = '<b>'.JText::_($params->get('menu_label_visited')).'</b>';
					}
					else
					{
						$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_visited')));
					}
					if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
					if($params->get('menu_icon_visited') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_visited').'" align="absmiddle" /> '.$menu_element;
					$user_menu['my']['visited'] = $menu_element;
				}
			}

			$num = getNumbers('commented', JRequest::getInt('user_id'), $section->id, $params);
			if($num)
			{
				if($params->get('menu_show_commented'))
				{
					$total_nums += $num;
					$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'commented'));
					if(JRequest::getVar('view_what') == 'commented')
					{
						$menu_element = '<b>'.JText::_($params->get('menu_label_commented')).'</b>';
					}
					else
					{
						$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_commented')));
					}
					if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
					if($params->get('menu_icon_commented') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_commented').'" align="absmiddle" /> '.$menu_element;
					$user_menu['my']['commented'] = $menu_element;
				}
			}

			if(MEAccess::isAuthor(JRequest::getInt('user_id'), /*$params->get('show_past_records')*/$params->get('menu_show_expired') > 0) ||
			MEAccess::isModerator($user->get('id'), 'moder_extend_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor())
			{
				$num = getNumbers('expired', JRequest::getInt('user_id'), $section->id, $params);
				if($num)
				{
					if($params->get('menu_show_expired'))
					{
						$total_nums += $num;
						$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'expired'));
						if(JRequest::getVar('view_what') == 'expired')
						{
							$menu_element = '<b>'.JText::_($params->get('menu_label_expired')).'</b>';
						}
						else
						{
							$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_expired')));
						}
						if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
						if($params->get('menu_icon_expired') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_expired').'" align="absmiddle" /> '.$menu_element;
						$user_menu['my']['expired'] = $menu_element;
					}
				}
			}
			if($user->get('id') == JRequest::getInt('user_id'))
			{
				$num = getNumbers('hidden', JRequest::getInt('user_id'), $section->id, $params);
				if($num)
				{
					if($params->get('menu_show_hidden'))
					{
						$total_nums += $num;
						$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'hidden'));
						if(JRequest::getVar('view_what') == 'hidden')
						{
							$menu_element = '<b>'.JText::_($params->get('menu_label_hidden')).'</b>';
						}
						else
						{
							$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_hidden')));
						}
						if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
						if($params->get('menu_icon_hidden') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_hidden').'" align="absmiddle" /> '.$menu_element;
						$user_menu['my']['hidden'] = $menu_element;
					}
				}
			}
			if(MEAccess::isAuthor(JRequest::getInt('user_id')) || MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor())
			{
				$num = getNumbers('unpublished', JRequest::getInt('user_id'), $section->id, $params);
				if($num)
				{
					if($params->get('menu_show_unpublished'))
					{
						$total_nums += $num;
						$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> JRequest::getInt('user_id'), 'view_what' => 'unpublished'));
						if(JRequest::getVar('view_what') == 'unpublished')
						{
							$menu_element = '<b>'.JText::_($params->get('menu_label_unpublished')).'</b>';
						}
						else
						{
							$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_unpublished')));
						}
						if($params->get('menu_show_nums')) $menu_element .= ' ('.$num.')';
						if($params->get('menu_icon_unpublished') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_unpublished').'" align="absmiddle" /> '.$menu_element;
						$user_menu['my']['unpublished'] = $menu_element;
					}
				}
			}
		}
		
		if(
			(
				($params->get('category_mode') > 1)
				&& (JRequest::getInt('user_id') != $user->get('id'))
				&& !JRequest::getInt('client_id') 
				&& $user->get('id')
			) 
			|| 
			(
				JRequest::getInt('client_id') && $params->get('menu_personalize_group') 
				&& (JRequest::getInt('user_id') != $user->get('id'))
				&& $user->get('id')
			)
		)
		//if(count($user_menu['my']) > 0 && $total_nums)
		{
			$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> $user->get('id'), 'view_what' => 'created'));
			$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_my')));
			if($params->get('menu_show_nums')) $menu_element .= ' ('.getNumbers('created', $user->get('id'), $section->id, $params).')';
			//if($params->get('menu_show_nums')) $menu_element .= " ({$total_nums})";
			if($params->get('menu_icon_my') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_my').'" align="absmiddle" /> '.$menu_element;
			$user_menu['my_records'] = $menu_element;
		}
		
		$menu_element = '';

		$types = explode(",", $params->get('type'));
		JArrayHelper::toInteger($types);
		foreach ($types AS $type)
		{
			if(!$type) continue;

			$tp = $model->getType($type);
			$type_params = new JParameter($tp->params);

			if($type_params->get('item_compare'))
			{
				$type_nums = $session->get('compare');
				settype($type_nums, 'array');
				if(!is_array(@$type_nums[$tp->id])) $type_nums[$tp->id] = array();
				$compare = count($type_nums[$tp->id]);

				$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id'=> 0, 'view_what' => 0, 'ucid' => 0));
				$link .= '&compare='.$tp->id;

				$menu_element = JHTML::link(MERoute::_($link), JText::_('Compare').': '.$tp->name);
				$menu_element .= " (<span id=\"type_compare_{$tp->id}\">{$compare}</span>)";
				if($params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/compare.png" align="absmiddle" /> '.$menu_element;
				$user_menu['compare'][] = $menu_element;
			}

			if(!MEAccess::isAdmin())
			{
				if($type_params->get('submission') == 'none')	continue;
				//if($params->get('category_mode') == 1)
				if($type_params->get('submission') > $user->get('aid') && ($type_params->get('submission') == 2))	continue;
			}
			$category_limit = $type_params->get('item_category_limit', array());
			if(!is_array($category_limit))
				settype($category_limit, 'array');
			if($type_params->get('submission') == 1 && !$user->get('id'))
			{
				if(empty($category_limit) || in_array($category->id, $category_limit)){
					$menu_element = JText::sprintf($params->get('menu_label_add_reg'), $tp->name);
					if($params->get('menu_icon_add') && $params->get('menu_show_icons') && $menu_element) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_add').'" align="absmiddle" /> '.$menu_element;
					$user_menu['add'][$tp->id] = $menu_element;
				}
			}
			else
			{
				if(empty($category_limit) || in_array($category->id, $category_limit)){
					$link = "index.php?option=com_resource&controller=article&category_id={$category->id}&view=article&layout=form&type_id={$type}&Itemid=".MEUrl::itemid(NULL, $category->id);
					$link = MEUrl::linkAdditions($link, array('user_id' => 0, 'ucid' => 0, 'view_what' => 0));
					$link .= '&redirect='.base64_encode($uri->toString());
	
					$menu_element = JHTML::link(MERoute::_($link), JText::sprintf($params->get('menu_label_add'), $tp->name));
					if($params->get('menu_icon_add') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_add').'" align="absmiddle" /> '.$menu_element;
					$user_menu['add'][$tp->id] = $menu_element;
				}
			}
		}
		
		$menu_element = '';
		if ((($params->get('category_mode') == 2 || $params->get('category_mode') == 3) && JRequest::getInt('user_id') && !JRequest::getInt('client_id')) || (JRequest::getInt('user_id') && JRequest::getInt('client_id') && $params->get('menu_personalize_group')) || JRequest::getInt('compare'))
		{
			$link = "index.php?option=com_resource&view=list&category_id=".JRequest::getVar('category_id', $section->id)."&Itemid=".MEUrl::itemid(NULL, JRequest::getVar('category_id', $section->id));
			$link = MEUrl::link_list(JRequest::getVar('category_id', $section->id), array('user_id' => 0, 'view_what' => 0, 'ucid'=>0));
			$menu_element = JHTML::link(MERoute::_($link), JText::_($params->get('menu_label_all')));
			if($params->get('menu_icon_all') && $params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$params->get('menu_icon_all').'" align="absmiddle" /> '.$menu_element;
			$user_menu['all'] = $menu_element;
		}

		MRRecordHelper::linkFiles($params);

		if(!@$items) $items = array();
//		if(!@$fields) $fileds = array();
		if(!@$filters) $filters = array();
		$this->assignRef('uri',		$uri);
		$this->assignRef('tag', 	$fname_tag);
		$this->assignRef('user',	$user);
		$this->assignRef('menu',	$user_menu);
		$this->assignRef('total', 	$total);
		//$this->assignRef('model', 	$model);
		$this->assignRef('views', 	$views);
		$this->assignRef('shows', 	$shows);
		$this->assignRef('lists', 	$lists);
		$this->assignRef('items',	$items[0]);
		$this->assignRef('ihtml',	$items[1]);
		$this->assignRef('fworn',	$fworn);
		$this->assignRef('params',	$params);
		$this->assignRef('events',	$events);
		$this->assignRef('columns',	$columns);
		$this->assignRef('section',	$section);
		$this->assignRef('category',$category);
		$this->assignRef('children',$children);
		$this->assignRef('ifilters',$filters);
		$this->assignRef('pcategory',	$pers_category);
		$this->assignRef('categories',	$categories);
		$this->assign('pagination',	@$pagination);
		$this->assignRef('pcategories',	$pcategories);
		$this->assignRef('search_default', $search_default);
		$this->assign('is_calendar', $params->get('tmpl_list') == 'calendar');

		// LEGACY
		//$this->assignRef('fields',	$nfields);
		//$this->assignRef('ifields',	$ifields);
		//$this->assignRef('cols',	$cols);
		//$this->assignRef('cols_additional', $cols_additional);

		parent::display($tpl);
	}
	function getRSS($array)
	{
		$str = '';
		foreach ($array AS $key => $val)
		{
			$str .= "{$key}={$val}";
		}
		return $str;
	}


	function tagName($id)
	{
		$db = & JFactory::getDBO();

		//if(!is_int($id)) return 123;
		//print_r($id); exit;

		$sql = "SELECT t.id, t.tag  FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_tags AS t ON t.id = h.tag_id
		WHERE t.id = {$id}";
		$db->setQuery($sql);
		$res = $db->loadObject();
		return $res->tag;
	}

	function drowPath(&$path, $catid, $home, $model, $params)
	{
		static $check = 0;

		//if($catid == $home) return;

		//echo $catid;
		//echo $home; Return;

		if($check == 0)
		{
			$iid1 = JRequest::getInt('Itemid');
			$iid2 = MEUrl::itemid(null, $home);

			if($iid1 != $iid2)
			{
				return;
			}
			$check = 1;
		}

		$category = $model->getCategory($catid);
		if($category->parent <= 0) return;
		//echo $category->parent;
		$this->drowPath($path, $category->parent, $home, $model, $params);
		//$link = "index.php?option=com_resource&view=list&category_id={$category->id}&Itemid="
		//.MEUrl::itemid(NULL, $category->id);
		$link = MEUrl::link_list($category->id);
			
		$path->addItem($category->name, $link);
	}
	function getFieldValue($field, $user)
	{
		$model = & $this->getModel('list');
		return $model->getFieldValue($field, $user);

	}
	function renderAlpha($a, $params, $submit = false)
	{
		static $alphas = array();

		if(!$alphas)
		{
			$category_id = JRequest::getInt('category_id',JRequest::getInt('section_id'));
			$section_id  = ResHelper::getCategorySection($category_id);
			$mode 		 = $params->get('filters_mode', 1);
			$where = getFilterWhere($params);
			switch ($mode)
			{
				case 3:
					$ids = ResHelper::getCategoryChildrenIds($category_id);
					$sql = "SELECT LOWER(SUBSTRING(r.title, 1, 1)) as letter, COUNT(r.id) as number FROM #__js_res_record AS r
					WHERE r.id IN (SELECT record_id from #__js_res_record_category WHERE catid IN({$ids})) {$where}
					group by letter";
					break;
				case 1:
					$sql = "SELECT LOWER(SUBSTRING(r.title, 1, 1)) as letter, COUNT(r.id) as number FROM #__js_res_record AS r
					LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
					WHERE r.id IN (SELECT record_id FROM #__js_res_record_category WHERE catid = {$category_id}) {$where}
					group by letter";
					break;
				case 2:
					$sql = "SELECT LOWER(SUBSTRING(r.title, 1, 1)) as letter, COUNT(r.id) as number FROM #__js_res_record AS r
					WHERE r.id IN (SELECT record_id FROM #__js_res_record_category WHERE catid IN (SELECT id FROM #__js_res_category WHERE id = {$section_id} OR section_id = {$section_id})) {$where}
					group by letter";
					break;
			}
			$db = & JFactory::getDBO();
			$db->setQuery($sql);
			$db->query();
			$result = $db->loadObjectList();
			$alphas = array();
			foreach ($result as $res) {
				$alphas[$res->letter] = $res->number;
			}
		}

		$num = @$alphas[JString::strtolower($a)];
		if($num)
		{
			return "<span class=\"alpha\"><a class=\"alpha_active hasTip\" href=\"javascript:void(0);\" title=\"::".JText::_('Found')." ({$num}) \" onclick=\"document.adminForm.filter_alpha.value='{$a}';".($submit ? 'submitform();' : NULL)."\">".JString::strtoupper($a)."</a></span>";
		}
		else
		{
			return '<span class="alpha">'.JString::strtoupper($a)."</span>";
		}
	}


	/*function getTags($item, $section_id, $iparams, $params)
	 {
		static $tags;

		$id = $item->id;
		$db = & JFactory::getDBO();
		$url = & JFactory::getURI();
		$section_id ? NULL : $section_id = JRequest::getInt('category_id');

		$sql = "SELECT t.id, t.tag  FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_tags AS t ON t.id = h.tag_id
		WHERE h.record_id = {$id} GROUP BY t.id";
		$db->setQuery($sql);
		$tags = $db->loadObjectList();
		$cat_id = ResHelper::getCategorySection($section_id);
		$params->merge($iparams);

		if($tags)
		{
		$where = getFilterWhere($params);
		foreach ($tags AS $tag)
		{
		$num = false;
		$atr = array();
			
		//$link = 'index.php?option=com_resource&view=list&category_id='.JRequest::getInt('category_id', $cat_id).'&Itemid='.MEUrl::itemid(NULL, JRequest::getVar('category_id', $cat_id->id));
		//$link = MEUrl::linkAdditions($link);
		if($params->get('category_mode') == 2 && $item->user_id)
		{
		$options['user_id'] = $item->user_id;
		$options['view_what'] = 'created';
		}
		$link = MEUrl::link_list(JRequest::getVar('category_id', $cat_id), $options);
			
			
		$link .= '&filter_tag='.$tag->id;
		$link = MERoute::_($link);
		//$link = 'javascript:void(0);';
		//$atr = array('onclick' => "document.adminForm.filter_tag.value='{$tag->id}'; submitform();");

		if ($params->get('item_tag_num'))
		{
		switch ($params->get('filters_mode', 1))
		{
		case 1:
		$sql = "SELECT h.id FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
		WHERE rc.catid = {$section_id} AND h.tag_id = {$tag->id} {$where} GROUP BY h.id";
		break;
		case 3:
		$category = JRequest::getInt('category_id', $category);
		$ids = ResHelper::getCategoryChildrenIds($category);
		$sql = "SELECT h.id FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = h.record_id
		WHERE rc.catid = IN ({$ids}) AND h.tag_id = {$tag->id} {$where} GROUP BY h.id";
		break;
		case 2:
		$sql = "SELECT h.id FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		WHERE h.section_id = {$cat_id} AND h.tag_id = {$tag->id} {$where}";
		break;
		}
		$sql = "SELECT id FROM #__js_res_tags_history
		WHERE section_id = {$cat_id} AND tag_id = {$tag->id}";
		if ($params->get('filters_mode', 1) == 1)
		{
		$sql = "SELECT h.id FROM #__js_res_tags_history AS h
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = h.record_id
		WHERE rc.catid = {$section_id} AND h.tag_id = {$tag->id} {$where} GROUP BY h.id";
		}

		$db->setQuery($sql);
		$db->query();
		$num = $db->getNumRows();
		$tag->tag .= " ({$num}) ";
		}

		$t[] = JHTML::link( $link, $tag->tag, $atr);
		}
		return implode(", ", $t);
		}
		return false;
		}*/

}

?>