<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ResViewModerator extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		
		$user 	=   JFactory::getUser();
		$uri 	= & JFactory::getURI();
		
		if(!$user->get('id')) MEAccess::login($uri->toString());

		if(JRequest::getWord('layout') == 'set_moderator')
		{
			$this->_set_moderator($tpl);
			return;
		}
		if(JRequest::getWord('layout') == 'reason')
		{
			$this->_reason($tpl);
			return;
		}
		
		parent::display($tpl);
	}
	
	function _reason($tpl = null)
	{ 
		global $mainframe, $option;
		
		$itemid =   JRequest::getInt('Itemid');
		$user 	=   JFactory::getUser();
		$uri 	= & JFactory::getURI();
		if(!$user->get('id')) MEAccess::login($uri->toString());
		
		$action = base64_decode(JRequest::getVar('action'));
		
		if(!$action) 
		{
			JError::raiseWarning(403, JText::_('Error: No action'));
			return ;
		}
		
		$this->assignRef('action',	$action);
		
		parent::display($tpl);
	}
	function _set_moderator($tpl = null)
	{ 
		global $mainframe, $option;
		
		$itemid =   JRequest::getInt('Itemid');
		$user 	=   JFactory::getUser();
		$uri 	= & JFactory::getURI();
		
		if(!$user->get('id')) MEAccess::login($uri->toString());
		
		if(!MEAccess::isAdmin())
		{
			JError::raiseWarning(403, JText::_('Only Administrator can accesss this page'));
			return ;
		}
		if(!JRequest::getInt('category_id'))
		{
			JError::raiseWarning(403, JText::_('Section not set'));
			return ;
		}
		if(!JRequest::getInt('user_id'))
		{
			JError::raiseWarning(403, JText::_('User ID not set'));
			return ;
		}
		
		$member = JFactory::getUser(JRequest::getInt('user_id'));
		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		
		$lists['moder_delete_record'] = JHTML::_('select.booleanlist', 'moder_delete_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_delete_record')));
		$lists['moder_publish_record'] = JHTML::_('select.booleanlist', 'moder_publish_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_publish_record')));
		$lists['moder_edit_record'] = JHTML::_('select.booleanlist', 'moder_edit_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_edit_record')));
		$lists['moder_delete_comment'] = JHTML::_('select.booleanlist', 'moder_delete_comment', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_delete_comment')));
		$lists['moder_publish_comment'] = JHTML::_('select.booleanlist', 'moder_publish_comment', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_publish_comment')));
		$lists['moder_delete_vote'] = JHTML::_('select.booleanlist', 'moder_delete_vote', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_delete_vote')));
		$lists['moder_delete_comment_vote'] = JHTML::_('select.booleanlist', 'moder_delete_comment_vote', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_delete_comment_vote')));
		$lists['moder_extend_record'] = JHTML::_('select.booleanlist', 'moder_extend_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_extend_record')));
		$lists['moder_edit_fields'] = JHTML::_('select.booleanlist', 'moder_edit_fields', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_edit_fields')));
		$lists['moder_archive_record'] = JHTML::_('select.booleanlist', 'moder_archive_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_archive_record')));
		$lists['moder_uncomment_record'] = JHTML::_('select.booleanlist', 'moder_uncomment_record', 'class="inputbox"', $this->checkUser($member->get('id'), $params->get('moder_uncomment_record')));
		
		$files = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'images'.DS.'moderator', '.png');
		foreach ($files AS $file)
		{
			$name = substr($file, 0, -4);
			$options[] = JHTML::_('select.option', $file, JText::_(JString::ucfirst($name)));
		}
		$lists['icon'] = JHTML::_('select.genericlist', $options, 'icon');
		
		
		$this->assignRef('params',	$params);
		$this->assignRef('member',	$member);
		$this->assignRef('lists',	$lists);
		$this->assignRef('action',	$uri->toString());
		
		parent::display($tpl);
	}
	
	function checkUser($user_id, $ids)
	{
		$ids = explode(',', $ids);
		if(in_array($user_id, $ids)) return 1;
		return 0;
	}
}