<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');

class ResViewTags extends JView
{
	function display( $tpl = null )
	{
		global $mainframe;
        $meta = $names = $items = array();
		$model = &JModel::getInstance('Tags','ResModel');
		$params = & $mainframe->getParams();
		$document = & JFactory::getDocument();

		$sections = $params->get('sections', JRequest::getVar('sections', array(), 'get', 'array'));

		If(!$sections)
		{
			JError::raiseWarning(500, JText::_('No section selected'));
			parent::display($tpl);
			return;
		}
		settype($sections, 'array');
		$html = explode(",", JRequest::getString('html', $params->get('html', 'H1, H2, H3, H4, H5, H6, strong, b, em, big, small')));
		
		$html_tags = count($html) - 1;
		if(is_array($sections))
		{
			foreach ($sections AS $section)
			{
				$tags = $model->getTags($section);
				
				if(!$tags) continue;
				
				$tags_max = $tags[0]->total;
				$tags_min = $tags[count($tags) - 1]->total;
				$step = ($tags_max - $tags_min) / $html_tags;
				if( !$step )
				    $step = 1;
				foreach ($tags AS $i => $tag)
				{
					$tags[$i]->index = abs(floor(($tags_max - $tag->total) / $step));
					if($params->get('show_totals'))
					{
						$tags[$i]->tag .= " ({$tag->total})";
					}
					@$meta[$tag->tag] += $tag->total;
				}
				shuffle($tags);
				
				$names[$section] = $model->getSectionName($section);
				$items[$section] = $tags;
			}
		}
		
	    if(count($meta)){
    		arsort($meta);
    		$meta = array_slice($meta, 0, 20);
    		$meta = array_flip($meta);
    		$meta_line = implode(", ", $meta);
    		if($params->get('meta_key')) $document->setMetadata('keywords', $meta_line);
		}
		if($params->get('meta_desc')) $document->setDescription( $params->get('meta_desc') );
		
		$this->assign('html', $html);
		$this->assign('params', $params);
		$this->assign('items', $items);
		$this->assign('sections', $names);
		parent::display($tpl);
	}
}
?>