<?php
/**
 * $Id: view.html.php 7313 2011-08-22 06:36:21Z dima $
 * $LastChangedDate: 2011-08-22 12:36:21 +0600 (Mon, 22 Aug 2011) $
 * $LastChangedBy: dima $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Access Restricted');

jimport ('joomla.application.component.view');


class ResViewUtility extends JView
{
	function display($tpl = null) {
		$layout = JRequest::getCmd('layout');

		if ('relation' == $layout) {
			return $this->showRelatedRecords();
		}

		if ('edit' == $layout) {
			return $this->showEditCheck($tpl);
		}


		return parent::display($tpl);
	}

	function showEditCheck($tpl)
	{
		global $mainframe;
		$id = JRequest::getInt('id');
		$db = & JFactory::getDBO();
		
		$key = md5(time().'-'.$id);
			
		if(!$id)
		{
			JError::raiseWarning(500, JText::_('no article ID'));
			$mainframe->redirect();
		}

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($id);
		
		$category_id = ResHelper::getArticleSection($id);
		JRequest::setVar('category_id', $category_id);
		
		$sql = "SELECT v.field_value AS email, r.user_id
		FROM #__js_res_record_values AS v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
		WHERE v.record_id = $article->id
		AND f.type = 'email'";
		$db->setQuery($sql);
		$emails = $db->loadObjectList();
		
		foreach($emails as $email)
		{
			$email = strtolower($email->email);
			if(!JMailHelper::isEmailAddress($email)) continue;
			$to = $email;
		}
		
		if(!@$to)
		{
			JError::raiseWarning(500, JText::sprintf('Cannot find any email associated with record (%s)', $article->title));
			$mainframe->redirect();
		}
		
		$options['email_field'] = 1;
		$options['immediate'] = 1;
		$body = JText::_("Access Key is: [KEY] to edit [TYPE]");
		$body = str_replace('[KEY]', $key, $body);
		MEAlerts::custom($article, 'Edit Confirmation', $body, null, $options);
		
		$article->access_key = $key;
		$article->store();

		$uri = & JFactory::getURI();


		$this->assignRef('uri', $uri);
		$this->assignRef('article', $article);

		return parent::display($tpl);
	}

	function showRelatedRecords()
	{
		$fieldId 	= JRequest::getInt('field');
		
		$field = & JTable::getInstance('Field', 'Table');
		if ( ! $field->load($fieldId)) {
			JError::raiseWarning(404, JText::_('Cannot find field. Please check menu link parameters'));
			return;
		}
		$field->params = new JParameter($field->params);
		
		$user = & JFactory::getUser();

		$categoryId = JRequest::getInt('category');
		$articleId 	= JRequest::getInt('article');

		$listModel = &JModel::getInstance('List','ResModel');
		
		echo JRequest::getVar('exclude');

		$section = null;
		$category = null;
		if ($categoryId) {
			$section  = $listModel->getCategory(ResHelper::getCategorySection($categoryId));
			$category = $listModel->getCategory($categoryId);
		}

		$catParams = null;
		if ($categoryId)
		$catParams = ResHelper::initListParams($categoryId);
		$article = & JTable::getInstance('Record', 'Res');
		if ( ! $article->load($articleId) ) {
			// The record is new
			$article->id = $articleId;
		}

		
		$forcedCategory = $field->params->get('force_category');

		$filterCategories = JRequest::getVar('filter_categories', array(), 'default', 'array');

		$lists = array();
		$lists['limitstart'] 	= JRequest::getInt('limitstart');
		$lists['limit'] 		= JRequest::getInt('limit', 15);

		$filterCat = empty($filterCategories[0]) ? $categoryId : $filterCategories[0];

		$model = & JModel::getInstance('Utility', 'ResModel');
		$model->setState('what', 		'related');
		$model->setState('id', 			$fieldId);
		$model->setState('record_id', 	$articleId);

		if ($filterCat && (! $forcedCategory || $user->get('aid') == 2))
		$model->setState('category', 	$filterCat);

		$model->setState('search', 		JRequest::getString('search', '', 'default', JREQUEST_ALLOWRAW));
		$model->setState('limit', 		$lists['limit']);
		$model->setState('limitstart', 	$lists['limitstart']);
		$model->setState('orderby', 	'r.`title`');
		$model->setState('user_strict', $field->params->get('user_strict'));

		$records 	= $model->getData();
		$db = &JFactory::getDBO();
		if($field->type == 'relate_parent3'){
			$sql = "SELECT record_id FROM #__js_res_record_values WHERE field_value LIKE '%,{$articleId},%' AND field_id = ".$field->params->get('relate_field');
			$db->setQuery($sql);
			$selected = $db->loadResultArray();
			$sql = "SELECT params FROM #__js_res_record_values WHERE record_id = {$articleId} AND field_id = ".$field->id;
			$db->setQuery($sql);
			$fparams = unserialize($db->loadResult());
		}else{
			$sql = "SELECT * FROM #__js_res_record_values WHERE record_id = {$articleId} AND field_id = ".$field->id;
			$db->setQuery($sql);
			$res = $db->loadObject();
			$selected = explode(',', $res->field_value);
			$fparams = unserialize($res->params);
		}

		$pagination = $model->getPagination();

		if (empty($records))
		$records = array();


		$lists['category'] = $this->_getAllowedCategories($field, $categoryId);


		$hiddenVars = array(
			'option' 	=> JRequest::getCmd('option'),
			'component' => JRequest::getCmd('component'),
			'category' 	=> JRequest::getCmd('category'),
			'field' 	=> JRequest::getCmd('field'),
			'article' 	=> JRequest::getCmd('article'),
			'view' 		=> JRequest::getCmd('view'),
			'layout' 	=> JRequest::getCmd('layout'),
		);


		$canSelectMultipleArticles = false;
		if ($field->params->get('multi_parented', 1) && $field->type == 'relate_child3' OR $field->type == 'relate_parent3')
		{
			$canSelectMultipleArticles = true;
		}

		$uri = & JFactory::getURI();

		$this->assignRef('uri',			$uri);
		$this->assignRef('records', 	$records);
		$this->assignRef('article', 	$article);
		$this->assignRef('category', 	$category);
		$this->assignRef('filter_cat', 	$filterCat);
		$this->assignRef('field', 		$field);
		$this->assignRef('lists', 		$lists);
		$this->assignRef('hiddenVars', 	$hiddenVars);
		$this->assignRef('selected', 	$selected);
		$this->assignRef('fparams', 	$fparams);
		$this->assignRef('multiple', 	$canSelectMultipleArticles); 
		$this->assignRef('relate_tags', 	$field->params->get('relate_tags', 0));

		$this->assignRef('pagination', 	$pagination);

		JHTML::_('behavior.tooltip');
		JHTML::_('behavior.modal');

		return parent::display();
	}

	function _getAllowedCategories(&$field, $selected = false) {
		$user = & JFactory::GetUser();
		$db = & JFactory::getDBO();

		$forcedCategory = $field->params->get('force_category');

		if ($forcedCategory && ! $user) {
			return false;
		}

		if (!in_array($field->type, array('relate_child3', 'relate_parent3'))) {
			JError::raiseWarning(404, JText::_('Cannot find related field'));
			return false;
		}

		$categories = null;

		if ($field->type == 'relate_parent3')
		{
			$childFieldId = $field->params->get('relate_field');
				
			$where = array();
			$where [] = 'rv.field_id = '.$childFieldId;
			$where [] = '(c.id = '.$field->params->get('parent_section').' OR '.'c.section_id = '.$field->params->get('parent_section').')';
			if ($user->get('aid') < 2)
			{
				$where [] = 'r.published = 1';
				$where [] = 'c.published = 1';
			}
				
			$where = 'WHERE '.implode(' AND ', $where);
				
			$q = 'SELECT c.id, c.name FROM
			#__js_res_category c
			INNER JOIN #__js_res_record_category rc 	ON rc.catid = c.id
			INNER JOIN #__js_res_record r 				ON rc.record_id = r.id
			INNER JOIN #__js_res_record_values rv 		ON r.id = rv.record_id '
			.$where
			.' GROUP BY c.id';
				
			$db->setQuery( $q );
			$categories = $db->loadObjectList();
			if (! $categories)
			$categories = array();
		}

		if ($field->type == 'relate_child3')
		{
			$parentType = $field->params->get('parent_type');
				
			$where = array();
			$where [] = 'r.type_id = '.$parentType;
			$where [] = '(c.id = '.$field->params->get('parent_section').' OR '.'c.section_id = '.$field->params->get('parent_section').')';
			if ($user->get('aid') < 2)
			{
				$where [] = 'r.published = 1';
				$where [] = 'c.published = 1';
			}
				
			$where = 'WHERE '.implode(' AND ', $where);
				
			$q = 'SELECT c.id, c.name FROM
			#__js_res_category c
			INNER JOIN #__js_res_record_category rc 	ON rc.catid = c.id
			INNER JOIN #__js_res_record r 				ON rc.record_id = r.id '
			.$where
			.' GROUP BY c.id';
				
			$db->setQuery( $q );
			$categories = $db->loadObjectList();
			if (! $categories)
			$categories = array();
		}

		$options = array();
		$options [] = JHTML::_('select.option', '', '-'.JText::_('Select category').'-');
		foreach ($categories as $c) {
			$options [] = JHTML::_('select.option', $c->id, $c->name);
		}

		return JHTML::_('select.genericlist', $options, 'filter_categories', null, 'value', 'text', $selected);
	}
}